/*******************************************************************************
  Snes9x - Portable Super Nintendo Entertainment System (TM) emulator.
 
  (c) Copyright 1996 - 2002 Gary Henderson (gary.henderson@ntlworld.com) and
                            Jerremy Koot (jkoot@snes9x.com)

  (c) Copyright 2001 - 2004 John Weidman (jweidman@slip.net)

  (c) Copyright 2002 - 2004 Brad Jorsch (anomie@users.sourceforge.net),
                            funkyass (funkyass@spam.shaw.ca),
                            Joel Yliluoma (http://iki.fi/bisqwit/)
                            Kris Bleakley (codeviolation@hotmail.com),
                            Matthew Kendora,
                            Nach (n-a-c-h@users.sourceforge.net),
                            Peter Bortas (peter@bortas.org) and
                            zones (kasumitokoduck@yahoo.com)

  C4 x86 assembler and some C emulation code
  (c) Copyright 2000 - 2003 zsKnight (zsknight@zsnes.com),
                            _Demo_ (_demo_@zsnes.com), and Nach

  C4 C++ code
  (c) Copyright 2003 Brad Jorsch

  DSP-1 emulator code
  (c) Copyright 1998 - 2004 Ivar (ivar@snes9x.com), _Demo_, Gary Henderson,
                            John Weidman, neviksti (neviksti@hotmail.com),
                            Kris Bleakley, Andreas Naive

  DSP-2 emulator code
  (c) Copyright 2003 Kris Bleakley, John Weidman, neviksti, Matthew Kendora, and
                     Lord Nightmare (lord_nightmare@users.sourceforge.net

  OBC1 emulator code
  (c) Copyright 2001 - 2004 zsKnight, pagefault (pagefault@zsnes.com) and
                            Kris Bleakley
  Ported from x86 assembler to C by sanmaiwashi

  SPC7110 and RTC C++ emulator code
  (c) Copyright 2002 Matthew Kendora with research by
                     zsKnight, John Weidman, and Dark Force

  S-DD1 C emulator code
  (c) Copyright 2003 Brad Jorsch with research by
                     Andreas Naive and John Weidman
 
  S-RTC C emulator code
  (c) Copyright 2001 John Weidman
  
  ST010 C++ emulator code
  (c) Copyright 2003 Feather, Kris Bleakley, John Weidman and Matthew Kendora

  Super FX x86 assembler emulator code 
  (c) Copyright 1998 - 2003 zsKnight, _Demo_, and pagefault 

  Super FX C emulator code 
  (c) Copyright 1997 - 1999 Ivar, Gary Henderson and John Weidman


  SH assembler code partly based on x86 assembler code
  (c) Copyright 2002 - 2004 Marcus Comstedt (marcus@mc.pp.se) 

 
  Specific ports contains the works of other authors. See headers in
  individual files.
 
  Snes9x homepage: http://www.snes9x.com
 
  Permission to use, copy, modify and distribute Snes9x in both binary and
  source form, for non-commercial purposes, is hereby granted without fee,
  providing that this license information and copyright notice appear with
  all copies and any derived work.
 
  This software is provided 'as-is', without any express or implied
  warranty. In no event shall the authors be held liable for any damages
  arising from the use of this software.
 
  Snes9x is freeware for PERSONAL USE only. Commercial users should
  seek permission of the copyright holders first. Commercial use includes
  charging money for Snes9x or software derived from Snes9x.
 
  The copyright holders request that bug fixes and improvements to the code
  should be forwarded to them so everyone can benefit from the modifications
  in future versions.
 
  Super NES and Super Nintendo Entertainment System are trademarks of
  Nintendo Co., Limited and its subsidiary companies.
*******************************************************************************/

#ifndef _CPUADDR_OLD_H_
#define _CPUADDR_OLD_H_

EXTERN_C long OpAddress_old;

static inline void Immediate8_old (AccessMode a)
{
    OpAddress_old = ICPU.ShiftedPB + Registers.PCw;
    Registers.PCw += 1;
}

static inline void Immediate16_old (AccessMode a)
{
    OpAddress_old = ICPU.ShiftedPB + Registers.PCw;
    Registers.PCw += 2;
}

static inline void Relative_old (AccessMode a)
{
    signed char Int8 = S9xGetByte(ICPU.ShiftedPB + Registers.PCw++);
    OpAddress_old = ((int) Registers.PCw + Int8) & 0xffff;
}

static inline void RelativeLong_old (AccessMode a)
{
    OpAddress_old = S9xGetWord(ICPU.ShiftedPB + Registers.PCw);
    Registers.PCw += 2;

    OpAddress_old += Registers.PCw;
    OpAddress_old &= 0xffff;
}

static inline void AbsoluteIndexedIndirect_old (AccessMode a)
{
    OpAddress_old = S9xGetWord(ICPU.ShiftedPB + Registers.PCw);
    OpenBus = (uint8)(OpAddress_old>>8);
    OpAddress_old = (Registers.X.W + OpAddress_old) & 0xffff;
    Registers.PCw += 2;
    OpAddress_old = S9xGetWord (ICPU.ShiftedPB + OpAddress_old);
    if(a&READ) OpenBus = (uint8)(OpAddress_old>>8);
}

static inline void AbsoluteIndirectLong_old (AccessMode a)
{
    OpAddress_old = S9xGetWord(ICPU.ShiftedPB + Registers.PCw);
    OpenBus = (uint8)(OpAddress_old>>8);
    Registers.PCw += 2;

    if(a&READ) {
	OpAddress_old = S9xGetWord (OpAddress_old) | ((OpenBus=S9xGetByte (OpAddress_old + 2)) << 16);
    } else {
    OpAddress_old = S9xGetWord (OpAddress_old) | (S9xGetByte (OpAddress_old + 2) << 16);
    }
}

static inline void AbsoluteIndirect_old (AccessMode a)
{
    OpAddress_old = S9xGetWord(ICPU.ShiftedPB + Registers.PCw);
    OpenBus = (uint8)(OpAddress_old>>8);
    Registers.PCw += 2;
    OpAddress_old = S9xGetWord (OpAddress_old);
    if(a&READ) OpenBus = (uint8)(OpAddress_old>>8);
    OpAddress_old += ICPU.ShiftedPB;
}

static inline void Absolute_old (AccessMode a)
{
    OpAddress_old = S9xGetWord(ICPU.ShiftedPB + Registers.PCw);
    if(a&READ) OpenBus = (uint8)(OpAddress_old>>8);
    OpAddress_old = OpAddress_old + ICPU.ShiftedDB;
    Registers.PCw += 2;
}

static inline void AbsoluteLong_old (AccessMode a)
{
    OpAddress_old = (S9xGetWord(ICPU.ShiftedPB + Registers.PCw) | (S9xGetByte(ICPU.ShiftedPB + Registers.PCw + 2) << 16)) & 0xffffff;
    if(a&READ) OpenBus = (uint8)(OpAddress_old>>16);
    Registers.PCw += 3;
}

static inline void Direct_old (AccessMode a)
{
    OpAddress_old = S9xGetByte(ICPU.ShiftedPB + Registers.PCw++);
    if(a&READ) OpenBus = (uint8)OpAddress_old;
    OpAddress_old = (OpAddress_old + Registers.D.W) & 0xffff;
//    if (Registers.DL != 0) CPU.Cycles += ONE_CYCLE;
}

static inline void DirectIndirectIndexed_old (AccessMode a)
{
    OpenBus = S9xGetByte(ICPU.ShiftedPB + Registers.PCw++);
    OpAddress_old = (OpenBus + Registers.D.W) & 0xffff;

    OpAddress_old = S9xGetWord (OpAddress_old);
    if(a&READ) OpenBus = (uint8)(OpAddress_old>>8);
    OpAddress_old += ICPU.ShiftedDB + Registers.Y.W;

//    if (Registers.DL != 0) CPU.Cycles += ONE_CYCLE;
    // XXX: always add one if STA
    // XXX: else Add one cycle if crosses page boundary
}

static inline void DirectIndirectIndexedLong_old (AccessMode a)
{
    OpenBus = S9xGetByte(ICPU.ShiftedPB + Registers.PCw++);
    OpAddress_old = (OpenBus + Registers.D.W) & 0xffff;

    if(a&READ){
	OpAddress_old = S9xGetWord (OpAddress_old) + ((OpenBus = S9xGetByte (OpAddress_old + 2)) << 16) + Registers.Y.W;
    } else {
	OpAddress_old = S9xGetWord (OpAddress_old) + (S9xGetByte (OpAddress_old + 2) << 16) + Registers.Y.W;
    }
//    if (Registers.DL != 0) CPU.Cycles += ONE_CYCLE;
}

static inline void DirectIndexedIndirect_old(AccessMode a)
{
    OpenBus = S9xGetByte(ICPU.ShiftedPB + Registers.PCw++);
    OpAddress_old = (OpenBus + Registers.D.W + Registers.X.W) & 0xffff;

    OpAddress_old = S9xGetWord (OpAddress_old);
    if(a&READ) OpenBus = (uint8)(OpAddress_old>>8);
    OpAddress_old += ICPU.ShiftedDB;

#ifndef SA1_OPCODES
//    if (Registers.DL != 0)
//	CPU.Cycles += TWO_CYCLES;
//    else
	CPU.Cycles += ONE_CYCLE;
#endif
}

static inline void DirectIndexedX_old (AccessMode a)
{
    OpAddress_old = S9xGetByte(ICPU.ShiftedPB + Registers.PCw++);
    if(a&READ) OpenBus = (uint8)OpAddress_old;
    OpAddress_old = (OpAddress_old + Registers.D.W + Registers.X.W);
    OpAddress_old &= CheckEmulation() ? 0xff : 0xffff;

#ifndef SA1_OPCODES
//    if (Registers.DL != 0)
//	CPU.Cycles += TWO_CYCLES;
//    else
	CPU.Cycles += ONE_CYCLE;
#endif
}

static inline void DirectIndexedY_old (AccessMode a)
{
    OpAddress_old = S9xGetByte(ICPU.ShiftedPB + Registers.PCw++);
    if(a&READ) OpenBus = (uint8)OpAddress_old;
    OpAddress_old = (OpAddress_old + Registers.D.W + Registers.Y.W);
    OpAddress_old &= CheckEmulation() ? 0xff : 0xffff;

#ifndef SA1_OPCODES
//    if (Registers.DL != 0)
//	CPU.Cycles += TWO_CYCLES;
//    else
	CPU.Cycles += ONE_CYCLE;
#endif
}

static inline void AbsoluteIndexedX_old (AccessMode a)
{
    OpAddress_old = S9xGetWord(ICPU.ShiftedPB + Registers.PCw);
    if(a&READ) OpenBus = (uint8)(OpAddress_old>>8);
    OpAddress_old = ICPU.ShiftedDB + OpAddress_old + Registers.X.W;
    Registers.PCw += 2;
    // XXX: always add one cycle for ROL, LSR, etc
    // XXX: else is cross page boundary add one cycle
}

static inline void AbsoluteIndexedY_old (AccessMode a)
{
    OpAddress_old = S9xGetWord(ICPU.ShiftedPB + Registers.PCw);
    if(a&READ) OpenBus = (uint8)(OpAddress_old>>8);
    OpAddress_old = ICPU.ShiftedDB + OpAddress_old + Registers.Y.W;
    Registers.PCw += 2;
    // XXX: always add cycle for STA
    // XXX: else is cross page boundary add one cycle
}

static inline void AbsoluteLongIndexedX_old (AccessMode a)
{
    OpAddress_old = S9xGetWord(ICPU.ShiftedPB + Registers.PCw) | (S9xGetByte(ICPU.ShiftedPB + Registers.PCw + 2) << 16);
    if(a&READ) OpenBus = (uint8)(OpAddress_old>>16);
    OpAddress_old = (OpAddress_old + Registers.X.W) & 0xffffff;
    Registers.PCw += 3;
}

static inline void DirectIndirect_old (AccessMode a)
{
    OpenBus = S9xGetByte(ICPU.ShiftedPB + Registers.PCw++);
    OpAddress_old = (OpenBus + Registers.D.W) & 0xffff;
    OpAddress_old = S9xGetWord (OpAddress_old);
    if(a&READ) OpenBus = (uint8)(OpAddress_old>>8);
    OpAddress_old += ICPU.ShiftedDB;

//    if (Registers.DL != 0) CPU.Cycles += ONE_CYCLE;
}

static inline void DirectIndirectLong_old (AccessMode a)
{
    OpenBus = S9xGetByte(ICPU.ShiftedPB + Registers.PCw++);
    OpAddress_old = (OpenBus + Registers.D.W) & 0xffff;
    if(a&READ){
	OpAddress_old = S9xGetWord (OpAddress_old) + ((OpenBus=S9xGetByte (OpAddress_old + 2)) << 16);
    } else {
	OpAddress_old = S9xGetWord (OpAddress_old) + (S9xGetByte (OpAddress_old + 2) << 16);
    }
//    if (Registers.DL != 0) CPU.Cycles += ONE_CYCLE;
}

static inline void StackRelative_old (AccessMode a)
{
    OpAddress_old = S9xGetByte(ICPU.ShiftedPB + Registers.PCw++);
    if(a&READ) OpenBus = (uint8)OpAddress_old;
    OpAddress_old = (OpAddress_old + Registers.S.W) & 0xffff;

#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
}

static inline void StackRelativeIndirectIndexed_old (AccessMode a)
{
    OpenBus = S9xGetByte(ICPU.ShiftedPB + Registers.PCw++);
    OpAddress_old = (OpenBus + Registers.S.W) & 0xffff;

#ifndef SA1_OPCODES
    CPU.Cycles += TWO_CYCLES;
#endif
    OpAddress_old = S9xGetWord (OpAddress_old);
    if(a&READ) OpenBus = (uint8)(OpAddress_old>>8);
    OpAddress_old = (OpAddress_old + ICPU.ShiftedDB +
		 Registers.Y.W) & 0xffffff;
}
#endif

