/***********************************************************************************
  Snes9x - Portable Super Nintendo Entertainment System (TM) emulator.

  (c) Copyright 1996 - 2002  Gary Henderson (gary.henderson@ntlworld.com),
                             Jerremy Koot (jkoot@snes9x.com)

  (c) Copyright 2002 - 2004  Matthew Kendora

  (c) Copyright 2002 - 2005  Peter Bortas (peter@bortas.org)

  (c) Copyright 2004 - 2005  Joel Yliluoma (http://iki.fi/bisqwit/)

  (c) Copyright 2001 - 2006  John Weidman (jweidman@slip.net)

  (c) Copyright 2002 - 2006  funkyass (funkyass@spam.shaw.ca),
                             Kris Bleakley (codeviolation@hotmail.com)

  (c) Copyright 2002 - 2010  Brad Jorsch (anomie@users.sourceforge.net),
                             Nach (n-a-c-h@users.sourceforge.net),
                             zones (kasumitokoduck@yahoo.com)

  (c) Copyright 2006 - 2007  nitsuja

  (c) Copyright 2009 - 2010  BearOso,
                             OV2


  BS-X C emulator code
  (c) Copyright 2005 - 2006  Dreamer Nom,
                             zones

  C4 x86 assembler and some C emulation code
  (c) Copyright 2000 - 2003  _Demo_ (_demo_@zsnes.com),
                             Nach,
                             zsKnight (zsknight@zsnes.com)

  C4 C++ code
  (c) Copyright 2003 - 2006  Brad Jorsch,
                             Nach

  DSP-1 emulator code
  (c) Copyright 1998 - 2006  _Demo_,
                             Andreas Naive (andreasnaive@gmail.com),
                             Gary Henderson,
                             Ivar (ivar@snes9x.com),
                             John Weidman,
                             Kris Bleakley,
                             Matthew Kendora,
                             Nach,
                             neviksti (neviksti@hotmail.com)

  DSP-2 emulator code
  (c) Copyright 2003         John Weidman,
                             Kris Bleakley,
                             Lord Nightmare (lord_nightmare@users.sourceforge.net),
                             Matthew Kendora,
                             neviksti

  DSP-3 emulator code
  (c) Copyright 2003 - 2006  John Weidman,
                             Kris Bleakley,
                             Lancer,
                             z80 gaiden

  DSP-4 emulator code
  (c) Copyright 2004 - 2006  Dreamer Nom,
                             John Weidman,
                             Kris Bleakley,
                             Nach,
                             z80 gaiden

  OBC1 emulator code
  (c) Copyright 2001 - 2004  zsKnight,
                             pagefault (pagefault@zsnes.com),
                             Kris Bleakley
                             Ported from x86 assembler to C by sanmaiwashi

  SPC7110 and RTC C++ emulator code used in 1.39-1.51
  (c) Copyright 2002         Matthew Kendora with research by
                             zsKnight,
                             John Weidman,
                             Dark Force

  SPC7110 and RTC C++ emulator code used in 1.52+
  (c) Copyright 2009         byuu,
                             neviksti

  S-DD1 C emulator code
  (c) Copyright 2003         Brad Jorsch with research by
                             Andreas Naive,
                             John Weidman

  S-RTC C emulator code
  (c) Copyright 2001 - 2006  byuu,
                             John Weidman

  ST010 C++ emulator code
  (c) Copyright 2003         Feather,
                             John Weidman,
                             Kris Bleakley,
                             Matthew Kendora

  Super FX x86 assembler emulator code
  (c) Copyright 1998 - 2003  _Demo_,
                             pagefault,
                             zsKnight

  Super FX C emulator code
  (c) Copyright 1997 - 1999  Ivar,
                             Gary Henderson,
                             John Weidman

  Sound emulator code used in 1.5-1.51
  (c) Copyright 1998 - 2003  Brad Martin
  (c) Copyright 1998 - 2006  Charles Bilyue'

  Sound emulator code used in 1.52+
  (c) Copyright 2004 - 2007  Shay Green (gblargg@gmail.com)

  SH assembler code partly based on x86 assembler code
  (c) Copyright 2002 - 2004  Marcus Comstedt (marcus@mc.pp.se)

  2xSaI filter
  (c) Copyright 1999 - 2001  Derek Liauw Kie Fa

  HQ2x, HQ3x, HQ4x filters
  (c) Copyright 2003         Maxim Stepin (maxim@hiend3d.com)

  NTSC filter
  (c) Copyright 2006 - 2007  Shay Green

  GTK+ GUI code
  (c) Copyright 2004 - 2010  BearOso

  Win32 GUI code
  (c) Copyright 2003 - 2006  blip,
                             funkyass,
                             Matthew Kendora,
                             Nach,
                             nitsuja
  (c) Copyright 2009 - 2010  OV2

  Mac OS GUI code
  (c) Copyright 1998 - 2001  John Stiles
  (c) Copyright 2001 - 2010  zones


  Specific ports contains the works of other authors. See headers in
  individual files.


  Snes9x homepage: http://www.snes9x.com/

  Permission to use, copy, modify and/or distribute Snes9x in both binary
  and source form, for non-commercial purposes, is hereby granted without
  fee, providing that this license information and copyright notice appear
  with all copies and any derived work.

  This software is provided 'as-is', without any express or implied
  warranty. In no event shall the authors be held liable for any damages
  arising from the use of this software or it's derivatives.

  Snes9x is freeware for PERSONAL USE only. Commercial users should
  seek permission of the copyright holders first. Commercial use includes,
  but is not limited to, charging money for Snes9x or software derived from
  Snes9x, including Snes9x or derivatives in commercial game bundles, and/or
  using Snes9x as a promotion for your commercial product.

  The copyright holders request that bug fixes and improvements to the code
  should be forwarded to them so everyone can benefit from the modifications
  in future versions.

  Super NES and Super Nintendo Entertainment System are trademarks of
  Nintendo Co., Limited and its subsidiary companies.
 ***********************************************************************************/


#include "snes9x.h"
#include "memmap.h"
#include "cpuops.h"
#include "dma.h"
//#include "apu/apu.h"
#include "soundux.h"
#include "apu_orig.h"
#include "fxemu.h"
#include "snapshot.h"
#ifdef DEBUGGER
#include "debug.h"
#include "missing.h"
#endif

//#define IRQ_DEBUG
#ifdef IRQ_DEBUG
static const char irq_log_name[] = "irq.log";
static FILE *irq_fs = NULL;
#endif

void
S9xSetIRQ (uint32 source)
{
  CPU.IRQActive |= source;
  CPU.Flags |= IRQ_FLAG;
  CPU.IRQPending = Settings.DisableIRQCycleCount ? 0 : Timings.IRQPendCount;

#if 1
  if (CheckFlag (IRQ) && CPU.WaitingForInterrupt)
    {
      // Force IRQ to trigger immediately after WAI - 
      // Final Fantasy Mystic Quest crashes without this.
      CPU.IRQPending = 0;
      CPU.WaitingForInterrupt = FALSE;
      Registers.PCw++;
    }
#endif
}

void
S9xClearIRQ (uint32 source)
{
  CPU.IRQActive &= ~source;
  if (!CPU.IRQActive)
    CPU.Flags &= ~IRQ_FLAG;

#ifdef DEBUGGER
  S9xTraceMessage ("--- /IRQ high");
#endif
}

static inline void
S9xReschedule (void)
{
  uint8 next = 0;
  int32 hpos = 0;

  switch (CPU.WhichEvent)
    {
    case HC_HBLANK_START_EVENT:
    case HC_IRQ_1_3_EVENT:
      if (!Settings.OldTiming)
	{
	  next = HC_HDMA_START_EVENT;
	  hpos = Timings.HDMAStart;
	}
      else
	{
	  next = HC_HCOUNTER_MAX_EVENT;
	  hpos = Timings.H_Max;
	}
      break;

    case HC_HDMA_START_EVENT:
    case HC_IRQ_3_5_EVENT:
      next = HC_HCOUNTER_MAX_EVENT;
      hpos = Timings.H_Max;
      break;

    case HC_HCOUNTER_MAX_EVENT:
    case HC_IRQ_5_7_EVENT:
      next = HC_HDMA_INIT_EVENT;
      hpos = Timings.HDMAInit;
      break;

    case HC_HDMA_INIT_EVENT:
    case HC_IRQ_7_9_EVENT:
      next = HC_RENDER_EVENT;
      hpos = Timings.RenderPos;
      break;

    case HC_RENDER_EVENT:
    case HC_IRQ_9_A_EVENT:
      if (!Settings.OldTiming)
	{
	  next = HC_WRAM_REFRESH_EVENT;
	  hpos = Timings.WRAMRefreshPos;
	}
      else
	{
	  next = HC_HBLANK_START_EVENT;
	  hpos = Timings.HBlankStart;
	}
      break;

    case HC_WRAM_REFRESH_EVENT:
    case HC_IRQ_A_1_EVENT:
      next = HC_HBLANK_START_EVENT;
      hpos = Timings.HBlankStart;
      break;
    }

  if (PPU.HTimerEnabled &&
      ((int32) PPU.HTimerPosition > CPU.NextEvent) && ((int32) PPU.HTimerPosition < hpos) &&
      (!PPU.VTimerEnabled || (PPU.VTimerEnabled && CPU.V_Counter == PPU.IRQVBeamPos)))
    {
      hpos = (int32) PPU.HTimerPosition;

      switch (next)
	{
	case HC_HDMA_START_EVENT:
	  next = HC_IRQ_1_3_EVENT;
	  break;

	case HC_HCOUNTER_MAX_EVENT:
	  next = HC_IRQ_3_5_EVENT;
	  break;

	case HC_HDMA_INIT_EVENT:
	  next = HC_IRQ_5_7_EVENT;
	  break;

	case HC_RENDER_EVENT:
	  next = HC_IRQ_7_9_EVENT;
	  break;

	case HC_WRAM_REFRESH_EVENT:
	  next = HC_IRQ_9_A_EVENT;
	  break;

	case HC_HBLANK_START_EVENT:
	  next = HC_IRQ_A_1_EVENT;
	  break;
	}
    }

  CPU.NextEvent = hpos;
  CPU.WhichEvent = next;
}

void
S9xDoHEventProcessing ()
{
#ifdef CPU_SHUTDOWN
  // CPU.WaitCounter is and there is a case of 0.
  CPU.WaitCounter = 1;
#endif

  switch (CPU.WhichEvent)
    {
    case HC_HBLANK_START_EVENT:
      S9xCheckMissingHTimerPosition(Timings.HBlankStart);
      //if (Settings.OldTiming && PPU.HDMA && CPU.V_Counter <= PPU.ScreenHeight)
      if (Settings.OldTiming && PPU.HDMA && CPU.V_Counter <= PPU.ScreenHeight)
	{
#ifdef DEBUGGER
	  S9xTraceFormattedMessage ("*** HDMA  HC:%04d, Channel:%02x",
				    CPU.Cycles, PPU.HDMA);
#endif
	  PPU.HDMA = S9xDoHDMA (PPU.HDMA);
	}
      break;

    case HC_HDMA_START_EVENT:
      S9xCheckMissingHTimerPosition(Timings.HDMAStart);
      //if (!Settings.OldTiming && PPU.HDMA && CPU.V_Counter <= PPU.ScreenHeight)
      if (!Settings.OldTiming && PPU.HDMA && CPU.V_Counter <= PPU.ScreenHeight)
	{
#ifdef DEBUGGER
	  S9xTraceFormattedMessage ("*** HDMA  HC:%04d, Channel:%02x",
				    CPU.Cycles, PPU.HDMA);
#endif
	  PPU.HDMA = S9xDoHDMA (PPU.HDMA);
	}
      break;

      case HC_HCOUNTER_MAX_EVENT:
#ifndef ZSNES_FX
	if (Settings.SuperFX)
	  {
	    if (!SuperFX.oneLineDone)
	      S9xSuperFXExec();
	    SuperFX.oneLineDone = FALSE;
	  }
#else
	S9xSuperFXExec();
#endif

      CPU.Cycles -= Timings.H_Max;
      APU.Cycles -= Timings.H_Max;
      EXT.NextAPUTimerPos -= Timings.H_Max;

      if ((Timings.NMITriggerPos != 0xffff)
	  && (Timings.NMITriggerPos >= Timings.H_Max))
	Timings.NMITriggerPos -= Timings.H_Max;

#ifdef MK_APU
      if (IAPU.APUExecuting)
	S9xCatchupCount ();
#endif
      S9xCheckMissingHTimerPosition(CPU.NextEvent);
      CPU.V_Counter++;

      if (CPU.V_Counter == FIRST_VISIBLE_LINE)
	{
	  S9xStartScreenRefresh ();
	}
      else if (CPU.V_Counter == PPU.ScreenHeight + FIRST_VISIBLE_LINE)
	{
	  S9xEndScreenRefresh ();
	  // Start of V-blank
	  PPU.HDMA = 0;
	  // Bits 7 and 6 of $4212 are computed when read in S9xGetPPU.
#ifdef DEBUGGER
	  missing.dma_this_frame = 0;
#endif
	  IPPU.MaxBrightness = PPU.Brightness;
	  PPU.ForcedBlanking = (Memory.FillRAM[0x2100] >> 7) & 1;

	  if (!PPU.ForcedBlanking)
	    {
	      PPU.OAMAddr = PPU.SavedOAMAddr;
	      {
		uint8 tmp = 0;
		if (PPU.OAMPriorityRotation)
		  tmp = (PPU.OAMAddr & 0xFE) >> 1;
		if ((PPU.OAMFlip & 1) || PPU.FirstSprite != tmp)
		  {
		    PPU.FirstSprite = tmp;
		    IPPU.OBJChanged = TRUE;
		  }
	      }
	      PPU.OAMFlip = 0;
	    }

	  Memory.FillRAM[0x4210] = 0x80 | Model->_5A22;
	  if (Memory.FillRAM[0x4200] & 0x80)
	    {
	      // FIXME: triggered at HC=6, checked just before the final CPU cycle,
	      // then, when to call S9xOpcode_NMI()?
	      CPU.Flags |= NMI_FLAG;
	      Timings.NMITriggerPos = 6 + 6;
	    }

#ifdef OLD_SNAPSHOT_CODE
	  if (CPU.Flags & SAVE_SNAPSHOT_FLAG)
	    {
	      CPU.Flags &= ~SAVE_SNAPSHOT_FLAG;
	      Registers.PCw = CPU.PC - CPU.PCBase;
	      S9xPackStatus ();
	      S9xAPUPackStatus ();
	      Snapshot (NULL);
	    }
#endif
	}
      else if (CPU.V_Counter == PPU.ScreenHeight + 3)
	{
	  if (Memory.FillRAM[0x4200] & 1)
	    S9xDoAutoJoypad();
	}
      else if (CPU.V_Counter >= Timings.V_Max)
	{
	  CPU.V_Counter = 0;
	  Timings.InterlaceField ^= 1;

	  // From byuu:
	  // [NTSC]
	  // interlace mode has 525 scanlines: 263 on the even frame, and 262 on the odd.
	  // non-interlace mode has 524 scanlines: 262 scanlines on both even and odd frames.
	  // [PAL] <PAL info is unverified on hardware>
	  // interlace mode has 625 scanlines: 313 on the even frame, and 312 on the odd.
	  // non-interlace mode has 624 scanlines: 312 scanlines on both even and odd frames.
	  if (IPPU.Interlace && !Timings.InterlaceField)
	    Timings.V_Max = Timings.V_Max_Master + 1;	// 263 (NTSC), 313?(PAL)
	  else
	    Timings.V_Max = Timings.V_Max_Master;		// 262 (NTSC), 312?(PAL)

	  Memory.FillRAM[0x213f] = ((uint8) Timings.InterlaceField << 7) | (Memory.FillRAM[0x213f] & 0x7f);
	  PPU.RangeTimeOver = 0;

	  // FIXME: reading $4210 will wait 2 cycles, then perform reading, then wait 4 more cycles.
	  Memory.FillRAM[0x4210] = Model->_5A22;
	  CPU.Flags &= ~NMI_FLAG;
	  Timings.NMITriggerPos = 0xffff;

	  // derby stallion is bad.
	  //S9xClearIRQ (PPU_IRQ_SOURCE);

	  ICPU.Frame++;
	  PPU.HVBeamCounterLatched = 0;
	  CPU.Flags |= SCAN_KEYS_FLAG;
#ifdef DEBUGGER
	  if (!(CPU.Flags & FRAME_ADVANCE_FLAG))
#endif
	    S9xSyncSpeed ();
	}

      // From byuu:
      // In non-interlace mode, there are 341 dots per scanline, and 262 scanlines per frame.
      // On odd frames, scanline 240 is one dot short.
      // In interlace mode, there are always 341 dots per scanline. Even frames have 263 scanlines,
      // and odd frames have 262 scanlines.
      // Interlace mode scanline 240 on odd frames is not missing a dot.
      if (CPU.V_Counter == 240 && !IPPU.Interlace && Timings.InterlaceField)	// V=240
	Timings.H_Max = Timings.H_Max_Master - ONE_DOT_CYCLE;	// HC=1360
      else
	Timings.H_Max = Timings.H_Max_Master;					// HC=1364

      if (Model->_5A22 == 2)
	{
	  if (CPU.V_Counter != 240 || IPPU.Interlace || !Timings.InterlaceField)	// V=240
	    {
	      if (Timings.WRAMRefreshPos == SNES_WRAM_REFRESH_HC_v2 - ONE_DOT_CYCLE)	// HC=534
		Timings.WRAMRefreshPos = SNES_WRAM_REFRESH_HC_v2;					// HC=538
	      else
		Timings.WRAMRefreshPos = SNES_WRAM_REFRESH_HC_v2 - ONE_DOT_CYCLE;	// HC=534
	    }
	}
      else
	Timings.WRAMRefreshPos = SNES_WRAM_REFRESH_HC_v1;

      EXT.Clock += Timings.H_Max;

      S9xCheckMissingHTimerPosition(0);
      S9xSetVIRQ (CPU.V_Counter);

      CPU.NextEvent = -1;
      //ICPU.Scanline++;
      break;

    case HC_HDMA_INIT_EVENT:
      S9xCheckMissingHTimerPosition(Timings.HDMAInit);
      if (CPU.V_Counter == 0)
	S9xStartHDMA();
      break;

    case HC_RENDER_EVENT:
      S9xCheckMissingHTimerPosition(Timings.RenderPos);
      if (CPU.V_Counter >= FIRST_VISIBLE_LINE && CPU.V_Counter < PPU.ScreenHeight + FIRST_VISIBLE_LINE)
	RenderLine((uint8) (CPU.V_Counter - FIRST_VISIBLE_LINE));
      break;

    case HC_WRAM_REFRESH_EVENT:
      S9xCheckMissingHTimerRange (Timings.WRAMRefreshPos, SNES_WRAM_REFRESH_CYCLES);
      if(!CPU.InDMAorHDMA)
	CPU.Cycles += SNES_WRAM_REFRESH_CYCLES;
      break;

    case HC_IRQ_1_3_EVENT:
    case HC_IRQ_3_5_EVENT:
    case HC_IRQ_5_7_EVENT:
    case HC_IRQ_7_9_EVENT:
    case HC_IRQ_9_A_EVENT:
    case HC_IRQ_A_1_EVENT:
      S9xCheckMissingHTimerPosition(PPU.HTimerPosition);
      break;
    }
  S9xReschedule ();
}

