/***********************************************************************************
  Snes9x - Portable Super Nintendo Entertainment System (TM) emulator.

  (c) Copyright 1996 - 2002  Gary Henderson (gary.henderson@ntlworld.com),
                             Jerremy Koot (jkoot@snes9x.com)

  (c) Copyright 2002 - 2004  Matthew Kendora

  (c) Copyright 2002 - 2005  Peter Bortas (peter@bortas.org)

  (c) Copyright 2004 - 2005  Joel Yliluoma (http://iki.fi/bisqwit/)

  (c) Copyright 2001 - 2006  John Weidman (jweidman@slip.net)

  (c) Copyright 2002 - 2006  funkyass (funkyass@spam.shaw.ca),
                             Kris Bleakley (codeviolation@hotmail.com)

  (c) Copyright 2002 - 2010  Brad Jorsch (anomie@users.sourceforge.net),
                             Nach (n-a-c-h@users.sourceforge.net),
                             zones (kasumitokoduck@yahoo.com)

  (c) Copyright 2006 - 2007  nitsuja

  (c) Copyright 2009 - 2010  BearOso,
                             OV2


  BS-X C emulator code
  (c) Copyright 2005 - 2006  Dreamer Nom,
                             zones

  C4 x86 assembler and some C emulation code
  (c) Copyright 2000 - 2003  _Demo_ (_demo_@zsnes.com),
                             Nach,
                             zsKnight (zsknight@zsnes.com)

  C4 C++ code
  (c) Copyright 2003 - 2006  Brad Jorsch,
                             Nach

  DSP-1 emulator code
  (c) Copyright 1998 - 2006  _Demo_,
                             Andreas Naive (andreasnaive@gmail.com),
                             Gary Henderson,
                             Ivar (ivar@snes9x.com),
                             John Weidman,
                             Kris Bleakley,
                             Matthew Kendora,
                             Nach,
                             neviksti (neviksti@hotmail.com)

  DSP-2 emulator code
  (c) Copyright 2003         John Weidman,
                             Kris Bleakley,
                             Lord Nightmare (lord_nightmare@users.sourceforge.net),
                             Matthew Kendora,
                             neviksti

  DSP-3 emulator code
  (c) Copyright 2003 - 2006  John Weidman,
                             Kris Bleakley,
                             Lancer,
                             z80 gaiden

  DSP-4 emulator code
  (c) Copyright 2004 - 2006  Dreamer Nom,
                             John Weidman,
                             Kris Bleakley,
                             Nach,
                             z80 gaiden

  OBC1 emulator code
  (c) Copyright 2001 - 2004  zsKnight,
                             pagefault (pagefault@zsnes.com),
                             Kris Bleakley
                             Ported from x86 assembler to C by sanmaiwashi

  SPC7110 and RTC C++ emulator code used in 1.39-1.51
  (c) Copyright 2002         Matthew Kendora with research by
                             zsKnight,
                             John Weidman,
                             Dark Force

  SPC7110 and RTC C++ emulator code used in 1.52+
  (c) Copyright 2009         byuu,
                             neviksti

  S-DD1 C emulator code
  (c) Copyright 2003         Brad Jorsch with research by
                             Andreas Naive,
                             John Weidman

  S-RTC C emulator code
  (c) Copyright 2001 - 2006  byuu,
                             John Weidman

  ST010 C++ emulator code
  (c) Copyright 2003         Feather,
                             John Weidman,
                             Kris Bleakley,
                             Matthew Kendora

  Super FX x86 assembler emulator code
  (c) Copyright 1998 - 2003  _Demo_,
                             pagefault,
                             zsKnight

  Super FX C emulator code
  (c) Copyright 1997 - 1999  Ivar,
                             Gary Henderson,
                             John Weidman

  Sound emulator code used in 1.5-1.51
  (c) Copyright 1998 - 2003  Brad Martin
  (c) Copyright 1998 - 2006  Charles Bilyue'

  Sound emulator code used in 1.52+
  (c) Copyright 2004 - 2007  Shay Green (gblargg@gmail.com)

  SH assembler code partly based on x86 assembler code
  (c) Copyright 2002 - 2004  Marcus Comstedt (marcus@mc.pp.se)

  2xSaI filter
  (c) Copyright 1999 - 2001  Derek Liauw Kie Fa

  HQ2x, HQ3x, HQ4x filters
  (c) Copyright 2003         Maxim Stepin (maxim@hiend3d.com)

  NTSC filter
  (c) Copyright 2006 - 2007  Shay Green

  GTK+ GUI code
  (c) Copyright 2004 - 2010  BearOso

  Win32 GUI code
  (c) Copyright 2003 - 2006  blip,
                             funkyass,
                             Matthew Kendora,
                             Nach,
                             nitsuja
  (c) Copyright 2009 - 2010  OV2

  Mac OS GUI code
  (c) Copyright 1998 - 2001  John Stiles
  (c) Copyright 2001 - 2010  zones


  Specific ports contains the works of other authors. See headers in
  individual files.


  Snes9x homepage: http://www.snes9x.com/

  Permission to use, copy, modify and/or distribute Snes9x in both binary
  and source form, for non-commercial purposes, is hereby granted without
  fee, providing that this license information and copyright notice appear
  with all copies and any derived work.

  This software is provided 'as-is', without any express or implied
  warranty. In no event shall the authors be held liable for any damages
  arising from the use of this software or it's derivatives.

  Snes9x is freeware for PERSONAL USE only. Commercial users should
  seek permission of the copyright holders first. Commercial use includes,
  but is not limited to, charging money for Snes9x or software derived from
  Snes9x, including Snes9x or derivatives in commercial game bundles, and/or
  using Snes9x as a promotion for your commercial product.

  The copyright holders request that bug fixes and improvements to the code
  should be forwarded to them so everyone can benefit from the modifications
  in future versions.

  Super NES and Super Nintendo Entertainment System are trademarks of
  Nintendo Co., Limited and its subsidiary companies.
 ***********************************************************************************/
#include "snes9x.h"
#include "memmap.h"
#include "cpuops.h"
#include "dma.h"
//#include "apu/apu.h"
#include "apu_orig.h"
#include "snesapu.h"
#include "fxemu.h"
#include "snapshot.h"
#ifdef DEBUGGER
#include "debug.h"
#include "missing.h"
#endif

static bool8 exit_loop;

//"HIOUDEN" "ZAN3 SFC"
void scpu_sync()
{
  if(APU.Cycles - CPU.Cycles <= ONE_CYCLE)
    return;

  APU.scpu_sync = TRUE;
  S9xMainLoop ();
  APU.scpu_sync = FALSE;
}

void S9xMainLoop (void)
{
  for (;;) {
    bool8 exec_int = FALSE;

#ifdef DEBUG_MAXCOUNT
    CPU.GlobalLoopCount++;
    if(Settings.MaxCount && CPU.GlobalLoopCount == Settings.MaxCount)
      {
	fprintf(stderr, "Max loop count reached: %ld \n", Settings.MaxCount);
	S9xExit();
      }
#endif
    if (CPU.Flags)
      {
#ifdef DEBUGGER
	if ((CPU.Flags & BREAK_FLAG) && !(CPU.Flags & SINGLE_STEP_FLAG))
	  {
	    for (int Break = 0; Break != 6; Break++)
	      {
		if (S9xBreakpoint[Break].Enabled &&
		    S9xBreakpoint[Break].Bank == Registers.PB &&
		    S9xBreakpoint[Break].Address == Registers.PCw) {
		  if (S9xBreakpoint[Break].Enabled == 2)
		    S9xBreakpoint[Break].Enabled = TRUE;
		  else
		    CPU.Flags |= DEBUG_MODE_FLAG;
		}
	      }
	  }
#endif

#ifdef DEBUGGER
	if (CPU.Flags & DEBUG_MODE_FLAG)
	  {
	    if(APU.scpu_sync)
	      exit_loop = TRUE;
	    else
	      break;
	  }
#endif

	if (CPU.Flags & SCAN_KEYS_FLAG)
	  {
	    CPU.Flags &= ~SCAN_KEYS_FLAG;
	    if(APU.scpu_sync)
	      exit_loop = TRUE;
	    else
	      break;
	  }

#ifdef DEBUGGER
	if (CPU.Flags & TRACE_FLAG)
	  S9xTrace ();

	if (CPU.Flags & SINGLE_STEP_FLAG)
	  {
	    CPU.Flags &= ~SINGLE_STEP_FLAG;
	    CPU.Flags |= DEBUG_MODE_FLAG;
	  }
#endif

	if (CPU.Flags & NMI_FLAG)
	  {
	    if (Timings.NMITriggerPos <= CPU.Cycles)
	      {
		CPU.Flags &= ~NMI_FLAG;
		Timings.NMITriggerPos = 0xffff;
		if (CPU.WaitingForInterrupt)
		  {
		    CPU.WaitingForInterrupt = FALSE;
		    Registers.PCw++;
		  }
		S9xOpcode_NMI ();
		exec_int = TRUE;
	      }
	  }

	if (CPU.Flags & IRQ_FLAG)
	  {
	    if (CPU.IRQPending == 0)
	      {
		if (CPU.WaitingForInterrupt)
		  {
		    CPU.WaitingForInterrupt = FALSE;
		    Registers.PCw++;
		  }
		if (CPU.IRQActive)
		  {
		    if (!CheckFlag (IRQ) && !Settings.DisableIRQ)
		      {
			S9xOpcode_IRQ ();
			exec_int = TRUE;
		      }
		  }
		else
		  CPU.Flags &= ~IRQ_FLAG;
	      }
	    else if(--CPU.IRQPending == 0 && CheckFlag (IRQ))
	      {
#if 0
		// "Mystic Quest"
		if (CPU.WaitingForInterrupt)
		  {
		    CPU.WaitingForInterrupt = FALSE;
		    Registers.PCw++;
		  }
#endif
		CPU.IRQPending = 1;
	      }
	  }

      } // if (CPU.Flags)
    
    if(!exec_int && CPU.Cycles <= APU.Cycles)
      {
#ifdef CPU_SHUTDOWN
	CPU.PBPCAtOpcodeStart = Registers.PBPC;
#endif

	register uint8				Op;
	register struct	SOpcodes	*Opcodes;

	CPU.PrevCycles = CPU.Cycles;

	if (CPU.PCBase)
	  {
	    Op = CPU.PCBase[Registers.PCw];
	    CPU.Cycles += CPU.MemSpeed;
	    Opcodes = ICPU.S9xOpcodes;
	  }
	else
	  {
	    Op = S9xGetByte(Registers.PBPC);
	    OpenBus = Op;
	    Opcodes = S9xOpcodesSlow;
	  }

	if ((Registers.PCw & MEMMAP_MASK) + ICPU.S9xOpLengths[Op] >= MEMMAP_BLOCK_SIZE)
	  {
	    uint8	*oldPCBase = CPU.PCBase;
	  
	    CPU.PCBase = S9xGetBasePointer(ICPU.ShiftedPB + ((uint16) (Registers.PCw + 4)));
	    if (oldPCBase != CPU.PCBase || (Registers.PCw & ~MEMMAP_MASK) == (0xffff & ~MEMMAP_MASK))
	      Opcodes = S9xOpcodesSlow;
	  }
      
	Registers.PCw++;
	(*Opcodes[Op].S9xOpcode)();
      }

    if (SA1.Executing)
      S9xSA1MainLoop ();

    if (CPU.Cycles >= CPU.NextEvent)
      S9xDoHEventProcessing ();

    if(APU.scpu_sync)
      return;

    S9xAPUMainLoop ();

    if(exit_loop)
      {
	exit_loop = FALSE;
	break;
      }
  } // for (;;)
}

