/***********************************************************************************
  Snes9x - Portable Super Nintendo Entertainment System (TM) emulator.

  (c) Copyright 1996 - 2002  Gary Henderson (gary.henderson@ntlworld.com),
                             Jerremy Koot (jkoot@snes9x.com)

  (c) Copyright 2002 - 2004  Matthew Kendora

  (c) Copyright 2002 - 2005  Peter Bortas (peter@bortas.org)

  (c) Copyright 2004 - 2005  Joel Yliluoma (http://iki.fi/bisqwit/)

  (c) Copyright 2001 - 2006  John Weidman (jweidman@slip.net)

  (c) Copyright 2002 - 2006  funkyass (funkyass@spam.shaw.ca),
                             Kris Bleakley (codeviolation@hotmail.com)

  (c) Copyright 2002 - 2010  Brad Jorsch (anomie@users.sourceforge.net),
                             Nach (n-a-c-h@users.sourceforge.net),
                             zones (kasumitokoduck@yahoo.com)

  (c) Copyright 2006 - 2007  nitsuja

  (c) Copyright 2009 - 2010  BearOso,
                             OV2


  BS-X C emulator code
  (c) Copyright 2005 - 2006  Dreamer Nom,
                             zones

  C4 x86 assembler and some C emulation code
  (c) Copyright 2000 - 2003  _Demo_ (_demo_@zsnes.com),
                             Nach,
                             zsKnight (zsknight@zsnes.com)

  C4 C++ code
  (c) Copyright 2003 - 2006  Brad Jorsch,
                             Nach

  DSP-1 emulator code
  (c) Copyright 1998 - 2006  _Demo_,
                             Andreas Naive (andreasnaive@gmail.com),
                             Gary Henderson,
                             Ivar (ivar@snes9x.com),
                             John Weidman,
                             Kris Bleakley,
                             Matthew Kendora,
                             Nach,
                             neviksti (neviksti@hotmail.com)

  DSP-2 emulator code
  (c) Copyright 2003         John Weidman,
                             Kris Bleakley,
                             Lord Nightmare (lord_nightmare@users.sourceforge.net),
                             Matthew Kendora,
                             neviksti

  DSP-3 emulator code
  (c) Copyright 2003 - 2006  John Weidman,
                             Kris Bleakley,
                             Lancer,
                             z80 gaiden

  DSP-4 emulator code
  (c) Copyright 2004 - 2006  Dreamer Nom,
                             John Weidman,
                             Kris Bleakley,
                             Nach,
                             z80 gaiden

  OBC1 emulator code
  (c) Copyright 2001 - 2004  zsKnight,
                             pagefault (pagefault@zsnes.com),
                             Kris Bleakley
                             Ported from x86 assembler to C by sanmaiwashi

  SPC7110 and RTC C++ emulator code used in 1.39-1.51
  (c) Copyright 2002         Matthew Kendora with research by
                             zsKnight,
                             John Weidman,
                             Dark Force

  SPC7110 and RTC C++ emulator code used in 1.52+
  (c) Copyright 2009         byuu,
                             neviksti

  S-DD1 C emulator code
  (c) Copyright 2003         Brad Jorsch with research by
                             Andreas Naive,
                             John Weidman

  S-RTC C emulator code
  (c) Copyright 2001 - 2006  byuu,
                             John Weidman

  ST010 C++ emulator code
  (c) Copyright 2003         Feather,
                             John Weidman,
                             Kris Bleakley,
                             Matthew Kendora

  Super FX x86 assembler emulator code
  (c) Copyright 1998 - 2003  _Demo_,
                             pagefault,
                             zsKnight

  Super FX C emulator code
  (c) Copyright 1997 - 1999  Ivar,
                             Gary Henderson,
                             John Weidman

  Sound emulator code used in 1.5-1.51
  (c) Copyright 1998 - 2003  Brad Martin
  (c) Copyright 1998 - 2006  Charles Bilyue'

  Sound emulator code used in 1.52+
  (c) Copyright 2004 - 2007  Shay Green (gblargg@gmail.com)

  SH assembler code partly based on x86 assembler code
  (c) Copyright 2002 - 2004  Marcus Comstedt (marcus@mc.pp.se)

  2xSaI filter
  (c) Copyright 1999 - 2001  Derek Liauw Kie Fa

  HQ2x, HQ3x, HQ4x filters
  (c) Copyright 2003         Maxim Stepin (maxim@hiend3d.com)

  NTSC filter
  (c) Copyright 2006 - 2007  Shay Green

  GTK+ GUI code
  (c) Copyright 2004 - 2010  BearOso

  Win32 GUI code
  (c) Copyright 2003 - 2006  blip,
                             funkyass,
                             Matthew Kendora,
                             Nach,
                             nitsuja
  (c) Copyright 2009 - 2010  OV2

  Mac OS GUI code
  (c) Copyright 1998 - 2001  John Stiles
  (c) Copyright 2001 - 2010  zones


  Specific ports contains the works of other authors. See headers in
  individual files.


  Snes9x homepage: http://www.snes9x.com/

  Permission to use, copy, modify and/or distribute Snes9x in both binary
  and source form, for non-commercial purposes, is hereby granted without
  fee, providing that this license information and copyright notice appear
  with all copies and any derived work.

  This software is provided 'as-is', without any express or implied
  warranty. In no event shall the authors be held liable for any damages
  arising from the use of this software or it's derivatives.

  Snes9x is freeware for PERSONAL USE only. Commercial users should
  seek permission of the copyright holders first. Commercial use includes,
  but is not limited to, charging money for Snes9x or software derived from
  Snes9x, including Snes9x or derivatives in commercial game bundles, and/or
  using Snes9x as a promotion for your commercial product.

  The copyright holders request that bug fixes and improvements to the code
  should be forwarded to them so everyone can benefit from the modifications
  in future versions.

  Super NES and Super Nintendo Entertainment System are trademarks of
  Nintendo Co., Limited and its subsidiary companies.
 ***********************************************************************************/


#include "snes9x.h"
#include "memmap.h"
//#include "apu/apu.h"

// for "Magic WDM" features
#ifdef DEBUGGER	
#include "snapshot.h"
#include "display.h"
#include "debug.h"
#include "missing.h"
#endif

START_EXTERN_C
extern uint8 A1, A2, A3, A4, W1, W2, W3, W4;
extern uint8 Ans8;
extern uint16 Ans16;
extern uint32 Ans32;
extern uint8 Work8;
extern uint16 Work16;
extern uint32 Work32;
extern signed char Int8;
extern short Int16;
extern long Int32;
END_EXTERN_C

#ifdef SA1_OPCODES
#define AddCycles(n)	{ }
#else
#define AddCycles(n)	CPU.Cycles += n
#endif

#include "cpuaddr.h"
#include "cpuops.h"
#include "cpumacro.h"
#include "cpuaddr_old.h"//old
#include "cpumacro_old.h"//old
#include "apu_orig.h"//old

/* ADC *************************************************************************************** */
static void Op69M1 (void)
{
    Immediate8_old (READ);
    ADC8_old ();
}

static void Op69M0 (void)
{
    Immediate16_old (READ);
    ADC16_old ();
}

static void Op69Slow (void)
{
	if (CheckMemory())
		ADC(Immediate8Slow(READ));
	else
		ADC(Immediate16Slow(READ));
}

static void Op65M1 (void)
{
    Direct_old (READ);
    ADC8_old ();
}

static void Op65M0 (void)
{
    Direct_old (READ);
    ADC16_old ();
}

rOPM (65Slow,   DirectSlow,                       WRAP_BANK, ADC)

static void Op75E1 (void)
{
    DirectIndexedX_old (READ);
    ADC8_old ();
}

static void Op75E0M1 (void)
{
    DirectIndexedX_old (READ);
    ADC8_old ();
}

static void Op75E0M0 (void)
{
    DirectIndexedX_old (READ);
    ADC16_old ();
}

rOPM (75Slow,   DirectIndexedXSlow,               WRAP_BANK, ADC)

static void Op72E1 (void)
{
    DirectIndirect_old (READ);
    ADC8_old ();
}

static void Op72E0M1 (void)
{
    DirectIndirect_old (READ);
    ADC8_old ();
}

static void Op72E0M0 (void)
{
    DirectIndirect_old (READ);
    ADC16_old ();
}

rOPM (72Slow,   DirectIndirectSlow,               WRAP_NONE, ADC)

static void Op61E1 (void)
{
    DirectIndexedIndirect_old (READ);
    ADC8_old ();
}

static void Op61E0M1 (void)
{
    DirectIndexedIndirect_old (READ);
    ADC8_old ();
}

static void Op61E0M0 (void)
{
    DirectIndexedIndirect_old (READ);
    ADC16_old ();
}

rOPM (61Slow,   DirectIndexedIndirectSlow,        WRAP_NONE, ADC)

static void Op71E1 (void)
{
    DirectIndirectIndexed_old (READ);
    ADC8_old ();
}

static void Op71E0M1X1 (void)
{
    DirectIndirectIndexed_old (READ);
    ADC8_old ();
}

static void Op71E0M0X1 (void)
{
    DirectIndirectIndexed_old (READ);
    ADC16_old ();
}

static void Op71E0M1X0 (void)
{
    DirectIndirectIndexed_old (READ);
    ADC8_old ();
}

static void Op71E0M0X0 (void)
{
    DirectIndirectIndexed_old (READ);
    ADC16_old ();
}

rOPM (71Slow,   DirectIndirectIndexedSlow,        WRAP_NONE, ADC)

static void Op67M1 (void)
{
    DirectIndirectLong_old (READ);
    ADC8_old ();
}

static void Op67M0 (void)
{
    DirectIndirectLong_old (READ);
    ADC16_old ();
}

rOPM (67Slow,   DirectIndirectLongSlow,           WRAP_NONE, ADC)

static void Op77M1 (void)
{
    DirectIndirectIndexedLong_old (READ);
    ADC8_old ();
}

static void Op77M0 (void)
{
    DirectIndirectIndexedLong_old (READ);
    ADC16_old ();
}

rOPM (77Slow,   DirectIndirectIndexedLongSlow,    WRAP_NONE, ADC)

static void Op6DM1 (void)
{
    Absolute_old (READ);
    ADC8_old ();
}

static void Op6DM0 (void)
{
    Absolute_old (READ);
    ADC16_old ();
}

rOPM (6DSlow,   AbsoluteSlow,                     WRAP_NONE, ADC)

static void Op7DM1X1 (void)
{
    AbsoluteIndexedX_old (READ);
    ADC8_old ();
}

static void Op7DM0X1 (void)
{
    AbsoluteIndexedX_old (READ);
    ADC16_old ();
}

static void Op7DM1X0 (void)
{
    AbsoluteIndexedX_old (READ);
    ADC8_old ();
}

static void Op7DM0X0 (void)
{
    AbsoluteIndexedX_old (READ);
    ADC16_old ();
}

rOPM (7DSlow,   AbsoluteIndexedXSlow,             WRAP_NONE, ADC)

static void Op79M1X1 (void)
{
    AbsoluteIndexedY_old (READ);
    ADC8_old ();
}

static void Op79M0X1 (void)
{
    AbsoluteIndexedY_old (READ);
    ADC16_old ();
}

static void Op79M1X0 (void)
{
    AbsoluteIndexedY_old (READ);
    ADC8_old ();
}

static void Op79M0X0 (void)
{
    AbsoluteIndexedY_old (READ);
    ADC16_old ();
}
rOPM (79Slow,   AbsoluteIndexedYSlow,             WRAP_NONE, ADC)

static void Op6FM1 (void)
{
    AbsoluteLong_old (READ);
    ADC8_old ();
}

static void Op6FM0 (void)
{
    AbsoluteLong_old (READ);
    ADC16_old ();
}

rOPM (6FSlow,   AbsoluteLongSlow,                 WRAP_NONE, ADC)

static void Op7FM1 (void)
{
    AbsoluteLongIndexedX_old (READ);
    ADC8_old ();
}

static void Op7FM0 (void)
{
    AbsoluteLongIndexedX_old (READ);
    ADC16_old ();
}

rOPM (7FSlow,   AbsoluteLongIndexedXSlow,         WRAP_NONE, ADC)

static void Op63M1 (void)
{
    StackRelative_old (READ);
    ADC8_old ();
}

static void Op63M0 (void)
{
    StackRelative_old (READ);
    ADC16_old ();
}

rOPM (63Slow,   StackRelativeSlow,                WRAP_NONE, ADC)

static void Op73M1 (void)
{
    StackRelativeIndirectIndexed_old (READ);
    ADC8_old ();
}

static void Op73M0 (void)
{
    StackRelativeIndirectIndexed_old (READ);
    ADC16_old ();
}

rOPM (73Slow,   StackRelativeIndirectIndexedSlow, WRAP_NONE, ADC)

/**********************************************************************************************/

/* AND *************************************************************************************** */
static void Op29M1 (void)
{
    Registers.AL &= S9xGetByte(ICPU.ShiftedPB + Registers.PCw++);
    SetZN8_old (Registers.AL);
}

static void Op29M0 (void)
{
    Registers.A.W &= S9xGetWord(ICPU.ShiftedPB + Registers.PCw);
    Registers.PCw += 2;
    SetZN16_old (Registers.A.W);
}

static void Op29Slow (void)
{
	if (CheckMemory())
	{
		Registers.AL &= Immediate8Slow(READ);
		SetZN(Registers.AL);
	}
	else
	{
		Registers.A.W &= Immediate16Slow(READ);
		SetZN(Registers.A.W);
	}
}

static void Op25M1 (void)
{
    Direct_old (READ);
    AND8_old ();
}

static void Op25M0 (void)
{
    Direct_old (READ);
    AND16_old ();
}

rOPM (25Slow,   DirectSlow,                       WRAP_BANK, AND)

static void Op35E1 (void)
{
    DirectIndexedX_old (READ);
    AND8_old ();
}

static void Op35E0M1 (void)
{
    DirectIndexedX_old (READ);
    AND8_old ();
}

static void Op35E0M0 (void)
{
    DirectIndexedX_old (READ);
    AND16_old ();
}

rOPM (35Slow,   DirectIndexedXSlow,               WRAP_BANK, AND)

static void Op32E1 (void)
{
    DirectIndirect_old (READ);
    AND8_old ();
}

static void Op32E0M1 (void)
{
    DirectIndirect_old (READ);
    AND8_old ();
}

static void Op32E0M0 (void)
{
    DirectIndirect_old (READ);
    AND16_old ();
}

rOPM (32Slow,   DirectIndirectSlow,               WRAP_NONE, AND)

static void Op21E1 (void)
{
    DirectIndexedIndirect_old (READ);
    AND8_old ();
}

static void Op21E0M1 (void)
{
    DirectIndexedIndirect_old (READ);
    AND8_old ();
}

static void Op21E0M0 (void)
{
    DirectIndexedIndirect_old (READ);
    AND16_old ();
}

rOPM (21Slow,   DirectIndexedIndirectSlow,        WRAP_NONE, AND)

static void Op31E1 (void)
{
    DirectIndirectIndexed_old (READ);
    AND8_old ();
}

static void Op31E0M1X1 (void)
{
    DirectIndirectIndexed_old (READ);
    AND8_old ();
}

static void Op31E0M0X1 (void)
{
    DirectIndirectIndexed_old (READ);
    AND16_old ();
}

static void Op31E0M1X0 (void)
{
    DirectIndirectIndexed_old (READ);
    AND8_old ();
}

static void Op31E0M0X0 (void)
{
    DirectIndirectIndexed_old (READ);
    AND16_old ();
}

rOPM (31Slow,   DirectIndirectIndexedSlow,        WRAP_NONE, AND)

static void Op27M1 (void)
{
    DirectIndirectLong_old (READ);
    AND8_old ();
}

static void Op27M0 (void)
{
    DirectIndirectLong_old (READ);
    AND16_old ();
}

rOPM (27Slow,   DirectIndirectLongSlow,           WRAP_NONE, AND)

static void Op37M1 (void)
{
    DirectIndirectIndexedLong_old (READ);
    AND8_old ();
}

static void Op37M0 (void)
{
    DirectIndirectIndexedLong_old (READ);
    AND16_old ();
}

rOPM (37Slow,   DirectIndirectIndexedLongSlow,    WRAP_NONE, AND)

static void Op2DM1 (void)
{
    Absolute_old (READ);
    AND8_old ();
}

static void Op2DM0 (void)
{
    Absolute_old (READ);
    AND16_old ();
}

rOPM (2DSlow,   AbsoluteSlow,                     WRAP_NONE, AND)

static void Op3DM1X1 (void)
{
    AbsoluteIndexedX_old (READ);
    AND8_old ();
}

static void Op3DM0X1 (void)
{
    AbsoluteIndexedX_old (READ);
    AND16_old ();
}

static void Op3DM1X0 (void)
{
    AbsoluteIndexedX_old (READ);
    AND8_old ();
}

static void Op3DM0X0 (void)
{
    AbsoluteIndexedX_old (READ);
    AND16_old ();
}

rOPM (3DSlow,   AbsoluteIndexedXSlow,             WRAP_NONE, AND)

static void Op39M1X1 (void)
{
    AbsoluteIndexedY_old (READ);
    AND8_old ();
}

static void Op39M0X1 (void)
{
    AbsoluteIndexedY_old (READ);
    AND16_old ();
}

static void Op39M1X0 (void)
{
    AbsoluteIndexedY_old (READ);
    AND8_old ();
}

static void Op39M0X0 (void)
{
    AbsoluteIndexedY_old (READ);
    AND16_old ();
}

rOPM (39Slow,   AbsoluteIndexedYSlow,             WRAP_NONE, AND)

static void Op2FM1 (void)
{
    AbsoluteLong_old (READ);
    AND8_old ();
}

static void Op2FM0 (void)
{
    AbsoluteLong_old (READ);
    AND16_old ();
}

rOPM (2FSlow,   AbsoluteLongSlow,                 WRAP_NONE, AND)

static void Op3FM1 (void)
{
    AbsoluteLongIndexedX_old (READ);
    AND8_old ();
}

static void Op3FM0 (void)
{
    AbsoluteLongIndexedX_old (READ);
    AND16_old ();
}

rOPM (3FSlow,   AbsoluteLongIndexedXSlow,         WRAP_NONE, AND)

static void Op23M1 (void)
{
    StackRelative_old (READ);
    AND8_old ();
}

static void Op23M0 (void)
{
    StackRelative_old (READ);
    AND16_old ();
}

rOPM (23Slow,   StackRelativeSlow,                WRAP_NONE, AND)

static void Op33M1 (void)
{
    StackRelativeIndirectIndexed_old (READ);
    AND8_old ();
}

static void Op33M0 (void)
{
    StackRelativeIndirectIndexed_old (READ);
    AND16_old ();
}

rOPM (33Slow,   StackRelativeIndirectIndexedSlow, WRAP_NONE, AND)

/**********************************************************************************************/

/* ASL *************************************************************************************** */
static void Op0AM1 (void)
{
    A_ASL8_old ();
}

static void Op0AM0 (void)
{
    A_ASL16_old ();
}

static void Op0ASlow (void)
{
	AddCycles(ONE_CYCLE);

	if (CheckMemory())
	{
		ICPU._Carry = (Registers.AL & 0x80) != 0;
		Registers.AL <<= 1;
		SetZN(Registers.AL);
	}
	else
	{
		ICPU._Carry = (Registers.AH & 0x80) != 0;
		Registers.A.W <<= 1;
		SetZN(Registers.A.W);
	}
}

static void Op06M1 (void)
{
    Direct_old (MODIFY);
    ASL8_old ();
}

static void Op06M0 (void)
{
    Direct_old (MODIFY);
    ASL16_old ();
}

mOPM (06Slow,   DirectSlow,                       WRAP_BANK, ASL)

static void Op16E1 (void)
{
    DirectIndexedX_old (MODIFY);
    ASL8_old ();
}

static void Op16E0M1 (void)
{
    DirectIndexedX_old (MODIFY);
    ASL8_old ();
}

static void Op16E0M0 (void)
{
    DirectIndexedX_old (MODIFY);
    ASL16_old ();
}

mOPM (16Slow,   DirectIndexedXSlow,               WRAP_BANK, ASL)

static void Op0EM1 (void)
{
    Absolute_old (MODIFY);
    ASL8_old ();
}

static void Op0EM0 (void)
{
    Absolute_old (MODIFY);
    ASL16_old ();
}

mOPM (0ESlow,   AbsoluteSlow,                     WRAP_NONE, ASL)

static void Op1EM1X1 (void)
{
    AbsoluteIndexedX_old (MODIFY);
    ASL8_old ();
}

static void Op1EM0X1 (void)
{
    AbsoluteIndexedX_old (MODIFY);
    ASL16_old ();
}

static void Op1EM1X0 (void)
{
    AbsoluteIndexedX_old (MODIFY);
    ASL8_old ();
}

static void Op1EM0X0 (void)
{
    AbsoluteIndexedX_old (MODIFY);
    ASL16_old ();
}

mOPM (1ESlow,   AbsoluteIndexedXSlow,             WRAP_NONE, ASL)

/**********************************************************************************************/

/* BIT *************************************************************************************** */
static void Op89M1 (void)
{
    ICPU._Zero = Registers.AL & S9xGetByte(ICPU.ShiftedPB + Registers.PCw++);
}

static void Op89M0 (void)
{
    ICPU._Zero = (Registers.A.W & S9xGetWord(ICPU.ShiftedPB + Registers.PCw)) != 0;
    Registers.PCw += 2;
}

static void Op89Slow (void)
{
	if (CheckMemory())
		ICPU._Zero = Registers.AL & Immediate8Slow(READ);
	else
		ICPU._Zero = (Registers.A.W & Immediate16Slow(READ)) != 0;
}

static void Op24M1 (void)
{
    Direct_old (READ);
    BIT8_old ();
}

static void Op24M0 (void)
{
    Direct_old (READ);
    BIT16_old ();
}

rOPM (24Slow,   DirectSlow,                       WRAP_BANK, BIT)

static void Op34E1 (void)
{
    DirectIndexedX_old (READ);
    BIT8_old ();
}

static void Op34E0M1 (void)
{
    DirectIndexedX_old (READ);
    BIT8_old ();
}

static void Op34E0M0 (void)
{
    DirectIndexedX_old (READ);
    BIT16_old ();
}

rOPM (34Slow,   DirectIndexedXSlow,               WRAP_BANK, BIT)

static void Op2CM1 (void)
{
    Absolute_old (READ);
    BIT8_old ();
}

static void Op2CM0 (void)
{
    Absolute_old (READ);
    BIT16_old ();
}

rOPM (2CSlow,   AbsoluteSlow,                     WRAP_NONE, BIT)

static void Op3CM1X1 (void)
{
    AbsoluteIndexedX_old (READ);
    BIT8_old ();
}

static void Op3CM0X1 (void)
{
    AbsoluteIndexedX_old (READ);
    BIT16_old ();
}

static void Op3CM1X0 (void)
{
    AbsoluteIndexedX_old (READ);
    BIT8_old ();
}

static void Op3CM0X0 (void)
{
    AbsoluteIndexedX_old (READ);
    BIT16_old ();
}

rOPM (3CSlow,   AbsoluteIndexedXSlow,             WRAP_NONE, BIT)

/**********************************************************************************************/

/* CMP *************************************************************************************** */
static void OpC9M1 (void)
{
    Int32 = (int) Registers.AL - (int) S9xGetByte(ICPU.ShiftedPB + Registers.PCw++);
    ICPU._Carry = Int32 >= 0;
    SetZN8_old ((uint8) Int32);
}

static void OpC9M0 (void)
{
    Int32 = (long) Registers.A.W - (long) S9xGetWord(ICPU.ShiftedPB + Registers.PCw);
    Registers.PCw += 2;
    ICPU._Carry = Int32 >= 0;
    SetZN16_old ((uint16) Int32);
}

static void OpC9Slow (void)
{
	if (CheckMemory())
	{
		int16	Int16 = (int16) Registers.AL - (int16) Immediate8Slow(READ);
		ICPU._Carry = Int16 >= 0;
		SetZN((uint8) Int16);
	}
	else
	{
		int32	Int32 = (int32) Registers.A.W - (int32) Immediate16Slow(READ);
		ICPU._Carry = Int32 >= 0;
		SetZN((uint16) Int32);
	}
}

static void OpC5M1 (void)
{
    Direct_old (READ);
    CMP8_old ();
}

static void OpC5M0 (void)
{
    Direct_old (READ);
    CMP16_old ();
}

rOPM (C5Slow,   DirectSlow,                       WRAP_BANK, CMP)

static void OpD5E1 (void)
{
    DirectIndexedX_old (READ);
    CMP8_old ();
}

static void OpD5E0M1 (void)
{
    DirectIndexedX_old (READ);
    CMP8_old ();
}

static void OpD5E0M0 (void)
{
    DirectIndexedX_old (READ);
    CMP16_old ();
}

rOPM (D5Slow,   DirectIndexedXSlow,               WRAP_BANK, CMP)

static void OpD2E1 (void)
{
    DirectIndirect_old (READ);
    CMP8_old ();
}

static void OpD2E0M1 (void)
{
    DirectIndirect_old (READ);
    CMP8_old ();
}

static void OpD2E0M0 (void)
{
    DirectIndirect_old (READ);
    CMP16_old ();
}

rOPM (D2Slow,   DirectIndirectSlow,               WRAP_NONE, CMP)

static void OpC1E1 (void)
{
    DirectIndexedIndirect_old (READ);
    CMP8_old ();
}

static void OpC1E0M1 (void)
{
    DirectIndexedIndirect_old (READ);
    CMP8_old ();
}

static void OpC1E0M0 (void)
{
    DirectIndexedIndirect_old (READ);
    CMP16_old ();
}

rOPM (C1Slow,   DirectIndexedIndirectSlow,        WRAP_NONE, CMP)

static void OpD1E1 (void)
{
    DirectIndirectIndexed_old (READ);
    CMP8_old ();
}

static void OpD1E0M1X1 (void)
{
    DirectIndirectIndexed_old (READ);
    CMP8_old ();
}

static void OpD1E0M0X1 (void)
{
    DirectIndirectIndexed_old (READ);
    CMP16_old ();
}

static void OpD1E0M1X0 (void)
{
    DirectIndirectIndexed_old (READ);
    CMP8_old ();
}

static void OpD1E0M0X0 (void)
{
    DirectIndirectIndexed_old (READ);
    CMP16_old ();
}

rOPM (D1Slow,   DirectIndirectIndexedSlow,        WRAP_NONE, CMP)

static void OpC7M1 (void)
{
    DirectIndirectLong_old (READ);
    CMP8_old ();
}

static void OpC7M0 (void)
{
    DirectIndirectLong_old (READ);
    CMP16_old ();
}

rOPM (C7Slow,   DirectIndirectLongSlow,           WRAP_NONE, CMP)

static void OpD7M1 (void)
{
    DirectIndirectIndexedLong_old (READ);
    CMP8_old ();
}

static void OpD7M0 (void)
{
    DirectIndirectIndexedLong_old (READ);
    CMP16_old ();
}

rOPM (D7Slow,   DirectIndirectIndexedLongSlow,    WRAP_NONE, CMP)

static void OpCDM1 (void)
{
    Absolute_old (READ);
    CMP8_old ();
}

static void OpCDM0 (void)
{
    Absolute_old (READ);
    CMP16_old ();
}

rOPM (CDSlow,   AbsoluteSlow,                     WRAP_NONE, CMP)

static void OpDDM1X1 (void)
{
    AbsoluteIndexedX_old (READ);
    CMP8_old ();
}

static void OpDDM0X1 (void)
{
    AbsoluteIndexedX_old (READ);
    CMP16_old ();
}

static void OpDDM1X0 (void)
{
    AbsoluteIndexedX_old (READ);
    CMP8_old ();
}

static void OpDDM0X0 (void)
{
    AbsoluteIndexedX_old (READ);
    CMP16_old ();
}

rOPM (DDSlow,   AbsoluteIndexedXSlow,             WRAP_NONE, CMP)

static void OpD9M1X1 (void)
{
    AbsoluteIndexedY_old (READ);
    CMP8_old ();
}

static void OpD9M0X1 (void)
{
    AbsoluteIndexedY_old (READ);
    CMP16_old ();
}

static void OpD9M1X0 (void)
{
    AbsoluteIndexedY_old (READ);
    CMP8_old ();
}

static void OpD9M0X0 (void)
{
    AbsoluteIndexedY_old (READ);
    CMP16_old ();
}

rOPM (D9Slow,   AbsoluteIndexedYSlow,             WRAP_NONE, CMP)

static void OpCFM1 (void)
{
    AbsoluteLong_old (READ);
    CMP8_old ();
}

static void OpCFM0 (void)
{
    AbsoluteLong_old (READ);
    CMP16_old ();
}

rOPM (CFSlow,   AbsoluteLongSlow,                 WRAP_NONE, CMP)

static void OpDFM1 (void)
{
    AbsoluteLongIndexedX_old (READ);
    CMP8_old ();
}

static void OpDFM0 (void)
{
    AbsoluteLongIndexedX_old (READ);
    CMP16_old ();
}

rOPM (DFSlow,   AbsoluteLongIndexedXSlow,         WRAP_NONE, CMP)

static void OpC3M1 (void)
{
    StackRelative_old (READ);
    CMP8_old ();
}

static void OpC3M0 (void)
{
    StackRelative_old (READ);
    CMP16_old ();
}

rOPM (C3Slow,   StackRelativeSlow,                WRAP_NONE, CMP)

static void OpD3M1 (void)
{
    StackRelativeIndirectIndexed_old (READ);
    CMP8_old ();
}

static void OpD3M0 (void)
{
    StackRelativeIndirectIndexed_old (READ);
    CMP16_old ();
}

rOPM (D3Slow,   StackRelativeIndirectIndexedSlow, WRAP_NONE, CMP)

/**********************************************************************************************/

/* CMX *************************************************************************************** */
static void OpE0X1 (void)
{
    Int32 = (int) Registers.XL - (int) S9xGetByte(ICPU.ShiftedPB + Registers.PCw++);
    ICPU._Carry = Int32 >= 0;
    SetZN8_old ((uint8) Int32);
}

static void OpE0X0 (void)
{
    Int32 = (long) Registers.X.W - (long) S9xGetWord(ICPU.ShiftedPB + Registers.PCw);
    Registers.PCw += 2;
    ICPU._Carry = Int32 >= 0;
    SetZN16_old ((uint16) Int32);
}

static void OpE0Slow (void)
{
	if (CheckIndex())
	{
		int16	Int16 = (int16) Registers.XL - (int16) Immediate8Slow(READ);
		ICPU._Carry = Int16 >= 0;
		SetZN((uint8) Int16);
	}
	else
	{
		int32	Int32 = (int32) Registers.X.W - (int32) Immediate16Slow(READ);
		ICPU._Carry = Int32 >= 0;
		SetZN((uint16) Int32);
	}
}

static void OpE4X1 (void)
{
    Direct_old (READ);
    CMX8_old ();
}

static void OpE4X0 (void)
{
    Direct_old (READ);
    CMX16_old ();
}

rOPX (E4Slow,   DirectSlow,                       WRAP_BANK, CPX)

static void OpECX1 (void)
{
    Absolute_old (READ);
    CMX8_old ();
}

static void OpECX0 (void)
{
    Absolute_old (READ);
    CMX16_old ();
}

rOPX (ECSlow,   AbsoluteSlow,                     WRAP_NONE, CPX)

/**********************************************************************************************/

/* CPY *************************************************************************************** */
static void OpC0X1 (void)
{
    Int32 = (int) Registers.YL - (int) S9xGetByte(ICPU.ShiftedPB + Registers.PCw++);
    ICPU._Carry = Int32 >= 0;
    SetZN8_old ((uint8) Int32);
}

static void OpC0X0 (void)
{
    Int32 = (long) Registers.Y.W - (long) S9xGetWord(ICPU.ShiftedPB + Registers.PCw);
    Registers.PCw += 2;
    ICPU._Carry = Int32 >= 0;
    SetZN16_old ((uint16) Int32);
}

static void OpC0Slow (void)
{
	if (CheckIndex())
	{
		int16	Int16 = (int16) Registers.YL - (int16) Immediate8Slow(READ);
		ICPU._Carry = Int16 >= 0;
		SetZN((uint8) Int16);
	}
	else
	{
		int32	Int32 = (int32) Registers.Y.W - (int32) Immediate16Slow(READ);
		ICPU._Carry = Int32 >= 0;
		SetZN((uint16) Int32);
	}
}

static void OpC4X1 (void)
{
    Direct_old (READ);
    CMY8_old ();
}

static void OpC4X0 (void)
{
    Direct_old (READ);
    CMY16_old ();
}

rOPX (C4Slow,   DirectSlow,                       WRAP_BANK, CPY)

static void OpCCX1 (void)
{
    Absolute_old (READ);
    CMY8_old ();
}

static void OpCCX0 (void)
{
    Absolute_old (READ);
    CMY16_old ();
}

rOPX (CCSlow,   AbsoluteSlow,                     WRAP_NONE, CPY)

/**********************************************************************************************/

/* DEC *************************************************************************************** */
static void Op3AM1 (void)
{
    A_DEC8_old ();
}

static void Op3AM0 (void)
{
    A_DEC16_old ();
}

static void Op3ASlow (void)
{
	AddCycles(ONE_CYCLE);
#ifdef CPU_SHUTDOWN
#ifndef SA1_OPCODES
	CPU.WaitAddress = 0xffffffff;
	CPU.WaitCounter = 1;
#endif
#endif

	if (CheckMemory())
	{
		Registers.AL--;
		SetZN(Registers.AL);
	}
	else
	{
		Registers.A.W--;
		SetZN(Registers.A.W);
	}
}

static void OpC6M1 (void)
{
    Direct_old (MODIFY);
    DEC8_old ();
}

static void OpC6M0 (void)
{
    Direct_old (MODIFY);
    DEC16_old ();
}

mOPM (C6Slow,   DirectSlow,                       WRAP_BANK, DEC)

static void OpD6E1 (void)
{
    DirectIndexedX_old (MODIFY);
    DEC8_old ();
}

static void OpD6E0M1 (void)
{
    DirectIndexedX_old (MODIFY);
    DEC8_old ();
}

static void OpD6E0M0 (void)
{
    DirectIndexedX_old (MODIFY);
    DEC16_old ();
}

mOPM (D6Slow,   DirectIndexedXSlow,               WRAP_BANK, DEC)

static void OpCEM1 (void)
{
    Absolute_old (MODIFY);
    DEC8_old ();
}

static void OpCEM0 (void)
{
    Absolute_old (MODIFY);
    DEC16_old ();
}

mOPM (CESlow,   AbsoluteSlow,                     WRAP_NONE, DEC)

static void OpDEM1X1 (void)
{
    AbsoluteIndexedX_old (MODIFY);
    DEC8_old ();
}

static void OpDEM0X1 (void)
{
    AbsoluteIndexedX_old (MODIFY);
    DEC16_old ();
}

static void OpDEM1X0 (void)
{
    AbsoluteIndexedX_old (MODIFY);
    DEC8_old ();
}

static void OpDEM0X0 (void)
{
    AbsoluteIndexedX_old (MODIFY);
    DEC16_old ();
}

mOPM (DESlow,   AbsoluteIndexedXSlow,             WRAP_NONE, DEC)

/**********************************************************************************************/

/* EOR *************************************************************************************** */
static void Op49M1 (void)
{
    Registers.AL ^= S9xGetByte(ICPU.ShiftedPB + Registers.PCw++);
    SetZN8_old (Registers.AL);
}

static void Op49M0 (void)
{
    Registers.A.W ^= S9xGetWord(ICPU.ShiftedPB + Registers.PCw);
    Registers.PCw += 2;
    SetZN16_old (Registers.A.W);
}

static void Op49Slow (void)
{
	if (CheckMemory())
	{
		Registers.AL ^= Immediate8Slow(READ);
		SetZN(Registers.AL);
	}
	else
	{
		Registers.A.W ^= Immediate16Slow(READ);
		SetZN(Registers.A.W);
	}
}

static void Op45M1 (void)
{
    Direct_old (READ);
    EOR8_old ();
}

static void Op45M0 (void)
{
    Direct_old (READ);
    EOR16_old ();
}

rOPM (45Slow,   DirectSlow,                       WRAP_BANK, EOR)

static void Op55E1 (void)
{
    DirectIndexedX_old (READ);
    EOR8_old ();
}

static void Op55E0M1 (void)
{
    DirectIndexedX_old (READ);
    EOR8_old ();
}

static void Op55E0M0 (void)
{
    DirectIndexedX_old (READ);
    EOR16_old ();
}

rOPM (55Slow,   DirectIndexedXSlow,               WRAP_BANK, EOR)

static void Op52E1 (void)
{
    DirectIndirect_old (READ);
    EOR8_old ();
}

static void Op52E0M1 (void)
{
    DirectIndirect_old (READ);
    EOR8_old ();
}

static void Op52E0M0 (void)
{
    DirectIndirect_old (READ);
    EOR16_old ();
}

rOPM (52Slow,   DirectIndirectSlow,               WRAP_NONE, EOR)

static void Op41E1 (void)
{
    DirectIndexedIndirect_old (READ);
    EOR8_old ();
}

static void Op41E0M1 (void)
{
    DirectIndexedIndirect_old (READ);
    EOR8_old ();
}

static void Op41E0M0 (void)
{
    DirectIndexedIndirect_old (READ);
    EOR16_old ();
}

rOPM (41Slow,   DirectIndexedIndirectSlow,        WRAP_NONE, EOR)

static void Op51E1 (void)
{
    DirectIndirectIndexed_old (READ);
    EOR8_old ();
}

static void Op51E0M1X1 (void)
{
    DirectIndirectIndexed_old (READ);
    EOR8_old ();
}

static void Op51E0M0X1 (void)
{
    DirectIndirectIndexed_old (READ);
    EOR16_old ();
}

static void Op51E0M1X0 (void)
{
    DirectIndirectIndexed_old (READ);
    EOR8_old ();
}

static void Op51E0M0X0 (void)
{
    DirectIndirectIndexed_old (READ);
    EOR16_old ();
}

rOPM (51Slow,   DirectIndirectIndexedSlow,        WRAP_NONE, EOR)

static void Op47M1 (void)
{
    DirectIndirectLong_old (READ);
    EOR8_old ();
}

static void Op47M0 (void)
{
    DirectIndirectLong_old (READ);
    EOR16_old ();
}

rOPM (47Slow,   DirectIndirectLongSlow,           WRAP_NONE, EOR)

static void Op57M1 (void)
{
    DirectIndirectIndexedLong_old (READ);
    EOR8_old ();
}

static void Op57M0 (void)
{
    DirectIndirectIndexedLong_old (READ);
    EOR16_old ();
}

rOPM (57Slow,   DirectIndirectIndexedLongSlow,    WRAP_NONE, EOR)

static void Op4DM1 (void)
{
    Absolute_old (READ);
    EOR8_old ();
}

static void Op4DM0 (void)
{
    Absolute_old (READ);
    EOR16_old ();
}

rOPM (4DSlow,   AbsoluteSlow,                     WRAP_NONE, EOR)

static void Op5DM1X1 (void)
{
    AbsoluteIndexedX_old (READ);
    EOR8_old ();
}

static void Op5DM0X1 (void)
{
    AbsoluteIndexedX_old (READ);
    EOR16_old ();
}

static void Op5DM1X0 (void)
{
    AbsoluteIndexedX_old (READ);
    EOR8_old ();
}

static void Op5DM0X0 (void)
{
    AbsoluteIndexedX_old (READ);
    EOR16_old ();
}

rOPM (5DSlow,   AbsoluteIndexedXSlow,             WRAP_NONE, EOR)

static void Op59M1X1 (void)
{
    AbsoluteIndexedY_old (READ);
    EOR8_old ();
}

static void Op59M0X1 (void)
{
    AbsoluteIndexedY_old (READ);
    EOR16_old ();
}

static void Op59M1X0 (void)
{
    AbsoluteIndexedY_old (READ);
    EOR8_old ();
}

static void Op59M0X0 (void)
{
    AbsoluteIndexedY_old (READ);
    EOR16_old ();
}

rOPM (59Slow,   AbsoluteIndexedYSlow,             WRAP_NONE, EOR)

static void Op4FM1 (void)
{
    AbsoluteLong_old (READ);
    EOR8_old ();
}

static void Op4FM0 (void)
{
    AbsoluteLong_old (READ);
    EOR16_old ();
}

rOPM (4FSlow,   AbsoluteLongSlow,                 WRAP_NONE, EOR)

static void Op5FM1 (void)
{
    AbsoluteLongIndexedX_old (READ);
    EOR8_old ();
}

static void Op5FM0 (void)
{
    AbsoluteLongIndexedX_old (READ);
    EOR16_old ();
}

rOPM (5FSlow,   AbsoluteLongIndexedXSlow,         WRAP_NONE, EOR)

static void Op43M1 (void)
{
    StackRelative_old (READ);
    EOR8_old ();
}

static void Op43M0 (void)
{
    StackRelative_old (READ);
    EOR16_old ();
}

rOPM (43Slow,   StackRelativeSlow,                WRAP_NONE, EOR)

static void Op53M1 (void)
{
    StackRelativeIndirectIndexed_old (READ);
    EOR8_old ();
}

static void Op53M0 (void)
{
    StackRelativeIndirectIndexed_old (READ);
    EOR16_old ();
}

rOPM (53Slow,   StackRelativeIndirectIndexedSlow, WRAP_NONE, EOR)

/**********************************************************************************************/

/* INC *************************************************************************************** */
static void Op1AM1 (void)
{
    A_INC8_old ();
}

static void Op1AM0 (void)
{
    A_INC16_old ();
}

static void Op1ASlow (void)
{
	AddCycles(ONE_CYCLE);
#ifdef CPU_SHUTDOWN
#ifndef SA1_OPCODES
	CPU.WaitAddress = 0xffffffff;
	CPU.WaitCounter = 1;
#endif
#endif

	if (CheckMemory())
	{
		Registers.AL++;
		SetZN(Registers.AL);
	}
	else
	{
		Registers.A.W++;
		SetZN(Registers.A.W);
	}
}

static void OpE6M1 (void)
{
    Direct_old (MODIFY);
    INC8_old ();
}

static void OpE6M0 (void)
{
    Direct_old (MODIFY);
    INC16_old ();
}
mOPM (E6Slow,   DirectSlow,                       WRAP_BANK, INC)

static void OpF6E1 (void)
{
    DirectIndexedX_old (MODIFY);
    INC8_old ();
}

static void OpF6E0M1 (void)
{
    DirectIndexedX_old (MODIFY);
    INC8_old ();
}

static void OpF6E0M0 (void)
{
    DirectIndexedX_old (MODIFY);
    INC16_old ();
}

mOPM (F6Slow,   DirectIndexedXSlow,               WRAP_BANK, INC)

static void OpEEM1 (void)
{
    Absolute_old (MODIFY);
    INC8_old ();
}

static void OpEEM0 (void)
{
    Absolute_old (MODIFY);
    INC16_old ();
}

mOPM (EESlow,   AbsoluteSlow,                     WRAP_NONE, INC)

static void OpFEM1X1 (void)
{
    AbsoluteIndexedX_old (MODIFY);
    INC8_old ();
}

static void OpFEM0X1 (void)
{
    AbsoluteIndexedX_old (MODIFY);
    INC16_old ();
}

static void OpFEM1X0 (void)
{
    AbsoluteIndexedX_old (MODIFY);
    INC8_old ();
}

static void OpFEM0X0 (void)
{
    AbsoluteIndexedX_old (MODIFY);
    INC16_old ();
}

mOPM (FESlow,   AbsoluteIndexedXSlow,             WRAP_NONE, INC)

/**********************************************************************************************/
/* LDA *************************************************************************************** */
static void OpA9M1 (void)
{
    Registers.AL = S9xGetByte(ICPU.ShiftedPB + Registers.PCw++);
    SetZN8_old (Registers.AL);
}

static void OpA9M0 (void)
{
    Registers.A.W = S9xGetWord(ICPU.ShiftedPB + Registers.PCw);
    Registers.PCw += 2;
    SetZN16_old (Registers.A.W);
}

static void OpA9Slow (void)
{
	if (CheckMemory())
	{
		Registers.AL = Immediate8Slow(READ);
		SetZN(Registers.AL);
	}
	else
	{
		Registers.A.W = Immediate16Slow(READ);
		SetZN(Registers.A.W);
	}
}

static void OpA5M1 (void)
{
    Direct_old (READ);
    LDA8_old ();
}

static void OpA5M0 (void)
{
    Direct_old (READ);
    LDA16_old ();
}

rOPM (A5Slow,   DirectSlow,                       WRAP_BANK, LDA)

static void OpB5E1 (void)
{
    DirectIndexedX_old (READ);
    LDA8_old ();
}

static void OpB5E0M1 (void)
{
    DirectIndexedX_old (READ);
    LDA8_old ();
}

static void OpB5E0M0 (void)
{
    DirectIndexedX_old (READ);
    LDA16_old ();
}

rOPM (B5Slow,   DirectIndexedXSlow,               WRAP_BANK, LDA)

static void OpB2E1 (void)
{
    DirectIndirect_old (READ);
    LDA8_old ();
}

static void OpB2E0M1 (void)
{
    DirectIndirect_old (READ);
    LDA8_old ();
}

static void OpB2E0M0 (void)
{
    DirectIndirect_old (READ);
    LDA16_old ();
}

rOPM (B2Slow,   DirectIndirectSlow,               WRAP_NONE, LDA)

static void OpA1E1 (void)
{
    DirectIndexedIndirect_old (READ);
    LDA8_old ();
}

static void OpA1E0M1 (void)
{
    DirectIndexedIndirect_old (READ);
    LDA8_old ();
}

static void OpA1E0M0 (void)
{
    DirectIndexedIndirect_old (READ);
    LDA16_old ();
}

rOPM (A1Slow,   DirectIndexedIndirectSlow,        WRAP_NONE, LDA)

static void OpB1E1 (void)
{
    DirectIndirectIndexed_old (READ);
    LDA8_old ();
}

static void OpB1E0M1X1 (void)
{
    DirectIndirectIndexed_old (READ);
    LDA8_old ();
}

static void OpB1E0M0X1 (void)
{
    DirectIndirectIndexed_old (READ);
    LDA16_old ();
}

static void OpB1E0M1X0 (void)
{
    DirectIndirectIndexed_old (READ);
    LDA8_old ();
}

static void OpB1E0M0X0 (void)
{
    DirectIndirectIndexed_old (READ);
    LDA16_old ();
}

rOPM (B1Slow,   DirectIndirectIndexedSlow,        WRAP_NONE, LDA)

static void OpA7M1 (void)
{
    DirectIndirectLong_old (READ);
    LDA8_old ();
}

static void OpA7M0 (void)
{
    DirectIndirectLong_old (READ);
    LDA16_old ();
}

rOPM (A7Slow,   DirectIndirectLongSlow,           WRAP_NONE, LDA)

static void OpB7M1 (void)
{
    DirectIndirectIndexedLong_old (READ);
    LDA8_old ();
}

static void OpB7M0 (void)
{
    DirectIndirectIndexedLong_old (READ);
    LDA16_old ();
}

rOPM (B7Slow,   DirectIndirectIndexedLongSlow,    WRAP_NONE, LDA)

static void OpADM1 (void)
{
    Absolute_old (READ);
    LDA8_old ();
}

static void OpADM0 (void)
{
    Absolute_old (READ);
    LDA16_old ();
}

rOPM (ADSlow,   AbsoluteSlow,                     WRAP_NONE, LDA)

static void OpBDM1X1 (void)
{
    AbsoluteIndexedX_old (READ);
    LDA8_old ();
}

static void OpBDM0X1 (void)
{
    AbsoluteIndexedX_old (READ);
    LDA16_old ();
}

static void OpBDM1X0 (void)
{
    AbsoluteIndexedX_old (READ);
    LDA8_old ();
}

static void OpBDM0X0 (void)
{
    AbsoluteIndexedX_old (READ);
    LDA16_old ();
}

rOPM (BDSlow,   AbsoluteIndexedXSlow,             WRAP_NONE, LDA)

static void OpB9M1X1 (void)
{
    AbsoluteIndexedY_old (READ);
    LDA8_old ();
}

static void OpB9M0X1 (void)
{
    AbsoluteIndexedY_old (READ);
    LDA16_old ();
}

static void OpB9M1X0 (void)
{
    AbsoluteIndexedY_old (READ);
    LDA8_old ();
}

static void OpB9M0X0 (void)
{
    AbsoluteIndexedY_old (READ);
    LDA16_old ();
}

rOPM (B9Slow,   AbsoluteIndexedYSlow,             WRAP_NONE, LDA)

static void OpAFM1 (void)
{
    AbsoluteLong_old (READ);
    LDA8_old ();
}

static void OpAFM0 (void)
{
    AbsoluteLong_old (READ);
    LDA16_old ();
}

rOPM (AFSlow,   AbsoluteLongSlow,                 WRAP_NONE, LDA)

static void OpBFM1 (void)
{
    AbsoluteLongIndexedX_old (READ);
    LDA8_old ();
}

static void OpBFM0 (void)
{
    AbsoluteLongIndexedX_old (READ);
    LDA16_old ();
}

rOPM (BFSlow,   AbsoluteLongIndexedXSlow,         WRAP_NONE, LDA)

static void OpA3M1 (void)
{
    StackRelative_old (READ);
    LDA8_old ();
}

static void OpA3M0 (void)
{
    StackRelative_old (READ);
    LDA16_old ();
}

rOPM (A3Slow,   StackRelativeSlow,                WRAP_NONE, LDA)

static void OpB3M1 (void)
{
    StackRelativeIndirectIndexed_old (READ);
    LDA8_old ();
}

static void OpB3M0 (void)
{
    StackRelativeIndirectIndexed_old (READ);
    LDA16_old ();
}

rOPM (B3Slow,   StackRelativeIndirectIndexedSlow, WRAP_NONE, LDA)

/**********************************************************************************************/

/* LDX *************************************************************************************** */
static void OpA2X1 (void)
{
    Registers.XL = S9xGetByte(ICPU.ShiftedPB + Registers.PCw++);
    SetZN8_old (Registers.XL);
}

static void OpA2X0 (void)
{
    Registers.X.W = S9xGetWord(ICPU.ShiftedPB + Registers.PCw);
    Registers.PCw += 2;
    SetZN16_old (Registers.X.W);
}

static void OpA2Slow (void)
{
	if (CheckIndex())
	{
		Registers.XL = Immediate8Slow(READ);
		SetZN(Registers.XL);
	}
	else
	{
		Registers.X.W = Immediate16Slow(READ);
		SetZN(Registers.X.W);
	}
}

static void OpA6X1 (void)
{
    Direct_old (READ);
    LDX8_old ();
}

static void OpA6X0 (void)
{
    Direct_old (READ);
    LDX16_old ();
}

rOPX (A6Slow,   DirectSlow,                       WRAP_BANK, LDX)

static void OpB6E1 (void)
{
    DirectIndexedY_old (READ);
    LDX8_old ();
}

static void OpB6E0X1 (void)
{
    DirectIndexedY_old (READ);
    LDX8_old ();
}

static void OpB6E0X0 (void)
{
    DirectIndexedY_old (READ);
    LDX16_old ();
}

rOPX (B6Slow,   DirectIndexedYSlow,               WRAP_BANK, LDX)

static void OpAEX1 (void)
{
    Absolute_old (READ);
    LDX8_old ();
}

static void OpAEX0 (void)
{
    Absolute_old (READ);
    LDX16_old ();
}

rOPX (AESlow,   AbsoluteSlow,                     WRAP_BANK, LDX)

static void OpBEX1 (void)
{
    AbsoluteIndexedY_old (READ);
    LDX8_old ();
}

static void OpBEX0 (void)
{
    AbsoluteIndexedY_old (READ);
    LDX16_old ();
}

rOPX (BESlow,   AbsoluteIndexedYSlow,             WRAP_BANK, LDX)

/**********************************************************************************************/

/* LDY *************************************************************************************** */
static void OpA0X1 (void)
{
    Registers.YL = S9xGetByte(ICPU.ShiftedPB + Registers.PCw++);
    SetZN8_old (Registers.YL);
}

static void OpA0X0 (void)
{
    Registers.Y.W = S9xGetWord(ICPU.ShiftedPB + Registers.PCw);
    Registers.PCw += 2;
    SetZN16_old (Registers.Y.W);
}

static void OpA0Slow (void)
{
	if (CheckIndex())
	{
		Registers.YL = Immediate8Slow(READ);
		SetZN(Registers.YL);
	}
	else
	{
		Registers.Y.W = Immediate16Slow(READ);
		SetZN(Registers.Y.W);
	}
}

static void OpA4X1 (void)
{
    Direct_old (READ);
    LDY8_old ();
}

static void OpA4X0 (void)
{
    Direct_old (READ);
    LDY16_old ();
}

rOPX (A4Slow,   DirectSlow,                       WRAP_BANK, LDY)

static void OpB4E1 (void)
{
    DirectIndexedX_old (READ);
    LDY8_old ();
}

static void OpB4E0X1 (void)
{
    DirectIndexedX_old (READ);
    LDY8_old ();
}

static void OpB4E0X0 (void)
{
    DirectIndexedX_old (READ);
    LDY16_old ();
}

rOPX (B4Slow,   DirectIndexedXSlow,               WRAP_BANK, LDY)

static void OpACX1 (void)
{
    Absolute_old (READ);
    LDY8_old ();
}

static void OpACX0 (void)
{
    Absolute_old (READ);
    LDY16_old ();
}

rOPX (ACSlow,   AbsoluteSlow,                     WRAP_BANK, LDY)

static void OpBCX1 (void)
{
    AbsoluteIndexedX_old (READ);
    LDY8_old ();
}

static void OpBCX0 (void)
{
    AbsoluteIndexedX_old (READ);
    LDY16_old ();
}

rOPX (BCSlow,   AbsoluteIndexedXSlow,             WRAP_BANK, LDY)

/**********************************************************************************************/

/* LSR *************************************************************************************** */
static void Op4AM1 (void)
{
    A_LSR8_old ();
}

static void Op4AM0 (void)
{
    A_LSR16_old ();
}

static void Op4ASlow (void)
{
	AddCycles(ONE_CYCLE);

	if (CheckMemory())
	{
		ICPU._Carry = Registers.AL & 1;
		Registers.AL >>= 1;
		SetZN(Registers.AL);
	}
	else
	{
		ICPU._Carry = Registers.A.W & 1;
		Registers.A.W >>= 1;
		SetZN(Registers.A.W);
	}
}

static void Op46M1 (void)
{
    Direct_old (MODIFY);
    LSR8_old ();
}

static void Op46M0 (void)
{
    Direct_old (MODIFY);
    LSR16_old ();
}

mOPM (46Slow,   DirectSlow,                       WRAP_BANK, LSR)

static void Op56E1 (void)
{
    DirectIndexedX_old (MODIFY);
    LSR8_old ();
}

static void Op56E0M1 (void)
{
    DirectIndexedX_old (MODIFY);
    LSR8_old ();
}

static void Op56E0M0 (void)
{
    DirectIndexedX_old (MODIFY);
    LSR16_old ();
}

mOPM (56Slow,   DirectIndexedXSlow,               WRAP_BANK, LSR)

static void Op4EM1 (void)
{
    Absolute_old (MODIFY);
    LSR8_old ();
}

static void Op4EM0 (void)
{
    Absolute_old (MODIFY);
    LSR16_old ();
}

mOPM (4ESlow,   AbsoluteSlow,                     WRAP_NONE, LSR)

static void Op5EM1X1 (void)
{
    AbsoluteIndexedX_old (MODIFY);
    LSR8_old ();
}

static void Op5EM0X1 (void)
{
    AbsoluteIndexedX_old (MODIFY);
    LSR16_old ();
}

static void Op5EM1X0 (void)
{
    AbsoluteIndexedX_old (MODIFY);
    LSR8_old ();
}

static void Op5EM0X0 (void)
{
    AbsoluteIndexedX_old (MODIFY);
    LSR16_old ();
}

mOPM (5ESlow,   AbsoluteIndexedXSlow,             WRAP_NONE, LSR)

/**********************************************************************************************/

/* ORA *************************************************************************************** */
static void Op09M1 (void)
{
    Registers.AL |= S9xGetByte(ICPU.ShiftedPB + Registers.PCw++);
    SetZN8_old (Registers.AL);
}

static void Op09M0 (void)
{
    Registers.A.W |= S9xGetWord(ICPU.ShiftedPB + Registers.PCw);
    Registers.PCw += 2;
    SetZN16_old (Registers.A.W);
}

static void Op09Slow (void)
{
	if (CheckMemory())
	{
		Registers.AL |= Immediate8Slow(READ);
		SetZN(Registers.AL);
	}
	else
	{
		Registers.A.W |= Immediate16Slow(READ);
		SetZN(Registers.A.W);
	}
}

static void Op05M1 (void)
{
    Direct_old (READ);
    ORA8_old ();
}

static void Op05M0 (void)
{
    Direct_old (READ);
    ORA16_old ();
}

rOPM (05Slow,   DirectSlow,                       WRAP_BANK, ORA)

static void Op15E1 (void)
{
    DirectIndexedX_old (READ);
    ORA8_old ();
}

static void Op15E0M1 (void)
{
    DirectIndexedX_old (READ);
    ORA8_old ();
}

static void Op15E0M0 (void)
{
    DirectIndexedX_old (READ);
    ORA16_old ();
}

rOPM (15Slow,   DirectIndexedXSlow,               WRAP_BANK, ORA)

static void Op12E1 (void)
{
    DirectIndirect_old (READ);
    ORA8_old ();
}

static void Op12E0M1 (void)
{
    DirectIndirect_old (READ);
    ORA8_old ();
}

static void Op12E0M0 (void)
{
    DirectIndirect_old (READ);
    ORA16_old ();
}

rOPM (12Slow,   DirectIndirectSlow,               WRAP_NONE, ORA)

static void Op01E1 (void)
{
    DirectIndexedIndirect_old (READ);
    ORA8_old ();
}

static void Op01E0M1 (void)
{
    DirectIndexedIndirect_old (READ);
    ORA8_old ();
}

static void Op01E0M0 (void)
{
    DirectIndexedIndirect_old (READ);
    ORA16_old ();
}

rOPM (01Slow,   DirectIndexedIndirectSlow,        WRAP_NONE, ORA)

static void Op11E1 (void)
{
    DirectIndirectIndexed_old (READ);
    ORA8_old ();
}

static void Op11E0M1X1 (void)
{
    DirectIndirectIndexed_old (READ);
    ORA8_old ();
}

static void Op11E0M0X1 (void)
{
    DirectIndirectIndexed_old (READ);
    ORA16_old ();
}

static void Op11E0M1X0 (void)
{
    DirectIndirectIndexed_old (READ);
    ORA8_old ();
}

static void Op11E0M0X0 (void)
{
    DirectIndirectIndexed_old (READ);
    ORA16_old ();
}

rOPM (11Slow,   DirectIndirectIndexedSlow,        WRAP_NONE, ORA)

static void Op07M1 (void)
{
    DirectIndirectLong_old (READ);
    ORA8_old ();
}

static void Op07M0 (void)
{
    DirectIndirectLong_old (READ);
    ORA16_old ();
}

rOPM (07Slow,   DirectIndirectLongSlow,           WRAP_NONE, ORA)

static void Op17M1 (void)
{
    DirectIndirectIndexedLong_old (READ);
    ORA8_old ();
}

static void Op17M0 (void)
{
    DirectIndirectIndexedLong_old (READ);
    ORA16_old ();
}

rOPM (17Slow,   DirectIndirectIndexedLongSlow,    WRAP_NONE, ORA)

static void Op0DM1 (void)
{
    Absolute_old (READ);
    ORA8_old ();
}

static void Op0DM0 (void)
{
    Absolute_old (READ);
    ORA16_old ();
}

rOPM (0DSlow,   AbsoluteSlow,                     WRAP_NONE, ORA)

static void Op1DM1X1 (void)
{
    AbsoluteIndexedX_old (READ);
    ORA8_old ();
}

static void Op1DM0X1 (void)
{
    AbsoluteIndexedX_old (READ);
    ORA16_old ();
}

static void Op1DM1X0 (void)
{
    AbsoluteIndexedX_old (READ);
    ORA8_old ();
}

static void Op1DM0X0 (void)
{
    AbsoluteIndexedX_old (READ);
    ORA16_old ();
}

rOPM (1DSlow,   AbsoluteIndexedXSlow,             WRAP_NONE, ORA)

static void Op19M1X1 (void)
{
    AbsoluteIndexedY_old (READ);
    ORA8_old ();
}

static void Op19M0X1 (void)
{
    AbsoluteIndexedY_old (READ);
    ORA16_old ();
}

static void Op19M1X0 (void)
{
    AbsoluteIndexedY_old (READ);
    ORA8_old ();
}

static void Op19M0X0 (void)
{
    AbsoluteIndexedY_old (READ);
    ORA16_old ();
}

rOPM (19Slow,   AbsoluteIndexedYSlow,             WRAP_NONE, ORA)

static void Op0FM1 (void)
{
    AbsoluteLong_old (READ);
    ORA8_old ();
}

static void Op0FM0 (void)
{
    AbsoluteLong_old (READ);
    ORA16_old ();
}

rOPM (0FSlow,   AbsoluteLongSlow,                 WRAP_NONE, ORA)

static void Op1FM1 (void)
{
    AbsoluteLongIndexedX_old (READ);
    ORA8_old ();
}

static void Op1FM0 (void)
{
    AbsoluteLongIndexedX_old (READ);
    ORA16_old ();
}

rOPM (1FSlow,   AbsoluteLongIndexedXSlow,         WRAP_NONE, ORA)

static void Op03M1 (void)
{
    StackRelative_old (READ);
    ORA8_old ();
}

static void Op03M0 (void)
{
    StackRelative_old (READ);
    ORA16_old ();
}

rOPM (03Slow,   StackRelativeSlow,                WRAP_NONE, ORA)

static void Op13M1 (void)
{
    StackRelativeIndirectIndexed_old (READ);
    ORA8_old ();
}

static void Op13M0 (void)
{
    StackRelativeIndirectIndexed_old (READ);
    ORA16_old ();
}

rOPM (13Slow,   StackRelativeIndirectIndexedSlow, WRAP_NONE, ORA)

/**********************************************************************************************/

/* ROL *************************************************************************************** */
static void Op2AM1 (void)
{
    A_ROL8_old ();
}

static void Op2AM0 (void)
{
    A_ROL16_old ();
}

static void Op2ASlow (void)
{
	AddCycles(ONE_CYCLE);

	if (CheckMemory())
	{
		uint16	w = (((uint16) Registers.AL) << 1) | CheckCarry();
		ICPU._Carry = w >= 0x100;
		Registers.AL = (uint8) w;
		SetZN(Registers.AL);
	}
	else
	{
		uint32	w = (((uint32) Registers.A.W) << 1) | CheckCarry();
		ICPU._Carry = w >= 0x10000;
		Registers.A.W = (uint16) w;
		SetZN(Registers.A.W);
	}
}

static void Op26M1 (void)
{
    Direct_old (MODIFY);
    ROL8_old ();
}

static void Op26M0 (void)
{
    Direct_old (MODIFY);
    ROL16_old ();
}

mOPM (26Slow,   DirectSlow,                       WRAP_BANK, ROL)

static void Op36E1 (void)
{
    DirectIndexedX_old (MODIFY);
    ROL8_old ();
}

static void Op36E0M1 (void)
{
    DirectIndexedX_old (MODIFY);
    ROL8_old ();
}

static void Op36E0M0 (void)
{
    DirectIndexedX_old (MODIFY);
    ROL16_old ();
}

mOPM (36Slow,   DirectIndexedXSlow,               WRAP_BANK, ROL)

static void Op2EM1 (void)
{
    Absolute_old (MODIFY);
    ROL8_old ();
}

static void Op2EM0 (void)
{
    Absolute_old (MODIFY);
    ROL16_old ();
}

mOPM (2ESlow,   AbsoluteSlow,                     WRAP_NONE, ROL)

static void Op3EM1X1 (void)
{
    AbsoluteIndexedX_old (MODIFY);
    ROL8_old ();
}

static void Op3EM0X1 (void)
{
    AbsoluteIndexedX_old (MODIFY);
    ROL16_old ();
}

static void Op3EM1X0 (void)
{
    AbsoluteIndexedX_old (MODIFY);
    ROL8_old ();
}

static void Op3EM0X0 (void)
{
    AbsoluteIndexedX_old (MODIFY);
    ROL16_old ();
}

mOPM (3ESlow,   AbsoluteIndexedXSlow,             WRAP_NONE, ROL)

/**********************************************************************************************/

/* ROR *************************************************************************************** */
static void Op6AM1 (void)
{
    A_ROR8_old ();
}

static void Op6AM0 (void)
{
    A_ROR16_old ();
}


static void Op6ASlow (void)
{
	AddCycles(ONE_CYCLE);

	if (CheckMemory())
	{
		uint16	w = ((uint16) Registers.AL) | (((uint16) CheckCarry()) << 8);
		ICPU._Carry = w & 1;
		w >>= 1;
		Registers.AL = (uint8) w;
		SetZN(Registers.AL);
	}
	else
	{
		uint32	w = ((uint32) Registers.A.W) | (((uint32) CheckCarry()) << 16);
		ICPU._Carry = w & 1;
		w >>= 1;
		Registers.A.W = (uint16) w;
		SetZN(Registers.A.W);
	}
}

static void Op66M1 (void)
{
    Direct_old (MODIFY);
    ROR8_old ();
}

static void Op66M0 (void)
{
    Direct_old (MODIFY);
    ROR16_old ();
}

mOPM (66Slow,   DirectSlow,                       WRAP_BANK, ROR)

static void Op76E1 (void)
{
    DirectIndexedX_old (MODIFY);
    ROR8_old ();
}

static void Op76E0M1 (void)
{
    DirectIndexedX_old (MODIFY);
    ROR8_old ();
}

static void Op76E0M0 (void)
{
    DirectIndexedX_old (MODIFY);
    ROR16_old ();
}

mOPM (76Slow,   DirectIndexedXSlow,               WRAP_BANK, ROR)

static void Op6EM1 (void)
{
    Absolute_old (MODIFY);
    ROR8_old ();
}

static void Op6EM0 (void)
{
    Absolute_old (MODIFY);
    ROR16_old ();
}

mOPM (6ESlow,   AbsoluteSlow,                     WRAP_NONE, ROR)

static void Op7EM1X1 (void)
{
    AbsoluteIndexedX_old (MODIFY);
    ROR8_old ();
}

static void Op7EM0X1 (void)
{
    AbsoluteIndexedX_old (MODIFY);
    ROR16_old ();
}

static void Op7EM1X0 (void)
{
    AbsoluteIndexedX_old (MODIFY);
    ROR8_old ();
}

static void Op7EM0X0 (void)
{
    AbsoluteIndexedX_old (MODIFY);
    ROR16_old ();
}

mOPM (7ESlow,   AbsoluteIndexedXSlow,             WRAP_NONE, ROR)


/**********************************************************************************************/

/* SBC *************************************************************************************** */

static void OpE9M1 (void)
{
    Immediate8_old (READ);
    SBC8_old ();
}

static void OpE9M0 (void)
{
    Immediate16_old (READ);
    SBC16_old ();
}

static void OpE9Slow (void)
{
	if (CheckMemory())
		SBC(Immediate8Slow(READ));
	else
		SBC(Immediate16Slow(READ));
}

static void OpE5M1 (void)
{
    Direct_old (READ);
    SBC8_old ();
}

static void OpE5M0 (void)
{
    Direct_old (READ);
    SBC16_old ();
}

rOPM (E5Slow,   DirectSlow,                       WRAP_BANK, SBC)

static void OpF5E1 (void)
{
    DirectIndexedX_old (READ);
    SBC8_old ();
}

static void OpF5E0M1 (void)
{
    DirectIndexedX_old (READ);
    SBC8_old ();
}

static void OpF5E0M0 (void)
{
    DirectIndexedX_old (READ);
    SBC16_old ();
}

rOPM (F5Slow,   DirectIndexedXSlow,               WRAP_BANK, SBC)

static void OpF2E1 (void)
{
    DirectIndirect_old (READ);
    SBC8_old ();
}

static void OpF2E0M1 (void)
{
    DirectIndirect_old (READ);
    SBC8_old ();
}

static void OpF2E0M0 (void)
{
    DirectIndirect_old (READ);
    SBC16_old ();
}

rOPM (F2Slow,   DirectIndirectSlow,               WRAP_NONE, SBC)

static void OpE1E1 (void)
{
    DirectIndexedIndirect_old (READ);
    SBC8_old ();
}

static void OpE1E0M1 (void)
{
    DirectIndexedIndirect_old (READ);
    SBC8_old ();
}

static void OpE1E0M0 (void)
{
    DirectIndexedIndirect_old (READ);
    SBC16_old ();
}

rOPM (E1Slow,   DirectIndexedIndirectSlow,        WRAP_NONE, SBC)

static void OpF1E1 (void)
{
    DirectIndirectIndexed_old (READ);
    SBC8_old ();
}

static void OpF1E0M1X1 (void)
{
    DirectIndirectIndexed_old (READ);
    SBC8_old ();
}

static void OpF1E0M0X1 (void)
{
    DirectIndirectIndexed_old (READ);
    SBC16_old ();
}

static void OpF1E0M1X0 (void)
{
    DirectIndirectIndexed_old (READ);
    SBC8_old ();
}

static void OpF1E0M0X0 (void)
{
    DirectIndirectIndexed_old (READ);
    SBC16_old ();
}

rOPM (F1Slow,   DirectIndirectIndexedSlow,        WRAP_NONE, SBC)

static void OpE7M1 (void)
{
    DirectIndirectLong_old (READ);
    SBC8_old ();
}

static void OpE7M0 (void)
{
    DirectIndirectLong_old (READ);
    SBC16_old ();
}

rOPM (E7Slow,   DirectIndirectLongSlow,           WRAP_NONE, SBC)

static void OpF7M1 (void)
{
    DirectIndirectIndexedLong_old (READ);
    SBC8_old ();
}

static void OpF7M0 (void)
{
    DirectIndirectIndexedLong_old (READ);
    SBC16_old ();
}

rOPM (F7Slow,   DirectIndirectIndexedLongSlow,    WRAP_NONE, SBC)

static void OpEDM1 (void)
{
    Absolute_old (READ);
    SBC8_old ();
}

static void OpEDM0 (void)
{
    Absolute_old (READ);
    SBC16_old ();
}

rOPM (EDSlow,   AbsoluteSlow,                     WRAP_NONE, SBC)

static void OpFDM1X1 (void)
{
    AbsoluteIndexedX_old (READ);
    SBC8_old ();
}

static void OpFDM0X1 (void)
{
    AbsoluteIndexedX_old (READ);
    SBC16_old ();
}

static void OpFDM1X0 (void)
{
    AbsoluteIndexedX_old (READ);
    SBC8_old ();
}

static void OpFDM0X0 (void)
{
    AbsoluteIndexedX_old (READ);
    SBC16_old ();
}

rOPM (FDSlow,   AbsoluteIndexedXSlow,             WRAP_NONE, SBC)

static void OpF9M1X1 (void)
{
    AbsoluteIndexedY_old (READ);
    SBC8_old ();
}

static void OpF9M0X1 (void)
{
    AbsoluteIndexedY_old (READ);
    SBC16_old ();
}

static void OpF9M1X0 (void)
{
    AbsoluteIndexedY_old (READ);
    SBC8_old ();
}

static void OpF9M0X0 (void)
{
    AbsoluteIndexedY_old (READ);
    SBC16_old ();
}

rOPM (F9Slow,   AbsoluteIndexedYSlow,             WRAP_NONE, SBC)

static void OpEFM1 (void)
{
    AbsoluteLong_old (READ);
    SBC8_old ();
}

static void OpEFM0 (void)
{
    AbsoluteLong_old (READ);
    SBC16_old ();
}

rOPM (EFSlow,   AbsoluteLongSlow,                 WRAP_NONE, SBC)

static void OpFFM1 (void)
{
    AbsoluteLongIndexedX_old (READ);
    SBC8_old ();
}

static void OpFFM0 (void)
{
    AbsoluteLongIndexedX_old (READ);
    SBC16_old ();
}

rOPM (FFSlow,   AbsoluteLongIndexedXSlow,         WRAP_NONE, SBC)

static void OpE3M1 (void)
{
    StackRelative_old (READ);
    SBC8_old ();
}

static void OpE3M0 (void)
{
    StackRelative_old (READ);
    SBC16_old ();
}

rOPM (E3Slow,   StackRelativeSlow,                WRAP_NONE, SBC)

static void OpF3M1 (void)
{
    StackRelativeIndirectIndexed_old (READ);
    SBC8_old ();
}

static void OpF3M0 (void)
{
    StackRelativeIndirectIndexed_old (READ);
    SBC16_old ();
}

rOPM (F3Slow,   StackRelativeIndirectIndexedSlow, WRAP_NONE, SBC)

/**********************************************************************************************/

/* STA *************************************************************************************** */
static void Op85M1 (void)
{
    Direct_old (WRITE);
    STA8_old ();
}

static void Op85M0 (void)
{
    Direct_old (WRITE);
    STA16_old ();
}

wOPM (85Slow,   DirectSlow,                       WRAP_BANK, STA)

static void Op95E1 (void)
{
    DirectIndexedX_old (WRITE);
    STA8_old ();
}

static void Op95E0M1 (void)
{
    DirectIndexedX_old (WRITE);
    STA8_old ();
}

static void Op95E0M0 (void)
{
    DirectIndexedX_old (WRITE);
    STA16_old ();
}

wOPM (95Slow,   DirectIndexedXSlow,               WRAP_BANK, STA)

static void Op92E1 (void)
{
    DirectIndirect_old (WRITE);
    STA8_old ();
}

static void Op92E0M1 (void)
{
    DirectIndirect_old (WRITE);
    STA8_old ();
}

static void Op92E0M0 (void)
{
    DirectIndirect_old (WRITE);
    STA16_old ();
}

wOPM (92Slow,   DirectIndirectSlow,               WRAP_NONE, STA)

static void Op81E1 (void)
{
    DirectIndexedIndirect_old (WRITE);
    STA8_old ();
}

static void Op81E0M1 (void)
{
    DirectIndexedIndirect_old (WRITE);
    STA8_old ();
}

static void Op81E0M0 (void)
{
    DirectIndexedIndirect_old (WRITE);
    STA16_old ();
}

wOPM (81Slow,   DirectIndexedIndirectSlow,        WRAP_NONE, STA)

static void Op91E1 (void)
{
    DirectIndirectIndexed_old (WRITE);
    STA8_old ();
}

static void Op91E0M1X1 (void)
{
    DirectIndirectIndexed_old (WRITE);
    STA8_old ();
}

static void Op91E0M0X1 (void)
{
    DirectIndirectIndexed_old (WRITE);
    STA16_old ();
}

static void Op91E0M1X0 (void)
{
    DirectIndirectIndexed_old (WRITE);
    STA8_old ();
}

static void Op91E0M0X0 (void)
{
    DirectIndirectIndexed_old (WRITE);
    STA16_old ();
}

wOPM (91Slow,   DirectIndirectIndexedSlow,        WRAP_NONE, STA)

static void Op87M1 (void)
{
    DirectIndirectLong_old (WRITE);
    STA8_old ();
}

static void Op87M0 (void)
{
    DirectIndirectLong_old (WRITE);
    STA16_old ();
}

wOPM (87Slow,   DirectIndirectLongSlow,           WRAP_NONE, STA)

static void Op97M1 (void)
{
    DirectIndirectIndexedLong_old (WRITE);
    STA8_old ();
}

static void Op97M0 (void)
{
    DirectIndirectIndexedLong_old (WRITE);
    STA16_old ();
}

wOPM (97Slow,   DirectIndirectIndexedLongSlow,    WRAP_NONE, STA)

static void Op8DM1 (void)
{
    Absolute_old (WRITE);
    STA8_old ();
}

static void Op8DM0 (void)
{
    Absolute_old (WRITE);
    STA16_old ();
}

wOPM (8DSlow,   AbsoluteSlow,                     WRAP_NONE, STA)

static void Op9DM1X1 (void)
{
    AbsoluteIndexedX_old (WRITE);
    STA8_old ();
}

static void Op9DM0X1 (void)
{
    AbsoluteIndexedX_old (WRITE);
    STA16_old ();
}

static void Op9DM1X0 (void)
{
    AbsoluteIndexedX_old (WRITE);
    STA8_old ();
}

static void Op9DM0X0 (void)
{
    AbsoluteIndexedX_old (WRITE);
    STA16_old ();
}

wOPM (9DSlow,   AbsoluteIndexedXSlow,             WRAP_NONE, STA)

static void Op99M1X1 (void)
{
    AbsoluteIndexedY_old (WRITE);
    STA8_old ();
}

static void Op99M0X1 (void)
{
    AbsoluteIndexedY_old (WRITE);
    STA16_old ();
}

static void Op99M1X0 (void)
{
    AbsoluteIndexedY_old (WRITE);
    STA8_old ();
}

static void Op99M0X0 (void)
{
    AbsoluteIndexedY_old (WRITE);
    STA16_old ();
}

wOPM (99Slow,   AbsoluteIndexedYSlow,             WRAP_NONE, STA)

static void Op8FM1 (void)
{
    AbsoluteLong_old (WRITE);
    STA8_old ();
}

static void Op8FM0 (void)
{
    AbsoluteLong_old (WRITE);
    STA16_old ();
}

wOPM (8FSlow,   AbsoluteLongSlow,                 WRAP_NONE, STA)

static void Op9FM1 (void)
{
    AbsoluteLongIndexedX_old (WRITE);
    STA8_old ();
}

static void Op9FM0 (void)
{
    AbsoluteLongIndexedX_old (WRITE);
    STA16_old ();
}

wOPM (9FSlow,   AbsoluteLongIndexedXSlow,         WRAP_NONE, STA)

static void Op83M1 (void)
{
    StackRelative_old (WRITE);
    STA8_old ();
}

static void Op83M0 (void)
{
    StackRelative_old (WRITE);
    STA16_old ();
}

wOPM (83Slow,   StackRelativeSlow,                WRAP_NONE, STA)

static void Op93M1 (void)
{
    StackRelativeIndirectIndexed_old (WRITE);
    STA8_old ();
}

static void Op93M0 (void)
{
    StackRelativeIndirectIndexed_old (WRITE);
    STA16_old ();
}

wOPM (93Slow,   StackRelativeIndirectIndexedSlow, WRAP_NONE, STA)

/**********************************************************************************************/

/* STX *************************************************************************************** */
static void Op86X1 (void)
{
    Direct_old (WRITE);
    STX8_old ();
}

static void Op86X0 (void)
{
    Direct_old (WRITE);
    STX16_old ();
}

wOPX (86Slow,   DirectSlow,                       WRAP_BANK, STX)

static void Op96E1 (void)
{
    DirectIndexedY_old (WRITE);
    STX8_old ();
}

static void Op96E0X1 (void)
{
    DirectIndexedY_old (WRITE);
    STX8_old ();
}

static void Op96E0X0 (void)
{
    DirectIndexedY_old (WRITE);
    STX16_old ();
}

wOPX (96Slow,   DirectIndexedYSlow,               WRAP_BANK, STX)

static void Op8EX1 (void)
{
    Absolute_old (WRITE);
    STX8_old ();
}

static void Op8EX0 (void)
{
    Absolute_old (WRITE);
    STX16_old ();
}

wOPX (8ESlow,   AbsoluteSlow,                     WRAP_BANK, STX)

/**********************************************************************************************/

/* STY *************************************************************************************** */
static void Op84X1 (void)
{
    Direct_old (WRITE);
    STY8_old ();
}

static void Op84X0 (void)
{
    Direct_old (WRITE);
    STY16_old ();
}

wOPX (84Slow,   DirectSlow,                       WRAP_BANK, STY)

static void Op94E1 (void)
{
    DirectIndexedX_old (WRITE);
    STY8_old ();
}

static void Op94E0X1 (void)
{
    DirectIndexedX_old (WRITE);
    STY8_old ();
}

static void Op94E0X0 (void)
{
    DirectIndexedX_old (WRITE);
    STY16_old ();
}

wOPX (94Slow,   DirectIndexedXSlow,               WRAP_BANK, STY)

static void Op8CX1 (void)
{
    Absolute_old (WRITE);
    STY8_old ();
}

static void Op8CX0 (void)
{
    Absolute_old (WRITE);
    STY16_old ();
}

wOPX (8CSlow,   AbsoluteSlow,                     WRAP_BANK, STY)

/**********************************************************************************************/

/* STZ *************************************************************************************** */
static void Op64M1 (void)
{
    Direct_old (WRITE);
    STZ8_old ();
}

static void Op64M0 (void)
{
    Direct_old (WRITE);
    STZ16_old ();
}

wOPM (64Slow,   DirectSlow,                       WRAP_BANK, STZ)

static void Op74E1 (void)
{
    DirectIndexedX_old (WRITE);
    STZ8_old ();
}

static void Op74E0M1 (void)
{
    DirectIndexedX_old (WRITE);
    STZ8_old ();
}

static void Op74E0M0 (void)
{
    DirectIndexedX_old (WRITE);
    STZ16_old ();
}

wOPM (74Slow,   DirectIndexedXSlow,               WRAP_BANK, STZ)

static void Op9CM1 (void)
{
    Absolute_old (WRITE);
    STZ8_old ();
}

static void Op9CM0 (void)
{
    Absolute_old (WRITE);
    STZ16_old ();
}

wOPM (9CSlow,   AbsoluteSlow,                     WRAP_NONE, STZ)

static void Op9EM1X1 (void)
{
    AbsoluteIndexedX_old (WRITE);
    STZ8_old ();
}

static void Op9EM0X1 (void)
{
    AbsoluteIndexedX_old (WRITE);
    STZ16_old ();
}

static void Op9EM1X0 (void)
{
    AbsoluteIndexedX_old (WRITE);
    STZ8_old ();
}

static void Op9EM0X0 (void)
{
    AbsoluteIndexedX_old (WRITE);
    STZ16_old ();
}

wOPM (9ESlow,   AbsoluteIndexedXSlow,             WRAP_NONE, STZ)

/**********************************************************************************************/

/* TRB *************************************************************************************** */
static void Op14M1 (void)
{
    Direct_old (MODIFY);
    TRB8_old ();
}

static void Op14M0 (void)
{
    Direct_old (MODIFY);
    TRB16_old ();
}

mOPM (14Slow,   DirectSlow,                       WRAP_BANK, TRB)

static void Op1CM1 (void)
{
    Absolute_old (MODIFY);
    TRB8_old ();
}

static void Op1CM0 (void)
{
    Absolute_old (MODIFY);
    TRB16_old ();
}

mOPM (1CSlow,   AbsoluteSlow,                     WRAP_BANK, TRB)

/**********************************************************************************************/

/* TSB *************************************************************************************** */
static void Op04M1 (void)
{
    Direct_old (MODIFY);
    TSB8_old ();
}

static void Op04M0 (void)
{
    Direct_old (MODIFY);
    TSB16_old ();
}

mOPM (04Slow,   DirectSlow,                       WRAP_BANK, TSB)

static void Op0CM1 (void)
{
    Absolute_old (MODIFY);
    TSB8_old ();
}

static void Op0CM0 (void)
{
    Absolute_old (MODIFY);
    TSB16_old ();
}

mOPM (0CSlow,   AbsoluteSlow,                     WRAP_BANK, TSB)

/**********************************************************************************************/

/* Branch Instructions *********************************************************************** */

#ifdef CPU_SHUTDOWN
#ifndef SA1_OPCODES
inline void CPUShutdown()
{
  if (Settings.Shutdown && Registers.PBPC == CPU.WaitAddress)
    {
	// Don't skip cycles with a pending NMI or IRQ - could cause delayed
	// interrupt. Interrupts are delayed for a few cycles already, but
	// the delay could allow the shutdown code to cycle skip again.
	// Was causing screen flashing on Top Gear 3000.

      if (CPU.WaitCounter == 0 && 
	  !(CPU.Flags & (IRQ_FLAG | NMI_FLAG)))
	{
	  CPU.WaitAddress = 0xffffffff;
	  if (Settings.SA1)
	    S9xSA1ExecuteDuringSleep ();
	  if(CPU.Cycles < CPU.NextEvent) {
	    CPU.Cycles = CPU.NextEvent;
	    ICPU.CPUExecuting = FALSE;
	    S9xAPUMainLoop();
	    ICPU.CPUExecuting = TRUE;
	    CPU.WaitCounter = 1;//This might be unnecessary.
	  }
	}
      else
	if (CPU.WaitCounter >= 2) {
	  CPU.WaitCounter = 1;
	}
	else {
	  CPU.PrevCycles = CPU.Cycles;
	  CPU.WaitCounter--;
	}
    }
}
#else
static inline void CPUShutdown()
{
  if (Settings.Shutdown && SA1Registers.PBPC == SA1.WaitAddress)
    {
	if (SA1.WaitCounter >= 1)
	{
	    SA1.Executing = FALSE;
	    SA1.CPUExecuting = FALSE;//old
	}
	else
	    SA1.WaitCounter++;
    }
}
#endif
#else
#define CPUShutdown()
#endif

/* BCC */
static void Op90E0 (void)
{
    Relative_old (JUMP);
    if (!CheckCarry ())
    {
	Registers.PCw = OpAddress_old;
#ifndef SA1_OPCODES
	CPU.Cycles += ONE_CYCLE;
#endif
	CPUShutdown ();
    }
#ifdef CPU_SHUTDOWN
#ifndef SA1_OPCODES
	else
		CPU.WaitCounter = 1;
#endif
#endif
}

static void Op90E1 (void)
{
    Relative_old (JUMP);
    if (!CheckCarry ())
    {
	Registers.PCw = OpAddress_old;
#ifndef SA1_OPCODES
	CPU.Cycles += ONE_CYCLE;
#endif
	CPUShutdown ();
    }
#ifdef CPU_SHUTDOWN
#ifndef SA1_OPCODES
	else
		CPU.WaitCounter = 1;
#endif
#endif
}

bOP(90Slow, RelativeSlow, !CheckCarry(),    0, CheckEmulation())

/* BCS */
static void OpB0E0 (void)
{
    Relative_old (JUMP);
    if (CheckCarry ())
    {
	Registers.PCw = OpAddress_old;
#ifndef SA1_OPCODES
	CPU.Cycles += ONE_CYCLE;
#endif
	CPUShutdown ();
    }
#ifdef CPU_SHUTDOWN
#ifndef SA1_OPCODES
	else
		CPU.WaitCounter = 1;
#endif
#endif
}

static void OpB0E1 (void)
{
    Relative_old (JUMP);
    if (CheckCarry ())
    {
	Registers.PCw = OpAddress_old;
#ifndef SA1_OPCODES
	CPU.Cycles += ONE_CYCLE;
#endif
	CPUShutdown ();
    }
#ifdef CPU_SHUTDOWN
#ifndef SA1_OPCODES
	else
		CPU.WaitCounter = 1;
#endif
#endif
}

bOP(B0Slow, RelativeSlow,  CheckCarry(),    0, CheckEmulation())

/* BEQ */
static void OpF0E0 (void)
{
    Relative_old (JUMP);
    if (CheckZero ())
    {
	Registers.PCw = OpAddress_old;
#ifndef SA1_OPCODES
	CPU.Cycles += ONE_CYCLE;
#endif
	CPUShutdown ();
    }
#ifdef CPU_SHUTDOWN
#ifndef SA1_OPCODES
	else
		CPU.WaitCounter = 1;
#endif
#endif
}

static void OpF0E1 (void)
{
    Relative_old (JUMP);
    if (CheckZero ())
    {
	Registers.PCw = OpAddress_old;
#ifndef SA1_OPCODES
	CPU.Cycles += ONE_CYCLE;
#endif
	CPUShutdown ();
    }
#ifdef CPU_SHUTDOWN
#ifndef SA1_OPCODES
	else
		CPU.WaitCounter = 1;
#endif
#endif
}

bOP(F0Slow, RelativeSlow,  CheckZero(),     2, CheckEmulation())

/* BMI */
static void Op30E0 (void)
{
    Relative_old (JUMP);
    if (CheckNegative ())
    {
	Registers.PCw = OpAddress_old;
#ifndef SA1_OPCODES
	CPU.Cycles += ONE_CYCLE;
#endif
	CPUShutdown ();
    }
#ifdef CPU_SHUTDOWN
#ifndef SA1_OPCODES
	else
		CPU.WaitCounter = 1;
#endif
#endif
}

static void Op30E1 (void)
{
    Relative_old (JUMP);
    if (CheckNegative ())
    {
	Registers.PCw = OpAddress_old;
#ifndef SA1_OPCODES
	CPU.Cycles += ONE_CYCLE;
#endif
	CPUShutdown ();
    }
#ifdef CPU_SHUTDOWN
#ifndef SA1_OPCODES
	else
		CPU.WaitCounter = 1;
#endif
#endif
}

bOP(30Slow, RelativeSlow,  CheckNegative(), 1, CheckEmulation())


/* BNE */
static void OpD0E0 (void)
{
    Relative_old (JUMP);
    if (!CheckZero ())
    {
	Registers.PCw = OpAddress_old;
#ifndef SA1_OPCODES
	CPU.Cycles += ONE_CYCLE;
#endif
	CPUShutdown ();
    }
#ifdef CPU_SHUTDOWN
#ifndef SA1_OPCODES
	else
		CPU.WaitCounter = 1;
#endif
#endif
}

static void OpD0E1 (void)
{
    Relative_old (JUMP);
    if (!CheckZero ())
    {
	Registers.PCw = OpAddress_old;
#ifndef SA1_OPCODES
	CPU.Cycles += ONE_CYCLE;
#endif
	CPUShutdown ();
    }
#ifdef CPU_SHUTDOWN
#ifndef SA1_OPCODES
	else
		CPU.WaitCounter = 1;
#endif
#endif
}

bOP(D0Slow, RelativeSlow, !CheckZero(),     1, CheckEmulation())

/* BPL */
static void Op10E0 (void)
{
    Relative_old (JUMP);
    if (!CheckNegative ())
    {
	Registers.PCw = OpAddress_old;
#ifndef SA1_OPCODES
	CPU.Cycles += ONE_CYCLE;
#endif
	CPUShutdown ();
    }
#ifdef CPU_SHUTDOWN
#ifndef SA1_OPCODES
	else
		CPU.WaitCounter = 1;
#endif
#endif
}

static void Op10E1 (void)
{
    Relative_old (JUMP);
    if (!CheckNegative ())
    {
	Registers.PCw = OpAddress_old;
#ifndef SA1_OPCODES
	CPU.Cycles += ONE_CYCLE;
#endif
	CPUShutdown ();
    }
#ifdef CPU_SHUTDOWN
#ifndef SA1_OPCODES
	else
		CPU.WaitCounter = 1;
#endif
#endif
}

bOP(10Slow, RelativeSlow, !CheckNegative(), 1, CheckEmulation())

/* BRA */
static void Op80E0 (void)
{
    Relative_old (JUMP);
    Registers.PCw = OpAddress_old;
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    CPUShutdown ();
}

static void Op80E1 (void)
{
    Relative_old (JUMP);
    Registers.PCw = OpAddress_old;
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    CPUShutdown ();
}

bOP(80Slow, RelativeSlow, 1,                X, CheckEmulation())

/* BVC */
static void Op50E0 (void)
{
    Relative_old (JUMP);
    if (!CheckOverflow ())
    {
	Registers.PCw = OpAddress_old;
#ifndef SA1_OPCODES
	CPU.Cycles += ONE_CYCLE;
#endif
	CPUShutdown ();
    }
#ifdef CPU_SHUTDOWN
#ifndef SA1_OPCODES
	else
		CPU.WaitCounter = 1;
#endif
#endif
}

static void Op50E1 (void)
{
    Relative_old (JUMP);
    if (!CheckOverflow ())
    {
	Registers.PCw = OpAddress_old;
#ifndef SA1_OPCODES
	CPU.Cycles += ONE_CYCLE;
#endif
	CPUShutdown ();
    }
#ifdef CPU_SHUTDOWN
#ifndef SA1_OPCODES
	else
		CPU.WaitCounter = 1;
#endif
#endif
}

bOP(50Slow, RelativeSlow, !CheckOverflow(), 0, CheckEmulation())

/* BVS */
static void Op70E0 (void)
{
    Relative_old (JUMP);
    if (CheckOverflow ())
    {
	Registers.PCw = OpAddress_old;
#ifndef SA1_OPCODES
	CPU.Cycles += ONE_CYCLE;
#endif
	CPUShutdown ();
    }
#ifdef CPU_SHUTDOWN
#ifndef SA1_OPCODES
	else
		CPU.WaitCounter = 1;
#endif
#endif
}

static void Op70E1 (void)
{
    Relative_old (JUMP);
    if (CheckOverflow ())
    {
	Registers.PCw = OpAddress_old;
#ifndef SA1_OPCODES
	CPU.Cycles += ONE_CYCLE;
#endif
	CPUShutdown ();
    }
#ifdef CPU_SHUTDOWN
#ifndef SA1_OPCODES
	else
		CPU.WaitCounter = 1;
#endif
#endif
}

bOP(70Slow, RelativeSlow,  CheckOverflow(), 0, CheckEmulation())

// BRL
static void Op82 (void)
{
    RelativeLong_old (JUMP);
    S9xSetPCBase (ICPU.ShiftedPB + OpAddress_old);
}

static void Op82Slow (void)
{
	S9xSetPCBase(ICPU.ShiftedPB + RelativeLongSlow(JUMP));
}

/* Flag Instructions ******************************************************* */

// CLC
static void Op18 (void)
{
    ClearCarry ();
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
}

// SEC
static void Op38 (void)
{
    SetCarry ();
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
}

// CLD
static void OpD8 (void)
{
    ClearDecimal ();
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
}

// SED
static void OpF8 (void)
{
    SetDecimal ();
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
#ifdef DEBUGGER
    missing.decimal_mode = 1;
#endif
}

// CLI
static void Op58 (void)
{
#ifndef SA1_OPCODES
	CPU.Cycles += ONE_CYCLE;
#endif
	ClearIRQ ();
	/*    CHECK_FOR_IRQ(); */
}

// SEI
static void Op78 (void)
{
#ifndef SA1_OPCODES
	CPU.Cycles += ONE_CYCLE;
#endif
	SetIRQ ();
}

// CLV
static void OpB8 (void)
{
    ClearOverflow ();
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
}

/* DEX/DEY ***************************************************************** */

static void OpCAX1 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
#ifdef CPU_SHUTDOWN
#ifndef SA1_OPCODES
    CPU.WaitAddress = 0xffffffff;
	CPU.WaitCounter = 1;
#endif
#endif

    Registers.XL--;
    SetZN8_old (Registers.XL);
}

static void OpCAX0 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
#ifdef CPU_SHUTDOWN
#ifndef SA1_OPCODES
    CPU.WaitAddress = 0xffffffff;
	CPU.WaitCounter = 1;
#endif
#endif

    Registers.X.W--;
    SetZN16_old (Registers.X.W);
}

static void OpCASlow (void)
{
	AddCycles(ONE_CYCLE);
#ifdef CPU_SHUTDOWN
#ifndef SA1_OPCODES
	CPU.WaitAddress = 0xffffffff;
	CPU.WaitCounter = 1;
#endif
#endif

	if (CheckIndex())
	{
		Registers.XL--;
		SetZN(Registers.XL);
	}
	else
	{
		Registers.X.W--;
		SetZN(Registers.X.W);
	}
}

static void Op88X1 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
#ifdef CPU_SHUTDOWN
#ifndef SA1_OPCODES
    CPU.WaitAddress = 0xffffffff;
	CPU.WaitCounter = 1;
#endif
#endif

    Registers.YL--;
    SetZN8_old (Registers.YL);
}

static void Op88X0 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
#ifdef CPU_SHUTDOWN
#ifndef SA1_OPCODES
    CPU.WaitAddress = 0xffffffff;
	CPU.WaitCounter = 1;
#endif
#endif

    Registers.Y.W--;
    SetZN16_old (Registers.Y.W);
}

static void Op88Slow (void)
{
	AddCycles(ONE_CYCLE);
#ifdef CPU_SHUTDOWN
#ifndef SA1_OPCODES
	CPU.WaitAddress = 0xffffffff;
	CPU.WaitCounter = 1;
#endif
#endif

	if (CheckIndex())
	{
		Registers.YL--;
		SetZN(Registers.YL);
	}
	else
	{
		Registers.Y.W--;
		SetZN(Registers.Y.W);
	}
}

/* INX/INY ***************************************************************** */

static void OpE8X1 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
#ifdef CPU_SHUTDOWN
#ifndef SA1_OPCODES
    CPU.WaitAddress = 0xffffffff;
	CPU.WaitCounter = 1;
#endif
#endif

    Registers.XL++;
    SetZN8_old (Registers.XL);
}

static void OpE8X0 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
#ifdef CPU_SHUTDOWN
#ifndef SA1_OPCODES
    CPU.WaitAddress = 0xffffffff;
	CPU.WaitCounter = 1;
#endif
#endif

    Registers.X.W++;
    SetZN16_old (Registers.X.W);
}

static void OpE8Slow (void)
{
	AddCycles(ONE_CYCLE);
#ifdef CPU_SHUTDOWN
#ifndef SA1_OPCODES
	CPU.WaitAddress = 0xffffffff;
	CPU.WaitCounter = 1;
#endif
#endif

	if (CheckIndex())
	{
		Registers.XL++;
		SetZN(Registers.XL);
	}
	else
	{
		Registers.X.W++;
		SetZN(Registers.X.W);
	}
}

static void OpC8X1 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
#ifdef CPU_SHUTDOWN
#ifndef SA1_OPCODES
    CPU.WaitAddress = 0xffffffff;
	CPU.WaitCounter = 1;
#endif
#endif

    Registers.YL++;
    SetZN8_old (Registers.YL);
}

static void OpC8X0 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
#ifdef CPU_SHUTDOWN
#ifndef SA1_OPCODES
    CPU.WaitAddress = 0xffffffff;
	CPU.WaitCounter = 1;
#endif
#endif

    Registers.Y.W++;
    SetZN16_old (Registers.Y.W);
}

static void OpC8Slow (void)
{
	AddCycles(ONE_CYCLE);
#ifdef CPU_SHUTDOWN
#ifndef SA1_OPCODES
	CPU.WaitAddress = 0xffffffff;
	CPU.WaitCounter = 1;
#endif
#endif

	if (CheckIndex())
	{
		Registers.YL--;
		SetZN(Registers.YL);
	}
	else
	{
		Registers.Y.W--;
		SetZN(Registers.Y.W);
	}
}

/* NOP ********************************************************************* */

static void OpEA (void)
{
	AddCycles(ONE_CYCLE);
}

/* PUSH Instructions ******************************************************* */

#define PushW(w) \
    S9xSetByte ((w)>>8, Registers.S.W);\
	S9xSetByte ((w)&0xff, (Registers.S.W - 1)&0xFFFF);\
    Registers.S.W -= 2;

#define PushWE(w) \
    S9xSetByte ((w)>>8, Registers.S.W--);\
	Registers.SH=0x01;\
	S9xSetByte ((w)&0xff, (Registers.S.W--)&0xFFFF);\
    Registers.SH = 0x01;

#define PushB(b)\
    S9xSetByte (b, Registers.S.W--);

#define PushBE(b)\
	S9xSetByte (b, Registers.S.W--);\
	Registers.SH=0x01;

#define PushWENew(w) \
    S9xSetByte ((w)>>8, Registers.S.W--);\
	S9xSetByte ((w)&0xff, (Registers.S.W--)&0xFFFF);\
    Registers.SH = 0x01;

// PEA
static void OpF4E0 (void)
{
    Absolute_old (NONE);
    PushW ((unsigned short)OpAddress_old);
    OpenBus = OpAddress_old & 0xff;
}

static void OpF4E1 (void)
{
    Absolute_old (NONE);
    PushWENew ((unsigned short)OpAddress_old);
    OpenBus = OpAddress_old & 0xff;
}

static void OpF4Slow (void)
{
	uint16	val = (uint16) AbsoluteSlow(NONE);
	PushW(val);
	OpenBus = val & 0xff;
	if (CheckEmulation())
		Registers.SH = 1;
}

// PEI
static void OpD4E0 (void)
{
    DirectIndirect_old (NONE);
    PushW ((unsigned short)OpAddress_old);
    OpenBus = OpAddress_old & 0xff;
}

static void OpD4E1 (void)
{
    DirectIndirect_old (NONE);
    PushWENew ((unsigned short)OpAddress_old);
    OpenBus = OpAddress_old & 0xff;
}

static void OpD4Slow (void)
{
	uint16	val = (uint16) DirectIndirectSlow(NONE);
	PushW(val);
	OpenBus = val & 0xff;
	if (CheckEmulation())
		Registers.SH = 1;
}

// PER
static void Op62E0 (void)
{
    RelativeLong_old (NONE);
    PushW ((unsigned short)OpAddress_old);
    OpenBus = OpAddress_old & 0xff;
}

static void Op62E1 (void)
{
    RelativeLong_old (NONE);
    PushWENew ((unsigned short)OpAddress_old);
    OpenBus = OpAddress_old & 0xff;
}

static void Op62Slow (void)
{
	uint16	val = (uint16) RelativeLongSlow(NONE);
	PushW(val);
	OpenBus = val & 0xff;
	if (CheckEmulation())
		Registers.SH = 1;
}

// PHA
static void Op48E1 (void)
{
    PushBE (Registers.AL);
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    OpenBus = Registers.AL;
}

static void Op48E0M1 (void)
{
    PushB (Registers.AL);
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    OpenBus = Registers.AL;
}

static void Op48E0M0 (void)
{
    PushW (Registers.A.W);
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    OpenBus = Registers.AL;
}

static void Op48Slow (void)
{
	AddCycles(ONE_CYCLE);

	if (CheckEmulation())
	{
		PushBE(Registers.AL);
	}
	else
	if (CheckMemory())
	{
		PushB(Registers.AL);
	}
	else
	{
		PushW(Registers.A.W);
	}

	OpenBus = Registers.AL;
}

// PHB
static void Op8BE1 (void)
{
    PushBE (Registers.DB);
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    OpenBus = Registers.DB;
}

static void Op8BE0 (void)
{
    PushB (Registers.DB);
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    OpenBus = Registers.DB;
}

static void Op8BSlow (void)
{
	AddCycles(ONE_CYCLE);

	if (CheckEmulation())
	{
		PushBE(Registers.DB);
	}
	else
	{
		PushB(Registers.DB);
	}

	OpenBus = Registers.DB;
}

// PHD
static void Op0BE0 (void)
{
    PushW (Registers.D.W);
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    OpenBus = Registers.DL;
}

static void Op0BE1 (void)
{
    PushWENew (Registers.D.W);
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    OpenBus = Registers.DL;
}

static void Op0BSlow (void)
{
	AddCycles(ONE_CYCLE);
	PushW(Registers.D.W);
	OpenBus = Registers.DL;
	if (CheckEmulation())
		Registers.SH = 1;
}

// PHK
static void Op4BE1 (void)
{
    PushBE (Registers.PB);
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    OpenBus = Registers.PB;
}

static void Op4BE0 (void)
{
    PushB (Registers.PB);
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    OpenBus = Registers.PB;
}

static void Op4BSlow (void)
{
	AddCycles(ONE_CYCLE);

	if (CheckEmulation())
	{
		PushBE(Registers.PB);
	}
	else
	{
		PushB(Registers.PB);
	}

	OpenBus = Registers.PB;
}

// PHP
static void Op08E0 (void)
{
    S9xPackStatus ();
    PushB (Registers.PL);
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    OpenBus = Registers.PL;
}

static void Op08E1 (void)
{
    S9xPackStatus ();
    PushBE (Registers.PL);
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    OpenBus = Registers.PL;
}

static void Op08Slow (void)
{
	S9xPackStatus();
	AddCycles(ONE_CYCLE);

	if (CheckEmulation())
	{
		PushBE(Registers.PL);
	}
	else
	{
		PushB(Registers.PL);
	}

	OpenBus = Registers.PL;
}

// PHX
static void OpDAE1 (void)
{
    PushBE (Registers.XL);
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    OpenBus = Registers.XL;
}

static void OpDAE0X1 (void)
{
    PushB (Registers.XL);
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    OpenBus = Registers.XL;
}

static void OpDAE0X0 (void)
{
    PushW (Registers.X.W);
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    OpenBus = Registers.XL;
}

static void OpDASlow (void)
{
	AddCycles(ONE_CYCLE);

	if (CheckEmulation())
	{
		PushBE(Registers.XL);
	}
	else
	if (CheckIndex())
	{
		PushB(Registers.XL);
	}
	else
	{
		PushW(Registers.X.W);
	}

	OpenBus = Registers.XL;
}

// PHY
static void Op5AE1 (void)
{
    PushBE (Registers.YL);
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    OpenBus = Registers.YL;
}

static void Op5AE0X1 (void)
{
    PushB (Registers.YL);
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    OpenBus = Registers.YL;
}

static void Op5AE0X0 (void)
{
    PushW (Registers.Y.W);
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    OpenBus = Registers.YL;
}

static void Op5ASlow (void)
{
	AddCycles(ONE_CYCLE);

	if (CheckEmulation())
	{
		PushBE(Registers.YL);
	}
	else
	if (CheckIndex())
	{
		PushB(Registers.YL);
	}
	else
	{
		PushW(Registers.Y.W);
	}

	OpenBus = Registers.YL;
}

/* PULL Instructions ******************************************************* */

#define PullW(w) \
	w = S9xGetByte (++Registers.S.W); \
	w |= (S9xGetByte (++Registers.S.W)<<8);

/*	w = S9xGetWord (Registers.S.W + 1); \
	Registers.S.W += 2;
*/

#define PullWE(w) \
	Registers.S.W++;\
	Registers.SH=0x01;\
	w = S9xGetByte (Registers.S.W); \
	Registers.S.W++; \
	Registers.SH=0x01;\
	w |= (S9xGetByte (Registers.S.W)<<8);


#define PullB(b)\
	b = S9xGetByte (++Registers.S.W);

#define PullBE(b)\
	Registers.S.W++;\
	Registers.SH=0x01;\
	b = S9xGetByte (Registers.S.W);

#define PullWENew(w) \
	PullW(w);\
	Registers.SH=0x01;	

// PLA
static void Op68E1 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += TWO_CYCLES;
#endif
    PullBE (Registers.AL);
    SetZN8_old (Registers.AL);
    OpenBus = Registers.AL;
}

static void Op68E0M1 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += TWO_CYCLES;
#endif
    PullB (Registers.AL);
    SetZN8_old (Registers.AL);
    OpenBus = Registers.AL;
}

static void Op68E0M0 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += TWO_CYCLES;
#endif
    PullW (Registers.A.W);
    SetZN16_old (Registers.A.W);
    OpenBus = Registers.AH;
}

static void Op68Slow (void)
{
	AddCycles(TWO_CYCLES);

	if (CheckEmulation())
	{
		PullBE(Registers.AL);
		SetZN(Registers.AL);
		OpenBus = Registers.AL;
	}
	else
	if (CheckMemory())
	{
		PullB(Registers.AL);
		SetZN(Registers.AL);
		OpenBus = Registers.AL;
	}
	else
	{
		PullW(Registers.A.W);
		SetZN(Registers.A.W);
		OpenBus = Registers.AH;
	}
}

// PLB
static void OpABE1 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += TWO_CYCLES;
#endif
    PullBE (Registers.DB);
    SetZN8_old (Registers.DB);
    ICPU.ShiftedDB = Registers.DB << 16;
    OpenBus = Registers.DB;
}

static void OpABE0 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += TWO_CYCLES;
#endif
    PullB (Registers.DB);
    SetZN8_old (Registers.DB);
    ICPU.ShiftedDB = Registers.DB << 16;
    OpenBus = Registers.DB;
}

static void OpABSlow (void)
{
	AddCycles(TWO_CYCLES);

	if (CheckEmulation())
	{
		PullBE(Registers.DB);
	}
	else
	{
		PullB(Registers.DB);
	}

	SetZN(Registers.DB);
	ICPU.ShiftedDB = Registers.DB << 16;
	OpenBus = Registers.DB;
}

// PLD
static void Op2BE0 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += TWO_CYCLES;
#endif
    PullW (Registers.D.W);
    SetZN16_old (Registers.D.W);
    OpenBus = Registers.DH;
}

static void Op2BE1 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += TWO_CYCLES;
#endif
    PullWENew (Registers.D.W);
    SetZN16_old (Registers.D.W);
    OpenBus = Registers.DH;
}

static void Op2BSlow (void)
{
	AddCycles(TWO_CYCLES);
	PullW(Registers.D.W);
	SetZN(Registers.D.W);
	OpenBus = Registers.DH;
	if (CheckEmulation())
		Registers.SH = 1;
}

// PLP
static void Op28E1 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += TWO_CYCLES;
#endif
    PullBE (Registers.PL);
    OpenBus = Registers.PL;
    S9xUnpackStatus ();

    if (CheckIndex ())
    {
	Registers.XH = 0;
	Registers.YH = 0;
    }
    S9xFixCycles();

	/*     CHECK_FOR_IRQ();*/
}

static void Op28E0 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += TWO_CYCLES;
#endif
    PullB (Registers.PL);
    OpenBus = Registers.PL;
    S9xUnpackStatus ();

    if (CheckIndex ())
    {
	Registers.XH = 0;
	Registers.YH = 0;
    }
    S9xFixCycles();

	/*     CHECK_FOR_IRQ();*/
}

static void Op28Slow (void)
{
	AddCycles(TWO_CYCLES);

	if (CheckEmulation())
	{
		PullBE(Registers.PL);
		OpenBus = Registers.PL;
		SetFlags(MemoryFlag | IndexFlag);
	}
	else
	{
		PullB(Registers.PL);
		OpenBus = Registers.PL;
	}

	S9xUnpackStatus();

	if (CheckIndex())
	{
		Registers.XH = 0;
		Registers.YH = 0;
	}

	S9xFixCycles();
	//CHECK_FOR_IRQ();
}

// PLX
static void OpFAE1 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += TWO_CYCLES;
#endif
    PullBE (Registers.XL);
    SetZN8_old (Registers.XL);
    OpenBus = Registers.XL;
}

static void OpFAE0X1 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += TWO_CYCLES;
#endif
    PullB (Registers.XL);
    SetZN8_old (Registers.XL);
    OpenBus = Registers.XL;
}

static void OpFAE0X0 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += TWO_CYCLES;
#endif
    PullW (Registers.X.W);
    SetZN16_old (Registers.X.W);
    OpenBus = Registers.XH;
}

static void OpFASlow (void)
{
	AddCycles(TWO_CYCLES);

	if (CheckEmulation())
	{
		PullBE(Registers.XL);
		SetZN(Registers.XL);
		OpenBus = Registers.XL;
	}
	else
	if (CheckIndex())
	{
		PullB(Registers.XL);
		SetZN(Registers.XL);
		OpenBus = Registers.XL;
	}
	else
	{
		PullW(Registers.X.W);
		SetZN(Registers.X.W);
		OpenBus = Registers.XH;
	}
}

// PLY
static void Op7AE1 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += TWO_CYCLES;
#endif
    PullBE (Registers.YL);
    SetZN8_old (Registers.YL);
    OpenBus = Registers.YL;
}

static void Op7AE0X1 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += TWO_CYCLES;
#endif
    PullB (Registers.YL);
    SetZN8_old (Registers.YL);
    OpenBus = Registers.YL;
}

static void Op7AE0X0 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += TWO_CYCLES;
#endif
    PullW (Registers.Y.W);
    SetZN16_old (Registers.Y.W);
    OpenBus = Registers.YH;
}

static void Op7ASlow (void)
{
	AddCycles(TWO_CYCLES);

	if (CheckEmulation())
	{
		PullBE(Registers.YL);
		SetZN(Registers.YL);
		OpenBus = Registers.YL;
	}
	else
	if (CheckIndex())
	{
		PullB(Registers.YL);
		SetZN(Registers.YL);
		OpenBus = Registers.YL;
	}
	else
	{
		PullW(Registers.Y.W);
		SetZN(Registers.Y.W);
		OpenBus = Registers.YH;
	}
}

/* Transfer Instructions *************************************************** */

// TAX
static void OpAAX1 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    Registers.XL = Registers.AL;
    SetZN8_old (Registers.XL);
}

static void OpAAX0 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    Registers.X.W = Registers.A.W;
    SetZN16_old (Registers.X.W);
}

static void OpAASlow (void)
{
	AddCycles(ONE_CYCLE);

	if (CheckIndex())
	{
		Registers.XL = Registers.AL;
		SetZN(Registers.XL);
	}
	else
	{
		Registers.X.W = Registers.A.W;
		SetZN(Registers.X.W);
	}
}

// TAY
static void OpA8X1 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    Registers.YL = Registers.AL;
    SetZN8_old (Registers.YL);
}

static void OpA8X0 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    Registers.Y.W = Registers.A.W;
    SetZN16_old (Registers.Y.W);
}

static void OpA8Slow (void)
{
	AddCycles(ONE_CYCLE);

	if (CheckIndex())
	{
		Registers.YL = Registers.AL;
		SetZN(Registers.YL);
	}
	else
	{
		Registers.Y.W = Registers.A.W;
		SetZN(Registers.Y.W);
	}
}

// TCD
static void Op5B (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    Registers.D.W = Registers.A.W;
    SetZN16_old (Registers.D.W);
}

// TCS
static void Op1B (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    Registers.S.W = Registers.A.W;
    if (CheckEmulation())
	Registers.SH = 1;
}

// TDC
static void Op7B (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    Registers.A.W = Registers.D.W;
    SetZN16_old (Registers.A.W);
}

// TSC
static void Op3B (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    Registers.A.W = Registers.S.W;
    SetZN16_old (Registers.A.W);
}

// TSX
static void OpBAX1 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    Registers.XL = Registers.SL;
    SetZN8_old (Registers.XL);
}

static void OpBAX0 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    Registers.X.W = Registers.S.W;
    SetZN16_old (Registers.X.W);
}

static void OpBASlow (void)
{
	AddCycles(ONE_CYCLE);

	if (CheckIndex())
	{
		Registers.XL = Registers.SL;
		SetZN(Registers.XL);
	}
	else
	{
		Registers.X.W = Registers.S.W;
		SetZN(Registers.X.W);
	}
}

// TXA
static void Op8AM1 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    Registers.AL = Registers.XL;
    SetZN8_old (Registers.AL);
}

static void Op8AM0 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    Registers.A.W = Registers.X.W;
    SetZN16_old (Registers.A.W);
}

static void Op8ASlow (void)
{
	AddCycles(ONE_CYCLE);

	if (CheckMemory())
	{
		Registers.AL = Registers.XL;
		SetZN(Registers.AL);
	}
	else
	{
		Registers.A.W = Registers.X.W;
		SetZN(Registers.A.W);
	}
}

// TXS
static void Op9A (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    Registers.S.W = Registers.X.W;
    if (CheckEmulation())
	Registers.SH = 1;
}

// TXY
static void Op9BX1 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    Registers.YL = Registers.XL;
    SetZN8_old (Registers.YL);
}

static void Op9BX0 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    Registers.Y.W = Registers.X.W;
    SetZN16_old (Registers.Y.W);
}

static void Op9BSlow (void)
{
	AddCycles(ONE_CYCLE);

	if (CheckIndex())
	{
		Registers.YL = Registers.XL;
		SetZN(Registers.YL);
	}
	else
	{
		Registers.Y.W = Registers.X.W;
		SetZN(Registers.Y.W);
	}
}

// TYA
static void Op98M1 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    Registers.AL = Registers.YL;
    SetZN8_old (Registers.AL);
}

static void Op98M0 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    Registers.A.W = Registers.Y.W;
    SetZN16_old (Registers.A.W);
}

static void Op98Slow (void)
{
	AddCycles(ONE_CYCLE);

	if (CheckMemory())
	{
		Registers.AL = Registers.YL;
		SetZN(Registers.AL);
	}
	else
	{
		Registers.A.W = Registers.Y.W;
		SetZN(Registers.A.W);
	}
}

// TYX
static void OpBBX1 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    Registers.XL = Registers.YL;
    SetZN8_old (Registers.XL);
}

static void OpBBX0 (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    Registers.X.W = Registers.Y.W;
    SetZN16_old (Registers.X.W);
}

static void OpBBSlow (void)
{
	AddCycles(ONE_CYCLE);

	if (CheckIndex())
	{
		Registers.XL = Registers.YL;
		SetZN(Registers.XL);
	}
	else
	{
		Registers.X.W = Registers.Y.W;
		SetZN(Registers.X.W);
	}
}

/* XCE ********************************************************************* */

static void OpFB (void)
{
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif

    A1 = ICPU._Carry;
    A2 = Registers.PH;
    ICPU._Carry = A2 & 1;
    Registers.PH = A1;

    if (CheckEmulation())
    {
	SetFlags (MemoryFlag | IndexFlag);
	Registers.SH = 1;
#ifdef DEBUGGER
	missing.emulate6502 = 1;
#endif
    }
    if (CheckIndex ())
    {
	Registers.XH = 0;
	Registers.YH = 0;
    }
    S9xFixCycles();
}


/* BRK ********************************************************************* */

static void Op00 (void)
{
#ifdef DEBUGGER
    if (CPU.Flags & TRACE_FLAG)
	S9xTraceMessage ("*** BRK");
#endif

#ifndef SA1_OPCODES
    CPU.BRKTriggered = TRUE;
#endif

    AddCycles(CPU.MemSpeed);

    uint16 addr;

    if (!CheckEmulation())
    {
	PushB (Registers.PB);
	PushW (Registers.PCw + 1);
	S9xPackStatus ();
	PushB (Registers.PL);
	OpenBus = Registers.PL;
	ClearDecimal ();
	SetIRQ ();

	Registers.PB = 0;
	ICPU.ShiftedPB = 0;

	addr = S9xGetWord(0xFFE6);
    }
    else
    {
	PushW (Registers.PCw);
	S9xPackStatus ();
	PushB (Registers.PL);
	OpenBus = Registers.PL;
	ClearDecimal ();
	SetIRQ ();

	Registers.PB = 0;
	ICPU.ShiftedPB = 0;

	addr = S9xGetWord(0xFFFE);
    }

    S9xSetPCBase(addr);
    OpenBus = addr >> 8;
}
/**********************************************************************************************/

/* IRQ *************************************************************************************** */
void S9xOpcode_IRQ (void)
{
#ifdef DEBUGGER
    if (CPU.Flags & TRACE_FLAG)
	S9xTraceMessage ("*** IRQ");
#endif

    // IRQ and NMI do an opcode fetch as their first "IO" cycle.
    AddCycles(CPU.MemSpeed + ONE_CYCLE);


    if (!CheckEmulation())
    {
	PushB (Registers.PB);
	PushW (Registers.PCw);
	S9xPackStatus ();
	PushB (Registers.PL);
	OpenBus = Registers.PL;
	ClearDecimal ();
	SetIRQ ();

	Registers.PB = 0;
	ICPU.ShiftedPB = 0;

#ifdef SA1_OPCODES
	OpenBus = Memory.FillRAM[0x2208];
	AddCycles(2 * SLOW_ONE_CYCLE);
	S9xSA1SetPCBase (Memory.FillRAM [0x2207] |
			 (Memory.FillRAM [0x2208] << 8));
#else
	if (Settings.SA1 && (Memory.FillRAM [0x2209] & 0x40))
	  {
	    OpenBus = Memory.FillRAM[0x220f];
	    AddCycles(2 * SLOW_ONE_CYCLE);
	    S9xSetPCBase (Memory.FillRAM [0x220e] | 
			  (Memory.FillRAM [0x220f] << 8));
	  }
	else
	  {
	    uint16	addr = S9xGetWord(0xFFEE);
	    OpenBus = addr >> 8;
	    S9xSetPCBase(addr);
	  }
#endif
    }
    else
    {
	PushW (Registers.PCw);
	S9xPackStatus ();
	PushB (Registers.PL);
	OpenBus = Registers.PL;
	ClearDecimal ();
	SetIRQ ();

	Registers.PB = 0;
	ICPU.ShiftedPB = 0;

#ifdef SA1_OPCODES
	OpenBus = Memory.FillRAM[0x2208];
	AddCycles(2 * SLOW_ONE_CYCLE);
	S9xSA1SetPCBase (Memory.FillRAM [0x2207] |
			 (Memory.FillRAM [0x2208] << 8));
#else
	if (Settings.SA1 && (Memory.FillRAM [0x2209] & 0x40))
	  {
	    OpenBus = Memory.FillRAM[0x220f];
	    AddCycles(2 * SLOW_ONE_CYCLE);
	    S9xSetPCBase (Memory.FillRAM [0x220e] | 
			  (Memory.FillRAM [0x220f] << 8));
	  }
	else
	  {
	    uint16	addr = S9xGetWord(0xFFFE);
	    OpenBus = addr >> 8;
	    S9xSetPCBase(addr);
	  }
#endif
    }
}

/**********************************************************************************************/

/* NMI *************************************************************************************** */
void S9xOpcode_NMI (void)
{
#ifdef DEBUGGER
    if (CPU.Flags & TRACE_FLAG)
	S9xTraceMessage ("*** NMI");
#endif

    // IRQ and NMI do an opcode fetch as their first "IO" cycle.
    AddCycles(CPU.MemSpeed + ONE_CYCLE);

    if (!CheckEmulation())
    {
	PushB (Registers.PB);
	PushW (Registers.PCw);
	S9xPackStatus ();
	PushB (Registers.PL);
	OpenBus = Registers.PL;
	ClearDecimal ();
	SetIRQ ();

	Registers.PB = 0;
	ICPU.ShiftedPB = 0;

#ifdef SA1_OPCODES
	OpenBus = Memory.FillRAM[0x2206];
	AddCycles(2 * SLOW_ONE_CYCLE);
	S9xSA1SetPCBase (Memory.FillRAM [0x2205] |
			 (Memory.FillRAM [0x2206] << 8));
#else
	if (Settings.SA1 && (Memory.FillRAM [0x2209] & 0x20))
	  {
	    OpenBus = Memory.FillRAM[0x220d];
	    AddCycles(2 * SLOW_ONE_CYCLE);
	    S9xSetPCBase (Memory.FillRAM [0x220c] |
			  (Memory.FillRAM [0x220d] << 8));
	  }
	else
	  {
	    uint16	addr = S9xGetWord(0xFFEA);
	    OpenBus = addr >> 8;
	    S9xSetPCBase(addr);
	  }
#endif
    }
    else
    {
	PushW (Registers.PCw);
	S9xPackStatus ();
	PushB (Registers.PL);
	OpenBus = Registers.PL;
	ClearDecimal ();
	SetIRQ ();

	Registers.PB = 0;
	ICPU.ShiftedPB = 0;

#ifdef SA1_OPCODES
	OpenBus = Memory.FillRAM[0x2206];
	AddCycles(2 * SLOW_ONE_CYCLE);
	S9xSA1SetPCBase (Memory.FillRAM [0x2205] |
			 (Memory.FillRAM [0x2206] << 8));
#else
	if (Settings.SA1 && (Memory.FillRAM [0x2209] & 0x20))
	  {
	    OpenBus = Memory.FillRAM[0x220d];
	    AddCycles(2 * SLOW_ONE_CYCLE);
	    S9xSetPCBase (Memory.FillRAM [0x220c] |
			  (Memory.FillRAM [0x220d] << 8));
	  }
	else
	  {
	    uint16	addr = S9xGetWord(0xFFFA);
	    OpenBus = addr >> 8;
	    S9xSetPCBase(addr);
	  }
#endif
    }
}
/**********************************************************************************************/

/* COP *************************************************************************************** */
static void Op02 (void)
{
#ifdef DEBUGGER
    if (CPU.Flags & TRACE_FLAG)
	S9xTraceMessage ("*** COP");
#endif	

    AddCycles(CPU.MemSpeed);

    uint16	addr;

    if (!CheckEmulation())
    {
	PushB (Registers.PB);
	PushW (Registers.PCw + 1);
	S9xPackStatus ();
	PushB (Registers.PL);
	OpenBus = Registers.PL;
	ClearDecimal ();
	SetIRQ ();

	Registers.PB = 0;
	ICPU.ShiftedPB = 0;

	addr = S9xGetWord(0xFFE4);
    }
    else
    {
	PushW (Registers.PCw);
	S9xPackStatus ();
	PushB (Registers.PL);
	OpenBus = Registers.PL;
	ClearDecimal ();
	SetIRQ ();

	Registers.PB = 0;
	ICPU.ShiftedPB = 0;

	addr = S9xGetWord(0xFFF4);
    }

    S9xSetPCBase(addr);
    OpenBus = addr >> 8;
}

/* JML ********************************************************************* */

static void OpDC (void)
{
    AbsoluteIndirectLong_old (JUMP);
    Registers.PB = (uint8) (OpAddress_old >> 16);
    ICPU.ShiftedPB = OpAddress_old & 0xff0000;
    S9xSetPCBase (OpAddress_old);
#ifndef SA1_OPCODES
    CPU.Cycles += TWO_CYCLES;
#endif
}

static void OpDCSlow (void)
{
	S9xSetPCBase(AbsoluteIndirectLongSlow(JUMP));
}

static void Op5C (void)
{
    AbsoluteLong_old (JUMP);
    Registers.PB = (uint8) (OpAddress_old >> 16);
    ICPU.ShiftedPB = OpAddress_old & 0xff0000;
    S9xSetPCBase (OpAddress_old);
}

static void Op5CSlow (void)
{
	S9xSetPCBase(AbsoluteLongSlow(JUMP));
}

/* JMP ********************************************************************* */

static void Op4C (void)
{
    Absolute_old (JUMP);
    S9xSetPCBase (ICPU.ShiftedPB + (OpAddress_old & 0xffff));
#if defined(CPU_SHUTDOWN) && defined(SA1_OPCODES)
    CPUShutdown ();
#endif
}

static void Op4CSlow (void)
{
	S9xSetPCBase(ICPU.ShiftedPB + ((uint16) AbsoluteSlow(JUMP)));
#if defined(CPU_SHUTDOWN) && defined(SA1_OPCODES)
	CPUShutdown();
#endif
}

static void Op6C (void)
{
    AbsoluteIndirect_old (JUMP);
    S9xSetPCBase (ICPU.ShiftedPB + (OpAddress_old & 0xffff));
}

static void Op6CSlow (void)
{
	S9xSetPCBase(ICPU.ShiftedPB + ((uint16) AbsoluteIndirectSlow(JUMP)));
}

static void Op7C (void)
{
    AbsoluteIndexedIndirect_old (JUMP);
    S9xSetPCBase (ICPU.ShiftedPB + OpAddress_old);
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
}

static void Op7CSlow (void)
{
	S9xSetPCBase(ICPU.ShiftedPB + ((uint16) AbsoluteIndexedIndirectSlow(JUMP)));
}

/* JSL/RTL ***************************************************************** */

static void Op22E1 (void)
{
    AbsoluteLong_old (JUMP);
    PushB (Registers.PB);
    PushWENew (Registers.PCw - 1);
    Registers.PB = (uint8) (OpAddress_old >> 16);
    ICPU.ShiftedPB = OpAddress_old & 0xff0000;
    S9xSetPCBase (OpAddress_old);
}

static void Op22E0 (void)
{
    AbsoluteLong_old (JUMP);
    PushB (Registers.PB);
    PushW (Registers.PCw - 1);
    Registers.PB = (uint8) (OpAddress_old >> 16);
    ICPU.ShiftedPB = OpAddress_old & 0xff0000;
    S9xSetPCBase (OpAddress_old);
}

static void Op22Slow (void)
{
	uint32	addr = AbsoluteLongSlow(JSR);
	PushB(Registers.PB);
	PushW(Registers.PCw - 1);
	if (CheckEmulation())
		Registers.SH = 1;
	S9xSetPCBase(addr);
}

static void Op6BE1 (void)
{
    PullWENew (Registers.PCw);
    PullB (Registers.PB);
    ICPU.ShiftedPB = Registers.PB << 16;
    S9xSetPCBase (ICPU.ShiftedPB + ((Registers.PCw + 1) & 0xffff));
#ifndef SA1_OPCODES
    CPU.Cycles += TWO_CYCLES;
#endif
}

static void Op6BE0 (void)
{
    PullW (Registers.PCw);
    PullB (Registers.PB);
    ICPU.ShiftedPB = Registers.PB << 16;
    S9xSetPCBase (ICPU.ShiftedPB + ((Registers.PCw + 1) & 0xffff));
#ifndef SA1_OPCODES
    CPU.Cycles += TWO_CYCLES;
#endif
}

static void Op6BSlow (void)
{
	AddCycles(TWO_CYCLES);
	PullW(Registers.PCw);
	PullB(Registers.PB);
	if (CheckEmulation())
		Registers.SH = 1;
	Registers.PCw++;
	S9xSetPCBase(Registers.PBPC);
}

/* JSR/RTS ***************************************************************** */

static void Op20E1 (void)
{
    Absolute_old (JUMP);
    PushW (Registers.PCw - 1);
    S9xSetPCBase (ICPU.ShiftedPB + (OpAddress_old & 0xffff));
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
}

static void Op20E0 (void)
{
    Absolute_old (JUMP);
    PushW (Registers.PCw - 1);
    S9xSetPCBase (ICPU.ShiftedPB + (OpAddress_old & 0xffff));
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
}

static void Op20Slow (void)
{
	uint16	addr = AbsoluteSlow(JSR);

	AddCycles(ONE_CYCLE);

	if (CheckEmulation())
	{
		PushWE(Registers.PCw - 1);
	}
	else
	{
		PushW(Registers.PCw - 1);
	}

	S9xSetPCBase(ICPU.ShiftedPB + addr);
}

//JSR a,x
static void OpFCE1 (void)
{
    AbsoluteIndexedIndirect_old (JUMP);
    PushWENew (Registers.PCw - 1);
    S9xSetPCBase (ICPU.ShiftedPB + OpAddress_old);
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
}

static void OpFCE0 (void)
{
    AbsoluteIndexedIndirect_old (JUMP);
    PushW (Registers.PCw - 1);
    S9xSetPCBase (ICPU.ShiftedPB + OpAddress_old);
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
}

static void OpFCSlow (void)
{
	uint16	addr = AbsoluteIndexedIndirectSlow(JSR);
	PushW(Registers.PCw - 1);
	if (CheckEmulation())
		Registers.SH = 1;
	S9xSetPCBase(ICPU.ShiftedPB + addr);
}

static void Op60E1 (void)
{
    PullW (Registers.PCw);
    S9xSetPCBase (ICPU.ShiftedPB + ((Registers.PCw + 1) & 0xffff));
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE * 3;
#endif
}

static void Op60E0 (void)
{
    PullW (Registers.PCw);
    S9xSetPCBase (ICPU.ShiftedPB + ((Registers.PCw + 1) & 0xffff));
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE * 3;
#endif
}

static void Op60Slow (void)
{
	AddCycles(TWO_CYCLES);

	if (CheckEmulation())
	{
		PullWE(Registers.PCw);
	}
	else
	{
		PullW(Registers.PCw);
	}

	AddCycles(ONE_CYCLE);
	Registers.PCw++;
	S9xSetPCBase(Registers.PBPC);
}

/* MVN/MVP ***************************************************************** */

static void Op54X1 (void)
{
    uint32 SrcBank;

#ifndef SA1_OPCODES
    CPU.Cycles += TWO_CYCLES;
#endif
    
    Registers.DB = S9xGetByte(ICPU.ShiftedPB + Registers.PCw++);
    ICPU.ShiftedDB = Registers.DB << 16;
    OpenBus = SrcBank = S9xGetByte(ICPU.ShiftedPB + Registers.PCw++);

    S9xSetByte (OpenBus = S9xGetByte ((SrcBank << 16) + Registers.X.W), 
	     ICPU.ShiftedDB + Registers.Y.W);

    Registers.XL++;
    Registers.YL++;
    Registers.A.W--;
    if (Registers.A.W != 0xffff)
      {
	Registers.PCw -= 3;
      }
}

static void Op54X0 (void)
{
    uint32 SrcBank;

#ifndef SA1_OPCODES
    CPU.Cycles += TWO_CYCLES;
#endif
    
    Registers.DB = S9xGetByte(ICPU.ShiftedPB + Registers.PCw++);
    ICPU.ShiftedDB = Registers.DB << 16;
    OpenBus = SrcBank = S9xGetByte(ICPU.ShiftedPB + Registers.PCw++);

    S9xSetByte (OpenBus = S9xGetByte ((SrcBank << 16) + Registers.X.W), 
	     ICPU.ShiftedDB + Registers.Y.W);

    Registers.X.W++;
    Registers.Y.W++;
    Registers.A.W--;
    if (Registers.A.W != 0xffff)
      {
	Registers.PCw -= 3;
      }
}

static void Op54Slow (void)
{
	uint32	SrcBank;

	OpenBus = Registers.DB = Immediate8Slow(NONE);
	ICPU.ShiftedDB = Registers.DB << 16;
	OpenBus = SrcBank = Immediate8Slow(NONE);

	S9xSetByte(OpenBus = S9xGetByte((SrcBank << 16) + Registers.X.W), ICPU.ShiftedDB + Registers.Y.W);

	if (CheckIndex())
	{
		Registers.XL++;
		Registers.YL++;
	}
	else
	{
		Registers.X.W++;
		Registers.Y.W++;
	}

	Registers.A.W--;
	if (Registers.A.W != 0xffff)
		Registers.PCw -= 3;

	AddCycles(TWO_CYCLES);
}

static void Op44X1 (void)
{
    uint32 SrcBank;

#ifndef SA1_OPCODES
    CPU.Cycles += TWO_CYCLES;
#endif    
    Registers.DB = S9xGetByte(ICPU.ShiftedPB + Registers.PCw++);
    ICPU.ShiftedDB = Registers.DB << 16;
    OpenBus = SrcBank = S9xGetByte(ICPU.ShiftedPB + Registers.PCw++);
    S9xSetByte (OpenBus = S9xGetByte ((SrcBank << 16) + Registers.X.W), 
	     ICPU.ShiftedDB + Registers.Y.W);

    Registers.XL--;
    Registers.YL--;
    Registers.A.W--;
    if (Registers.A.W != 0xffff)
      {
	Registers.PCw -= 3;
      }
}

static void Op44X0 (void)
{
    uint32 SrcBank;

#ifndef SA1_OPCODES
    CPU.Cycles += TWO_CYCLES;
#endif    
    Registers.DB = S9xGetByte(ICPU.ShiftedPB + Registers.PCw++);
    ICPU.ShiftedDB = Registers.DB << 16;
    OpenBus = SrcBank = S9xGetByte(ICPU.ShiftedPB + Registers.PCw++);
    S9xSetByte (OpenBus = S9xGetByte ((SrcBank << 16) + Registers.X.W), 
	     ICPU.ShiftedDB + Registers.Y.W);

    Registers.X.W--;
    Registers.Y.W--;
    Registers.A.W--;
    if (Registers.A.W != 0xffff)
      {
	Registers.PCw -= 3;
      }
}

static void Op44Slow (void)
{
	uint32	SrcBank;

	OpenBus = Registers.DB = Immediate8Slow(NONE);
	ICPU.ShiftedDB = Registers.DB << 16;
	OpenBus = SrcBank = Immediate8Slow(NONE);

	S9xSetByte(OpenBus = S9xGetByte((SrcBank << 16) + Registers.X.W), ICPU.ShiftedDB + Registers.Y.W);

	if (CheckIndex())
	{
		Registers.XL--;
		Registers.YL--;
	}
	else
	{
		Registers.X.W--;
		Registers.Y.W--;
	}

	Registers.A.W--;
	if (Registers.A.W != 0xffff)
		Registers.PCw -= 3;

	AddCycles(TWO_CYCLES);
}

/* REP/SEP ***************************************************************** */

static void OpC2 (void)
{
    Work8 = ~S9xGetByte(ICPU.ShiftedPB + Registers.PCw++);
    Registers.PL &= Work8;
    ICPU._Carry &= Work8;
    ICPU._Overflow &= (Work8 >> 6);
    ICPU._Negative &= Work8;
    ICPU._Zero |= ~Work8 & Zero;

#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    if (CheckEmulation())
    {
	SetFlags (MemoryFlag | IndexFlag);
#ifdef DEBUGGER
	missing.emulate6502 = 1;
#endif
    }
    if (CheckIndex ())
    {
	Registers.XH = 0;
	Registers.YH = 0;
    }
    S9xFixCycles();

	/*    CHECK_FOR_IRQ(); */
}

static void OpC2Slow (void)
{
	uint8	Work8 = ~Immediate8Slow(READ);
	Registers.PL &= Work8;
	ICPU._Carry &= Work8;
	ICPU._Overflow &= (Work8 >> 6);
	ICPU._Negative &= Work8;
	ICPU._Zero |= ~Work8 & Zero;

	AddCycles(ONE_CYCLE);

	if (CheckEmulation())
	{
		SetFlags(MemoryFlag | IndexFlag);
	#ifdef DEBUGGER
		missing.emulate6502 = 1;
	#endif
	}

	if (CheckIndex())
	{
		Registers.XH = 0;
		Registers.YH = 0;
	}

	S9xFixCycles();
	//CHECK_FOR_IRQ();
}

static void OpE2 (void)
{
    Work8 = S9xGetByte(ICPU.ShiftedPB + Registers.PCw++);
    Registers.PL |= Work8;
    ICPU._Carry |= Work8 & 1;
    ICPU._Overflow |= (Work8 >> 6) & 1;
    ICPU._Negative |= Work8;
    if (Work8 & Zero)
	ICPU._Zero = 0;
#ifndef SA1_OPCODES
    CPU.Cycles += ONE_CYCLE;
#endif
    if (CheckEmulation())
    {
	SetFlags (MemoryFlag | IndexFlag);
#ifdef DEBUGGER
	missing.emulate6502 = 1;
#endif
    }
    if (CheckIndex ())
    {
	Registers.XH = 0;
	Registers.YH = 0;
    }
    S9xFixCycles();

	/*    CHECK_FOR_IRQ(); */
}

static void OpE2Slow (void)
{
	uint8	Work8 = Immediate8Slow(READ);
	Registers.PL |= Work8;
	ICPU._Carry |= Work8 & 1;
	ICPU._Overflow |= (Work8 >> 6) & 1;
	ICPU._Negative |= Work8;
	if (Work8 & Zero)
		ICPU._Zero = 0;

	AddCycles(ONE_CYCLE);

	if (CheckEmulation())
	{
		SetFlags(MemoryFlag | IndexFlag);
	#ifdef DEBUGGER
		missing.emulate6502 = 1;
	#endif
	}

	if (CheckIndex())
	{
		Registers.XH = 0;
		Registers.YH = 0;
	}

	S9xFixCycles();
}

/* XBA ********************************************************************* */

static void OpEB (void)
{
    Work8 = Registers.AL;
    Registers.AL = Registers.AH;
    Registers.AH = Work8;

    SetZN8_old (Registers.AL);
#ifndef SA1_OPCODES
    CPU.Cycles += TWO_CYCLES;
#endif
}

/* RTI ********************************************************************* */

static void Op40Slow (void)
{
    PullB (Registers.PL);
    S9xUnpackStatus ();
    PullW (Registers.PCw);
    if (!CheckEmulation())
    {
	PullB (Registers.PB);
	OpenBus = Registers.PB;
	ICPU.ShiftedPB = Registers.PB << 16;
    }
    else
    {
      OpenBus = Registers.PCh;
	SetFlags (MemoryFlag | IndexFlag);
#ifdef DEBUGGER
	missing.emulate6502 = 1;
#endif
    }
    S9xSetPCBase (ICPU.ShiftedPB + Registers.PCw);
    
    if (CheckIndex ())
    {
	Registers.XH = 0;
	Registers.YH = 0;
    }
#ifndef SA1_OPCODES
    CPU.Cycles += TWO_CYCLES;
#endif
    S9xFixCycles();

	/*    CHECK_FOR_IRQ(); */
}

/* STP/WAI ***************************************************************** */

// WAI
static void OpCB (void)
{
  CPU.WaitingForInterrupt = TRUE;
  Registers.PCw--;
#ifndef SA1_OPCODES
#ifdef CPU_SHUTDOWN
  if (Settings.Shutdown &&
      !(CPU.Flags & (IRQ_FLAG | NMI_FLAG))) {
    //if (Settings.SA1)
    //S9xSA1ExecuteDuringSleep ();
    if(CPU.Cycles < CPU.NextEvent) {
      CPU.Cycles = CPU.NextEvent - ((CPU.NextEvent - CPU.Cycles) % CPU.MemSpeed);
      ICPU.CPUExecuting = FALSE;
      S9xAPUMainLoop();
      ICPU.CPUExecuting = TRUE;
    }
  }
  else
    AddCycles(TWO_CYCLES);
#else
    AddCycles(TWO_CYCLES);
#endif
#endif
}

// STP
static void OpDB (void)
{
	Registers.PCw--;
	CPU.Flags |= DEBUG_MODE_FLAG | HALTED_FLAG;
}

/* WDM (Reserved S9xOpcode) ************************************************ */

#ifdef DEBUGGER
extern FILE	*trace, *trace2;
#endif

static void Op42 (void)
{
#ifdef DEBUGGER
	uint8	byte = (uint8) S9xGetWord(Registers.PBPC);
#else
	S9xGetWord(Registers.PBPC);
#endif
	//"Sengoku denshou" pause WDM is 2byte
	Registers.PCw++;

#ifdef DEBUGGER
	// Hey, let's use this to trigger debug modes.
	switch (byte)
	{
		case 0xdb: // "STP" = Enter debug mode
			CPU.Flags |= DEBUG_MODE_FLAG;
			break;

	#ifndef SA1_OPCODES
		case 0xe2: // "SEP" = Trace on
			if (!(CPU.Flags & TRACE_FLAG))
			{
				char	buf[25];
				CPU.Flags |= TRACE_FLAG;
				snprintf(buf, 25, "WDM trace on at $%02X:%04X", Registers.PB, Registers.PCw);
				S9xMessage(S9X_DEBUG, S9X_DEBUG_OUTPUT, buf);
				if (trace != NULL)
					fclose(trace);
				trace = fopen("WDMtrace.log", "ab");
			}

			break;

		case 0xc2: // "REP" = Trace off
			if (CPU.Flags & TRACE_FLAG)
			{
				char	buf[26];
				CPU.Flags &= ~TRACE_FLAG;
				snprintf(buf, 26, "WDM trace off at $%02X:%04X", Registers.PB, Registers.PCw);
				S9xMessage(S9X_DEBUG, S9X_DEBUG_OUTPUT, buf);
				if (trace != NULL)
					fclose(trace);
				trace = NULL;
			}

			break;
	#endif

		case 0x42: // "WDM" = Snapshot
			char	filename[PATH_MAX + 1], drive[_MAX_DRIVE + 1], dir[_MAX_DIR + 1], def[PATH_MAX + 1], ext[_MAX_EXT + 1];

			_splitpath(Memory.ROMFilename, drive, dir, def, ext);
			snprintf(filename, PATH_MAX, "%s%s%s-%06X.wdm", S9xGetDirectory(SNAPSHOT_DIR), SLASH_STR, def, Registers.PBPC & 0xffffff);
			sprintf(def, "WDM Snapshot at $%02X:%04X: %s", Registers.PB, Registers.PCw, filename);
			S9xMessage(S9X_DEBUG, S9X_DEBUG_OUTPUT, def);
			S9xFreezeGame(filename);

			break;

		default:
			break;
	}
#endif
}

/* CPU-S9xOpcodes Definitions ************************************************/

struct SOpcodes S9xOpcodesM1X1[256] =
{
	{ Op00 },        { Op01E0M1 },    { Op02 },        { Op03M1 },      { Op04M1 },
	{ Op05M1 },      { Op06M1 },      { Op07M1 },      { Op08E0 },      { Op09M1 },
	{ Op0AM1 },      { Op0BE0 },      { Op0CM1 },      { Op0DM1 },      { Op0EM1 },
	{ Op0FM1 },      { Op10E0 },      { Op11E0M1X1 },  { Op12E0M1 },    { Op13M1 },
	{ Op14M1 },      { Op15E0M1 },    { Op16E0M1 },    { Op17M1 },      { Op18 },
	{ Op19M1X1 },    { Op1AM1 },      { Op1B },        { Op1CM1 },      { Op1DM1X1 },
	{ Op1EM1X1 },    { Op1FM1 },      { Op20E0 },      { Op21E0M1 },    { Op22E0 },
	{ Op23M1 },      { Op24M1 },      { Op25M1 },      { Op26M1 },      { Op27M1 },
	{ Op28E0 },      { Op29M1 },      { Op2AM1 },      { Op2BE0 },      { Op2CM1 },
	{ Op2DM1 },      { Op2EM1 },      { Op2FM1 },      { Op30E0 },      { Op31E0M1X1 },
	{ Op32E0M1 },    { Op33M1 },      { Op34E0M1 },    { Op35E0M1 },    { Op36E0M1 },
	{ Op37M1 },      { Op38 },        { Op39M1X1 },    { Op3AM1 },      { Op3B },
	{ Op3CM1X1 },    { Op3DM1X1 },    { Op3EM1X1 },    { Op3FM1 },      { Op40Slow },
	{ Op41E0M1 },    { Op42 },        { Op43M1 },      { Op44X1 },      { Op45M1 },
	{ Op46M1 },      { Op47M1 },      { Op48E0M1 },    { Op49M1 },      { Op4AM1 },
	{ Op4BE0 },      { Op4C },        { Op4DM1 },      { Op4EM1 },      { Op4FM1 },
	{ Op50E0 },      { Op51E0M1X1 },  { Op52E0M1 },    { Op53M1 },      { Op54X1 },
	{ Op55E0M1 },    { Op56E0M1 },    { Op57M1 },      { Op58 },        { Op59M1X1 },
	{ Op5AE0X1 },    { Op5B },        { Op5C },        { Op5DM1X1 },    { Op5EM1X1 },
	{ Op5FM1 },      { Op60E0 },      { Op61E0M1 },    { Op62E0 },      { Op63M1 },
	{ Op64M1 },      { Op65M1 },      { Op66M1 },      { Op67M1 },      { Op68E0M1 },
	{ Op69M1 },      { Op6AM1 },      { Op6BE0 },      { Op6C },        { Op6DM1 },
	{ Op6EM1 },      { Op6FM1 },      { Op70E0 },      { Op71E0M1X1 },  { Op72E0M1 },
	{ Op73M1 },      { Op74E0M1 },    { Op75E0M1 },    { Op76E0M1 },    { Op77M1 },
	{ Op78 },        { Op79M1X1 },    { Op7AE0X1 },    { Op7B },        { Op7C },
	{ Op7DM1X1 },    { Op7EM1X1 },    { Op7FM1 },      { Op80E0 },      { Op81E0M1 },
	{ Op82 },        { Op83M1 },      { Op84X1 },      { Op85M1 },      { Op86X1 },
	{ Op87M1 },      { Op88X1 },      { Op89M1 },      { Op8AM1 },      { Op8BE0 },
	{ Op8CX1 },      { Op8DM1 },      { Op8EX1 },      { Op8FM1 },      { Op90E0 },
	{ Op91E0M1X1 },  { Op92E0M1 },    { Op93M1 },      { Op94E0X1 },    { Op95E0M1 },
	{ Op96E0X1 },    { Op97M1 },      { Op98M1 },      { Op99M1X1 },    { Op9A },
	{ Op9BX1 },      { Op9CM1 },      { Op9DM1X1 },    { Op9EM1X1 },    { Op9FM1 },
	{ OpA0X1 },      { OpA1E0M1 },    { OpA2X1 },      { OpA3M1 },      { OpA4X1 },
	{ OpA5M1 },      { OpA6X1 },      { OpA7M1 },      { OpA8X1 },      { OpA9M1 },
	{ OpAAX1 },      { OpABE0 },      { OpACX1 },      { OpADM1 },      { OpAEX1 },
	{ OpAFM1 },      { OpB0E0 },      { OpB1E0M1X1 },  { OpB2E0M1 },    { OpB3M1 },
	{ OpB4E0X1 },    { OpB5E0M1 },    { OpB6E0X1 },    { OpB7M1 },      { OpB8 },
	{ OpB9M1X1 },    { OpBAX1 },      { OpBBX1 },      { OpBCX1 },      { OpBDM1X1 },
	{ OpBEX1 },      { OpBFM1 },      { OpC0X1 },      { OpC1E0M1 },    { OpC2 },
	{ OpC3M1 },      { OpC4X1 },      { OpC5M1 },      { OpC6M1 },      { OpC7M1 },
	{ OpC8X1 },      { OpC9M1 },      { OpCAX1 },      { OpCB },        { OpCCX1 },
	{ OpCDM1 },      { OpCEM1 },      { OpCFM1 },      { OpD0E0 },      { OpD1E0M1X1 },
	{ OpD2E0M1 },    { OpD3M1 },      { OpD4E0 },      { OpD5E0M1 },    { OpD6E0M1 },
	{ OpD7M1 },      { OpD8 },        { OpD9M1X1 },    { OpDAE0X1 },    { OpDB },
	{ OpDC },        { OpDDM1X1 },    { OpDEM1X1 },    { OpDFM1 },      { OpE0X1 },
	{ OpE1E0M1 },    { OpE2 },        { OpE3M1 },      { OpE4X1 },      { OpE5M1 },
	{ OpE6M1 },      { OpE7M1 },      { OpE8X1 },      { OpE9M1 },      { OpEA },
	{ OpEB },        { OpECX1 },      { OpEDM1 },      { OpEEM1 },      { OpEFM1 },
	{ OpF0E0 },      { OpF1E0M1X1 },  { OpF2E0M1 },    { OpF3M1 },      { OpF4E0 },
	{ OpF5E0M1 },    { OpF6E0M1 },    { OpF7M1 },      { OpF8 },        { OpF9M1X1 },
	{ OpFAE0X1 },    { OpFB },        { OpFCE0 },      { OpFDM1X1 },    { OpFEM1X1 },
	{ OpFFM1 }
};

struct SOpcodes S9xOpcodesE1[256] =
{
	{ Op00 },        { Op01E1 },      { Op02 },        { Op03M1 },      { Op04M1 },
	{ Op05M1 },      { Op06M1 },      { Op07M1 },      { Op08E1 },      { Op09M1 },
	{ Op0AM1 },      { Op0BE1 },      { Op0CM1 },      { Op0DM1 },      { Op0EM1 },
	{ Op0FM1 },      { Op10E1 },      { Op11E1 },      { Op12E1 },      { Op13M1 },
	{ Op14M1 },      { Op15E1 },      { Op16E1 },      { Op17M1 },      { Op18 },
	{ Op19M1X1 },    { Op1AM1 },      { Op1B },        { Op1CM1 },      { Op1DM1X1 },
	{ Op1EM1X1 },    { Op1FM1 },      { Op20E1 },      { Op21E1 },      { Op22E1 },
	{ Op23M1 },      { Op24M1 },      { Op25M1 },      { Op26M1 },      { Op27M1 },
	{ Op28E1 },      { Op29M1 },      { Op2AM1 },      { Op2BE1 },      { Op2CM1 },
	{ Op2DM1 },      { Op2EM1 },      { Op2FM1 },      { Op30E1 },      { Op31E1 },
	{ Op32E1 },      { Op33M1 },      { Op34E1 },      { Op35E1 },      { Op36E1 },
	{ Op37M1 },      { Op38 },        { Op39M1X1 },    { Op3AM1 },      { Op3B },
	{ Op3CM1X1 },    { Op3DM1X1 },    { Op3EM1X1 },    { Op3FM1 },      { Op40Slow },
	{ Op41E1 },      { Op42 },        { Op43M1 },      { Op44X1 },      { Op45M1 },
	{ Op46M1 },      { Op47M1 },      { Op48E1 },      { Op49M1 },      { Op4AM1 },
	{ Op4BE1 },      { Op4C },        { Op4DM1 },      { Op4EM1 },      { Op4FM1 },
	{ Op50E1 },      { Op51E1 },      { Op52E1 },      { Op53M1 },      { Op54X1 },
	{ Op55E1 },      { Op56E1 },      { Op57M1 },      { Op58 },        { Op59M1X1 },
	{ Op5AE1 },      { Op5B },        { Op5C },        { Op5DM1X1 },    { Op5EM1X1 },
	{ Op5FM1 },      { Op60E1 },      { Op61E1 },      { Op62E1 },      { Op63M1 },
	{ Op64M1 },      { Op65M1 },      { Op66M1 },      { Op67M1 },      { Op68E1 },
	{ Op69M1 },      { Op6AM1 },      { Op6BE1 },      { Op6C },        { Op6DM1 },
	{ Op6EM1 },      { Op6FM1 },      { Op70E1 },      { Op71E1 },      { Op72E1 },
	{ Op73M1 },      { Op74E1 },      { Op75E1 },      { Op76E1 },      { Op77M1 },
	{ Op78 },        { Op79M1X1 },    { Op7AE1 },      { Op7B },        { Op7C },
	{ Op7DM1X1 },    { Op7EM1X1 },    { Op7FM1 },      { Op80E1 },      { Op81E1 },
	{ Op82 },        { Op83M1 },      { Op84X1 },      { Op85M1 },      { Op86X1 },
	{ Op87M1 },      { Op88X1 },      { Op89M1 },      { Op8AM1 },      { Op8BE1 },
	{ Op8CX1 },      { Op8DM1 },      { Op8EX1 },      { Op8FM1 },      { Op90E1 },
	{ Op91E1 },      { Op92E1 },      { Op93M1 },      { Op94E1 },      { Op95E1 },
	{ Op96E1 },      { Op97M1 },      { Op98M1 },      { Op99M1X1 },    { Op9A },
	{ Op9BX1 },      { Op9CM1 },      { Op9DM1X1 },    { Op9EM1X1 },    { Op9FM1 },
	{ OpA0X1 },      { OpA1E1 },      { OpA2X1 },      { OpA3M1 },      { OpA4X1 },
	{ OpA5M1 },      { OpA6X1 },      { OpA7M1 },      { OpA8X1 },      { OpA9M1 },
	{ OpAAX1 },      { OpABE1 },      { OpACX1 },      { OpADM1 },      { OpAEX1 },
	{ OpAFM1 },      { OpB0E1 },      { OpB1E1 },      { OpB2E1 },      { OpB3M1 },
	{ OpB4E1 },      { OpB5E1 },      { OpB6E1 },      { OpB7M1 },      { OpB8 },
	{ OpB9M1X1 },    { OpBAX1 },      { OpBBX1 },      { OpBCX1 },      { OpBDM1X1 },
	{ OpBEX1 },      { OpBFM1 },      { OpC0X1 },      { OpC1E1 },      { OpC2 },
	{ OpC3M1 },      { OpC4X1 },      { OpC5M1 },      { OpC6M1 },      { OpC7M1 },
	{ OpC8X1 },      { OpC9M1 },      { OpCAX1 },      { OpCB },        { OpCCX1 },
	{ OpCDM1 },      { OpCEM1 },      { OpCFM1 },      { OpD0E1 },      { OpD1E1 },
	{ OpD2E1 },      { OpD3M1 },      { OpD4E1 },      { OpD5E1 },      { OpD6E1 },
	{ OpD7M1 },      { OpD8 },        { OpD9M1X1 },    { OpDAE1 },      { OpDB },
	{ OpDC },        { OpDDM1X1 },    { OpDEM1X1 },    { OpDFM1 },      { OpE0X1 },
	{ OpE1E1 },      { OpE2 },        { OpE3M1 },      { OpE4X1 },      { OpE5M1 },
	{ OpE6M1 },      { OpE7M1 },      { OpE8X1 },      { OpE9M1 },      { OpEA },
	{ OpEB },        { OpECX1 },      { OpEDM1 },      { OpEEM1 },      { OpEFM1 },
	{ OpF0E1 },      { OpF1E1 },      { OpF2E1 },      { OpF3M1 },      { OpF4E1 },
	{ OpF5E1 },      { OpF6E1 },      { OpF7M1 },      { OpF8 },        { OpF9M1X1 },
	{ OpFAE1 },      { OpFB },        { OpFCE1 },      { OpFDM1X1 },    { OpFEM1X1 },
	{ OpFFM1 }
};

struct SOpcodes S9xOpcodesM1X0[256] =
{
	{ Op00 },        { Op01E0M1 },    { Op02 },        { Op03M1 },      { Op04M1 },
	{ Op05M1 },      { Op06M1 },      { Op07M1 },      { Op08E0 },      { Op09M1 },
	{ Op0AM1 },      { Op0BE0 },      { Op0CM1 },      { Op0DM1 },      { Op0EM1 },
	{ Op0FM1 },      { Op10E0 },      { Op11E0M1X0 },  { Op12E0M1 },    { Op13M1 },
	{ Op14M1 },      { Op15E0M1 },    { Op16E0M1 },    { Op17M1 },      { Op18 },
	{ Op19M1X0 },    { Op1AM1 },      { Op1B },        { Op1CM1 },      { Op1DM1X0 },
	{ Op1EM1X0 },    { Op1FM1 },      { Op20E0 },      { Op21E0M1 },    { Op22E0 },
	{ Op23M1 },      { Op24M1 },      { Op25M1 },      { Op26M1 },      { Op27M1 },
	{ Op28E0 },      { Op29M1 },      { Op2AM1 },      { Op2BE0 },      { Op2CM1 },
	{ Op2DM1 },      { Op2EM1 },      { Op2FM1 },      { Op30E0 },      { Op31E0M1X0 },
	{ Op32E0M1 },    { Op33M1 },      { Op34E0M1 },    { Op35E0M1 },    { Op36E0M1 },
	{ Op37M1 },      { Op38 },        { Op39M1X0 },    { Op3AM1 },      { Op3B },
	{ Op3CM1X0 },    { Op3DM1X0 },    { Op3EM1X0 },    { Op3FM1 },      { Op40Slow },
	{ Op41E0M1 },    { Op42 },        { Op43M1 },      { Op44X0 },      { Op45M1 },
	{ Op46M1 },      { Op47M1 },      { Op48E0M1 },    { Op49M1 },      { Op4AM1 },
	{ Op4BE0 },      { Op4C },        { Op4DM1 },      { Op4EM1 },      { Op4FM1 },
	{ Op50E0 },      { Op51E0M1X0 },  { Op52E0M1 },    { Op53M1 },      { Op54X0 },
	{ Op55E0M1 },    { Op56E0M1 },    { Op57M1 },      { Op58 },        { Op59M1X0 },
	{ Op5AE0X0 },    { Op5B },        { Op5C },        { Op5DM1X0 },    { Op5EM1X0 },
	{ Op5FM1 },      { Op60E0 },      { Op61E0M1 },    { Op62E0 },      { Op63M1 },
	{ Op64M1 },      { Op65M1 },      { Op66M1 },      { Op67M1 },      { Op68E0M1 },
	{ Op69M1 },      { Op6AM1 },      { Op6BE0 },      { Op6C },        { Op6DM1 },
	{ Op6EM1 },      { Op6FM1 },      { Op70E0 },      { Op71E0M1X0 },  { Op72E0M1 },
	{ Op73M1 },      { Op74E0M1 },    { Op75E0M1 },    { Op76E0M1 },    { Op77M1 },
	{ Op78 },        { Op79M1X0 },    { Op7AE0X0 },    { Op7B },        { Op7C },
	{ Op7DM1X0 },    { Op7EM1X0 },    { Op7FM1 },      { Op80E0 },      { Op81E0M1 },
	{ Op82 },        { Op83M1 },      { Op84X0 },      { Op85M1 },      { Op86X0 },
	{ Op87M1 },      { Op88X0 },      { Op89M1 },      { Op8AM1 },      { Op8BE0 },
	{ Op8CX0 },      { Op8DM1 },      { Op8EX0 },      { Op8FM1 },      { Op90E0 },
	{ Op91E0M1X0 },  { Op92E0M1 },    { Op93M1 },      { Op94E0X0 },    { Op95E0M1 },
	{ Op96E0X0 },    { Op97M1 },      { Op98M1 },      { Op99M1X0 },    { Op9A },
	{ Op9BX0 },      { Op9CM1 },      { Op9DM1X0 },    { Op9EM1X0 },    { Op9FM1 },
	{ OpA0X0 },      { OpA1E0M1 },    { OpA2X0 },      { OpA3M1 },      { OpA4X0 },
	{ OpA5M1 },      { OpA6X0 },      { OpA7M1 },      { OpA8X0 },      { OpA9M1 },
	{ OpAAX0 },      { OpABE0 },      { OpACX0 },      { OpADM1 },      { OpAEX0 },
	{ OpAFM1 },      { OpB0E0 },      { OpB1E0M1X0 },  { OpB2E0M1 },    { OpB3M1 },
	{ OpB4E0X0 },    { OpB5E0M1 },    { OpB6E0X0 },    { OpB7M1 },      { OpB8 },
	{ OpB9M1X0 },    { OpBAX0 },      { OpBBX0 },      { OpBCX0 },      { OpBDM1X0 },
	{ OpBEX0 },      { OpBFM1 },      { OpC0X0 },      { OpC1E0M1 },    { OpC2 },
	{ OpC3M1 },      { OpC4X0 },      { OpC5M1 },      { OpC6M1 },      { OpC7M1 },
	{ OpC8X0 },      { OpC9M1 },      { OpCAX0 },      { OpCB },        { OpCCX0 },
	{ OpCDM1 },      { OpCEM1 },      { OpCFM1 },      { OpD0E0 },      { OpD1E0M1X0 },
	{ OpD2E0M1 },    { OpD3M1 },      { OpD4E0 },      { OpD5E0M1 },    { OpD6E0M1 },
	{ OpD7M1 },      { OpD8 },        { OpD9M1X0 },    { OpDAE0X0 },    { OpDB },
	{ OpDC },        { OpDDM1X0 },    { OpDEM1X0 },    { OpDFM1 },      { OpE0X0 },
	{ OpE1E0M1 },    { OpE2 },        { OpE3M1 },      { OpE4X0 },      { OpE5M1 },
	{ OpE6M1 },      { OpE7M1 },      { OpE8X0 },      { OpE9M1 },      { OpEA },
	{ OpEB },        { OpECX0 },      { OpEDM1 },      { OpEEM1 },      { OpEFM1 },
	{ OpF0E0 },      { OpF1E0M1X0 },  { OpF2E0M1 },    { OpF3M1 },      { OpF4E0 },
	{ OpF5E0M1 },    { OpF6E0M1 },    { OpF7M1 },      { OpF8 },        { OpF9M1X0 },
	{ OpFAE0X0 },    { OpFB },        { OpFCE0 },      { OpFDM1X0 },    { OpFEM1X0 },
	{ OpFFM1 }
};

struct SOpcodes S9xOpcodesM0X0[256] =
{
	{ Op00 },        { Op01E0M0 },    { Op02 },        { Op03M0 },      { Op04M0 },
	{ Op05M0 },      { Op06M0 },      { Op07M0 },      { Op08E0 },      { Op09M0 },
	{ Op0AM0 },      { Op0BE0 },      { Op0CM0 },      { Op0DM0 },      { Op0EM0 },
	{ Op0FM0 },      { Op10E0 },      { Op11E0M0X0 },  { Op12E0M0 },    { Op13M0 },
	{ Op14M0 },      { Op15E0M0 },    { Op16E0M0 },    { Op17M0 },      { Op18 },
	{ Op19M0X0 },    { Op1AM0 },      { Op1B },        { Op1CM0 },      { Op1DM0X0 },
	{ Op1EM0X0 },    { Op1FM0 },      { Op20E0 },      { Op21E0M0 },    { Op22E0 },
	{ Op23M0 },      { Op24M0 },      { Op25M0 },      { Op26M0 },      { Op27M0 },
	{ Op28E0 },      { Op29M0 },      { Op2AM0 },      { Op2BE0 },      { Op2CM0 },
	{ Op2DM0 },      { Op2EM0 },      { Op2FM0 },      { Op30E0 },      { Op31E0M0X0 },
	{ Op32E0M0 },    { Op33M0 },      { Op34E0M0 },    { Op35E0M0 },    { Op36E0M0 },
	{ Op37M0 },      { Op38 },        { Op39M0X0 },    { Op3AM0 },      { Op3B },
	{ Op3CM0X0 },    { Op3DM0X0 },    { Op3EM0X0 },    { Op3FM0 },      { Op40Slow },
	{ Op41E0M0 },    { Op42 },        { Op43M0 },      { Op44X0 },      { Op45M0 },
	{ Op46M0 },      { Op47M0 },      { Op48E0M0 },    { Op49M0 },      { Op4AM0 },
	{ Op4BE0 },      { Op4C },        { Op4DM0 },      { Op4EM0 },      { Op4FM0 },
	{ Op50E0 },      { Op51E0M0X0 },  { Op52E0M0 },    { Op53M0 },      { Op54X0 },
	{ Op55E0M0 },    { Op56E0M0 },    { Op57M0 },      { Op58 },        { Op59M0X0 },
	{ Op5AE0X0 },    { Op5B },        { Op5C },        { Op5DM0X0 },    { Op5EM0X0 },
	{ Op5FM0 },      { Op60E0 },      { Op61E0M0 },    { Op62E0 },      { Op63M0 },
	{ Op64M0 },      { Op65M0 },      { Op66M0 },      { Op67M0 },      { Op68E0M0 },
	{ Op69M0 },      { Op6AM0 },      { Op6BE0 },      { Op6C },        { Op6DM0 },
	{ Op6EM0 },      { Op6FM0 },      { Op70E0 },      { Op71E0M0X0 },  { Op72E0M0 },
	{ Op73M0 },      { Op74E0M0 },    { Op75E0M0 },    { Op76E0M0 },    { Op77M0 },
	{ Op78 },        { Op79M0X0 },    { Op7AE0X0 },    { Op7B },        { Op7C },
	{ Op7DM0X0 },    { Op7EM0X0 },    { Op7FM0 },      { Op80E0 },      { Op81E0M0 },
	{ Op82 },        { Op83M0 },      { Op84X0 },      { Op85M0 },      { Op86X0 },
	{ Op87M0 },      { Op88X0 },      { Op89M0 },      { Op8AM0 },      { Op8BE0 },
	{ Op8CX0 },      { Op8DM0 },      { Op8EX0 },      { Op8FM0 },      { Op90E0 },
	{ Op91E0M0X0 },  { Op92E0M0 },    { Op93M0 },      { Op94E0X0 },    { Op95E0M0 },
	{ Op96E0X0 },    { Op97M0 },      { Op98M0 },      { Op99M0X0 },    { Op9A },
	{ Op9BX0 },      { Op9CM0 },      { Op9DM0X0 },    { Op9EM0X0 },    { Op9FM0 },
	{ OpA0X0 },      { OpA1E0M0 },    { OpA2X0 },      { OpA3M0 },      { OpA4X0 },
	{ OpA5M0 },      { OpA6X0 },      { OpA7M0 },      { OpA8X0 },      { OpA9M0 },
	{ OpAAX0 },      { OpABE0 },      { OpACX0 },      { OpADM0 },      { OpAEX0 },
	{ OpAFM0 },      { OpB0E0 },      { OpB1E0M0X0 },  { OpB2E0M0 },    { OpB3M0 },
	{ OpB4E0X0 },    { OpB5E0M0 },    { OpB6E0X0 },    { OpB7M0 },      { OpB8 },
	{ OpB9M0X0 },    { OpBAX0 },      { OpBBX0 },      { OpBCX0 },      { OpBDM0X0 },
	{ OpBEX0 },      { OpBFM0 },      { OpC0X0 },      { OpC1E0M0 },    { OpC2 },
	{ OpC3M0 },      { OpC4X0 },      { OpC5M0 },      { OpC6M0 },      { OpC7M0 },
	{ OpC8X0 },      { OpC9M0 },      { OpCAX0 },      { OpCB },        { OpCCX0 },
	{ OpCDM0 },      { OpCEM0 },      { OpCFM0 },      { OpD0E0 },      { OpD1E0M0X0 },
	{ OpD2E0M0 },    { OpD3M0 },      { OpD4E0 },      { OpD5E0M0 },    { OpD6E0M0 },
	{ OpD7M0 },      { OpD8 },        { OpD9M0X0 },    { OpDAE0X0 },    { OpDB },
	{ OpDC },        { OpDDM0X0 },    { OpDEM0X0 },    { OpDFM0 },      { OpE0X0 },
	{ OpE1E0M0 },    { OpE2 },        { OpE3M0 },      { OpE4X0 },      { OpE5M0 },
	{ OpE6M0 },      { OpE7M0 },      { OpE8X0 },      { OpE9M0 },      { OpEA },
	{ OpEB },        { OpECX0 },      { OpEDM0 },      { OpEEM0 },      { OpEFM0 },
	{ OpF0E0 },      { OpF1E0M0X0 },  { OpF2E0M0 },    { OpF3M0 },      { OpF4E0 },
	{ OpF5E0M0 },    { OpF6E0M0 },    { OpF7M0 },      { OpF8 },        { OpF9M0X0 },
	{ OpFAE0X0 },    { OpFB },        { OpFCE0 },      { OpFDM0X0 },    { OpFEM0X0 },
	{ OpFFM0 }
};

struct SOpcodes S9xOpcodesM0X1[256] =
{
	{ Op00 },        { Op01E0M0 },    { Op02 },        { Op03M0 },      { Op04M0 },
	{ Op05M0 },      { Op06M0 },      { Op07M0 },      { Op08E0 },      { Op09M0 },
	{ Op0AM0 },      { Op0BE0 },      { Op0CM0 },      { Op0DM0 },      { Op0EM0 },
	{ Op0FM0 },      { Op10E0 },      { Op11E0M0X1 },  { Op12E0M0 },    { Op13M0 },
	{ Op14M0 },      { Op15E0M0 },    { Op16E0M0 },    { Op17M0 },      { Op18 },
	{ Op19M0X1 },    { Op1AM0 },      { Op1B },        { Op1CM0 },      { Op1DM0X1 },
	{ Op1EM0X1 },    { Op1FM0 },      { Op20E0 },      { Op21E0M0 },    { Op22E0 },
	{ Op23M0 },      { Op24M0 },      { Op25M0 },      { Op26M0 },      { Op27M0 },
	{ Op28E0 },      { Op29M0 },      { Op2AM0 },      { Op2BE0 },      { Op2CM0 },
	{ Op2DM0 },      { Op2EM0 },      { Op2FM0 },      { Op30E0 },      { Op31E0M0X1 },
	{ Op32E0M0 },    { Op33M0 },      { Op34E0M0 },    { Op35E0M0 },    { Op36E0M0 },
	{ Op37M0 },      { Op38 },        { Op39M0X1 },    { Op3AM0 },      { Op3B },
	{ Op3CM0X1 },    { Op3DM0X1 },    { Op3EM0X1 },    { Op3FM0 },      { Op40Slow },
	{ Op41E0M0 },    { Op42 },        { Op43M0 },      { Op44X1 },      { Op45M0 },
	{ Op46M0 },      { Op47M0 },      { Op48E0M0 },    { Op49M0 },      { Op4AM0 },
	{ Op4BE0 },      { Op4C },        { Op4DM0 },      { Op4EM0 },      { Op4FM0 },
	{ Op50E0 },      { Op51E0M0X1 },  { Op52E0M0 },    { Op53M0 },      { Op54X1 },
	{ Op55E0M0 },    { Op56E0M0 },    { Op57M0 },      { Op58 },        { Op59M0X1 },
	{ Op5AE0X1 },    { Op5B },        { Op5C },        { Op5DM0X1 },    { Op5EM0X1 },
	{ Op5FM0 },      { Op60E0 },      { Op61E0M0 },    { Op62E0 },      { Op63M0 },
	{ Op64M0 },      { Op65M0 },      { Op66M0 },      { Op67M0 },      { Op68E0M0 },
	{ Op69M0 },      { Op6AM0 },      { Op6BE0 },      { Op6C },        { Op6DM0 },
	{ Op6EM0 },      { Op6FM0 },      { Op70E0 },      { Op71E0M0X1 },  { Op72E0M0 },
	{ Op73M0 },      { Op74E0M0 },    { Op75E0M0 },    { Op76E0M0 },    { Op77M0 },
	{ Op78 },        { Op79M0X1 },    { Op7AE0X1 },    { Op7B },        { Op7C },
	{ Op7DM0X1 },    { Op7EM0X1 },    { Op7FM0 },      { Op80E0 },      { Op81E0M0 },
	{ Op82 },        { Op83M0 },      { Op84X1 },      { Op85M0 },      { Op86X1 },
	{ Op87M0 },      { Op88X1 },      { Op89M0 },      { Op8AM0 },      { Op8BE0 },
	{ Op8CX1 },      { Op8DM0 },      { Op8EX1 },      { Op8FM0 },      { Op90E0 },
	{ Op91E0M0X1 },  { Op92E0M0 },    { Op93M0 },      { Op94E0X1 },    { Op95E0M0 },
	{ Op96E0X1 },    { Op97M0 },      { Op98M0 },      { Op99M0X1 },    { Op9A },
	{ Op9BX1 },      { Op9CM0 },      { Op9DM0X1 },    { Op9EM0X1 },    { Op9FM0 },
	{ OpA0X1 },      { OpA1E0M0 },    { OpA2X1 },      { OpA3M0 },      { OpA4X1 },
	{ OpA5M0 },      { OpA6X1 },      { OpA7M0 },      { OpA8X1 },      { OpA9M0 },
	{ OpAAX1 },      { OpABE0 },      { OpACX1 },      { OpADM0 },      { OpAEX1 },
	{ OpAFM0 },      { OpB0E0 },      { OpB1E0M0X1 },  { OpB2E0M0 },    { OpB3M0 },
	{ OpB4E0X1 },    { OpB5E0M0 },    { OpB6E0X1 },    { OpB7M0 },      { OpB8 },
	{ OpB9M0X1 },    { OpBAX1 },      { OpBBX1 },      { OpBCX1 },      { OpBDM0X1 },
	{ OpBEX1 },      { OpBFM0 },      { OpC0X1 },      { OpC1E0M0 },    { OpC2 },
	{ OpC3M0 },      { OpC4X1 },      { OpC5M0 },      { OpC6M0 },      { OpC7M0 },
	{ OpC8X1 },      { OpC9M0 },      { OpCAX1 },      { OpCB },        { OpCCX1 },
	{ OpCDM0 },      { OpCEM0 },      { OpCFM0 },      { OpD0E0 },      { OpD1E0M0X1 },
	{ OpD2E0M0 },    { OpD3M0 },      { OpD4E0 },      { OpD5E0M0 },    { OpD6E0M0 },
	{ OpD7M0 },      { OpD8 },        { OpD9M0X1 },    { OpDAE0X1 },    { OpDB },
	{ OpDC },        { OpDDM0X1 },    { OpDEM0X1 },    { OpDFM0 },      { OpE0X1 },
	{ OpE1E0M0 },    { OpE2 },        { OpE3M0 },      { OpE4X1 },      { OpE5M0 },
	{ OpE6M0 },      { OpE7M0 },      { OpE8X1 },      { OpE9M0 },      { OpEA },
	{ OpEB },        { OpECX1 },      { OpEDM0 },      { OpEEM0 },      { OpEFM0 },
	{ OpF0E0 },      { OpF1E0M0X1 },  { OpF2E0M0 },    { OpF3M0 },      { OpF4E0 },
	{ OpF5E0M0 },    { OpF6E0M0 },    { OpF7M0 },      { OpF8 },        { OpF9M0X1 },
	{ OpFAE0X1 },    { OpFB },        { OpFCE0 },      { OpFDM0X1 },    { OpFEM0X1 },
	{ OpFFM0 }
};

struct SOpcodes S9xOpcodesSlow[256] =
{
	{ Op00 },        { Op01Slow },    { Op02 },        { Op03Slow },    { Op04Slow },
	{ Op05Slow },    { Op06Slow },    { Op07Slow },    { Op08Slow },    { Op09Slow },
	{ Op0ASlow },    { Op0BSlow },    { Op0CSlow },    { Op0DSlow },    { Op0ESlow },
	{ Op0FSlow },    { Op10Slow },    { Op11Slow },    { Op12Slow },    { Op13Slow },
	{ Op14Slow },    { Op15Slow },    { Op16Slow },    { Op17Slow },    { Op18 },
	{ Op19Slow },    { Op1ASlow },    { Op1B },        { Op1CSlow },    { Op1DSlow },
	{ Op1ESlow },    { Op1FSlow },    { Op20Slow },    { Op21Slow },    { Op22Slow },
	{ Op23Slow },    { Op24Slow },    { Op25Slow },    { Op26Slow },    { Op27Slow },
	{ Op28Slow },    { Op29Slow },    { Op2ASlow },    { Op2BSlow },    { Op2CSlow },
	{ Op2DSlow },    { Op2ESlow },    { Op2FSlow },    { Op30Slow },    { Op31Slow },
	{ Op32Slow },    { Op33Slow },    { Op34Slow },    { Op35Slow },    { Op36Slow },
	{ Op37Slow },    { Op38 },        { Op39Slow },    { Op3ASlow },    { Op3B },
	{ Op3CSlow },    { Op3DSlow },    { Op3ESlow },    { Op3FSlow },    { Op40Slow },
	{ Op41Slow },    { Op42 },        { Op43Slow },    { Op44Slow },    { Op45Slow },
	{ Op46Slow },    { Op47Slow },    { Op48Slow },    { Op49Slow },    { Op4ASlow },
	{ Op4BSlow },    { Op4CSlow },    { Op4DSlow },    { Op4ESlow },    { Op4FSlow },
	{ Op50Slow },    { Op51Slow },    { Op52Slow },    { Op53Slow },    { Op54Slow },
	{ Op55Slow },    { Op56Slow },    { Op57Slow },    { Op58 },        { Op59Slow },
	{ Op5ASlow },    { Op5B },        { Op5CSlow },    { Op5DSlow },    { Op5ESlow },
	{ Op5FSlow },    { Op60Slow },    { Op61Slow },    { Op62Slow },    { Op63Slow },
	{ Op64Slow },    { Op65Slow },    { Op66Slow },    { Op67Slow },    { Op68Slow },
	{ Op69Slow },    { Op6ASlow },    { Op6BSlow },    { Op6CSlow },    { Op6DSlow },
	{ Op6ESlow },    { Op6FSlow },    { Op70Slow },    { Op71Slow },    { Op72Slow },
	{ Op73Slow },    { Op74Slow },    { Op75Slow },    { Op76Slow },    { Op77Slow },
	{ Op78 },        { Op79Slow },    { Op7ASlow },    { Op7B },        { Op7CSlow },
	{ Op7DSlow },    { Op7ESlow },    { Op7FSlow },    { Op80Slow },    { Op81Slow },
	{ Op82Slow },    { Op83Slow },    { Op84Slow },    { Op85Slow },    { Op86Slow },
	{ Op87Slow },    { Op88Slow },    { Op89Slow },    { Op8ASlow },    { Op8BSlow },
	{ Op8CSlow },    { Op8DSlow },    { Op8ESlow },    { Op8FSlow },    { Op90Slow },
	{ Op91Slow },    { Op92Slow },    { Op93Slow },    { Op94Slow },    { Op95Slow },
	{ Op96Slow },    { Op97Slow },    { Op98Slow },    { Op99Slow },    { Op9A },
	{ Op9BSlow },    { Op9CSlow },    { Op9DSlow },    { Op9ESlow },    { Op9FSlow },
	{ OpA0Slow },    { OpA1Slow },    { OpA2Slow },    { OpA3Slow },    { OpA4Slow },
	{ OpA5Slow },    { OpA6Slow },    { OpA7Slow },    { OpA8Slow },    { OpA9Slow },
	{ OpAASlow },    { OpABSlow },    { OpACSlow },    { OpADSlow },    { OpAESlow },
	{ OpAFSlow },    { OpB0Slow },    { OpB1Slow },    { OpB2Slow },    { OpB3Slow },
	{ OpB4Slow },    { OpB5Slow },    { OpB6Slow },    { OpB7Slow },    { OpB8 },
	{ OpB9Slow },    { OpBASlow },    { OpBBSlow },    { OpBCSlow },    { OpBDSlow },
	{ OpBESlow },    { OpBFSlow },    { OpC0Slow },    { OpC1Slow },    { OpC2Slow },
	{ OpC3Slow },    { OpC4Slow },    { OpC5Slow },    { OpC6Slow },    { OpC7Slow },
	{ OpC8Slow },    { OpC9Slow },    { OpCASlow },    { OpCB },        { OpCCSlow },
	{ OpCDSlow },    { OpCESlow },    { OpCFSlow },    { OpD0Slow },    { OpD1Slow },
	{ OpD2Slow },    { OpD3Slow },    { OpD4Slow },    { OpD5Slow },    { OpD6Slow },
	{ OpD7Slow },    { OpD8 },        { OpD9Slow },    { OpDASlow },    { OpDB },
	{ OpDCSlow },    { OpDDSlow },    { OpDESlow },    { OpDFSlow },    { OpE0Slow },
	{ OpE1Slow },    { OpE2Slow },    { OpE3Slow },    { OpE4Slow },    { OpE5Slow },
	{ OpE6Slow },    { OpE7Slow },    { OpE8Slow },    { OpE9Slow },    { OpEA },
	{ OpEB },        { OpECSlow },    { OpEDSlow },    { OpEESlow },    { OpEFSlow },
	{ OpF0Slow },    { OpF1Slow },    { OpF2Slow },    { OpF3Slow },    { OpF4Slow },
	{ OpF5Slow },    { OpF6Slow },    { OpF7Slow },    { OpF8 },        { OpF9Slow },
	{ OpFASlow },    { OpFB },        { OpFCSlow },    { OpFDSlow },    { OpFESlow },
	{ OpFFSlow }
};
