/***********************************************************************************
  Snes9x - Portable Super Nintendo Entertainment System (TM) emulator.

  (c) Copyright 1996 - 2002  Gary Henderson (gary.henderson@ntlworld.com),
                             Jerremy Koot (jkoot@snes9x.com)

  (c) Copyright 2002 - 2004  Matthew Kendora

  (c) Copyright 2002 - 2005  Peter Bortas (peter@bortas.org)

  (c) Copyright 2004 - 2005  Joel Yliluoma (http://iki.fi/bisqwit/)

  (c) Copyright 2001 - 2006  John Weidman (jweidman@slip.net)

  (c) Copyright 2002 - 2006  funkyass (funkyass@spam.shaw.ca),
                             Kris Bleakley (codeviolation@hotmail.com)

  (c) Copyright 2002 - 2010  Brad Jorsch (anomie@users.sourceforge.net),
                             Nach (n-a-c-h@users.sourceforge.net),
                             zones (kasumitokoduck@yahoo.com)

  (c) Copyright 2006 - 2007  nitsuja

  (c) Copyright 2009 - 2010  BearOso,
                             OV2


  BS-X C emulator code
  (c) Copyright 2005 - 2006  Dreamer Nom,
                             zones

  C4 x86 assembler and some C emulation code
  (c) Copyright 2000 - 2003  _Demo_ (_demo_@zsnes.com),
                             Nach,
                             zsKnight (zsknight@zsnes.com)

  C4 C++ code
  (c) Copyright 2003 - 2006  Brad Jorsch,
                             Nach

  DSP-1 emulator code
  (c) Copyright 1998 - 2006  _Demo_,
                             Andreas Naive (andreasnaive@gmail.com),
                             Gary Henderson,
                             Ivar (ivar@snes9x.com),
                             John Weidman,
                             Kris Bleakley,
                             Matthew Kendora,
                             Nach,
                             neviksti (neviksti@hotmail.com)

  DSP-2 emulator code
  (c) Copyright 2003         John Weidman,
                             Kris Bleakley,
                             Lord Nightmare (lord_nightmare@users.sourceforge.net),
                             Matthew Kendora,
                             neviksti

  DSP-3 emulator code
  (c) Copyright 2003 - 2006  John Weidman,
                             Kris Bleakley,
                             Lancer,
                             z80 gaiden

  DSP-4 emulator code
  (c) Copyright 2004 - 2006  Dreamer Nom,
                             John Weidman,
                             Kris Bleakley,
                             Nach,
                             z80 gaiden

  OBC1 emulator code
  (c) Copyright 2001 - 2004  zsKnight,
                             pagefault (pagefault@zsnes.com),
                             Kris Bleakley
                             Ported from x86 assembler to C by sanmaiwashi

  SPC7110 and RTC C++ emulator code used in 1.39-1.51
  (c) Copyright 2002         Matthew Kendora with research by
                             zsKnight,
                             John Weidman,
                             Dark Force

  SPC7110 and RTC C++ emulator code used in 1.52+
  (c) Copyright 2009         byuu,
                             neviksti

  S-DD1 C emulator code
  (c) Copyright 2003         Brad Jorsch with research by
                             Andreas Naive,
                             John Weidman

  S-RTC C emulator code
  (c) Copyright 2001 - 2006  byuu,
                             John Weidman

  ST010 C++ emulator code
  (c) Copyright 2003         Feather,
                             John Weidman,
                             Kris Bleakley,
                             Matthew Kendora

  Super FX x86 assembler emulator code
  (c) Copyright 1998 - 2003  _Demo_,
                             pagefault,
                             zsKnight

  Super FX C emulator code
  (c) Copyright 1997 - 1999  Ivar,
                             Gary Henderson,
                             John Weidman

  Sound emulator code used in 1.5-1.51
  (c) Copyright 1998 - 2003  Brad Martin
  (c) Copyright 1998 - 2006  Charles Bilyue'

  Sound emulator code used in 1.52+
  (c) Copyright 2004 - 2007  Shay Green (gblargg@gmail.com)

  SH assembler code partly based on x86 assembler code
  (c) Copyright 2002 - 2004  Marcus Comstedt (marcus@mc.pp.se)

  2xSaI filter
  (c) Copyright 1999 - 2001  Derek Liauw Kie Fa

  HQ2x, HQ3x, HQ4x filters
  (c) Copyright 2003         Maxim Stepin (maxim@hiend3d.com)

  NTSC filter
  (c) Copyright 2006 - 2007  Shay Green

  GTK+ GUI code
  (c) Copyright 2004 - 2010  BearOso

  Win32 GUI code
  (c) Copyright 2003 - 2006  blip,
                             funkyass,
                             Matthew Kendora,
                             Nach,
                             nitsuja
  (c) Copyright 2009 - 2010  OV2

  Mac OS GUI code
  (c) Copyright 1998 - 2001  John Stiles
  (c) Copyright 2001 - 2010  zones


  Specific ports contains the works of other authors. See headers in
  individual files.


  Snes9x homepage: http://www.snes9x.com/

  Permission to use, copy, modify and/or distribute Snes9x in both binary
  and source form, for non-commercial purposes, is hereby granted without
  fee, providing that this license information and copyright notice appear
  with all copies and any derived work.

  This software is provided 'as-is', without any express or implied
  warranty. In no event shall the authors be held liable for any damages
  arising from the use of this software or it's derivatives.

  Snes9x is freeware for PERSONAL USE only. Commercial users should
  seek permission of the copyright holders first. Commercial use includes,
  but is not limited to, charging money for Snes9x or software derived from
  Snes9x, including Snes9x or derivatives in commercial game bundles, and/or
  using Snes9x as a promotion for your commercial product.

  The copyright holders request that bug fixes and improvements to the code
  should be forwarded to them so everyone can benefit from the modifications
  in future versions.

  Super NES and Super Nintendo Entertainment System are trademarks of
  Nintendo Co., Limited and its subsidiary companies.
 ***********************************************************************************/


#ifndef _PPU_H_
#define _PPU_H_

#define FIRST_VISIBLE_LINE	1

#define TILE_2BIT			0
#define TILE_4BIT			1
#define TILE_8BIT			2
#define TILE_2BIT_EVEN		3
#define TILE_2BIT_ODD		4
#define TILE_4BIT_EVEN		5
#define TILE_4BIT_ODD		6

#define MAX_2BIT_TILES		4096
#define MAX_4BIT_TILES		2048
#define MAX_8BIT_TILES		1024

#define CLIP_OR				0
#define CLIP_AND			1
#define CLIP_XOR			2
#define CLIP_XNOR			3

#define PPU_IRQ_SOURCE		(1 << 1)
#define GSU_IRQ_SOURCE		(1 << 2)
#define SA1_IRQ_SOURCE		(1 << 7)
#define SA1_DMA_IRQ_SOURCE	(1 << 5)

//uosnes added
#ifndef DMA_EXECUTE_PER_EVENT
extern int32 DMA_V_Counter;
extern int32 DMA_Cycles;
#endif

struct ClipData
{
	uint8	Count;
	uint8	DrawMode[6];
	uint16	Left[6];
	uint16	Right[6];
};

struct InternalPPU
{
	struct ClipData Clip[2][6];
	bool8	ColorsChanged;
	bool8	OBJChanged;
	bool8	DirectColourMapsNeedRebuild;
	uint8	*TileCache[7];
	uint8	*TileCached[7];
#ifdef CORRECT_VRAM_READS
	uint16	VRAMReadBuffer;
#else
	bool8	FirstVRAMRead;
#endif
	bool8	Interlace;
	bool8	InterlaceOBJ;//new
	bool8	PseudoHires;//new
	bool8	DoubleWidthPixels;
	bool8	DoubleHeightPixels;
	int		CurrentLine;
	int		PreviousLine;
	uint8	*XB;
	uint32	Red[256];
	uint32	Green[256];
	uint32	Blue[256];
	uint16	ScreenColors[256];
	uint8	MaxBrightness;
	bool8	RenderThisFrame;
	int		RenderedScreenWidth;
	int		RenderedScreenHeight;
	uint32	FrameCount;
	uint32	RenderedFramesCount;
	uint32	DisplayedRenderedFrameCount;
	uint32	TotalEmulatedFrames;//new
	uint32	SkippedFrames;
	uint32	FrameSkip;
};

struct SOBJ
{
	int16	HPos;
	uint16	VPos;
	uint8	HFlip;
	uint8	VFlip;
	uint16	Name;
	uint8	Priority;
	uint8	Palette;
	uint8	Size;
};

struct SPPU
{
	struct
	{
		bool8	High;
		uint8	Increment;
		uint16	Address;
		uint16	Mask1;
		uint16	FullGraphicCount;
		uint16	Shift;
	}	VMA;

	uint32	WRAM;

	struct
	{
		uint16	SCBase;
		uint16	HOffset;
		uint16	VOffset;
		uint8	BGSize;
		uint16	NameBase;
		uint16	SCSize;
	}	BG[4];

	uint8	BGMode;
	uint8	BG3Priority;

	bool8	CGFLIP;
	uint8	CGFLIPRead;
	uint8	CGADD;
	uint16	CGDATA[256];

	struct SOBJ OBJ[128];
	bool8	OBJThroughMain;
	bool8	OBJThroughSub;
	bool8	OBJAddition;
	uint16	OBJNameBase;
	uint16	OBJNameSelect;
	uint8	OBJSizeSelect;

	uint16	OAMAddr;
	uint16	SavedOAMAddr;
	uint8	OAMPriorityRotation;
	uint8	OAMFlip;
	uint8	OAMReadFlip;
	uint16	OAMTileAddress;
	uint16	OAMWriteRegister;//new
	uint8	OAMData[512 + 32];

	uint8	FirstSprite;
	uint8	LastSprite;
	uint8	RangeTimeOver;

	bool8	HTimerEnabled;
	bool8	VTimerEnabled;
	short	HTimerPosition;
	short	VTimerPosition;//new
	uint16	IRQHBeamPos;
	uint16	IRQVBeamPos;

	uint8	HBeamFlip;
	uint8	VBeamFlip;
	uint16	HBeamPosLatched;
	uint16	VBeamPosLatched;
	uint16	GunHLatch;//new
	uint16	GunVLatch;//new
	uint8	HVBeamCounterLatched;

	bool8	Mode7HFlip;
	bool8	Mode7VFlip;
	uint8	Mode7Repeat;
	short	MatrixA;
	short	MatrixB;
	short	MatrixC;
	short	MatrixD;
	short	CentreX;
	short	CentreY;
	short	M7HOFS;//new
	short	M7VOFS;//new

	uint8	Mosaic;
	uint8	MosaicStart;//new
	bool8	BGMosaic[4];

	uint8	Window1Left;
	uint8	Window1Right;
	uint8	Window2Left;
	uint8	Window2Right;
	bool8	RecomputeClipWindows;
	uint8	ClipCounts[6];
	uint8	ClipWindowOverlapLogic[6];
	uint8	ClipWindow1Enable[6];
	uint8	ClipWindow2Enable[6];
	bool8	ClipWindow1Inside[6];
	bool8	ClipWindow2Inside[6];

	bool8	ForcedBlanking;

	uint8	FixedColourRed;
	uint8	FixedColourGreen;
	uint8	FixedColourBlue;
	uint8	Brightness;
	uint16	ScreenHeight;

	bool8	Need16x8Mulitply;
	// XXX Do these need to be added to snapshot.cpp?
	uint8	BGnxOFSbyte;
	uint8	M7byte;//new

	uint8	HDMA;//new
	uint8	HDMAEnded;//new

	uint8	OpenBus1;
	uint8	OpenBus2;

	uint8  Joypad1ButtonReadPos;//old
	uint8  Joypad2ButtonReadPos;//old
	uint8  Joypad3ButtonReadPos;//old
	uint8  MouseSpeed[2];//old
};

extern uint16				SignExtend[2];
extern struct SPPU			PPU;
extern struct InternalPPU	IPPU;

void S9xResetPPU (void);
void S9xSoftResetPPU (void);
void S9xSetPPU (uint8, uint16);
uint8 S9xGetPPU (uint16);
void S9xSetCPU (uint8, uint16);
uint8 S9xGetCPU (uint16);
void S9xUpdateHVTimerPosition (void);
void S9xCheckMissingHTimerPosition (int32);
void S9xCheckMissingHTimerRange (int32, int32);
void S9xCheckMissingHTimerHalt (int32, int32);
void S9xFixColourBrightness (void);
void S9xDoAutoJoypad (void);

void S9xUpdateJoypads ();//old
void S9xProcessMouse(int which1);//old
void JustifierButtons(uint32&);//old
bool JustifierOffscreen();//old

#include "gfx.h"
#include "memmap.h"

typedef struct
{
	uint8	_5C77;
	uint8	_5C78;
	uint8	_5A22;
}	SnesModel;

extern SnesModel	*Model;
extern SnesModel	M1SNES;
extern SnesModel	M2SNES;

#define MAX_5C77_VERSION	0x01
#define MAX_5C78_VERSION	0x03
#define MAX_5A22_VERSION	0x02

#ifndef DMA_EXECUTE_PER_EVENT
#define V_COUNTER (!CPU.InDMA ? CPU.V_Counter : DMA_V_Counter)
#define CYCLES (!CPU.InDMA ? CPU.Cycles : DMA_Cycles)
#else
#define V_COUNTER (CPU.V_Counter)
#define CYCLES (CPU.Cycles)
#endif

#define BLANK_CHECK()\
  (PPU.ForcedBlanking || (V_COUNTER >= PPU.ScreenHeight + FIRST_VISIBLE_LINE))

static inline void FLUSH_REDRAW (void)
{
	if (IPPU.PreviousLine != IPPU.CurrentLine)
		S9xUpdateScreen();
}

static inline void CLEAR_REDRAW ()
{
	if(IPPU.PreviousLine != V_COUNTER &&
	   V_COUNTER > SNES_HEIGHT &&
	   V_COUNTER <= SNES_HEIGHT_EXTENDED)
		S9xUpdateClearScreen ();
}

static inline void REGISTER_2104 (uint8 Byte)
{
	// OAM format
	// 4 bytes
	// 0byte X
	// 1byte Y
	//
	// 3-4 bytes
	// 0-8 bits pattern number
	// 9-11 bits palette number
	// 12-13 bits priority bits
	// 14 bit H-Flip
	// 15 bit V-Flip

	if(!BLANK_CHECK())
	  {
	    int addr = 0x218;
	    if (Byte != PPU.OAMData [addr])
	      {
		FLUSH_REDRAW();
		PPU.OAMData[addr] = Byte;
		IPPU.OBJChanged = TRUE;

		// X position high bit, and sprite size (x4)
		struct SOBJ *pObj = &PPU.OBJ[(addr & 0x1f) * 4];
		pObj->HPos = (pObj->HPos & 0xFF) | SignExtend[(Byte >> 0) & 1];
		pObj++->Size = Byte & 2;
		pObj->HPos = (pObj->HPos & 0xFF) | SignExtend[(Byte >> 2) & 1];
		pObj++->Size = Byte & 8;
		pObj->HPos = (pObj->HPos & 0xFF) | SignExtend[(Byte >> 4) & 1];
		pObj++->Size = Byte & 32;
		pObj->HPos = (pObj->HPos & 0xFF) | SignExtend[(Byte >> 6) & 1];
		pObj->Size = Byte & 128;
	      }

	    PPU.OAMFlip ^= 1;
	    if (!(PPU.OAMFlip & 1))
	      {
		++PPU.OAMAddr;
		PPU.OAMAddr &= 0x1ff;
		if (PPU.OAMPriorityRotation && PPU.FirstSprite != (PPU.OAMAddr >> 1))
		  {
		    PPU.FirstSprite = (PPU.OAMAddr & 0xfe) >> 1;
		    IPPU.OBJChanged = TRUE;
		  }
	      }
	    else
	      {
		if (PPU.OAMPriorityRotation && (PPU.OAMAddr & 1))
		  IPPU.OBJChanged = TRUE;
	      }
	    return;
	  }

	if (PPU.OAMAddr & 0x100)
	{
		int addr = ((PPU.OAMAddr & 0x10f) << 1) + (PPU.OAMFlip & 1);
		if (Byte != PPU.OAMData[addr])
		{
			FLUSH_REDRAW();
			PPU.OAMData[addr] = Byte;
			IPPU.OBJChanged = TRUE;

			// X position high bit, and sprite size (x4)
			struct SOBJ *pObj = &PPU.OBJ[(addr & 0x1f) * 4];
			pObj->HPos = (pObj->HPos & 0xFF) | SignExtend[(Byte >> 0) & 1];
			pObj++->Size = Byte & 2;
			pObj->HPos = (pObj->HPos & 0xFF) | SignExtend[(Byte >> 2) & 1];
			pObj++->Size = Byte & 8;
			pObj->HPos = (pObj->HPos & 0xFF) | SignExtend[(Byte >> 4) & 1];
			pObj++->Size = Byte & 32;
			pObj->HPos = (pObj->HPos & 0xFF) | SignExtend[(Byte >> 6) & 1];
			pObj->Size = Byte & 128;
		}

		PPU.OAMFlip ^= 1;
		if (!(PPU.OAMFlip & 1))
		{
			++PPU.OAMAddr;
			PPU.OAMAddr &= 0x1ff;
			if (PPU.OAMPriorityRotation && PPU.FirstSprite != (PPU.OAMAddr >> 1))
			{
				PPU.FirstSprite = (PPU.OAMAddr & 0xfe) >> 1;
				IPPU.OBJChanged = TRUE;
			}
		}
		else
		{
			if (PPU.OAMPriorityRotation && (PPU.OAMAddr & 1))
				IPPU.OBJChanged = TRUE;
		}
	}
	else
	if (!(PPU.OAMFlip & 1))
	{
		PPU.OAMWriteRegister &= 0xff00;
		PPU.OAMWriteRegister |= Byte;
		PPU.OAMFlip |= 1;
		if (PPU.OAMPriorityRotation && (PPU.OAMAddr & 1))
			IPPU.OBJChanged = TRUE;
	}
	else
	{
		PPU.OAMWriteRegister &= 0x00ff;
		uint8 lowbyte = (uint8) (PPU.OAMWriteRegister);
		uint8 highbyte = Byte;
		PPU.OAMWriteRegister |= Byte << 8;

		int addr = (PPU.OAMAddr << 1);
		if (lowbyte != PPU.OAMData[addr] || highbyte != PPU.OAMData[addr + 1])
		{
			FLUSH_REDRAW();
			PPU.OAMData[addr] = lowbyte;
			PPU.OAMData[addr + 1] = highbyte;
			IPPU.OBJChanged = TRUE;
			if (addr & 2)
			{
				// Tile
				PPU.OBJ[addr = PPU.OAMAddr >> 1].Name = PPU.OAMWriteRegister & 0x1ff;
				// priority, h and v flip.
				PPU.OBJ[addr].Palette  = (highbyte >> 1) & 7;
				PPU.OBJ[addr].Priority = (highbyte >> 4) & 3;
				PPU.OBJ[addr].HFlip    = (highbyte >> 6) & 1;
				PPU.OBJ[addr].VFlip    = (highbyte >> 7) & 1;
			}
			else
			{
				// X position (low)
				PPU.OBJ[addr = PPU.OAMAddr >> 1].HPos &= 0xff00;
				PPU.OBJ[addr].HPos |= lowbyte;
				// Sprite Y position
				PPU.OBJ[addr].VPos = highbyte;
			}
		}

		PPU.OAMFlip &= ~1;
		++PPU.OAMAddr;
		if (PPU.OAMPriorityRotation && PPU.FirstSprite != (PPU.OAMAddr >> 1))
		{
			PPU.FirstSprite = (PPU.OAMAddr & 0xfe) >> 1;
			IPPU.OBJChanged = TRUE;
		}
	}
}

// This code is correct, however due to Snes9x's inaccurate timings, some games might be broken by this chage. :(
#ifdef DEBUGGER
#define CHECK_INBLANK() \
	if (!PPU.ForcedBlanking && V_COUNTER < PPU.ScreenHeight + FIRST_VISIBLE_LINE) \
	{ \
		printf("Invalid VRAM acess at (%04d, %04d) blank:%d\n", CYCLES, V_COUNTER, PPU.ForcedBlanking); \
		if (Settings.BlockInvalidVRAMAccess) \
			return; \
	}
#else
#define CHECK_INBLANK() \
	if (Settings.BlockInvalidVRAMAccess && !PPU.ForcedBlanking && V_COUNTER < PPU.ScreenHeight + FIRST_VISIBLE_LINE) \
		return;
#endif

static inline void REGISTER_2118 (uint8 Byte)
{
  //CHECK_INBLANK();

	uint32	address;

	if (PPU.VMA.FullGraphicCount)
	{
		uint32 rem = PPU.VMA.Address & PPU.VMA.Mask1;
		address = (((PPU.VMA.Address & ~PPU.VMA.Mask1) + (rem >> PPU.VMA.Shift) + ((rem & (PPU.VMA.FullGraphicCount - 1)) << 3)) << 1) & 0xffff;
		if(!Settings.BlockInvalidVRAMAccess || BLANK_CHECK())
		  Memory.VRAM [address] = Byte;
	}
	else
	  {
	    if(!Settings.BlockInvalidVRAMAccess || BLANK_CHECK())
	      Memory.VRAM[address = (PPU.VMA.Address << 1) & 0xffff] = Byte;
	    else
	      address = (PPU.VMA.Address << 1) & 0xffff;
	  }

	IPPU.TileCached[TILE_2BIT][address >> 4] = FALSE;
	IPPU.TileCached[TILE_4BIT][address >> 5] = FALSE;
	IPPU.TileCached[TILE_8BIT][address >> 6] = FALSE;
	IPPU.TileCached[TILE_2BIT_EVEN][address >> 4] = FALSE;
	IPPU.TileCached[TILE_2BIT_EVEN][((address >> 4) - 1) & (MAX_2BIT_TILES - 1)] = FALSE;
	IPPU.TileCached[TILE_2BIT_ODD] [address >> 4] = FALSE;
	IPPU.TileCached[TILE_2BIT_ODD] [((address >> 4) - 1) & (MAX_2BIT_TILES - 1)] = FALSE;
	IPPU.TileCached[TILE_4BIT_EVEN][address >> 5] = FALSE;
	IPPU.TileCached[TILE_4BIT_EVEN][((address >> 5) - 1) & (MAX_4BIT_TILES - 1)] = FALSE;
	IPPU.TileCached[TILE_4BIT_ODD] [address >> 5] = FALSE;
	IPPU.TileCached[TILE_4BIT_ODD] [((address >> 5) - 1) & (MAX_4BIT_TILES - 1)] = FALSE;

	if (!PPU.VMA.High)
	{
	#ifdef DEBUGGER
		if (Settings.TraceVRAM && !CPU.InDMAorHDMA)
			printf("VRAM write byte: $%04X (%d, %d)\n", PPU.VMA.Address, Memory.FillRAM[0x2115] & 3, (Memory.FillRAM[0x2115] & 0x0c) >> 2);
	#endif
		PPU.VMA.Address += PPU.VMA.Increment;
	}
}

static inline void REGISTER_2119 (uint8 Byte)
{
  //CHECK_INBLANK();

	uint32	address;

	if (PPU.VMA.FullGraphicCount)
	{
		uint32 rem = PPU.VMA.Address & PPU.VMA.Mask1;
		address = ((((PPU.VMA.Address & ~PPU.VMA.Mask1) + (rem >> PPU.VMA.Shift) + ((rem & (PPU.VMA.FullGraphicCount - 1)) << 3)) << 1) + 1) & 0xffff;
		if(!Settings.BlockInvalidVRAMAccess || BLANK_CHECK())
		  Memory.VRAM [address] = Byte;
	}
	else
	  {
	    if(!Settings.BlockInvalidVRAMAccess || BLANK_CHECK())
	      Memory.VRAM[address = ((PPU.VMA.Address << 1) + 1) & 0xffff] = Byte;
	    else
	      address = ((PPU.VMA.Address << 1) + 1) & 0xffff;
	  }

	IPPU.TileCached[TILE_2BIT][address >> 4] = FALSE;
	IPPU.TileCached[TILE_4BIT][address >> 5] = FALSE;
	IPPU.TileCached[TILE_8BIT][address >> 6] = FALSE;
	IPPU.TileCached[TILE_2BIT_EVEN][address >> 4] = FALSE;
	IPPU.TileCached[TILE_2BIT_EVEN][((address >> 4) - 1) & (MAX_2BIT_TILES - 1)] = FALSE;
	IPPU.TileCached[TILE_2BIT_ODD] [address >> 4] = FALSE;
	IPPU.TileCached[TILE_2BIT_ODD] [((address >> 4) - 1) & (MAX_2BIT_TILES - 1)] = FALSE;
	IPPU.TileCached[TILE_4BIT_EVEN][address >> 5] = FALSE;
	IPPU.TileCached[TILE_4BIT_EVEN][((address >> 5) - 1) & (MAX_4BIT_TILES - 1)] = FALSE;
	IPPU.TileCached[TILE_4BIT_ODD] [address >> 5] = FALSE;
	IPPU.TileCached[TILE_4BIT_ODD] [((address >> 5) - 1) & (MAX_4BIT_TILES - 1)] = FALSE;

	if (PPU.VMA.High)
	{
	#ifdef DEBUGGER
		if (Settings.TraceVRAM && !CPU.InDMAorHDMA)
			printf("VRAM write word: $%04X (%d, %d)\n", PPU.VMA.Address, Memory.FillRAM[0x2115] & 3, (Memory.FillRAM[0x2115] & 0x0c) >> 2);
	#endif
		PPU.VMA.Address += PPU.VMA.Increment;
	}
}

//PPU.VMA.FullGraphicCount != 0
//
//00000100b Increment by 8 for 32 times (2-bit formation).
//0000h, 0008h, 0010h, 0018h, 0020h, 0028h, 0030h, 0038h,
//0040h, 0048h, 0050h, 0058h, 0060h, 0068h, 0070h, 0078h,
//0080h, 0088h, 0090h, 0098h, 00A0h, 00A8h, 00B0h, 00B8h,
//00C0h, 00C8h, 00D0h, 00D8h, 00E0h, 00E8h, 00F0h, 00F8h,
//
//0001h, 0009h, 0011h, 0019h, 0021h, 0029h, 0031h, 0039h,
//0041h, 0049h, 0051h, 0059h, 0061h, 0069h, 0071h, 0079h,
//0081h, 0089h, 0091h, 0099h, 00A1h, 00A9h, 00B1h, 00B9h,
//00C1h, 00C9h, 00D1h, 00D9h, 00E1h, 00E9h, 00F1h, 00F9h,
//
//0002h, 000Ah, 0012h, 001Ah, 0022h, 002Ah, 0032h, 003Ah,
//0042h, 004Ah, 0052h, 005Ah, 0062h, 006Ah, 0072h, 007Ah,
//0082h, 008Ah, 0092h, 009Ah, 00A2h, 00AAh, 00B2h, 00BAh,
//00C2h, 00CAh, 00D2h, 00DAh, 00E2h, 00EAh, 00F2h, 00FAh,
//
//0003h, 000Bh, 0013h, 001Bh, 0023h, 002Bh, 0033h, 003Bh,
//0043h, 004Bh, 0053h, 005Bh, 0063h, 006Bh, 0073h, 007Bh,
//0083h, 008Bh, 0093h, 009Bh, 00A3h, 00ABh, 00B3h, 00BBh,
//00C3h, 00CBh, 00D3h, 00DBh, 00E3h, 00EBh, 00F3h, 00FBh,
//
//0004h, 000Ch, 0014h, 001Ch, 0024h, 002Ch, 0034h, 003Ch,
//0044h, 004Ch, 0054h, 005Ch, 0064h, 006Ch, 0074h, 007Ch,
//0084h, 008Ch, 0094h, 009Ch, 00A4h, 00ACh, 00B4h, 00BCh,
//00C4h, 00CCh, 00D4h, 00DCh, 00E4h, 00ECh, 00F4h, 00FCh,
//
//0005h, 000Dh, 0015h, 001Dh, 0025h, 002Dh, 0035h, 003Dh,
//0045h, 004Dh, 0055h, 005Dh, 0065h, 006Dh, 0075h, 007Dh,
//0085h, 008Dh, 0095h, 009Dh, 00A5h, 00ADh, 00B5h, 00BDh,
//00C5h, 00CDh, 00D5h, 00DDh, 00E5h, 00EDh, 00F5h, 00FDh,
//
//0006h, 000Eh, 0016h, 001Eh, 0026h, 002Eh, 0036h, 003Eh,
//0046h, 004Eh, 0056h, 005Eh, 0066h, 006Eh, 0076h, 007Eh,
//0086h, 008Eh, 0096h, 009Eh, 00A6h, 00AEh, 00B6h, 00BEh,
//00C6h, 00CEh, 00D6h, 00DEh, 00E6h, 00EEh, 00F6h, 00FEh,
//
//0007h, 000Fh, 0017h, 001Fh, 0027h, 002Fh, 0037h, 003Fh,
//0047h, 004Fh, 0057h, 005Fh, 0067h, 006Fh, 0077h, 007Fh,
//0087h, 008Fh, 0097h, 009Fh, 00A7h, 00AFh, 00B7h, 00BFh,
//00C7h, 00CFh, 00D7h, 00DFh, 00E7h, 00EFh, 00F7h, 00FFh,
//
//
//0100h, 0108h, 0110h, 0118h, 0120h, 0128h, 0130h, 0138h,
//0140h, 0148h, 0150h, 0158h, 0160h, 0168h, 0170h, 0178h,
//0180h, 0188h, 0190h, 0198h, 01A0h, 01A8h, 01B0h, 01B8h,
//01C0h, 01C8h, 01D0h, 01D8h, 01E0h, 01E8h, 01F0h, 01F8h,
//
//0101h, 0109h, 0111h, 0119h, 0121h, 0129h, 0131h, 0139h,
//0141h, 0149h, 0151h, 0159h, 0161h, 0169h, 0171h, 0179h,
//0181h, 0189h, 0191h, 0199h, 01A1h, 01A9h, 01B1h, 01B9h,
//01C1h, 01C9h, 01D1h, 01D9h, 01E1h, 01E9h, 01F1h, 01F9h,
//
//0102h, 010Ah, 0112h, 011Ah, 0122h, 012Ah, 0132h, 013Ah,
//0142h, 014Ah, 0152h, 015Ah, 0162h, 016Ah, 0172h, 017Ah,
//0182h, 018Ah, 0192h, 019Ah, 01A2h, 01AAh, 01B2h, 01BAh,
//01C2h, 01CAh, 01D2h, 01DAh, 01E2h, 01EAh, 01F2h, 01FAh,
//
//0103h, 010Bh, 0113h, 011Bh, 0123h, 012Bh, 0133h, 013Bh,
//0143h, 014Bh, 0153h, 015Bh, 0163h, 016Bh, 0173h, 017Bh,
//0183h, 018Bh, 0193h, 019Bh, 01A3h, 01ABh, 01B3h, 01BBh,
//01C3h, 01CBh, 01D3h, 01DBh, 01E3h, 01EBh, 01F3h, 01FBh,
//
//0104h, 010Ch, 0114h, 011Ch, 0124h, 012Ch, 0134h, 013Ch,
//0144h, 014Ch, 0154h, 015Ch, 0164h, 016Ch, 0174h, 017Ch,
//0184h, 018Ch, 0194h, 019Ch, 01A4h, 01ACh, 01B4h, 01BCh,
//01C4h, 01CCh, 01D4h, 01DCh, 01E4h, 01ECh, 01F4h, 01FCh,
//
//0105h, 010Dh, 0115h, 011Dh, 0125h, 012Dh, 0135h, 013Dh,
//0145h, 014Dh, 0155h, 015Dh, 0165h, 016Dh, 0175h, 017Dh,
//0185h, 018Dh, 0195h, 019Dh, 01A5h, 01ADh, 01B5h, 01BDh,
//01C5h, 01CDh, 01D5h, 01DDh, 01E5h, 01EDh, 01F5h, 01FDh,
//
//0106h, 010Eh, 0116h, 011Eh, 0126h, 012Eh, 0136h, 013Eh,
//0146h, 014Eh, 0156h, 015Eh, 0166h, 016Eh, 0176h, 017Eh,
//0186h, 018Eh, 0196h, 019Eh, 01A6h, 01AEh, 01B6h, 01BEh,
//01C6h, 01CEh, 01D6h, 01DEh, 01E6h, 01EEh, 01F6h, 01FEh,
//
//0107h, 010Fh, 0117h, 011Fh, 0127h, 012Fh, 0137h, 013Fh,
//0147h, 014Fh, 0157h, 015Fh, 0167h, 016Fh, 0177h, 017Fh,
//0187h, 018Fh, 0197h, 019Fh, 01A7h, 01AFh, 01B7h, 01BFh,
//01C7h, 01CFh, 01D7h, 01DFh, 01E7h, 01EFh, 01F7h, 01FFh,
//
static inline void REGISTER_2118_tile (uint8 Byte)
{
  //CHECK_INBLANK();

	uint32 rem = PPU.VMA.Address & PPU.VMA.Mask1;
	uint32 address = (((PPU.VMA.Address & ~PPU.VMA.Mask1) + (rem >> PPU.VMA.Shift) + ((rem & (PPU.VMA.FullGraphicCount - 1)) << 3)) << 1) & 0xffff;

	if(!Settings.BlockInvalidVRAMAccess || BLANK_CHECK())
	  Memory.VRAM [address] = Byte;

	IPPU.TileCached[TILE_2BIT][address >> 4] = FALSE;
	IPPU.TileCached[TILE_4BIT][address >> 5] = FALSE;
	IPPU.TileCached[TILE_8BIT][address >> 6] = FALSE;
	IPPU.TileCached[TILE_2BIT_EVEN][address >> 4] = FALSE;
	IPPU.TileCached[TILE_2BIT_EVEN][((address >> 4) - 1) & (MAX_2BIT_TILES - 1)] = FALSE;
	IPPU.TileCached[TILE_2BIT_ODD] [address >> 4] = FALSE;
	IPPU.TileCached[TILE_2BIT_ODD] [((address >> 4) - 1) & (MAX_2BIT_TILES - 1)] = FALSE;
	IPPU.TileCached[TILE_4BIT_EVEN][address >> 5] = FALSE;
	IPPU.TileCached[TILE_4BIT_EVEN][((address >> 5) - 1) & (MAX_4BIT_TILES - 1)] = FALSE;
	IPPU.TileCached[TILE_4BIT_ODD] [address >> 5] = FALSE;
	IPPU.TileCached[TILE_4BIT_ODD] [((address >> 5) - 1) & (MAX_4BIT_TILES - 1)] = FALSE;

	if (!PPU.VMA.High)
		PPU.VMA.Address += PPU.VMA.Increment;
}

static inline void REGISTER_2119_tile (uint8 Byte)
{
  //CHECK_INBLANK();

	uint32 rem = PPU.VMA.Address & PPU.VMA.Mask1;
	uint32 address = ((((PPU.VMA.Address & ~PPU.VMA.Mask1) + (rem >> PPU.VMA.Shift) + ((rem & (PPU.VMA.FullGraphicCount - 1)) << 3)) << 1) + 1) & 0xffff;

	if(!Settings.BlockInvalidVRAMAccess || BLANK_CHECK())
	  Memory.VRAM [address] = Byte;

	IPPU.TileCached[TILE_2BIT][address >> 4] = FALSE;
	IPPU.TileCached[TILE_4BIT][address >> 5] = FALSE;
	IPPU.TileCached[TILE_8BIT][address >> 6] = FALSE;
	IPPU.TileCached[TILE_2BIT_EVEN][address >> 4] = FALSE;
	IPPU.TileCached[TILE_2BIT_EVEN][((address >> 4) - 1) & (MAX_2BIT_TILES - 1)] = FALSE;
	IPPU.TileCached[TILE_2BIT_ODD] [address >> 4] = FALSE;
	IPPU.TileCached[TILE_2BIT_ODD] [((address >> 4) - 1) & (MAX_2BIT_TILES - 1)] = FALSE;
	IPPU.TileCached[TILE_4BIT_EVEN][address >> 5] = FALSE;
	IPPU.TileCached[TILE_4BIT_EVEN][((address >> 5) - 1) & (MAX_4BIT_TILES - 1)] = FALSE;
	IPPU.TileCached[TILE_4BIT_ODD] [address >> 5] = FALSE;
	IPPU.TileCached[TILE_4BIT_ODD] [((address >> 5) - 1) & (MAX_4BIT_TILES - 1)] = FALSE;

	if (PPU.VMA.High)
		PPU.VMA.Address += PPU.VMA.Increment;
}

static inline void REGISTER_2118_linear (uint8 Byte)
{
  //CHECK_INBLANK();

	uint32	address;

	if(!Settings.BlockInvalidVRAMAccess || BLANK_CHECK())
	  Memory.VRAM[address = (PPU.VMA.Address << 1) & 0xffff] = Byte;
	else
	  address = (PPU.VMA.Address << 1) & 0xffff;

	IPPU.TileCached[TILE_2BIT][address >> 4] = FALSE;
	IPPU.TileCached[TILE_4BIT][address >> 5] = FALSE;
	IPPU.TileCached[TILE_8BIT][address >> 6] = FALSE;
	IPPU.TileCached[TILE_2BIT_EVEN][address >> 4] = FALSE;
	IPPU.TileCached[TILE_2BIT_EVEN][((address >> 4) - 1) & (MAX_2BIT_TILES - 1)] = FALSE;
	IPPU.TileCached[TILE_2BIT_ODD] [address >> 4] = FALSE;
	IPPU.TileCached[TILE_2BIT_ODD] [((address >> 4) - 1) & (MAX_2BIT_TILES - 1)] = FALSE;
	IPPU.TileCached[TILE_4BIT_EVEN][address >> 5] = FALSE;
	IPPU.TileCached[TILE_4BIT_EVEN][((address >> 5) - 1) & (MAX_4BIT_TILES - 1)] = FALSE;
	IPPU.TileCached[TILE_4BIT_ODD] [address >> 5] = FALSE;
	IPPU.TileCached[TILE_4BIT_ODD] [((address >> 5) - 1) & (MAX_4BIT_TILES - 1)] = FALSE;

	if (!PPU.VMA.High)
		PPU.VMA.Address += PPU.VMA.Increment;
}

static inline void REGISTER_2119_linear (uint8 Byte)
{
  //CHECK_INBLANK();

	uint32	address;

	if(!Settings.BlockInvalidVRAMAccess || BLANK_CHECK())
	  Memory.VRAM[address = ((PPU.VMA.Address << 1) + 1) & 0xffff] = Byte;
	else
	  address = ((PPU.VMA.Address << 1) + 1) & 0xffff;

	IPPU.TileCached[TILE_2BIT][address >> 4] = FALSE;
	IPPU.TileCached[TILE_4BIT][address >> 5] = FALSE;
	IPPU.TileCached[TILE_8BIT][address >> 6] = FALSE;
	IPPU.TileCached[TILE_2BIT_EVEN][address >> 4] = FALSE;
	IPPU.TileCached[TILE_2BIT_EVEN][((address >> 4) - 1) & (MAX_2BIT_TILES - 1)] = FALSE;
	IPPU.TileCached[TILE_2BIT_ODD] [address >> 4] = FALSE;
	IPPU.TileCached[TILE_2BIT_ODD] [((address >> 4) - 1) & (MAX_2BIT_TILES - 1)] = FALSE;
	IPPU.TileCached[TILE_4BIT_EVEN][address >> 5] = FALSE;
	IPPU.TileCached[TILE_4BIT_EVEN][((address >> 5) - 1) & (MAX_4BIT_TILES - 1)] = FALSE;
	IPPU.TileCached[TILE_4BIT_ODD] [address >> 5] = FALSE;
	IPPU.TileCached[TILE_4BIT_ODD] [((address >> 5) - 1) & (MAX_4BIT_TILES - 1)] = FALSE;

	if (PPU.VMA.High)
		PPU.VMA.Address += PPU.VMA.Increment;
}

static inline void REGISTER_2122 (uint8 Byte)
{
	if (PPU.CGFLIP)
	{
		if ((Byte & 0x7f) != (PPU.CGDATA[PPU.CGADD] >> 8))
		{
			FLUSH_REDRAW();
			PPU.CGDATA[PPU.CGADD] &= 0x00ff;
			PPU.CGDATA[PPU.CGADD] |= (Byte & 0x7f) << 8;
			IPPU.ColorsChanged = TRUE;
			IPPU.Blue[PPU.CGADD] = IPPU.XB[(Byte >> 2) & 0x1f];
			IPPU.Green[PPU.CGADD] = IPPU.XB[(PPU.CGDATA[PPU.CGADD] >> 5) & 0x1f];
			IPPU.ScreenColors[PPU.CGADD] = (uint16) BUILD_PIXEL(IPPU.Red[PPU.CGADD], IPPU.Green[PPU.CGADD], IPPU.Blue[PPU.CGADD]);
		}

		PPU.CGADD++;
	}
	else
	{
		if (Byte != (uint8) (PPU.CGDATA[PPU.CGADD] & 0xff))
		{
			FLUSH_REDRAW();
			PPU.CGDATA[PPU.CGADD] &= 0x7f00;
			PPU.CGDATA[PPU.CGADD] |= Byte;
			IPPU.ColorsChanged = TRUE;
			IPPU.Red[PPU.CGADD] = IPPU.XB[Byte & 0x1f];
			IPPU.Green[PPU.CGADD] = IPPU.XB[(PPU.CGDATA[PPU.CGADD] >> 5) & 0x1f];
			IPPU.ScreenColors[PPU.CGADD] = (uint16) BUILD_PIXEL(IPPU.Red[PPU.CGADD], IPPU.Green[PPU.CGADD], IPPU.Blue[PPU.CGADD]);
		}
	}

	PPU.CGFLIP ^= 1;
}

static inline void REGISTER_2180 (uint8 Byte)
{
	Memory.RAM[PPU.WRAM++] = Byte;
	PPU.WRAM &= 0x1ffff;
}

static inline uint8 REGISTER_4212 (void)
{
	uint8	byte = 0;

    if ((CPU.V_Counter >= PPU.ScreenHeight + FIRST_VISIBLE_LINE) && (CPU.V_Counter < PPU.ScreenHeight + FIRST_VISIBLE_LINE + 3))
		byte = 1;
	if ((CPU.Cycles < Timings.HBlankEnd) || (CPU.Cycles >= Timings.HBlankStart))
		byte |= 0x40;
    if (CPU.V_Counter >= PPU.ScreenHeight + FIRST_VISIBLE_LINE)
		byte |= 0x80;

    return (byte);
}

#endif
