/*******************************************************************************
  Snes9x - Portable Super Nintendo Entertainment System (TM) emulator.
 
  (c) Copyright 1996 - 2002 Gary Henderson (gary.henderson@ntlworld.com) and
                            Jerremy Koot (jkoot@snes9x.com)

  (c) Copyright 2001 - 2004 John Weidman (jweidman@slip.net)

  (c) Copyright 2002 - 2004 Brad Jorsch (anomie@users.sourceforge.net),
                            funkyass (funkyass@spam.shaw.ca),
                            Joel Yliluoma (http://iki.fi/bisqwit/)
                            Kris Bleakley (codeviolation@hotmail.com),
                            Matthew Kendora,
                            Nach (n-a-c-h@users.sourceforge.net),
                            Peter Bortas (peter@bortas.org) and
                            zones (kasumitokoduck@yahoo.com)

  C4 x86 assembler and some C emulation code
  (c) Copyright 2000 - 2003 zsKnight (zsknight@zsnes.com),
                            _Demo_ (_demo_@zsnes.com), and Nach

  C4 C++ code
  (c) Copyright 2003 Brad Jorsch

  DSP-1 emulator code
  (c) Copyright 1998 - 2004 Ivar (ivar@snes9x.com), _Demo_, Gary Henderson,
                            John Weidman, neviksti (neviksti@hotmail.com),
                            Kris Bleakley, Andreas Naive

  DSP-2 emulator code
  (c) Copyright 2003 Kris Bleakley, John Weidman, neviksti, Matthew Kendora, and
                     Lord Nightmare (lord_nightmare@users.sourceforge.net

  OBC1 emulator code
  (c) Copyright 2001 - 2004 zsKnight, pagefault (pagefault@zsnes.com) and
                            Kris Bleakley
  Ported from x86 assembler to C by sanmaiwashi

  SPC7110 and RTC C++ emulator code
  (c) Copyright 2002 Matthew Kendora with research by
                     zsKnight, John Weidman, and Dark Force

  S-DD1 C emulator code
  (c) Copyright 2003 Brad Jorsch with research by
                     Andreas Naive and John Weidman
 
  S-RTC C emulator code
  (c) Copyright 2001 John Weidman
  
  ST010 C++ emulator code
  (c) Copyright 2003 Feather, Kris Bleakley, John Weidman and Matthew Kendora

  Super FX x86 assembler emulator code 
  (c) Copyright 1998 - 2003 zsKnight, _Demo_, and pagefault 

  Super FX C emulator code 
  (c) Copyright 1997 - 1999 Ivar, Gary Henderson and John Weidman


  SH assembler code partly based on x86 assembler code
  (c) Copyright 2002 - 2004 Marcus Comstedt (marcus@mc.pp.se) 

 
  Specific ports contains the works of other authors. See headers in
  individual files.
 
  Snes9x homepage: http://www.snes9x.com
 
  Permission to use, copy, modify and distribute Snes9x in both binary and
  source form, for non-commercial purposes, is hereby granted without fee,
  providing that this license information and copyright notice appear with
  all copies and any derived work.
 
  This software is provided 'as-is', without any express or implied
  warranty. In no event shall the authors be held liable for any damages
  arising from the use of this software.
 
  Snes9x is freeware for PERSONAL USE only. Commercial users should
  seek permission of the copyright holders first. Commercial use includes
  charging money for Snes9x or software derived from Snes9x.
 
  The copyright holders request that bug fixes and improvements to the code
  should be forwarded to them so everyone can benefit from the modifications
  in future versions.
 
  Super NES and Super Nintendo Entertainment System are trademarks of
  Nintendo Co., Limited and its subsidiary companies.
*******************************************************************************/

#include "snes9x.h"
#include "memmap.h"
#include "ppu.h"
#include "cpuexec.h"

#include "sa1.h"
#define CPU SA1
#define ICPU SA1
#define Registers SA1Registers
#define OpenBus							SA1OpenBus
#define S9xGetByte S9xSA1GetByte
#define S9xGetWord S9xSA1GetWord
#define S9xSetByte S9xSA1SetByte
#define S9xSetWord S9xSA1SetWord
#define S9xSetPCBase S9xSA1SetPCBase
#define S9xOpcodesM1X1 S9xSA1OpcodesM1X1
#define S9xOpcodesM1X0 S9xSA1OpcodesM1X0
#define S9xOpcodesM0X1 S9xSA1OpcodesM0X1
#define S9xOpcodesM0X0 S9xSA1OpcodesM0X0
#define S9xOpcodesE1   S9xSA1OpcodesE1
#define S9xOpcodesSlow					S9xSA1OpcodesSlow
#define S9xOpcode_IRQ S9xSA1Opcode_IRQ
#define S9xOpcode_NMI S9xSA1Opcode_NMI
#define S9xUnpackStatus S9xSA1UnpackStatus
#define S9xPackStatus S9xSA1PackStatus
#define S9xFixCycles S9xSA1FixCycles
#define Immediate8 SA1Immediate8
#define Immediate16 SA1Immediate16
#define Relative SA1Relative
#define RelativeLong SA1RelativeLong
#define AbsoluteIndexedIndirect SA1AbsoluteIndexedIndirect
#define AbsoluteIndirectLong SA1AbsoluteIndirectLong
#define AbsoluteIndirect SA1AbsoluteIndirect
#define Absolute SA1Absolute
#define AbsoluteLong SA1AbsoluteLong
#define Direct SA1Direct
#define DirectIndirectIndexed SA1DirectIndirectIndexed
#define DirectIndirectIndexedLong SA1DirectIndirectIndexedLong
#define DirectIndexedIndirect SA1DirectIndexedIndirect
#define DirectIndexedX SA1DirectIndexedX
#define DirectIndexedY SA1DirectIndexedY
#define AbsoluteIndexedX SA1AbsoluteIndexedX
#define AbsoluteIndexedY SA1AbsoluteIndexedY
#define AbsoluteLongIndexedX SA1AbsoluteLongIndexedX
#define DirectIndirect SA1DirectIndirect
#define DirectIndirectLong SA1DirectIndirectLong
#define StackRelative SA1StackRelative
#define StackRelativeIndirectIndexed SA1StackRelativeIndirectIndexed

////////////////////
//old definition
//
#define Immediate8_old						SA1Immediate8_old
#define Immediate16_old						SA1Immediate16_old
#define Relative_old						SA1Relative_old
#define RelativeLong_old					SA1RelativeLong_old
#define Absolute_old						SA1Absolute_old
#define AbsoluteLong_old					SA1AbsoluteLong_old
#define AbsoluteIndirect_old				SA1AbsoluteIndirect_old
#define AbsoluteIndirectLong_old			SA1AbsoluteIndirectLong_old
#define AbsoluteIndexedIndirect_old			SA1AbsoluteIndexedIndirect_old
#define Direct_old							SA1Direct_old
#define DirectIndirectIndexed_old			SA1DirectIndirectIndexed_old
#define DirectIndirectIndexedLong_old		SA1DirectIndirectIndexedLong_old
#define DirectIndexedIndirect_old			SA1DirectIndexedIndirect_old
#define DirectIndexedX_old					SA1DirectIndexedX_old
#define DirectIndexedY_old					SA1DirectIndexedY_old
#define AbsoluteIndexedX_old				SA1AbsoluteIndexedX_old
#define AbsoluteIndexedY_old				SA1AbsoluteIndexedY_old
#define AbsoluteLongIndexedX_old			SA1AbsoluteLongIndexedX_old
#define DirectIndirect_old					SA1DirectIndirect_old
#define DirectIndirectLong_old				SA1DirectIndirectLong_old
#define StackRelative_old					SA1StackRelative_old
#define StackRelativeIndirectIndexed_old	SA1StackRelativeIndirectIndexed_old

//#undef CPU_SHUTDOWN
#define SA1_OPCODES

#include "cpuops.cpp"

void S9xSA1MainLoop ()
{
    int i;
	for (i = 0; i < 3 && SA1.Executing; i++) {
		if (SA1.Flags) {
#if 0
			if (SA1.Flags & NMI_FLAG) {
				SA1.Flags &= ~NMI_FLAG;
				if (SA1.WaitingForInterrupt) {
					SA1.WaitingForInterrupt = FALSE;
					SA1.PC++;
					SA1Registers.PCw++;
				}
				S9xSA1Opcode_NMI ();
			}
#endif
			if (SA1.Flags & IRQ_FLAG) {
				if (SA1.IRQActive) {
					if (SA1.WaitingForInterrupt) {
						SA1.WaitingForInterrupt = FALSE;
						SA1.PC++;
						SA1Registers.PCw++;
					}
					if (!SA1CheckFlag (IRQ))
						S9xSA1Opcode_IRQ ();
				}
				else
					SA1.Flags &= ~IRQ_FLAG;
			}
#ifdef DEBUGGER
			if (SA1.Flags & TRACE_FLAG)
				S9xSA1Trace ();
#endif
		}
#ifdef CPU_SHUTDOWN
#ifdef OLD_PCBASE
		SA1.PBPCAtOpcodeStart = (SA1.ShiftedPB + SA1.PC - SA1.PCBase);
#else
		SA1.PBPCAtOpcodeStart = SA1Registers.PBPC;
#endif
#endif

		if (SA1.PCBase)
		{
			SA1OpenBus = SA1.PCBase[Registers.PCw];
		}

		//SA1Registers.PCw++;
		SA1.PC++;
		(*SA1.S9xOpcodes [S9xSA1GetByte(SA1.ShiftedPB + SA1Registers.PCw++)].S9xOpcode) ();
	}
}

