/***********************************************************************************
  Snes9x - Portable Super Nintendo Entertainment System (TM) emulator.

  (c) Copyright 1996 - 2002  Gary Henderson (gary.henderson@ntlworld.com),
                             Jerremy Koot (jkoot@snes9x.com)

  (c) Copyright 2002 - 2004  Matthew Kendora

  (c) Copyright 2002 - 2005  Peter Bortas (peter@bortas.org)

  (c) Copyright 2004 - 2005  Joel Yliluoma (http://iki.fi/bisqwit/)

  (c) Copyright 2001 - 2006  John Weidman (jweidman@slip.net)

  (c) Copyright 2002 - 2006  funkyass (funkyass@spam.shaw.ca),
                             Kris Bleakley (codeviolation@hotmail.com)

  (c) Copyright 2002 - 2010  Brad Jorsch (anomie@users.sourceforge.net),
                             Nach (n-a-c-h@users.sourceforge.net),
                             zones (kasumitokoduck@yahoo.com)

  (c) Copyright 2006 - 2007  nitsuja

  (c) Copyright 2009 - 2010  BearOso,
                             OV2


  BS-X C emulator code
  (c) Copyright 2005 - 2006  Dreamer Nom,
                             zones

  C4 x86 assembler and some C emulation code
  (c) Copyright 2000 - 2003  _Demo_ (_demo_@zsnes.com),
                             Nach,
                             zsKnight (zsknight@zsnes.com)

  C4 C++ code
  (c) Copyright 2003 - 2006  Brad Jorsch,
                             Nach

  DSP-1 emulator code
  (c) Copyright 1998 - 2006  _Demo_,
                             Andreas Naive (andreasnaive@gmail.com),
                             Gary Henderson,
                             Ivar (ivar@snes9x.com),
                             John Weidman,
                             Kris Bleakley,
                             Matthew Kendora,
                             Nach,
                             neviksti (neviksti@hotmail.com)

  DSP-2 emulator code
  (c) Copyright 2003         John Weidman,
                             Kris Bleakley,
                             Lord Nightmare (lord_nightmare@users.sourceforge.net),
                             Matthew Kendora,
                             neviksti

  DSP-3 emulator code
  (c) Copyright 2003 - 2006  John Weidman,
                             Kris Bleakley,
                             Lancer,
                             z80 gaiden

  DSP-4 emulator code
  (c) Copyright 2004 - 2006  Dreamer Nom,
                             John Weidman,
                             Kris Bleakley,
                             Nach,
                             z80 gaiden

  OBC1 emulator code
  (c) Copyright 2001 - 2004  zsKnight,
                             pagefault (pagefault@zsnes.com),
                             Kris Bleakley
                             Ported from x86 assembler to C by sanmaiwashi

  SPC7110 and RTC C++ emulator code used in 1.39-1.51
  (c) Copyright 2002         Matthew Kendora with research by
                             zsKnight,
                             John Weidman,
                             Dark Force

  SPC7110 and RTC C++ emulator code used in 1.52+
  (c) Copyright 2009         byuu,
                             neviksti

  S-DD1 C emulator code
  (c) Copyright 2003         Brad Jorsch with research by
                             Andreas Naive,
                             John Weidman

  S-RTC C emulator code
  (c) Copyright 2001 - 2006  byuu,
                             John Weidman

  ST010 C++ emulator code
  (c) Copyright 2003         Feather,
                             John Weidman,
                             Kris Bleakley,
                             Matthew Kendora

  Super FX x86 assembler emulator code
  (c) Copyright 1998 - 2003  _Demo_,
                             pagefault,
                             zsKnight

  Super FX C emulator code
  (c) Copyright 1997 - 1999  Ivar,
                             Gary Henderson,
                             John Weidman

  Sound emulator code used in 1.5-1.51
  (c) Copyright 1998 - 2003  Brad Martin
  (c) Copyright 1998 - 2006  Charles Bilyue'

  Sound emulator code used in 1.52+
  (c) Copyright 2004 - 2007  Shay Green (gblargg@gmail.com)

  SH assembler code partly based on x86 assembler code
  (c) Copyright 2002 - 2004  Marcus Comstedt (marcus@mc.pp.se)

  2xSaI filter
  (c) Copyright 1999 - 2001  Derek Liauw Kie Fa

  HQ2x, HQ3x, HQ4x filters
  (c) Copyright 2003         Maxim Stepin (maxim@hiend3d.com)

  NTSC filter
  (c) Copyright 2006 - 2007  Shay Green

  GTK+ GUI code
  (c) Copyright 2004 - 2010  BearOso

  Win32 GUI code
  (c) Copyright 2003 - 2006  blip,
                             funkyass,
                             Matthew Kendora,
                             Nach,
                             nitsuja
  (c) Copyright 2009 - 2010  OV2

  Mac OS GUI code
  (c) Copyright 1998 - 2001  John Stiles
  (c) Copyright 2001 - 2010  zones


  Specific ports contains the works of other authors. See headers in
  individual files.


  Snes9x homepage: http://www.snes9x.com/

  Permission to use, copy, modify and/or distribute Snes9x in both binary
  and source form, for non-commercial purposes, is hereby granted without
  fee, providing that this license information and copyright notice appear
  with all copies and any derived work.

  This software is provided 'as-is', without any express or implied
  warranty. In no event shall the authors be held liable for any damages
  arising from the use of this software or it's derivatives.

  Snes9x is freeware for PERSONAL USE only. Commercial users should
  seek permission of the copyright holders first. Commercial use includes,
  but is not limited to, charging money for Snes9x or software derived from
  Snes9x, including Snes9x or derivatives in commercial game bundles, and/or
  using Snes9x as a promotion for your commercial product.

  The copyright holders request that bug fixes and improvements to the code
  should be forwarded to them so everyone can benefit from the modifications
  in future versions.

  Super NES and Super Nintendo Entertainment System are trademarks of
  Nintendo Co., Limited and its subsidiary companies.
 ***********************************************************************************/


#ifndef _SNES9X_H_
#define _SNES9X_H_

#ifndef __UOSNES__
#ifndef VERSION
#define VERSION	"1.52"
#endif
#endif

#ifdef __UOSNES__
#include "uosnes.h"
#endif

#include "port.h"
#include "65c816.h"
#include "messages.h"

#ifdef ZLIB
#include <zlib.h>
#define STREAM					gzFile
#define READ_STREAM(p, l, s)	gzread(s, p, l)
#define WRITE_STREAM(p, l, s)	gzwrite(s, p, l)
#define GETS_STREAM(p, l, s)	gzgets(s, p, l)
#define GETC_STREAM(s)			gzgetc(s)
#define OPEN_STREAM(f, m)		gzopen(f, m)
#define REOPEN_STREAM(f, m)		gzdopen(f, m)
#define FIND_STREAM(f)			gztell(f)
#define REVERT_STREAM(f, o, s)	gzseek(f, o, s)
#define CLOSE_STREAM(s)			gzclose(s)
#else
#define STREAM					FILE *
#define READ_STREAM(p, l, s)	fread(p, 1, l, s)
#define WRITE_STREAM(p, l, s)	fwrite(p, 1, l, s)
#define GETS_STREAM(p, l, s)	fgets(p, l, s)
#define GETC_STREAM(s)			fgetc(s)
#define OPEN_STREAM(f, m)		fopen(f, m)
#define REOPEN_STREAM(f, m)		fdopen(f, m)
#define FIND_STREAM(f)			ftell(f)
#define REVERT_STREAM(f, o, s)	fseek(f, o, s)
#define CLOSE_STREAM(s)			fclose(s)
#endif

#define SNES_WIDTH					256
#define SNES_HEIGHT					224
#define SNES_HEIGHT_EXTENDED		239
#define MAX_SNES_WIDTH				(SNES_WIDTH * 2)
#define MAX_SNES_HEIGHT				(SNES_HEIGHT_EXTENDED * 2)
#define IMAGE_WIDTH					(Settings.SupportHiRes ? MAX_SNES_WIDTH : SNES_WIDTH)
#define IMAGE_HEIGHT				(Settings.SupportHiRes ? MAX_SNES_HEIGHT : SNES_HEIGHT_EXTENDED)

//wsnes9x.h defs
#define EXT_WIDTH (MAX_SNES_WIDTH + 4)
#define EXT_PITCH (EXT_WIDTH * 2)
#define EXT_HEIGHT (MAX_SNES_HEIGHT + 4)
// Offset into buffer to allow a two pixel border around the whole rendered
// SNES image. This is a speed up hack to allow some of the image processing
// routines to access black pixel data outside the normal bounds of the buffer.
#define EXT_OFFSET (EXT_PITCH * 2 + 2 * 2)
//

#define	NTSC_MASTER_CLOCK			21477272.0
#define	PAL_MASTER_CLOCK			21281370.0

#define SNES_MAX_NTSC_VCOUNTER		262
#define SNES_MAX_PAL_VCOUNTER		312

// 0-340
#define SNES_HCOUNTER_MAX			341

#define SPC700_TO_65C816_RATIO	2

#define ONE_CYCLE					6
#define SLOW_ONE_CYCLE				8
#define TWO_CYCLES					12
#define	ONE_DOT_CYCLE				4
#define DELAY_CYCLES 16
#define MAX_CYCLES 0x7fffffff

/* NTSC master clock signal 21.477272MHz
 * PPU: master clock / 4
 * 1 / PPU clock * 341 -> 63.509us
 * 63.509us / (1 / 3.579545MHz) -> 228 cycles per scanline
 * From Earth Worm Jim: APU executes an average of 65.14285714 cycles per
 * scanline giving an APU clock speed of 1.022731096MHz                    */

/* PAL master clock signal 21.28137MHz
 * PPU: master clock / 4
 * 1 / PPU clock * 341 -> 64.093us
 * 64.093us / (1 / 3.546895MHz) -> 228 cycles per scanline.  */

#define SNES_CYCLES_PER_SCANLINE	(SNES_HCOUNTER_MAX * ONE_DOT_CYCLE)
#define SNES_CYCLES_PER_SCANLINE_SHORT ((SNES_HCOUNTER_MAX - 1) * ONE_DOT_CYCLE)

//0.000063509 second
#define SNES_SCANLINE_TIME			(SNES_CYCLES_PER_SCANLINE / NTSC_MASTER_CLOCK)

//SPC700 Mater Clock, defined by bsnes
//32040.5 * 768
#define SMP_MASTER_CLOCK 24607104
#define SMP_ONE_CYCLE 24
#define FREQ_64K 384
#define RATE_64K 64081

////////////////////
//old definition
//

//#define OLD_PCBASE
//#define OLD_OPCODES

#ifdef NEW_TIMING
#define HBLANK_START (ONE_DOT_CYCLE * (22 + 256))
#define HBLANK_END (ONE_DOT_CYCLE * 22)
#else
#define HBLANK_START (ONE_DOT_CYCLE * 256)
#define HBLANK_END (ONE_DOT_CYCLE * 0)
#endif
#define RESET_POS              188
#define DRAM_REFRESH_POS       538
#define DRAM_REFRESH_POS_SHORT 534
#define DRAM_REFRESH_LENGTH    (ONE_DOT_CYCLE * 10)
//NTSC/PAL Differences, It referred to nesdev.
//
//Consoles in the USA and Europe run at different speeds due to the different television standards used.
//The main differences between the NTSC and PAL PPUs is as follows:
//
//Property 	        NTSC                PAL
//Clock speed       21.477272MHz / 4    26.601712MHz / 5
//Length of VBLANK 	20 scanlines        70 scanlines
#define SNES_NTSC_CYCLES_PER_SECOND 21477272
// 26601712 * 4 / 5 == 21281369.6
#define SNES_PAL_CYCLES_PER_SECOND 21281370
#define SNES_CYCLES_PER_SECOND (Settings.PAL ? SNES_PAL_CYCLES_PER_SECOND : SNES_NTSC_CYCLES_PER_SECOND)
//
//old definition End
///////////////////////


#define SNES_WRAM_REFRESH_HC_v1		530
#define SNES_WRAM_REFRESH_HC_v2		538
#define SNES_WRAM_REFRESH_CYCLES	40

#define SNES_HBLANK_START_HC		1096					// H=274
#define	SNES_HDMA_START_HC			1106					// FIXME: not true
#define	SNES_HBLANK_END_HC			4						// H=1
#define	SNES_HDMA_INIT_HC			20						// FIXME: not true
#define	SNES_RENDER_START_HC		(48 * ONE_DOT_CYCLE)	// FIXME: Snes9x renders a line at a time.

#define SNES_TR_MASK		(1 <<  4)
#define SNES_TL_MASK		(1 <<  5)
#define SNES_X_MASK			(1 <<  6)
#define SNES_A_MASK			(1 <<  7)
#define SNES_RIGHT_MASK		(1 <<  8)
#define SNES_LEFT_MASK		(1 <<  9)
#define SNES_DOWN_MASK		(1 << 10)
#define SNES_UP_MASK		(1 << 11)
#define SNES_START_MASK		(1 << 12)
#define SNES_SELECT_MASK	(1 << 13)
#define SNES_Y_MASK			(1 << 14)
#define SNES_B_MASK			(1 << 15)

//wsnes9x.h defs
enum
{
	SNES_JOYPAD,
	SNES_MOUSE,
	SNES_SUPERSCOPE,
	SNES_MULTIPLAYER5,
	SNES_JUSTIFIER,
	SNES_MOUSE_SWAPPED,
	SNES_MULTIPLAYER8,
	SNES_JUSTIFIER_2,
	SNES_MAX_CONTROLLER_OPTIONS
};

#define DEBUG_MODE_FLAG		(1 <<  0)	// debugger
#define TRACE_FLAG			(1 <<  1)	// debugger
#define SINGLE_STEP_FLAG	(1 <<  2)	// debugger
#define BREAK_FLAG			(1 <<  3)	// debugger
#define SAVE_SNAPSHOT_FLAG  (1 << 5)//old
#define DELAYED_NMI_FLAG    (1 << 6)//old
#define NMI_FLAG			(1 <<  7)	// CPU
#define PROCESS_SOUND_FLAG  (1 << 8)//old
#define IRQ_FLAG			(1 << 11)	// CPU
#define SCAN_KEYS_FLAG		(1 <<  4)	// CPU
#define HALTED_FLAG			(1 << 12)	// APU
#define FRAME_ADVANCE_FLAG	(1 <<  9)
#define DELAYED_NMI_FLAG2   (1 << 10)//old

#define ROM_NAME_LEN	23
#define AUTO_FRAMERATE	200

struct SCPUState
{
	int32	Cycles;
	int32	PrevCycles;
	int32	V_Counter;
	uint32	Flags;
	uint8	*PCBase;
	//  uint8   *PC;//old
	bool8   BranchSkip;//old
	bool8	IRQActive;
	int32	IRQPending;
	int32	MemSpeed;
	int32	MemSpeedx2;
	int32	FastROMSpeed;
	bool8	InDMA;
	bool8	InHDMA;
	bool8	InDMAorHDMA;
	bool8	InWRAMDMAorHDMA;
	uint8	HDMARanInDMA;
	int32	CurrentDMAorHDMAChannel;
	uint8	WhichEvent;
	int32	NextEvent;
	bool8	WaitingForInterrupt;
	bool8   NMIActive;//old
	uint32	WaitAddress;
	uint32	WaitCounter;
	uint32	PBPCAtOpcodeStart;
	uint32	AutoSaveTimer;
	bool8	SRAMModified;
	uint32 NMITriggerPoint;//old
	bool8  BRKTriggered;//old
	bool8  TriedInterleavedMode2;//old

    /* */

#ifdef DEBUG_MAXCOUNT
	unsigned long GlobalLoopCount;//old
#endif
	bool8  ssmp_sync;
};

////////////////////
//old definition
//
struct SEXTState {
	uint32 Clock;
	uint32 t64Cnt;
    long   NMICycleCount;
    int32  IRQCycleCount;
    long   SA1NMICycleCount;
    long   SA1IRQCycleCount;
    long   NextAPUTimerPos;
    long   APUTimerCounter;
    uint32 APUTimerCounter_err;
};
//
//old definition End
///////////////////////


////////////////////
//old definition
//
#define HBLANK_START_EVENT 0
#define HBLANK_END_EVENT 1
#define HTIMER_BEFORE_EVENT 2
#define HTIMER_AFTER_EVENT 3
#define HBLANK_HMAX_EVENT 4
#define DRAM_REFRESH_EVENT 5
#define NO_EVENT 6
//
//old definition End
///////////////////////


enum
{
	HC_HBLANK_START_EVENT = 1,
	HC_IRQ_1_3_EVENT      = 2,
	HC_HDMA_START_EVENT   = 3,
	HC_IRQ_3_5_EVENT      = 4,
	HC_HCOUNTER_MAX_EVENT = 5,
	HC_IRQ_5_7_EVENT      = 6,
	HC_HDMA_INIT_EVENT    = 7,
	HC_IRQ_7_9_EVENT      = 8,
	HC_RENDER_EVENT       = 9,
	HC_IRQ_9_A_EVENT      = 10,
	HC_WRAM_REFRESH_EVENT = 11,
	HC_IRQ_A_1_EVENT      = 12
};

struct STimings
{
	int32	H_Max_Master;
	int32	H_Max;
	int32	V_Max_Master;
	int32	V_Max;
	int32	HBlankStart;
	int32	HBlankEnd;
	int32	HDMAInit;
	int32	HDMAStart;
	int32	NMITriggerPos;
	int32	WRAMRefreshPos;
	int32	RenderPos;
	bool8	InterlaceField;
	int32	DMACPUSync;		// The cycles to synchronize DMA and CPU. Snes9x cannot emulate correctly.
	int32	NMIDMADelay;	// The delay of NMI trigger after DMA transfers. Snes9x cannot emulate correctly.
	int32	IRQPendCount;	// This value is just a hack, because Snes9x cannot emulate any events in an opcode.
	int32	APUSpeedup;
};

struct SSettings
{
	bool8	TraceDMA;
	bool8	TraceHDMA;
	bool8	TraceVRAM;
	bool8	TraceUnknownRegisters;
	bool8	TraceDSP;
	bool8	TraceHCEvent;

	bool8	SuperFX;
	uint8	DSP;
	bool8	SA1;
	bool8	C4;
	bool8	SDD1;
	bool8	SPC7110;
	bool8	SPC7110RTC;
	bool8	OBC1;
	uint8	SETA;
	bool8	SRTC;
	bool8	BS;
	bool8	BSXItself;
	bool8	BSXBootup;
	bool8	MouseMaster;
	bool8	SuperScopeMaster;
	bool8	JustifierMaster;
	bool8	MultiPlayer5Master;

	int	ControllerOption;//uosnes

	bool8	ForceLoROM;
	bool8	ForceHiROM;
	bool8	ForceHeader;
	bool8	ForceNoHeader;
	bool8	ForceInterleaved;
	bool8	ForceInterleaved2;
	bool8	ForceInterleaveGD24;
	bool8	ForceNotInterleaved;
	bool8	ForcePAL;
	bool8	ForceNTSC;
	bool8	PAL;
	uint32	FrameTimePAL;
	uint32	FrameTimeNTSC;
	uint32	FrameTime;

	bool8	SoundSync;
	bool8	SixteenBitSound;
	uint32	SoundPlaybackRate;
	uint32	SoundInputRate;
	bool8	Stereo;
	bool8	ReverseStereo;
	bool8	Mute;

	bool8	SupportHiRes;
	bool8	Transparency;
	uint8	BG_Forced;
	bool8	DisableGraphicWindows;

	bool8	DisplayFrameRate;
	bool8	DisplayWatchedAddresses;
	bool8	DisplayPressedKeys;
	bool8	DisplayMovieFrame;
	bool8	AutoDisplayMessages;
	uint32	InitialInfoStringTimeout;
	uint16	DisplayColor;

	bool8	Multi;
	char	CartAName[PATH_MAX + 1];
	char	CartBName[PATH_MAX + 1];

	bool8	DisableGameSpecificHacks;
	bool8	ShutdownMaster;
	bool8	Shutdown;
	bool8	ShutdownLock;//uosnes
	bool8	BlockInvalidVRAMAccessMaster;
	bool8	BlockInvalidVRAMAccess;
	bool8	BlockInvalidVRAMAccessLock;//uosnes
	bool8	DisableIRQ;
	bool8	DisableHDMA;
	int32	HDMATimingHack;
	int32	H_MaxTimingHack;//uosnes
	bool8	OldTimingMaster;//uosnes
	bool8	OldTiming;//uosnes
	bool8	HCyclesLock;//uosnes
	int32   APUOneCycle;//uosnes
	bool8   APUCycleLock;//uosnes
	int32   smp_master_clock;//uosnes
	bool8	ForcedPause;
	bool8	Paused;
	bool8	StopEmulation;

	uint32	SkipFrames;
	uint32	TurboSkipFrames;
	uint32	AutoMaxSkipFrames;
	bool8	TurboMode;
	bool8	SoundConstantTempo;
	uint32	HighSpeedSeek;
	bool8	FrameAdvance;

	bool8	NetPlay;
	bool8	NetPlayServer;
	char	ServerName[128];
	int		Port;

	bool8	MovieTruncate;
	bool8	MovieNotifyIgnored;
	bool8	WrongMovieStateProtection;
	bool8	DumpStreams;
	int		DumpStreamsMaxFrames;

	bool8	TakeScreenshot;
	int8	StretchScreenshots;
	bool8	SnapshotScreenshots;

	bool8	ApplyCheats;
	bool8	NoPatch;
	int32	AutoSaveDelay;
	bool8	DontSaveOopsSnapshot;
	bool8	UpAndDown;

	bool8	OpenGLEnable;

////////////////////
//old definition
//
    /* CPU options */
    bool8  APUEnabled;
    uint8  SoundSkipMethod;

    /* Tracing options */

    /* Joystick options */
    bool8  JoystickEnabled;
    bool8  JoystickConnected[8];

    /* Peripherial options */
    bool8  ForceSuperFX;
    bool8  ForceNoSuperFX;
    bool8  ForceDSP1;
    bool8  ForceNoDSP1;
    bool8  ForceSA1;
    bool8  ForceNoSA1;
    bool8  ForceC4;
    bool8  ForceNoC4;
    bool8  ForceSDD1;
    bool8  ForceNoSDD1;
    bool8  ForceBS;
    bool8  ForceNoBS;
    
    bool8  DSP1Master;
    bool8  SFT; /* Sufami Turbo */
 	bool8  XBAND;
 
	/* Sound options */
    bool8  TraceSoundDSP;
    int    SoundBufferSize;
    int    SoundMixInterval;
    bool8  SoundEnvelopeHeightReading;
    bool8  DisableSoundEcho;
    bool8  DisableSampleCaching;
    bool8  DisableMasterVolume;
    int    InterpolatedSound;
	bool8  LowPassFilter;
	bool8  SimpleFilter;
    bool8  ThreadSound;
    bool8  NextAPUEnabled;
    uint8  AltSampleDecode;
    bool8  FixFrequency;
    
    /* Graphics options */
    bool8  SixteenBit;
    bool8  Mode7Interpolate;
	bool8  GFXengine2;

    /* SNES graphics options */
    bool8  BGLayering;
    bool8  ForceTransparency;
    bool8  ForceNoTransparency;
    bool8  DisableRangeTimeOver; /* XXX: unused */

    /* Others */
    bool8  GlideEnable;
	bool8  DisableIRQCycleCount;
	bool8  SPCPlaying;
  
	/* Fixes for individual games */
    bool8  StarfoxHack;
    uint32 Mode7CentreMask; /* Old */
    bool8  ChuckRock; /* Old */
    bool8  WinterGold;
    bool8  WrestlemaniaArcade; /* Old */
    bool8  DaffyDuck;
    bool8  SampleCatchup;
    int    SoundDriver;
    int    AIDOShmId;

    uint8  APURAMInitialValue;
    uint8  APURAMInitialValueMaster;
    uint8  APURAMInitialValues[2];

	uint8  SRAMInitialValue;
	uint8  SRAMInitialValueMaster;
	uint8  SRAMInitialValues[4];

	uint8  RAMInitialValue;
	uint8  RAMInitialValueMaster;
	uint8  RAMInitialValues[2];

    bool8  LatchedInterlace_Fix; // Original
#ifdef DEBUG_MAXCOUNT
    unsigned int MaxCount;
#endif
//
//old definition End
///////////////////////
};


#ifdef __UOSNES__
#include "snes9xx.h"
#endif

struct SSNESGameFixes
{
	uint8	SRAMInitialValue;
	uint8	Uniracers;

////////////////////
//old definition
//
    uint8 alienVSpredetorFix;
    uint8 APU_OutPorts_ReturnValueFix;
    uint8 SoundEnvelopeHeightReading2;
	bool8 EchoOnlyOutput;
    // It is thought that there are some which are not needed.
	uint8 umiharakawaseFix;
	uint8 TouhaidenControllerFix;
	uint8 DerbyStallion;
	uint8 LetsPachi;
	uint8 ShinnichiFix;
	uint8 Panepon_SoundFix;
	uint8 XXX_IRQVBeamPos;
	uint8 PPU4212_Hack;
	uint8 VoicerKun;
	uint8 OLD_S9xAPUSetEndOfSample;
	uint8 APU_Disable;
	uint8 FuriFuriGirls;
	uint8 OdaNobunaga;

	uint8 SD_gundam_gaiden2_entaku_no_kishi;
	uint8 Chousenshi_in_tokyo_dome;
	uint8 BS_Lets_Pachinko_Nante_Gindama;
	uint8 NBABullsVsBlazersPB;
	uint8 All_JapanProWrestle;
	uint8 ikari_no_yousai;
//	uint8 PPU2102_ObjFix;
//
//old definition End
///////////////////////
};

enum
{
	PAUSE_NETPLAY_CONNECT		= (1 << 0),
	PAUSE_TOGGLE_FULL_SCREEN	= (1 << 1),
	PAUSE_EXIT					= (1 << 2),
	PAUSE_MENU					= (1 << 3),
	PAUSE_INACTIVE_WINDOW		= (1 << 4),
	PAUSE_WINDOW_ICONISED		= (1 << 5),
	PAUSE_RESTORE_GUI			= (1 << 6),
	PAUSE_FREEZE_FILE			= (1 << 7)
};

void S9xSetPause(uint32);
void S9xClearPause(uint32);
void S9xExit(void);
void S9xMessage(int, int, const char *);
void S9xLoadDefaultSettings ();//old

extern struct SSettings			Settings;
extern struct SSettings DefaultSettings;//old
extern struct SCPUState			CPU;
extern struct SEXTState EXT;//old
extern struct STimings			Timings;
extern struct SSNESGameFixes	SNESGameFixes;
extern char						String[513];

#endif
