/*
  Copyright (C) 2010 sanmaiwashi
*/

#include "snes9x.h"
#include "memmap.h"
#include "soundux.h"
#include "display.h"
#ifdef HAVE_IO_H
#include <io.h>
#elif HAVE_SYS_IO_H
#include <sys/io.h>
#endif
#include "cfgfile.h"
#include "config_tpl.h"
#include "commutil.h"

static char cfgfilename[_MAX_PATH + 1];

//RevID for refresh config
static int RevID = 134;

static void write_config ();

void
read_config ()
{
#ifdef __WIN32__
  //create fullpath of config.
  //
  //vista win7 or higher
  if (Options.osvi.dwMajorVersion >= 6)
    {
      if(strlen(Options.HomeDirectory) > PATH_MAX - 12)
	return;
      strcpy (cfgfilename, Options.HomeDirectory);
      strcat (cfgfilename, "\\uosnesw.ini");
    }
  else
    {
      int len = strlen (__argv[0]);
      if (len > _MAX_PATH)
	return;
      strcpy (cfgfilename, __argv[0]);
      strcpy (cfgfilename + (len - 4), ".ini");
    }
#endif

  if (!load_configfile (cfgfilename, config_data, write_config))
    {
      if (!configfile_cannot_create)
	{
	  write_config ();
	  flush_configfile ();
	}
      return;
    }

  read_port_config ();

  //clock
  Options.ClockDiff =
    (time_t) get_config_int (Options.ClockDiff, cs.option,
			    "ClockDiff");

  //other
  Options.LoadLastImageStartup =
    (b8) get_config_int (Options.LoadLastImageStartup, cs.option,
			    "LoadLastImageStartup");

  /* check RevID */
  if (RevID != get_config_int (0, cs.option, "RevID"))
    {
      remove ((const char *) cfgfilename);
      if (!load_configfile (cfgfilename, config_data, write_config))
	{
	  if (!configfile_cannot_create)
	    {
	      write_config ();
	      flush_configfile ();
	    }
	}
    }
  return;
}

static void
write_config ()
{
  if (configfile_cannot_create)
    return;

  write_port_config ();

  //clock
  set_config_int (cs.option, "ClockDiff", Options.ClockDiff);

  //other
  set_config_int (cs.option, "LoadLastImageStartup", Options.LoadLastImageStartup);

  set_config_int (cs.option, "RevID", RevID);
  return;
}
