#ifndef _CONFIG_TPL_H_
#define _CONFIG_TPL_H_

static const char config_data[] = {
"# uosnes Windows config file.\n"
"\n"
"[windows]\n"
"#  0 - IDLE_PRIORITY_CLASS             Specify this class for a process whose threads run only when\n"
"#                                      the system is idle. The threads of the process are preempted\n"
"#                                      by the threads of any process running in a higher priority\n"
"#                                      class. An example is a screen saver. The idle-priority class is\n"
"#                                      inherited by child processes.\n"
"#\n"
"#  1 - NORMAL_PRIORITY_CLASS(default)  Specify this class for a process with no special scheduling\n"
"#                                      needs.\n"
"#\n"
"#  2 - HIGH_PRIORITY_CLASS             Specify this class for a process that performs time-critical\n"
"#                                      tasks that must be executed immediately. The threads of the\n"
"#                                      process preempt the threads of normal or idle priority class\n"
"#                                      processes. An example is Windows Task List, which must\n"
"#                                      respond quickly when called by the user, regardless of the\n"
"#                                      load on the operating system. Use extreme care when using\n"
"#                                      the high-priority class, because a high-priority class\n"
"#                                      application can use nearly all available CPU time.\n"
"#\n"
"#  3 - REALTIME_PRIORITY_CLASS         Specify this class for a process that has the highest possible\n"
"#                                      priority. The threads of the process preempt the threads of all\n"
"#                                      other processes, including operating system processes\n"
"#                                      performing important tasks. For example, a real-time process\n"
"#                                      that executes for more than a very brief interval can cause disk\n"
"#                                      caches not to flush or cause the mouse to be unresponsive.\n"
"PriorityClass=\n"
"\n"
"#  0 - THREAD_PRIORITY_LOWEST          Indicates 2 points below normal priority for the\n"
"#                                      priority class.\n"
"#\n"
"#  1 - THREAD_PRIORITY_BELOW_NORMAL    Indicates 1 point below normal priority for the\n"
"#                                      priority class.\n"
"#\n"
"#  2 - THREAD_PRIORITY_NORMAL(default) Indicates normal priority for the priority class.\n"
"#\n"
"#  3 - THREAD_PRIORITY_ABOVE_NORMAL    Indicates 1 point above normal priority for the\n"
"#                                      priority class.\n"
"#\n"
"#  4 - THREAD_PRIORITY_HIGHEST         Indicates 2 points above normal priority for the\n"
"#                                      priority class.\n"
"#\n"
"#  5 - THREAD_PRIORITY_IDLE            Indicates a base priority level of 1 for\n"
"#                                      IDLE_PRIORITY_CLASS,\n"
"#                                      NORMAL_PRIORITY_CLASS, or\n"
"#                                      HIGH_PRIORITY_CLASS processes, and a base\n"
"#                                      priority level of 16 for\n"
"#                                      REALTIME_PRIORITY_CLASS processes.\n"
"#\n"
"#  6 - THREAD_PRIORITY_TIME_CRITICAL   Indicates a base priority level of 15 for\n"
"#                                      IDLE_PRIORITY_CLASS,\n"
"#                                      NORMAL_PRIORITY_CLASS, or\n"
"#                                      HIGH_PRIORITY_CLASS processes, and a base\n"
"#                                      priority level of 31 for\n"
"#                                      REALTIME_PRIORITY_CLASS processes.\n"
"ThreadPriority=\n"
"\n"
"#  Display window on foreground.\n"
"#  0 - off\n"
"#  1 - on(default)\n"
"WindowTopMost=\n"
"\n"
"#  Display window on foreground always.\n"
"#  0 - off(default)\n"
"#  1 - on\n"
"WindowTopMostAlways=\n"
"\n"
"#  statusbar setting.\n"
"statusbar=\n"
"\n"
"#  4:3 scale window adjust.\n"
"#  0 - off(default)\n"
"#  1 - on\n"
"AdjustWindow43=\n"
"\n"
"#  The operation when the application program is not active is permitted.\n"
"#  0 - off(default)\n"
"#  1 - on\n"
"Inactive_X=\n"
"\n"
"[graphics]\n"
"#  Windowed or Fullscreen.\n"
"#  0 - Window mode(default)\n"
"#  1 - Fullscreen mode\n"
"Fullscreen=\n"
"\n"
"#  DoubleRendering (default: Double)\n"
"#  Enable Double(x2) Rendering Mode, Hi-Res mode need this setting enable.\n"
"#  0 - Normal\n"
"#  1 - Double\n"
"DoubleRendering=\n"
"\n"
"#  Image Filter Selection.\n"
"#   0 - None\n"
"#   1 - Software Scale 2X 3X 4X\n"
"#   2 - Scanline 2X\n"
"#   3 - 2xSaI 2X\n"
"#   4 - Super 2xSaI 2X\n"
"#   5 - SuperEagle 2X\n"
"#   6 - TV Mode 2X\n"
"#   7 - HQ2X 3X 4X\n"
"#   8 - LQ2X\n"
"#   9 - EPX 2X\n"
"#  10 - Blargg's NTSC (Composite) 4:3 2X\n"
"#  11 - Blargg's NTSC (S-Video) 4:3 2X\n"
"#  12 - Blargg's NTSC (RGB) 4:3 2X\n"
"FilterMethod=\n"
"\n"
"#  Don't edit.\n"
"FullscreenDisplayModeIndex=\n"
"\n"
"#  Don't edit.\n"
"DisplayModeString=\n"
"\n"
"#  DoubleBuffering\n"
"#  Use DoubleBuffering on Fullscreen Mode(default: off)\n"
"#  0 - off\n"
"#  1 - on\n"
"DoubleBuffering=\n"
"\n"
"#  Windowed DirectDraw Clipper\n"
"#  Force Windowed DirectDraw Clipper or auto switch\n"
"#  Forced setting always do exactly DirectDraw cliping in window mode, but slowdown.\n"
"#  0 - Auto switch\n"
"#  1 - Force(default)\n"
"ForceWindowedDirectDrawClipper=\n"
"\n"
"#  Enables Vsync to smoothen animation. (slows down emulation though)\n"
"#  (default: None)\n"
"#  0 - None\n"
"#  1 - WaitForVerticalBlank()\n"
"#  2 - GetScanLine() and Timer\n"
"#  3 - Thread Render\n"
"wait_for_vsync=\n"
"\n"
"#  OffScreenVRAM\n"
"#  This setting reserve offscreen buffer in VRAM area,\n"
"#  to Speed Up or Slow Down ???\n"
"#  default setting reserve VRAM.\n"
"#  0 - off\n"
"#  1 - on(default)\n"
"OffScreenVRAM=\n"
"\n"
"#  BackBufferVRAM\n"
"#  0 - off\n"
"#  1 - on(default)\n"
"BackBufferVRAM=\n"
"\n"
"#  Use customized GFX engine.\n"
"#  0 - Disable\n"
"#  1 - Enable(default)\n"
"GFXengine2=\n"
"\n"
"#  GFX SixteenBit (default: on)\n"
"#  0 - off\n"
"#  1 - on\n"
"SixteenBit=\n"
"\n"
"#  Transparency (default: on)\n"
"#  0 - off\n"
"#  1 - on\n"
"Transparency=\n"
"\n"
"#  Swap background layer priorities from background involved in sub-screen\n"
"#  addition/subtraction. (default: disabled)\n"
"#  0 - Disable\n"
"#  1 - Enable\n"
"BGLayering=\n"
"\n"
"#  Disable graphics windows emulation. (default: disable)\n"
"#  0 - Disable (Enable Graphics Windows Emulation)\n"
"#  1 - Enable\n"
"DisableGraphicWindows=\n"
"\n"
"#  Turn off the H-DMA emulation. Pressing '0' during a game toggles H-DMA on\n"
"#  and off. (default: enabled)\n"
"#  0 - Enable\n"
"#  1 - Disable\n"
"DisableHDMA=\n"
"\n"
"#  Stretch the SNES display to fit the whole computer display. \n"
"#  (default: off)\n"
"#  0 - off\n"
"#  1 - on\n"
"#  2 - ClipScale\n"
"#  3 - ClipScale 4:3\n"
"stretch=\n"
"\n"
"#  Enables Hi-Res mode. Makes HiRes SNES games look correct\n"
"#  (default: on)\n"
"#  0 - off\n"
"#  1 - on\n"
"hires=\n"
"\n"
"#  Enables the mode 7 bi-linear filter code.\n"
"#  (default: off)\n"
"#  0 - off\n"
"#  1 - on\n"
"Mode7Interpolate=\n"
"\n"
"#  :P\n"
"#\n"
"#  0 - off\n"
"#  1 - on(default)\n"
"BlockInvalidVRAMAccess=\n"
"\n"
"[sound]\n"
"#  Stream API (default: DirectSound)\n"
"#  0 - waveOutSound\n"
"#  1 - DirectSound\n"
"DirectSound=\n"
"\n"
"#  Use DirectSound Notification Positions method.\n"
"#  (default: timeSetEvent)\n"
"#  0 - timeSetEvent\n"
"#  1 - DirectSoundNotify\n"
"DirectSoundNotify=\n"
"\n"
"#  Sound Output (default: on)\n"
"#  0 - off\n"
"#  1 - on\n"
"APUEnabled=\n"
"\n"
"#  Sound Rate Index\n"
"#  0 -  8000Hz\n"
"#  1 - 11025Hz\n"
"#  2 - 22050Hz\n"
"#  3 - 32000Hz(default)\n"
"#  4 - 44100Hz\n"
"#  5 - 48000Hz\n"
"SoundRate=\n"
"\n"
"#  Sound Bit\n"
"#  0 -  8bit\n"
"#  1 - 16bit(default)\n"
"SoundBit=\n"
"\n"
"#  Stereo\n"
"#  0 - mono\n"
"#  1 - stereo(default)\n"
"Stereo=\n"
"\n"
"#  InterpolatedSound 'smoothens' sound.\n"
"#  (default: Cubic)\n"
"#  0 - None\n"
"#  1 - Linear\n"
"#  2 - Cubic\n"
"#  3 - Gaussian\n"
"#  4 - Sinc\n"
"InterpolatedSound=\n"
"\n"
"#  low pass filter [bass] effect \n"
"#  (default: off)\n"
"#  0 - off\n"
"#  1 - on\n"
"LowPassFilter=\n"
"\n"
"#  Original Simple Method filter.\n"
"#  (default: off)\n"
"#  0 - off\n"
"#  1 - on\n"
"SimpleFilter=\n"
"\n"
"#  Sound playback buffer length 2-9*interval ms. (default: 3)\n"
"SoundBufferLength=\n"
"\n"
"#  SoundMixInterval 1-999ms. (default: 30)\n"
"SoundMixInterval=\n"
"\n"
"#  Create global Sound buffer. (default: 1)\n"
"SoundGlobalFocus=\n"
"\n"
"#  Enable volume envelope height reading by the sound CPU. (default: enabled)\n"
"SoundEnvelopeHeightReading=\n"
"\n"
"#  Disable Sound echo and FIR filter effects. (default: enabled)\n"
"#  0 - Enable\n"
"#  1 - Disable\n"
"DisableSoundEcho=\n"
"\n"
"#  Disable emulation of the sound DSP master volume control.\n"
"#  (default: disable)\n"
"#  0 - Disable (Enable DSP master volume control)\n"
"#  1 - Enable\n"
"DisableMasterVolume=\n"
"\n"
"#  Volume level 1-5. (default: 1)\n"
"VolumeLevel=\n"
"\n"
"#  Sound Skip Waiting Method. (DO NOT use if sound output is enabled)\n"
"#  (default: 0)\n"
"#  valid values: 0 - 3 \n"
"SoundSkipMethod=\n"
"\n"
"#  Reverse stereo sound output. (default: Disable)\n"
"#  0 - Disable\n"
"#  1 - Enable\n"
"ReverseStereo=\n"
"\n"
"[cpu]\n"
"#  Turn off a couple of speed hacks. The hacks boost the speed of many ROMs\n"
"#  but cause problems in a few ROMs. (default: enabled)\n"
"#  0 - Enable\n"
"#  1 - Disable\n"
"Shutdown=\n"
"\n"
"#  ONE_DOT_CYCLE == 4\n"
"#  SNES_HCOUNTER_MAX == 341\n"
"#\n"
"#  SNES_CYCLES_PER_SCANLINE == (SNES_HCOUNTER_MAX * ONE_DOT_CYCLE) == 1364, is MAX.\n"
"#\n"
"#  SNES_HBLANK_START_HC == 1096\n"
"#  SNES_HDMA_START_HC == 1106\n"
"#\n"
"#  HDMAStart == SNES_HDMA_START_HC + HDMATimingHack - 100\n"
"#  HBlankStart == SNES_HBLANK_START_HC + HDMAStart - SNES_HDMA_START_HC\n"
"#\n"
"#  HDMATimingHack setting is 0-350 effective range. (default: 100)\n"
"HDMATimingHack=\n"
"\n"
"#  H_Max == SNES_CYCLES_PER_SCANLINE + H_MaxTimingHack - 250\n"
"#\n"
"#  H_MaxTimingHack setting is 0-999 effective range. (default: 250)\n"
"H_MaxTimingHack=\n"
"\n"
"#  SNES_HBLANK_START_HC == (ONE_DOT_CYCLE * 256), and skip DRAM_REFRESH_EVENT.\n"
"#  0 - Disable\n"
"#  1 - Enable\n"
"OldTiming=\n"
"\n"
"#  IRQ Delay is set to 0.\n"
"#  0 - Disable\n"
"#  1 - Enable\n"
"DisableIRQCycleCount=\n"
"\n"
"#  SMP_MASTER_CLOCK default is 24607104.\n"
"smp_master_clock=\n"
"\n"
"#  SMP_ONE_CYCLE default is 24, SMP_MASTER_CLOCK/SMP_ONE_CYCLE == 1025296Hz.\n"
"smp_one_cycle=\n"
"\n"
"[timer]\n"
"#  Set this value to deliberately fix the frame skip rate and disable auto-\n"
"#  speed regulation. (default: auto-adjust)\n"
"#  valid values: 0 - 9\n"
"#  Leave blank for auto-adjust\n"
"SkipFrames=\n"
"\n"
"#  Max value of frame skip for auto-adjust.\n"
"#  valid values: 0 - 10 (default: 10)\n"
"AutoMaxSkipFrames=\n"
"\n"
"#  It skip this frame count in Turbo mode.\n"
"#  valid values: (slow) 0 - 15 (fast) (default: 15)\n"
"TurboSkipFrames=\n"
"\n"
"#  If auto-adjust frame skip option is in effect, then the emulator will\n"
"#  try to maintain a constant game and music speed locked to this value by\n"
"#  skipping the rendering of some frames or waiting until the required time\n"
"#  is reached. Increase the value to slow down games, decrease it to speed\n"
"#  up games.(Default: 16 for NTSC, 20 for PAL)\n"
"NTSCtiming=\n"
"PALtiming=\n"
"\n"
"#  Sound is constant in Turbo mode.\n"
"#  1 - Enable\n"
"#  0 - Disable(default)\n"
"SoundConstantTempo=\n"
"\n"
"[FileDirectory]\n"
"#  Home Directory.\n"
"#  ex. \"c:\\Program Files\\uosnesw\"\n"
"#      \"~/.uosnes\"\n"
"HomeDirectory=\n"
"\n"
"#Sets the search directory for ROM images.\n"
"LastROMFileName=\n"
"\n"
"#Recent Games\n"
"RecentROMFileName1=\n"
"RecentROMFileName2=\n"
"RecentROMFileName3=\n"
"RecentROMFileName4=\n"
"RecentROMFileName5=\n"
"RecentROMFileName6=\n"
"RecentROMFileName7=\n"
"RecentROMFileName8=\n"
"RecentROMFileName9=\n"
"RecentROMFileNameA=\n"
"\n"
"#  Directory to store SRAM State save files to.\n"
"#  (ex. C:\\uosnes\\SNESNAPS)\n"
"SnapShotDirectory=\n"
"\n"
"#  Screen image file save directory.\n"
"#  (ex. C:\\uosnes\\SCREEN)\n"
"ScreenShotDirectory=\n"
"\n"
"#  Dumped SPC file save directory.\n"
"#  (ex. C:\\uosnes\\SPC)\n"
"SPCDumpDirectory=\n"
"\n"
"#  Dumped Binary file save directory.\n"
"#  (ex. C:\\uosnes\\BINARY)\n"
"BinaryDumpDirectory=\n"
"\n"
"BSX=\n"
"SFT=\n"
"\n"
"[ControllerOption]\n"
"#  Connected status of Joysticks.\n"
"#  1 - Connected\n"
"#  0 - None\n"
"JoystickConnected0=\n"
"JoystickConnected1=\n"
"JoystickConnected2=\n"
"JoystickConnected3=\n"
"JoystickConnected4=\n"
"JoystickConnected5=\n"
"JoystickConnected6=\n"
"JoystickConnected7=\n"
"\n"
"#  Pluged input device.\n"
"#  0 - SNES Joypad(s) (default)\n"
"#  1 - SNES Mouse\n"
"#  2 - Super Scope\n"
"#  3 - Super Multitap (5-player)\n"
"#  4 - Konami Justifier\n"
"#  5 - Mouse in alternate port\n"
"#  6 - Multitaps (8-player)\n"
"#  7 - Dual Justifiers\n"
"ControllerOption=\n"
"\n"
"#  Set DirectInput or WinAPI.\n"
"#  0 - WinAPI\n"
"#  1 - DirectInput (default)\n"
"DirectInput=\n"
"\n"
"#  Enable Turbo Shot.\n"
"#  0 - Disable\n"
"#  1 - Enable (default)\n"
"TurboShotEnable=\n"
"\n"
"#  Don't edit this section.\n"
"[joypadA1]\n"
"Up=\n"
"Down=\n"
"Left=\n"
"Right=\n"
"AButton=\n"
"BButton=\n"
"XButton=\n"
"YButton=\n"
"SelectButton=\n"
"StartButton=\n"
"LButton=\n"
"RButton=\n"
"Up_Turbo=\n"
"Down_Turbo=\n"
"Left_Turbo=\n"
"Right_Turbo=\n"
"AButton_Turbo=\n"
"BButton_Turbo=\n"
"XButton_Turbo=\n"
"YButton_Turbo=\n"
"SelectButton_Turbo=\n"
"StartButton_Turbo=\n"
"LButton_Turbo=\n"
"RButton_Turbo=\n"
"\n"
"#  Don't edit this section.\n"
"[joypadA2]\n"
"Up=\n"
"Down=\n"
"Left=\n"
"Right=\n"
"AButton=\n"
"BButton=\n"
"XButton=\n"
"YButton=\n"
"SelectButton=\n"
"StartButton=\n"
"LButton=\n"
"RButton=\n"
"Up_Turbo=\n"
"Down_Turbo=\n"
"Left_Turbo=\n"
"Right_Turbo=\n"
"AButton_Turbo=\n"
"BButton_Turbo=\n"
"XButton_Turbo=\n"
"YButton_Turbo=\n"
"SelectButton_Turbo=\n"
"StartButton_Turbo=\n"
"LButton_Turbo=\n"
"RButton_Turbo=\n"
"\n"
"#  Don't edit this section.\n"
"[joypadA3]\n"
"Up=\n"
"Down=\n"
"Left=\n"
"Right=\n"
"AButton=\n"
"BButton=\n"
"XButton=\n"
"YButton=\n"
"SelectButton=\n"
"StartButton=\n"
"LButton=\n"
"RButton=\n"
"Up_Turbo=\n"
"Down_Turbo=\n"
"Left_Turbo=\n"
"Right_Turbo=\n"
"AButton_Turbo=\n"
"BButton_Turbo=\n"
"XButton_Turbo=\n"
"YButton_Turbo=\n"
"SelectButton_Turbo=\n"
"StartButton_Turbo=\n"
"LButton_Turbo=\n"
"RButton_Turbo=\n"
"\n"
"#  Don't edit this section.\n"
"[joypadA4]\n"
"Up=\n"
"Down=\n"
"Left=\n"
"Right=\n"
"AButton=\n"
"BButton=\n"
"XButton=\n"
"YButton=\n"
"SelectButton=\n"
"StartButton=\n"
"LButton=\n"
"RButton=\n"
"Up_Turbo=\n"
"Down_Turbo=\n"
"Left_Turbo=\n"
"Right_Turbo=\n"
"AButton_Turbo=\n"
"BButton_Turbo=\n"
"XButton_Turbo=\n"
"YButton_Turbo=\n"
"SelectButton_Turbo=\n"
"StartButton_Turbo=\n"
"LButton_Turbo=\n"
"RButton_Turbo=\n"
"\n"
"#  Don't edit this section.\n"
"[joypadA5]\n"
"Up=\n"
"Down=\n"
"Left=\n"
"Right=\n"
"AButton=\n"
"BButton=\n"
"XButton=\n"
"YButton=\n"
"SelectButton=\n"
"StartButton=\n"
"LButton=\n"
"RButton=\n"
"Up_Turbo=\n"
"Down_Turbo=\n"
"Left_Turbo=\n"
"Right_Turbo=\n"
"AButton_Turbo=\n"
"BButton_Turbo=\n"
"XButton_Turbo=\n"
"YButton_Turbo=\n"
"SelectButton_Turbo=\n"
"StartButton_Turbo=\n"
"LButton_Turbo=\n"
"RButton_Turbo=\n"
"\n"
"#  Don't edit this section.\n"
"[joypadA6]\n"
"Up=\n"
"Down=\n"
"Left=\n"
"Right=\n"
"AButton=\n"
"BButton=\n"
"XButton=\n"
"YButton=\n"
"SelectButton=\n"
"StartButton=\n"
"LButton=\n"
"RButton=\n"
"Up_Turbo=\n"
"Down_Turbo=\n"
"Left_Turbo=\n"
"Right_Turbo=\n"
"AButton_Turbo=\n"
"BButton_Turbo=\n"
"XButton_Turbo=\n"
"YButton_Turbo=\n"
"SelectButton_Turbo=\n"
"StartButton_Turbo=\n"
"LButton_Turbo=\n"
"RButton_Turbo=\n"
"\n"
"#  Don't edit this section.\n"
"[joypadA7]\n"
"Up=\n"
"Down=\n"
"Left=\n"
"Right=\n"
"AButton=\n"
"BButton=\n"
"XButton=\n"
"YButton=\n"
"SelectButton=\n"
"StartButton=\n"
"LButton=\n"
"RButton=\n"
"Up_Turbo=\n"
"Down_Turbo=\n"
"Left_Turbo=\n"
"Right_Turbo=\n"
"AButton_Turbo=\n"
"BButton_Turbo=\n"
"XButton_Turbo=\n"
"YButton_Turbo=\n"
"SelectButton_Turbo=\n"
"StartButton_Turbo=\n"
"LButton_Turbo=\n"
"RButton_Turbo=\n"
"\n"
"#  Don't edit this section.\n"
"[joypadA8]\n"
"Up=\n"
"Down=\n"
"Left=\n"
"Right=\n"
"AButton=\n"
"BButton=\n"
"XButton=\n"
"YButton=\n"
"SelectButton=\n"
"StartButton=\n"
"LButton=\n"
"RButton=\n"
"Up_Turbo=\n"
"Down_Turbo=\n"
"Left_Turbo=\n"
"Right_Turbo=\n"
"AButton_Turbo=\n"
"BButton_Turbo=\n"
"XButton_Turbo=\n"
"YButton_Turbo=\n"
"SelectButton_Turbo=\n"
"StartButton_Turbo=\n"
"LButton_Turbo=\n"
"RButton_Turbo=\n"
"\n"
"#  Don't edit.\n"
"[FunctionCodeA]\n"
"Code0=\n"
"Code1=\n"
"Code2=\n"
"Code3=\n"
"Code4=\n"
"Code5=\n"
"Code6=\n"
"Code7=\n"
"Code8=\n"
"\n"
"#  Don't edit this section.\n"
"[joypadB1]\n"
"Up=\n"
"Down=\n"
"Left=\n"
"Right=\n"
"AButton=\n"
"BButton=\n"
"XButton=\n"
"YButton=\n"
"SelectButton=\n"
"StartButton=\n"
"LButton=\n"
"RButton=\n"
"Up_Turbo=\n"
"Down_Turbo=\n"
"Left_Turbo=\n"
"Right_Turbo=\n"
"AButton_Turbo=\n"
"BButton_Turbo=\n"
"XButton_Turbo=\n"
"YButton_Turbo=\n"
"SelectButton_Turbo=\n"
"StartButton_Turbo=\n"
"LButton_Turbo=\n"
"RButton_Turbo=\n"
"\n"
"#  Don't edit this section.\n"
"[joypadB2]\n"
"Up=\n"
"Down=\n"
"Left=\n"
"Right=\n"
"AButton=\n"
"BButton=\n"
"XButton=\n"
"YButton=\n"
"SelectButton=\n"
"StartButton=\n"
"LButton=\n"
"RButton=\n"
"Up_Turbo=\n"
"Down_Turbo=\n"
"Left_Turbo=\n"
"Right_Turbo=\n"
"AButton_Turbo=\n"
"BButton_Turbo=\n"
"XButton_Turbo=\n"
"YButton_Turbo=\n"
"SelectButton_Turbo=\n"
"StartButton_Turbo=\n"
"LButton_Turbo=\n"
"RButton_Turbo=\n"
"\n"
"#  Don't edit this section.\n"
"[joypadB3]\n"
"Up=\n"
"Down=\n"
"Left=\n"
"Right=\n"
"AButton=\n"
"BButton=\n"
"XButton=\n"
"YButton=\n"
"SelectButton=\n"
"StartButton=\n"
"LButton=\n"
"RButton=\n"
"Up_Turbo=\n"
"Down_Turbo=\n"
"Left_Turbo=\n"
"Right_Turbo=\n"
"AButton_Turbo=\n"
"BButton_Turbo=\n"
"XButton_Turbo=\n"
"YButton_Turbo=\n"
"SelectButton_Turbo=\n"
"StartButton_Turbo=\n"
"LButton_Turbo=\n"
"RButton_Turbo=\n"
"\n"
"#  Don't edit this section.\n"
"[joypadB4]\n"
"Up=\n"
"Down=\n"
"Left=\n"
"Right=\n"
"AButton=\n"
"BButton=\n"
"XButton=\n"
"YButton=\n"
"SelectButton=\n"
"StartButton=\n"
"LButton=\n"
"RButton=\n"
"Up_Turbo=\n"
"Down_Turbo=\n"
"Left_Turbo=\n"
"Right_Turbo=\n"
"AButton_Turbo=\n"
"BButton_Turbo=\n"
"XButton_Turbo=\n"
"YButton_Turbo=\n"
"SelectButton_Turbo=\n"
"StartButton_Turbo=\n"
"LButton_Turbo=\n"
"RButton_Turbo=\n"
"\n"
"#  Don't edit this section.\n"
"[joypadB5]\n"
"Up=\n"
"Down=\n"
"Left=\n"
"Right=\n"
"AButton=\n"
"BButton=\n"
"XButton=\n"
"YButton=\n"
"SelectButton=\n"
"StartButton=\n"
"LButton=\n"
"RButton=\n"
"Up_Turbo=\n"
"Down_Turbo=\n"
"Left_Turbo=\n"
"Right_Turbo=\n"
"AButton_Turbo=\n"
"BButton_Turbo=\n"
"XButton_Turbo=\n"
"YButton_Turbo=\n"
"SelectButton_Turbo=\n"
"StartButton_Turbo=\n"
"LButton_Turbo=\n"
"RButton_Turbo=\n"
"\n"
"#  Don't edit this section.\n"
"[joypadB6]\n"
"Up=\n"
"Down=\n"
"Left=\n"
"Right=\n"
"AButton=\n"
"BButton=\n"
"XButton=\n"
"YButton=\n"
"SelectButton=\n"
"StartButton=\n"
"LButton=\n"
"RButton=\n"
"Up_Turbo=\n"
"Down_Turbo=\n"
"Left_Turbo=\n"
"Right_Turbo=\n"
"AButton_Turbo=\n"
"BButton_Turbo=\n"
"XButton_Turbo=\n"
"YButton_Turbo=\n"
"SelectButton_Turbo=\n"
"StartButton_Turbo=\n"
"LButton_Turbo=\n"
"RButton_Turbo=\n"
"\n"
"#  Don't edit this section.\n"
"[joypadB7]\n"
"Up=\n"
"Down=\n"
"Left=\n"
"Right=\n"
"AButton=\n"
"BButton=\n"
"XButton=\n"
"YButton=\n"
"SelectButton=\n"
"StartButton=\n"
"LButton=\n"
"RButton=\n"
"Up_Turbo=\n"
"Down_Turbo=\n"
"Left_Turbo=\n"
"Right_Turbo=\n"
"AButton_Turbo=\n"
"BButton_Turbo=\n"
"XButton_Turbo=\n"
"YButton_Turbo=\n"
"SelectButton_Turbo=\n"
"StartButton_Turbo=\n"
"LButton_Turbo=\n"
"RButton_Turbo=\n"
"\n"
"#  Don't edit this section.\n"
"[joypadB8]\n"
"Up=\n"
"Down=\n"
"Left=\n"
"Right=\n"
"AButton=\n"
"BButton=\n"
"XButton=\n"
"YButton=\n"
"SelectButton=\n"
"StartButton=\n"
"LButton=\n"
"RButton=\n"
"Up_Turbo=\n"
"Down_Turbo=\n"
"Left_Turbo=\n"
"Right_Turbo=\n"
"AButton_Turbo=\n"
"BButton_Turbo=\n"
"XButton_Turbo=\n"
"YButton_Turbo=\n"
"SelectButton_Turbo=\n"
"StartButton_Turbo=\n"
"LButton_Turbo=\n"
"RButton_Turbo=\n"
"\n"
"#  Don't edit.\n"
"[FunctionCodeB]\n"
"Code0=\n"
"Code1=\n"
"Code2=\n"
"Code3=\n"
"Code4=\n"
"Code5=\n"
"Code6=\n"
"Code7=\n"
"Code8=\n"
"\n"
"[gui]\n"
"#  Language US or JP, this setting is switchable in JP environment.\n"
"#  0 - US\n"
"#  1 - JP\n"
"Language=\n"
"\n"
"#  File Browse Window.\n"
"#  0 - GetOpenFileName()\n"
"#  1 - uosXplorer\n"
"FileBrowseWindow=\n"
"\n"
"#  Don't edit.\n"
"WindowRectLeft=\n"
"WindowRectRight=\n"
"WindowRectTop=\n"
"WindowRectBottom=\n"
"uosXpWindowRectLeft=\n"
"uosXpWindowRectRight=\n"
"uosXpWindowRectTop=\n"
"uosXpWindowRectBottom=\n"
"uosXpMaximize=\n"
"uosXpVSplitBarPos0=\n"
"uosXpColumnWidth0=\n"
"uosXpColumnWidth1=\n"
"uosXpColumnWidth2=\n"
"uosXpColumnWidth3=\n"
"\n"
"[screenshot]\n"
"#  SaveImagefileFormat\n"
"#  0 - bmp (default)\n"
"#  1 - pcx\n"
"#  2 - gif\n"
"#  3 - png\n"
"SaveImagefileFormat=\n"
"\n"
"#  Reduce the color of image file to 256.\n"
"ReduceTheColorTo256=\n"
"\n"
"#  Reduce the color of image file to 256(8bit), if it's within 256.\n"
"ReduceTheColorTo256IfWithin=\n"
"\n"
"ImagefileHiresStretch=\n"
"\n"
"RLEcompression256bitmap=\n"
"\n"
"[debug]\n"
"AttachConsole=\n"
"\n"
"DisableGameSpecificHacks=\n"
"\n"
"DisplayScreenBufferAll=\n"
"\n"
"[option]\n"
"#  Enable cheat code\n"
"#  It load cheat data \"*.CHT\" file from SnapShotDirectory.\n"
"#  0 - Disable\n"
"#  1 - Enable\n"
"ApplyCheats=\n"
"\n"
"ShowFPS=\n"
"\n"
"MuteSound=\n"
"\n"
"AutoSaveDelay=\n"
"\n"
"#  Enable uosnes CD-DA\n"
"#  0 - Disable\n"
"#  1 - Enable\n"
"UseCDDA=\n"
"\n"
"#  uosnes CD-Drive Select\n"
"#  0 - A: / 1 - B: / 2 - C: / 3 - D: / 4 - E: / 5 - F: / 6 - G:\n"
"#  7 - H: / ... / 25 - Z:\n"
"CDDrv=\n"
"\n"
"#  time_t diff which is -(past) or +(future), default value is 0.\n"
"#\n"
"#  Don't edit.\n"
"ClockDiff=\n"
"\n"
"#  Last image is loaded at the startup.\n"
"#  1 - Enable\n"
"#  0 - Disable(default)\n"
"LoadLastImageStartup=\n"
"\n"
"#  Don't edit.\n"
"RevID=\n"
"\n"
};

#endif /* _CONFIG_TPL_H_ */

