#ifndef _RENDER_H
#define _RENDER_H

#ifndef __WIN32__
struct SSurface
{
  uint8 *Surface;
  uint32 Pitch;
  uint32 Width;
  uint32 Height;
};
typedef struct tagRECT { 
  long left;
  long top;
  long right;
  long bottom;
} RECT;
#endif

typedef void (*TRenderMethod) (SSurface * Src, SSurface * Dst, RECT * srcRect,
			       RECT * dstRect);

void SelectRenderMethod (int FilterMethod,
			 int srcWidth, int srcHeight,
			 int dstWidth, int dstHeight,
			 int &imageWidth, int &imageHeight);
void ResetRenderMethod ();
bool8 RenderInit (int filtermethod,
		  int screendepth,
		  int redshift,
		  int greenshift,
		  int blueshift);
void RenderDeinit();
int GetFilterScale(int FilterMethod);
extern TRenderMethod RenderMethod;
extern TRenderMethod OldRenderMethod;
extern bool8 DoubleHeight, DoubleWidth, ExtendHeight, ExtendHeight_previos;

#endif /* _RENDER_H */

