/*
  Copyright (C) 2010 sanmaiwashi
*/

#include "uosnes.h"
#include "snes9x.h"
#ifdef __WIN32__
#include "uosnesw.h"
#include <shlobj.h>
#endif

const char version_string[] = PACKAGE_VERSION;
const char bug_report_url[] = PACKAGE_BUGREPORT;

OOptions Options;
OOptions DefaultOptions;

Scs cs = {
  "windows",			//windows
  "graphics",			//graphics
  "sound",			//sound
  "cpu",			//cpu
  "timer",			//timer
  "FileDirectory",		//FileDirectory
  "ControllerOption",		//ControllerOption
  {"joypadA1", "joypadA2", "joypadA3", "joypadA4", "joypadA5", "joypadA6", "joypadA7", "joypadA8"},//joypadA
  {"joypadB1", "joypadB2", "joypadB3", "joypadB4", "joypadB5", "joypadB6", "joypadB7", "joypadB8"},//joypadB
  {"Up",			//button
   "Down",
   "Left",
   "Right",
   "AButton",
   "BButton",
   "XButton",
   "YButton",
   "SelectButton",
   "StartButton",
   "LButton",
   "RButton",
   "Up_Turbo",
   "Down_Turbo",
   "Left_Turbo",
   "Right_Turbo",
   "AButton_Turbo",
   "BButton_Turbo",
   "XButton_Turbo",
   "YButton_Turbo",
   "SelectButton_Turbo",
   "StartButton_Turbo",
   "LButton_Turbo",
   "RButton_Turbo"},
  "FunctionCodeA",		//functioncodeA
  "FunctionCodeB",		//functioncodeB
  "gui",			//gui
  "screenshot",			//screenshot
  "debug",			//debug
  "option"			//option
};

int SoundRates[6] = {
  8000,
  11025,
  22050,
  32000,
  44100,
  48000
};

#ifndef __WIN32__
int __argc;
char **__argv;
#endif

#if 0
#ifndef __WIN32__
int
main (int argc, char **argv)
{
  __argc = argc;
  __argv = argv;
#else
int WINAPI
WinMain (HINSTANCE hInstance,
	 HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
#endif
#ifndef __WIN32__
  return 0;
#else
  return msg.wParam;
#endif
}
#endif

void
LoadDefaultSettings ()
{
  memset (&Options, 0, sizeof (Options));
  memset (&DefaultOptions, 0, sizeof (DefaultOptions));

  DefaultOptions.JPenvFlag = 0;
  DefaultOptions.VolumeLevel = 1;
  DefaultOptions.inactive_x = FALSE;

  //Sound
  DefaultOptions.SoundRate = 3;
  DefaultOptions.SoundBit = 16;
  DefaultOptions.SoundChn = 2;

  //screenshot
  DefaultOptions.SaveImagefileFormat = 0;
  DefaultOptions.ReduceTheColorTo256 = FALSE;
  DefaultOptions.ReduceTheColorTo256IfWithin = TRUE;
  DefaultOptions.ImagefileHiresStretch = TRUE;
  DefaultOptions.RLEcompression256bitmap = FALSE;

  //SNES debug settings
  DefaultOptions.DisplayScreenBufferAll = FALSE;

  //condition
  DefaultOptions.MovieRecording = FALSE;
  DefaultOptions.toggle = FALSE;

  //clock
  DefaultOptions.ClockDiff = 0;

  //other
  DefaultOptions.LoadLastImageStartup = FALSE;
  DefaultOptions.TurboShotEnable = TRUE;

#ifdef __WIN32__
  //get windows version
  DefaultOptions.osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
  GetVersionEx (&DefaultOptions.osvi);
#endif

  //directory
#ifdef __WIN32__
  char szPath[PATH_MAX + 1];
  char filename [PATH_MAX + 1];
  char dir [_MAX_DIR + 1];
  char drive [_MAX_DRIVE + 1];
  char fname [_MAX_FNAME + 1];
  char ext [_MAX_EXT + 1];
#endif

#ifdef __WIN32__
  GetCurrentDirectory (PATH_MAX, DefaultOptions.HomeDirectory);

  //vista win7 or higher
  if (DefaultOptions.osvi.dwMajorVersion >= 6)
    {
      LPITEMIDLIST pidl;
      IMalloc *pMalloc;
      SHGetMalloc (&pMalloc);
      if (SUCCEEDED
	  (SHGetSpecialFolderLocation (NULL, CSIDL_APPDATA, &pidl)))
	{
	  if (SHGetPathFromIDList (pidl, szPath) == 1 &&
	      strlen(szPath) <= PATH_MAX - 7)
	    {
	      strcat(szPath, "\\uosnes");
	      //mkdir
	      if (access ((const char *) szPath, 0))
		mkdir ((const char *) szPath);
	      strcpy(DefaultOptions.HomeDirectory, szPath);
	    }
	  pMalloc->Free (pidl);
	}
      pMalloc->Release ();
    }
#else
  strcpy (DefaultOptions.HomeDirectory, "~/.uosnes");
#endif

  strcpy (DefaultOptions.LastHomeDirectory, DefaultOptions.HomeDirectory);
  DefaultOptions.HomeDirectoryMoved = FALSE;

  //datafile directory
#ifdef __WIN32__
  if(GetModuleFileName(NULL, filename, PATH_MAX) > 0)
    {
      _splitpath (filename, drive, dir, fname, ext);
      _makepath (szPath, drive, dir, NULL, NULL);
      int len = strlen(szPath);
      if(len > 0)
	szPath[len - 1] = 0;
      strcpy(DefaultOptions.ModuleDirectory, szPath);
    }
#endif

  strcpy (DefaultOptions.BinaryDumpDirectory, DefaultOptions.HomeDirectory);

  Options = DefaultOptions;
}
