/*
  Copyright (C) 2004 sanmaiwashi
*/

#ifndef _UOSNES_H_
#define _UOSNES_H_

#include "common.h"
#include "port.h"

typedef struct
{
  b8 JPenvFlag;
  int VolumeLevel;
  b8 inactive_x;

  //Sound
  int SoundRate;
  int SoundBit;
  int SoundChn;

  //screenshot
  int SaveImagefileFormat;
  b8 ReduceTheColorTo256;
  b8 ReduceTheColorTo256IfWithin;
  b8 ImagefileHiresStretch;
  b8 RLEcompression256bitmap;

  //debug settings
  b8 DisplayScreenBufferAll;

  //condition
  b8 MovieRecording;
  b8 toggle;

  //directory
  char HomeDirectory[PATH_MAX + 1];
  char LastHomeDirectory[PATH_MAX + 1];
  char ModuleDirectory[PATH_MAX + 1];
  char BinaryDumpDirectory[PATH_MAX + 1];
  b8 HomeDirectoryMoved;

  //clock
  time_t ClockDiff;

  //other
  b8 LoadLastImageStartup;
  b8 TurboShotEnable;

#ifdef __WIN32__
  OSVERSIONINFO osvi;
#endif
} OOptions;

typedef struct
{
  const char *windows;
  const char *graphics;
  const char *sound;
  const char *cpu;
  const char *timer;
  const char *filedirectory;
  const char *ControllerOption;
  const char *joypadA[8];
  const char *joypadB[8];
  const char *button[24];
  const char *functioncodeA;
  const char *functioncodeB;
  const char *gui;
  const char *screenshot;
  const char *debug;
  const char *option;
} Scs;

START_EXTERN_C void read_config ();
void read_port_config ();
void write_port_config ();
extern const char version_string[];
extern const char bug_report_url[];
extern OOptions Options;
extern OOptions DefaultOptions;
extern Scs cs;
extern int SoundRates[];
#ifndef __WIN32__
extern int __argc;
extern char **__argv;
#endif
void LoadDefaultSettings ();
END_EXTERN_C
#endif /* _UOSNES_H_ */
