#include "snes9x.h"
#include "memmap.h"
#include "srtc.h"
#include "uosnesw.h"
#include "cfgdlg.h"

static BOOL OtherDlgTimerActive = false;
static BOOL hCriticalSection;
static CRITICAL_SECTION dtpcs;
static BOOL ModifiedDTP0;
static BOOL ModifiedDTP;
static SYSTEMTIME dst, tst;

/*****************
 loaded settings
*****************/

static int Options_SaveImagefileFormat_cpy;
static b8 Options_ReduceTheColorTo256_cpy;
static b8 Options_ReduceTheColorTo256IfWithin_cpy;
static b8 Options_ImagefileHiresStretch_cpy;
static b8 Options_RLEcompression256bitmap_cpy;
static BOOL GUI_AttachConsole_cpy;
static b8 Options_DisplayScreenBufferAll_cpy;

static unsigned char Xxxcdda_Enable_cpy;
static unsigned char Xxxcdda_Drv_cpy;
static int GUI_FileBrowseWindow_cpy;
static bool8 Settings_DisableGameSpecificHacks_cpy;
static b8 Options_inactive_x_cpy;
static time_t Options_ClockDiff_cpy;
static b8 Options_LoadLastImageStartup_cpy;

/*****************
 default settings
*****************/
extern int GUI_FileBrowseWindow_def;
extern BOOL GUI_AttachConsole_def;
 

/*****************
 proc def
*****************/
static void OtherDlgCtrlSet (HWND hWnd);
static void   SetDTP (HWND hWnd, time_t diff);
static time_t GetDTPD ();
static VOID CALLBACK UpdateDTP(HWND hWnd, UINT uMsg, UINT_PTR idEvent, DWORD dwTime);

void
OtherSettingsLoad ()
{
  Options_SaveImagefileFormat_cpy = Options.SaveImagefileFormat;
  Options_ReduceTheColorTo256_cpy = Options.ReduceTheColorTo256;
  Options_ReduceTheColorTo256IfWithin_cpy =
    Options.ReduceTheColorTo256IfWithin;
  Options_ImagefileHiresStretch_cpy = Options.ImagefileHiresStretch;
  Options_RLEcompression256bitmap_cpy = Options.RLEcompression256bitmap;

  Options_LoadLastImageStartup_cpy = Options.LoadLastImageStartup;
  Options_ClockDiff_cpy = Options.ClockDiff;

  GUI_AttachConsole_cpy = GUI.AttachConsole;
  Options_DisplayScreenBufferAll_cpy = Options.DisplayScreenBufferAll;
  Options_inactive_x_cpy = Options.inactive_x;

  Xxxcdda_Enable_cpy = Xxxcdda.Enable;	// Original
  Xxxcdda_Drv_cpy = Xxxcdda.Drv;	// Original

  Settings_DisableGameSpecificHacks_cpy = Settings.DisableGameSpecificHacks;

  GUI_FileBrowseWindow_cpy = GUI.FileBrowseWindow;
}

static HWND hOtherDlg;

void
OtherDefaultSettingsLoad ()
{
  Options_SaveImagefileFormat_cpy = DefaultOptions.SaveImagefileFormat;
  Options_ReduceTheColorTo256_cpy = DefaultOptions.ReduceTheColorTo256;
  Options_ReduceTheColorTo256IfWithin_cpy =
    DefaultOptions.ReduceTheColorTo256IfWithin;
  Options_ImagefileHiresStretch_cpy = DefaultOptions.ImagefileHiresStretch;
  Options_RLEcompression256bitmap_cpy =
    DefaultOptions.RLEcompression256bitmap;

  Options_LoadLastImageStartup_cpy = DefaultOptions.LoadLastImageStartup;
  Options_ClockDiff_cpy = DefaultOptions.ClockDiff;

  GUI_AttachConsole_cpy = GUI_AttachConsole_def;
  Options_DisplayScreenBufferAll_cpy = DefaultOptions.DisplayScreenBufferAll;
  Options_inactive_x_cpy = DefaultOptions.inactive_x;

  Xxxcdda_Enable_cpy = OPTIONS_XXX_CDDAENABLE;	// Original
  Xxxcdda_Drv_cpy = OPTIONS_XXX_CDDADRV;	// Original

  Settings_DisableGameSpecificHacks_cpy = DefaultSettings.DisableGameSpecificHacks;

  GUI_FileBrowseWindow_cpy = GUI_FileBrowseWindow_def;

  OtherDlgCtrlSet (hOtherDlg);
}

void
OtherSettingsSave ()
{
  Options.SaveImagefileFormat = Options_SaveImagefileFormat_cpy;
  //Options.ReduceTheColorTo256 = Options_ReduceTheColorTo256_cpy;
  Options.ReduceTheColorTo256IfWithin =
    Options_ReduceTheColorTo256IfWithin_cpy;
  Options.ImagefileHiresStretch = Options_ImagefileHiresStretch_cpy;
  Options.RLEcompression256bitmap = Options_RLEcompression256bitmap_cpy;

  Options.LoadLastImageStartup = Options_LoadLastImageStartup_cpy;

  //clock
  Options.ClockDiff = Options_ClockDiff_cpy;

  if(GUI.AttachConsole != GUI_AttachConsole_cpy)
    {
      GUI.AttachConsole = GUI_AttachConsole_cpy;
      if(GUI.AttachConsole)
	{
	  AllocConsole();
	  freopen("CONOUT$", "w", stdout);
	  freopen("CONOUT$", "w", stderr); 
	  freopen( "CONIN$", "r", stdin );
	}
      else
	FreeConsole();
    }

  Options.DisplayScreenBufferAll = Options_DisplayScreenBufferAll_cpy;
  Options.inactive_x = Options_inactive_x_cpy;
  GUI.FileBrowseWindow = GUI_FileBrowseWindow_cpy;

  Settings.DisableGameSpecificHacks = Settings_DisableGameSpecificHacks_cpy;

  // Original
  if (Xxxcdda_Drv_cpy != Xxxcdda.Drv)
    {
      cdda_exit ();
      Xxxcdda.Drv = Xxxcdda_Drv_cpy;
      cdda_open ();
      cdda_stop ();
    }

  if (Xxxcdda_Enable_cpy != Xxxcdda.Enable)
    {
      if (Xxxcdda.Enable)
	cdda_exit ();
      else
	{
	  cdda_open ();
	  cdda_stop ();
	}
      Xxxcdda.Enable = Xxxcdda_Enable_cpy;
    }
}

static LPCTSTR date_format_string = "yyy'/'MM'/'dd"; 
static LPCTSTR time_format_string = "HH':'mm':'ss"; 

LRESULT CALLBACK
OtherDlgProc (HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  static const char *combostrCdDrvFunc[] = {
    "A:",
    "B:",
    "C:",
    "D:",
    "E:",
    "F:",
    "G:",
    "H:",
    "I:",
    "J:",
    "K:",
    "L:",
    "M:",
    "N:",
    "O:",
    "P:",
    "Q:",
    "R:",
    "S:",
    "T:",
    "U:",
    "V:",
    "W:",
    "X:",
    "Y:",
    "Z:"
  };

  switch (uMsg)
    {
    case WM_INITDIALOG:
      {
#if 0
	MessageBox (hWnd,
		    "WM_INITDIALOG",
		    "uosnes", MB_OK | MB_ICONINFORMATION);
#endif

	hOtherDlg = hWnd;

	// Original
	for (int i = 0; i < 26; i++)
	  {
	    SendMessage (GetDlgItem (hWnd, IDC_CDDRV_COMBO),
			 CB_INSERTSTRING,
			 (WPARAM) i, (LPARAM) (combostrCdDrvFunc[i]));
	  }

	//setup DTP format
	SendMessage(GetDlgItem(hWnd, IDC_DATETIMEPICKER_DATE), DTM_SETFORMAT, 0, (LPARAM)date_format_string); 
	SendMessage(GetDlgItem(hWnd, IDC_DATETIMEPICKER_TIME), DTM_SETFORMAT, 0, (LPARAM)time_format_string); 

	OtherDlgCtrlSet (hWnd);
      }
      break;

    case WM_COMMAND:
      switch (LOWORD (wParam))
	{
	case IDC_RADIO_SAVEIMAGEFILEFORMAT_BMP:
	case IDC_RADIO_SAVEIMAGEFILEFORMAT_PCX:
	case IDC_RADIO_SAVEIMAGEFILEFORMAT_GIF:
	case IDC_RADIO_SAVEIMAGEFILEFORMAT_PNG:
	  if (HIWORD (wParam) == BN_CLICKED)
	    {
	      Options_SaveImagefileFormat_cpy = LOWORD (wParam) - IDC_RADIO_SAVEIMAGEFILEFORMAT_BMP;

	      EnableWindow (GetDlgItem (hWnd, IDC_CHECK_REDUCETHECOLORTO256IFWITHIN),
			    LOWORD (wParam) != IDC_RADIO_SAVEIMAGEFILEFORMAT_GIF ? TRUE : FALSE);

	      EnableWindow (GetDlgItem (hWnd, IDC_CHECK_RLECOMPRESSION256BITMAP),
			    LOWORD (wParam) == IDC_RADIO_SAVEIMAGEFILEFORMAT_BMP ? TRUE : FALSE);
	      //EnableWindow(GetDlgItem(hWnd, IDC_CHECK_REDUCETHECOLORTO256), TRUE);
	      if (Options.SaveImagefileFormat != Options_SaveImagefileFormat_cpy)
		ConfigDlgSettingsChanged (hWnd);
	    }
	  break;

	case IDC_CHECK_REDUCETHECOLORTO256IFWITHIN:
	  if (HIWORD (wParam) == BN_CLICKED)
	    {
	      Options_ReduceTheColorTo256IfWithin_cpy = (b8)(IsDlgButtonChecked (hWnd, (int) LOWORD (wParam)) ==  BST_CHECKED);
	      ConfigDlgSettingsChanged (hWnd);
	    }
	  break;

	case IDC_CHECK_REDUCETHECOLORTO256:
	  if (HIWORD (wParam) == BN_CLICKED)
	    {
	      Options_ReduceTheColorTo256_cpy = (b8)(IsDlgButtonChecked (hWnd, (int) LOWORD (wParam)) ==  BST_CHECKED);
	      ConfigDlgSettingsChanged (hWnd);
	    }
	  break;

	case IDC_CHECK_HIRESSTRETCH:
	  if (HIWORD (wParam) == BN_CLICKED)
	    {
	      Options_ImagefileHiresStretch_cpy = (b8)(IsDlgButtonChecked (hWnd, (int) LOWORD (wParam)) ==  BST_CHECKED);
	      ConfigDlgSettingsChanged (hWnd);
	    }
	  break;

	case IDC_CHECK_RLECOMPRESSION256BITMAP:
	  if (HIWORD (wParam) == BN_CLICKED)
	    {
	      Options_RLEcompression256bitmap_cpy = (b8)(IsDlgButtonChecked (hWnd, (int) LOWORD (wParam)) ==  BST_CHECKED);
	      ConfigDlgSettingsChanged (hWnd);
	    }
	  break;

	case IDC_CHECK_ATTACHCONSOLE:
	  if (HIWORD (wParam) == BN_CLICKED)
	    {
	      GUI_AttachConsole_cpy = (BOOL)(IsDlgButtonChecked (hWnd, (int) LOWORD (wParam)) ==  BST_CHECKED);
	      ConfigDlgSettingsChanged (hWnd);
	    }
	  break;

	case IDC_CHECK_LOADLASTIMAGESTARTUP:
	  if (HIWORD (wParam) == BN_CLICKED)
	    {
	      Options_LoadLastImageStartup_cpy = (b8)(IsDlgButtonChecked (hWnd, (int) LOWORD (wParam)) ==  BST_CHECKED);
	      ConfigDlgSettingsChanged (hWnd);
	    }
	  break;

	case IDC_CHECK_DISABLEGAMESPECIFICHACKS:
	  if (HIWORD (wParam) == BN_CLICKED)
	    {
	      Settings_DisableGameSpecificHacks_cpy = (bool8)(IsDlgButtonChecked (hWnd, (int) LOWORD (wParam)) ==  BST_CHECKED);
	      ConfigDlgSettingsChanged (hWnd);
	    }
	  break;

	case IDC_CHECK_DISPLAYSCREENBUFFERALL:
	  if (HIWORD (wParam) == BN_CLICKED)
	    {
	      Options_DisplayScreenBufferAll_cpy = (b8)(IsDlgButtonChecked (hWnd, (int) LOWORD (wParam)) ==  BST_CHECKED);
	      ConfigDlgSettingsChanged (hWnd);
	    }
	  break;

	case IDC_CHECK_UOSXPLORER:
	  if (HIWORD (wParam) == BN_CLICKED)
	    {
	      GUI_FileBrowseWindow_cpy = IsDlgButtonChecked (hWnd, (int) LOWORD (wParam)) ==  BST_CHECKED ? 1 : 0;
	      ConfigDlgSettingsChanged (hWnd);
	    }
	  break;

	case IDC_CHECK_INACTIVE_X:
	  if (HIWORD (wParam) == BN_CLICKED)
	    {
	      Options_inactive_x_cpy = (b8)(IsDlgButtonChecked (hWnd, (int) LOWORD (wParam)) ==  BST_CHECKED);
	      ConfigDlgSettingsChanged (hWnd);
	    }
	  break;

	  // Original
	case IDC_CHECK_USECDDA:
	  if (HIWORD (wParam) == BN_CLICKED)
	    {
	      bool8 tmpVal =
		(bool8) (IsDlgButtonChecked (hWnd, (int) LOWORD (wParam)) ==
			 BST_CHECKED);
	      if (LOWORD (wParam) == IDC_CHECK_USECDDA)
		Xxxcdda_Enable_cpy = tmpVal;
	      ConfigDlgSettingsChanged (hWnd);
	    }
	  break;

	case IDC_CDDRV_COMBO:
	  if (HIWORD (wParam) == CBN_SELENDOK)
	    {
	      if (LOWORD (wParam) == IDC_CDDRV_COMBO)
		{
		  int i =
		    (int) SendMessage (GetDlgItem (hWnd, (int) LOWORD (wParam)),
				     CB_GETCURSEL, 0, 0);
		  Xxxcdda_Drv_cpy = (uint8) i;
		}
	      if (Xxxcdda_Drv_cpy != Xxxcdda.Drv)
		ConfigDlgSettingsChanged (hWnd);
	    }
	  break;

	case IDC_BUTTON_LOADNOW:
	  SetDTP (hWnd, Options_ClockDiff_cpy = 0);
	  ConfigDlgSettingsChanged (hWnd);
	  break;

	case IDC_BUTTON_RTCSYNC:
	  if(!Settings.StopEmulation && !Settings.SPCPlaying && (Settings.SRTC || Settings.SPC7110RTC || Settings.BS))
	    {
	      if (Settings.SRTC)
		S9xSyncSRTC(time(NULL) + GetDTPD ());
	      else if (Settings.SPC7110RTC)
		S9xSyncSPC7110RTC(time(NULL) + GetDTPD ());
	      else if (Settings.BS)
		S9xSyncBSXRTC(time(NULL) + GetDTPD ());
	      break;
	    }
	  break;

	default:
	  break;
	}
      break;

    case WM_NOTIFY:
      switch (((NMHDR *) lParam)->code)
	{

	case DTN_DATETIMECHANGE:
	  if(((LPNMDATETIMECHANGE) lParam)->dwFlags == GDT_VALID)
	    {
	      //for timer update
	      if(hCriticalSection)
		{
		  EnterCriticalSection(&dtpcs);
		  if(((NMHDR *) lParam)->hwndFrom == GetDlgItem(hWnd, IDC_DATETIMEPICKER_DATE))
		    dst = ((LPNMDATETIMECHANGE) lParam)->st;
		  else if(((NMHDR *) lParam)->hwndFrom == GetDlgItem(hWnd, IDC_DATETIMEPICKER_TIME))
		    tst = ((LPNMDATETIMECHANGE) lParam)->st;
		  ModifiedDTP0 = ModifiedDTP = TRUE;
		  LeaveCriticalSection(&dtpcs);
		}
	      ConfigDlgSettingsChanged (hWnd);
	    }
	  break;

	case PSN_APPLY:
	  if(ModifiedDTP)
	    {
	      Options_ClockDiff_cpy = GetDTPD ();
	      ModifiedDTP = FALSE;
	    }
	  ConfigDlgSettingsSave ();
	  break;

	case PSN_HELP:
	  ConfigDlgDefaultSettingsLoad (hWnd);
	  break;

	case PSN_QUERYCANCEL:
	  break;

	case PSN_SETACTIVE:
#if 0
	  MessageBox (hWnd,
		      "PSN_SETACTIVE",
		      "uosnes", MB_OK | MB_ICONINFORMATION);
#endif
	  EnableWindow (GetDlgItem
			(hWnd, IDC_CHECK_REDUCETHECOLORTO256IFWITHIN),
			Options_SaveImagefileFormat_cpy != 2 ? TRUE : FALSE);
	  //EnableWindow(GetDlgItem(hWnd, IDC_CHECK_REDUCETHECOLORTO256),
	  //Options_SaveImagefileFormat_cpy != 2 ? TRUE : FALSE);
	  StartPageIndex = 4;

	  SetDTP (hWnd, Options_ClockDiff_cpy);

	  //set timer for DTP update
	  if(!hCriticalSection)
	    {
	      InitializeCriticalSection(&dtpcs);
	      hCriticalSection = TRUE;
	    }
	  if (!OtherDlgTimerActive && SetTimer (hWnd, 100, 500, UpdateDTP))
	    OtherDlgTimerActive = true;
	  break;

	case PSN_KILLACTIVE:
#if 0
	  MessageBox (hWnd,
		      "PSN_KILLACTIVE",
		      "uosnes", MB_OK | MB_ICONINFORMATION);
#endif
	  if (OtherDlgTimerActive)
	    {
	      KillTimer (hWnd, 100);
	      OtherDlgTimerActive = false;
	    }
	  if(hCriticalSection)
	    {
	      DeleteCriticalSection(&dtpcs);
	      hCriticalSection = FALSE;
	    }
	  break;

	default:
	  break;
	}
      break;

    case WM_DESTROY:
      //note, PSN_KILLACTIVE is not sent.
#if 0
      MessageBox (hWnd,
		  "WM_DESTROY",
		  "uosnes", MB_OK | MB_ICONINFORMATION);
#endif
      if (OtherDlgTimerActive)
	{
	  KillTimer (hWnd, 100);
	  OtherDlgTimerActive = false;
	}
      if(hCriticalSection)
	{
	  DeleteCriticalSection(&dtpcs);
	  hCriticalSection = FALSE;
	}
      ModifiedDTP = FALSE;
      hOtherDlg = NULL;
      break;

    default:
      break;
    }
  return FALSE;
}

static void
OtherDlgCtrlSet (HWND hWnd)
{
  if (!hWnd)
    return;

  SendMessage (GetDlgItem (hWnd, IDC_RADIO_SAVEIMAGEFILEFORMAT_BMP),
	       BM_SETCHECK,
	       (WPARAM) (Options_SaveImagefileFormat_cpy ==
			 0 ? BST_CHECKED : BST_UNCHECKED), 0);

  SendMessage (GetDlgItem (hWnd, IDC_RADIO_SAVEIMAGEFILEFORMAT_PCX),
	       BM_SETCHECK,
	       (WPARAM) (Options_SaveImagefileFormat_cpy ==
			 1 ? BST_CHECKED : BST_UNCHECKED), 0);

  SendMessage (GetDlgItem (hWnd, IDC_RADIO_SAVEIMAGEFILEFORMAT_GIF),
	       BM_SETCHECK,
	       (WPARAM) (Options_SaveImagefileFormat_cpy ==
			 2 ? BST_CHECKED : BST_UNCHECKED), 0);

  SendMessage (GetDlgItem (hWnd, IDC_RADIO_SAVEIMAGEFILEFORMAT_PNG),
	       BM_SETCHECK,
	       (WPARAM) (Options_SaveImagefileFormat_cpy ==
			 3 ? BST_CHECKED : BST_UNCHECKED), 0);

  SendMessage (GetDlgItem (hWnd, IDC_CHECK_REDUCETHECOLORTO256),
	       BM_SETCHECK,
	       (WPARAM) (Options_ReduceTheColorTo256_cpy ? BST_CHECKED :
			 BST_UNCHECKED), 0);

  SendMessage (GetDlgItem (hWnd, IDC_CHECK_REDUCETHECOLORTO256IFWITHIN),
	       BM_SETCHECK,
	       (WPARAM) (Options_ReduceTheColorTo256IfWithin_cpy ? BST_CHECKED
			 : BST_UNCHECKED), 0);

  SendMessage (GetDlgItem (hWnd, IDC_CHECK_HIRESSTRETCH),
	       BM_SETCHECK,
	       (WPARAM) (Options_ImagefileHiresStretch_cpy ? BST_CHECKED :
			 BST_UNCHECKED), 0);

  SendMessage (GetDlgItem (hWnd, IDC_CHECK_RLECOMPRESSION256BITMAP),
	       BM_SETCHECK,
	       (WPARAM) (Options_RLEcompression256bitmap_cpy ? BST_CHECKED :
			 BST_UNCHECKED), 0);

  SendMessage (GetDlgItem (hWnd, IDC_CHECK_ATTACHCONSOLE),
	       BM_SETCHECK,
	       (WPARAM) (GUI_AttachConsole_cpy ? BST_CHECKED :
			 BST_UNCHECKED), 0);

  SendMessage (GetDlgItem (hWnd, IDC_CHECK_LOADLASTIMAGESTARTUP),
	       BM_SETCHECK,
	       (WPARAM) (Options_LoadLastImageStartup_cpy ? BST_CHECKED :
			 BST_UNCHECKED), 0);

  SendMessage (GetDlgItem (hWnd, IDC_CHECK_DISPLAYSCREENBUFFERALL),
	       BM_SETCHECK,
	       (WPARAM) (Options_DisplayScreenBufferAll_cpy ? BST_CHECKED :
			 BST_UNCHECKED), 0);

  SendMessage (GetDlgItem (hWnd, IDC_CHECK_USECDDA),
	       BM_SETCHECK,
	       (WPARAM) (Xxxcdda_Enable_cpy ? BST_CHECKED : BST_UNCHECKED),
	       0);

  SendMessage (GetDlgItem (hWnd, IDC_CDDRV_COMBO),
	       CB_SETCURSEL, (WPARAM) Xxxcdda.Drv, 0);

  SendMessage (GetDlgItem (hWnd, IDC_CHECK_DISABLEGAMESPECIFICHACKS),
	       BM_SETCHECK,
	       (WPARAM) (Settings_DisableGameSpecificHacks_cpy ? BST_CHECKED :
			 BST_UNCHECKED), 0);

  SendMessage (GetDlgItem (hWnd, IDC_CHECK_UOSXPLORER),
	       BM_SETCHECK,
	       (WPARAM) (GUI_FileBrowseWindow_cpy == 1 ? BST_CHECKED :
			 BST_UNCHECKED), 0);

  SendMessage (GetDlgItem (hWnd, IDC_CHECK_INACTIVE_X),
	       BM_SETCHECK,
	       (WPARAM) (Options_inactive_x_cpy ? BST_CHECKED :
			 BST_UNCHECKED), 0);

  EnableWindow (GetDlgItem (hWnd, IDC_CHECK_REDUCETHECOLORTO256IFWITHIN),
		Options_SaveImagefileFormat_cpy != 2 ? TRUE : FALSE);

  EnableWindow (GetDlgItem (hWnd, IDC_CHECK_REDUCETHECOLORTO256),
		Options_SaveImagefileFormat_cpy != 2 ? TRUE : FALSE);

  EnableWindow (GetDlgItem (hWnd, IDC_CHECK_RLECOMPRESSION256BITMAP),
		(Options_SaveImagefileFormat_cpy == 0) ? TRUE : FALSE);

  EnableWindow (GetDlgItem (hWnd, IDC_CHECK_DISPLAYSCREENBUFFERALL),
		GUI.DoubleRendering ? TRUE : FALSE);

  //not supported yet
  EnableWindow (GetDlgItem (hWnd, IDC_CHECK_REDUCETHECOLORTO256), FALSE);

  if(!Settings.StopEmulation && !Settings.SPCPlaying && (Settings.SRTC || Settings.SPC7110RTC || Settings.BS))
    EnableWindow (GetDlgItem (hWnd, IDC_BUTTON_RTCSYNC), TRUE);
  else
    EnableWindow (GetDlgItem (hWnd, IDC_BUTTON_RTCSYNC), FALSE);

  SetDTP (hWnd, Options_ClockDiff_cpy);
}

static void SetDTP (HWND hWnd, time_t diff)
{
  time_t vt = time(NULL) + diff;
  struct tm *pvtt= localtime(&vt);
  
  SYSTEMTIME st;
  
  ZeroMemory(&st, sizeof(SYSTEMTIME));

  st.wYear = 1900 + pvtt->tm_year;
  st.wMonth = pvtt->tm_mon + 1;
  st.wDayOfWeek = pvtt->tm_wday;
  st.wDay = pvtt->tm_mday;
  st.wHour = pvtt->tm_hour;
  st.wMinute = pvtt->tm_min;
  st.wSecond = pvtt->tm_sec;
  st.wMilliseconds = 0;

  dst = tst = st;

  SendMessage(GetDlgItem(hWnd, IDC_DATETIMEPICKER_DATE), DTM_SETSYSTEMTIME, GDT_VALID, (LPARAM)&dst);
  SendMessage(GetDlgItem(hWnd, IDC_DATETIMEPICKER_TIME), DTM_SETSYSTEMTIME, GDT_VALID, (LPARAM)&tst);
}


static time_t GetDTPD ()
{
  struct tm vtt;

  vtt.tm_sec = tst.wSecond;
  vtt.tm_min = tst.wMinute;
  vtt.tm_hour = tst.wHour;
  vtt.tm_mday = dst.wDay;
  vtt.tm_mon = dst.wMonth - 1;
  vtt.tm_year = dst.wYear - 1900;
  vtt.tm_wday = dst.wDayOfWeek;//It is not used
  vtt.tm_yday = 0;//It is not used
  vtt.tm_isdst = -1;

  time_t vt;

  if((vt = mktime(&vtt)) == -1)
    return Options_ClockDiff_cpy;

  return vt - time(NULL);
}

static VOID CALLBACK UpdateDTP(HWND hWnd, UINT uMsg, UINT_PTR idEvent, DWORD dwTime)
{
  EnterCriticalSection(&dtpcs);
  if(ModifiedDTP0)
    {
      Options_ClockDiff_cpy = GetDTPD ();
      ModifiedDTP0 = FALSE;
    }
  SetDTP (hWnd, Options_ClockDiff_cpy);
  LeaveCriticalSection(&dtpcs);
}

