/*****************************************************************************/
/*  uosnes: Win32                                                            */
/*****************************************************************************/
#include "snes9x.h"
#include "uosnesw.h"
#include "memmap.h"
#include "cpuexec.h"
#include "cheats.h"
#include "display.h"
#include "snapshot.h"
#include "apu_orig.h"
#include "soundux.h"
#include "controls.h"
#include "controls2.h"
#include "snesapu.h"
#include "gfxutil.h"
#include "winutil.h"
#include "spcplay.h"
#include "commutil.h"
#include "cfgfile.h"
#include "windraw.h"
#include "wintimer.h"
#include "uow_draw.h"
#include "uow_sound.h"
#include "uow_input.h"
#include "render.h"
#include "cheatdlg.h"
#include "uosnes_avcodec.h"

#include <windowsx.h>
#include <shellapi.h>
#include <io.h>
#include <direct.h>

#ifdef DEBUGGER
extern FILE *trace;
extern FILE *trace2;
static const char *TracelogFilename = NULL;
#endif

//#define UOSNESW_TRACE

#ifdef UOSNESW_TRACE
static const char *uowTracelogFilename = NULL;
FILE *tracex;
#endif

/*****************************************************************************/
/* uosnesw proc define                                                       */
/*****************************************************************************/
static void WinLoad ();
static bool ROMLoadProc (char *FileName);
static void Draw1frame ();
static void S9xMessage2 (const char *str, int TimeOut);
static void SetPriorityClassAndThreadPriority (DWORD priocl, int threadprio);
static void PauseExecution (BOOL pause, BOOL lock, BOOL clear_lock);
static void NullExecLoop ();
static void uowClose (HWND hWnd);
static void MovieRecord (b8 &MovieRecording);
static BOOL uowCreateStatusBar (HWND hWnd);
static void uowDestroyStatusBar ();

/*****************************************************************************/
/* variables define                                                          */
/*****************************************************************************/
static void (*ExecLoop) (void);
static char *rom_filename = NULL;

static char FileTitle[_MAX_PATH] = { 0 };
char ROMFileName[_MAX_PATH] = { 0 };
char InitialROMFileDirectory[_MAX_PATH] = { 0 };
char RecentROMFileName[_MAX_PATH * 11] = { 0 };

/*****************************************************************************/
/* Global variables                                                          */
/*****************************************************************************/

sGUI GUI;
sGUI DefaultGUI;

char WindowTitleTextNormal_bak[] = "uosnes : Windows";
char WindowTitleTextNormal[] = "uosnes : Windows";
char WindowTitleTextPaused[] = "uosnes : - Paused";
char WindowTitleTextTurbo[] = "uosnes : - Turbo";
char WindowTitleText[256] = "uosnes : Windows";

static BOOL SPCLoadedFlag = FALSE;

struct sLanguages Languages[] = {
  {IDR_MENU_US,
   "DirectX failed to initialize!",
   "DirectDraw failed to set the selected display mode!",
   "Sound failed to initialize, no sound will be played.",
   "These settings won't take effect until you restart the emulator.",
   "The frame timer failed to initialize, please do NOT select the automatic framerate option or uosnes will crash!",
   "Anything error occured! uosnesw shutdown.",
   "Memory allocation error! uosnesw shutdown.",
   "Display Graphic mode settings failed! uosnesw shutdown.",
   "DirectInput failed to initialize, WinAPI will be used."},
  {IDR_MENU_JP,
   "DirectX Ɏs܂",
   "DirectDraw fBXvC[hݒɎs܂",
   "Sound Ɏs܂",
   "These settings won't take effect until you restart the emulator.",
   "^C}[Ɏs܂Aframerate(ftHg)̐ݒősꍇ̓NbV܂",
   "̃G[NuosneswI܂",
   "mۂɎs܂AI܂",
   "fBXvCAOtBbN[h؂芷Ɏs܂AI܂",
   "DirectInputɎs܂AWinAPIgp܂"}
};

/*****************************************************************************/
/* uosnes Settings                                                           */
/*****************************************************************************/
static int sb_size[3] = { 45, 140, 205 };

/*****************************************************************************/
/* Work variables                                                            */
/*****************************************************************************/
static char tmpcharbuf[256];
static char OnScreenMessageStr[256] = { 0 };

/*****************************************************************************/
/* Procedures                                                                */
/*****************************************************************************/

static void
NullExecLoop ()
{
  return;
}

//It will send WM_PAINT after this proc.
static void
RedrawClientRectAfterSizedMovedClient (HWND hWnd, const RECT * r)
{
  HDC hdc = GetDC (hWnd);
  FillRect (hdc, r, (HBRUSH) GetStockObject (BLACK_BRUSH));
  ReleaseDC (hWnd, hdc);
  InvalidateRect (hWnd, r, FALSE);
}

void
RefreshRectParams (HWND hWnd, HWND hStatusWnd)
{
  GetClientRect (hWnd, &GUI.ClientRect);

  if (hStatusWnd)
    {
      RECT strect;
      GetWindowRect (hStatusWnd, &strect);
      GUI.ClientRect.bottom -= (strect.bottom - strect.top);
      if (GUI.ClientRect.bottom <= GUI.ClientRect.top)
	GUI.ClientRect.top = GUI.ClientRect.bottom = 0;
    }

  POINT p;
  p.x = GUI.ClientRect.left;
  p.y = GUI.ClientRect.top;
  ClientToScreen (hWnd, &p);

  GUI.sClientRect.left = p.x;
  GUI.sClientRect.top = p.y;
  GUI.sClientRect.right =
    GUI.sClientRect.left + (GUI.ClientRect.right - GUI.ClientRect.left);
  GUI.sClientRect.bottom =
    GUI.sClientRect.top + (GUI.ClientRect.bottom - GUI.ClientRect.top);

  return;
}

void
uowDisplayStatusInfo (DWORD sb_needrefresh)
{
  if (!GUI.hStatusWnd)
    return;

  char string[30];

  if (sb_needrefresh & SB_NEEDREFRESH_FPS)
    {
      if (!Settings.StopEmulation && !Settings.SPCPlaying)
	wsprintf (string, "%02d/%02d", IPPU.DisplayedRenderedFrameCount,
		  (int) Memory.ROMFramesPerSecond);
      else
	wsprintf (string, "xx/xx");

      SendMessage (GUI.hStatusWnd, SB_SETTEXT, (WPARAM) 0 | 0,
		   (LPARAM) (LPSTR) string);
    }

  if (sb_needrefresh & SB_NEEDREFRESH_SPCCHANNEL)
    {
      lstrcpy (string, "SPC ");
      if (!Settings.StopEmulation)
	{
	  int spcchannelstatus = S9xGetSoundControl ();
	  for (int i = 0; i < 8; i++)
	    {
	      if (spcchannelstatus & (1 << i))
		wsprintf (string + lstrlen (string), "%d", i);
	      else
		lstrcat (string, "x");
	    }
	}
      else
	{
	  for (int i = 0; i < 8; i++)
	    lstrcat (string, "x");
	}
      SendMessage (GUI.hStatusWnd, SB_SETTEXT, (WPARAM) 1 | 0,
		   (LPARAM) (LPSTR) string);
    }

  if (sb_needrefresh & SB_NEEDREFRESH_BGMODE)
    {
      if (!Settings.StopEmulation && !Settings.SPCPlaying)
	{
	  wsprintf (string, "BGMode %d", PPU.BGMode);
	  lstrcat (string, (Memory.FillRAM[0x2133] & 0x08) ? "w" : " ");
	}
      else
	{
	  wsprintf (string, "BGMode xx");
	}
      SendMessage (GUI.hStatusWnd, SB_SETTEXT, (WPARAM) 2 | 0,
		   (LPARAM) (LPSTR) string);
    }
}

static void
UpdateBackBuffer ()
{
  if (!Renderer.Windowed)
    {
      DirectX_ClearPrimarySurface ();
      DirectX_ClearBackbufferSurface ();
    }
  else
    DirectX_ClearOffscreenSurface ();
}

// screen messages
static char S9xInfoString[256] = { 0 };
static char OnScreenMessage[256] = { 0 };
static char ExitMenuMessage[256] = { 0 };
static char MouseEraseMessage[256] = { 0 };

static DWORD OnScreenMessageTimeOut = 0;
static DWORD ExitMenuTimeOut = 0;
static DWORD MouseEraseTimeOut = 0;
static bool OnScreenMessageTimerActiveFlag = FALSE;
static bool8 MinimizedFlag = 0;
static bool ncbuttondown_flag = 0;
static bool WindowActiveFlag = 0;
static bool SizingFlag = 0;
static int NeedScreenInit = 1;
static bool ScreenRedraw_OK = FALSE;
static BOOL DisplayModeChanged = FALSE;

static void
S9xMessage2 (const char *str, int TimeOut)
{
  //ExitMenuMessage
  if (!lstrcmp (str, "ExitMenu"))
    {
      lstrcpy (ExitMenuMessage, str);
      ExitMenuTimeOut = timeGetTime () + TimeOut;
    }
  //MouseEraseMessage
  else if (!lstrcmp (str, "EraseMouseCursor"))
    {
      lstrcpy (MouseEraseMessage, str);
      MouseEraseTimeOut = timeGetTime () + TimeOut;
    }
  //OnScreenMessage
  else
    {
      lstrcpy (OnScreenMessage, str);
      OnScreenMessageTimeOut = timeGetTime () + TimeOut;
      if (Renderer.Windowed)
	{
	  SetWindowText (GUI.hWnd, OnScreenMessage);
	}
    }

  //set timer
  if (!OnScreenMessageTimerActiveFlag)
    {
      SetTimer (GUI.hWnd, 101, 100, NULL);
      OnScreenMessageTimerActiveFlag = TRUE;
    }
}

static inline BOOL
EraseMouseCursor ()
{
  if (!Settings.StopEmulation && !Settings.Paused && !Settings.SPCPlaying)
    {

      S9xMessage2 ("EraseMouseCursor", 1000);
      return TRUE;
    }
  return FALSE;
}

void
OnScreenMessageUpdate ()
{
  //ExitMenuMessage
  if (!lstrcmp (ExitMenuMessage, "ExitMenu")
      && timeGetTime () > ExitMenuTimeOut)
    {
      if ((!MinimizedFlag || Settings.SPCPlaying) &&
	  !GUI.FullScreen &&
	  Renderer.Windowed &&
	  !Settings.Paused &&
	  (WindowActiveFlag || Options.inactive_x) && !SizingFlag
	  && !ncbuttondown_flag)
	PauseExecution (FALSE, TRUE, FALSE);
      ExitMenuMessage[0] = 0;
      ExitMenuTimeOut = 0;
    }
  //MouseEraseMessage
  if (!lstrcmp (MouseEraseMessage, "EraseMouseCursor")
      && timeGetTime () > MouseEraseTimeOut)
    {
      if (!Settings.StopEmulation &&
	  !Settings.ForcedPause && !Settings.Paused && !Settings.SPCPlaying)
	SetCursor (NULL);
      MouseEraseMessage[0] = 0;
      MouseEraseTimeOut = 0;
    }
  //OnScreenMessage
  if (OnScreenMessage[0] && timeGetTime () > OnScreenMessageTimeOut)
    {
      if (Renderer.Windowed)
	{
	  SetWindowText (GUI.hWnd, WindowTitleText);
	}
      OnScreenMessage[0] = 0;
      OnScreenMessageTimeOut = 0;
    }
  if (!ExitMenuMessage[0] && !MouseEraseMessage[0] &&
      !OnScreenMessage[0] && OnScreenMessageTimerActiveFlag)
    {
      KillTimer (GUI.hWnd, 101);
      OnScreenMessageTimerActiveFlag = FALSE;
    }
}

static void
uowKillMessageTimer (HWND hWnd)
{
  if (OnScreenMessageTimerActiveFlag)
    {
      KillTimer (hWnd, 101);
      OnScreenMessageTimerActiveFlag = FALSE;
    }
  if (Renderer.Windowed)
    {
      SetWindowText (hWnd, WindowTitleText);
    }
  ExitMenuMessage[0] = MouseEraseMessage[0] = OnScreenMessage[0] = 0;
  ExitMenuTimeOut = MouseEraseTimeOut = OnScreenMessageTimeOut = 0;
}

static void
SwitchScreenModeFailed ()
{
  DirectX_SetDisplayMode (Renderer.dm[GUI.FullscreenDisplayModeIndex].Width,
			  Renderer.dm[GUI.FullscreenDisplayModeIndex].Height,
			  GetFilterScale (GUI.FilterMethod),
			  Renderer.dm[GUI.FullscreenDisplayModeIndex].Depth,
			  Renderer.dm[GUI.FullscreenDisplayModeIndex].Rate,
			  TRUE, GUI.DoubleBuffered);

  GUI.ScreenDepth = Renderer.Depth;
  GUI.FullScreen = !Renderer.Windowed;
  S9xSetWindowPos ();
  if (GUI.statusbar == 1)
    uowCreateStatusBar (GUI.hWnd);
  if (GetMenu (GUI.hWnd) == NULL)
    {
      SetMenu (GUI.hWnd, GUI.hMenu);
      GUI.AppMenuConnect = TRUE;
    }
  RefreshRectParams (GUI.hWnd, GUI.hStatusWnd);
  SetWindowText (GUI.hWnd, WindowTitleText);
  MessageBox (GUI.hWnd,
	      Languages[GUI.Language].errSwitchGFX,
	      "uosnes - Switch GFX mode", MB_OK | MB_ICONSTOP);
  SetMenuStatus (GUI.hMenu, GUI.hSysMenu);
  PostMessage (GUI.hWnd, WM_CLOSE, 0, 0);
}

BOOL
SwitchScreenMode (BOOL Windowed)
{
  BOOL SwitchDisplayMode = Renderer.Windowed != Windowed;
  DisplayModeChanged = SwitchDisplayMode;

  if (!Windowed && Renderer.Windowed)
    SetWindowText (GUI.hWnd, WindowTitleText);

  //switch to fullscreen
  if (!Windowed)
    {
      uowDestroyStatusBar ();
      if (GetMenu (GUI.hWnd) != NULL)
	{
	  SetMenu (GUI.hWnd, NULL);
	  GUI.AppMenuConnect = FALSE;
	}
      RefreshRectParams (GUI.hWnd, GUI.hStatusWnd);
    }

  //Release vsync timer resources for thread safety
  SetupVsyncTimer (0, VsyncTimerProc, NULL);

  S9xGraphicsDeinit ();
  RenderDeinit ();

  BOOL err;

  err =
    DirectX_SetDisplayMode (Renderer.dm[GUI.FullscreenDisplayModeIndex].Width,
			    Renderer.dm[GUI.FullscreenDisplayModeIndex].
			    Height, GetFilterScale (GUI.FilterMethod),
			    Renderer.dm[GUI.FullscreenDisplayModeIndex].Depth,
			    Renderer.dm[GUI.FullscreenDisplayModeIndex].Rate,
			    Windowed, GUI.DoubleBuffered);

  if (!err && !Windowed)
    {
      SwitchScreenModeFailed ();
      return FALSE;
    }

  GUI.ScreenDepth = Renderer.Depth;
  GUI.FullScreen = !Renderer.Windowed;

  S9xSetWinPixelFormat ();

  //failed
  if (!RenderInit (GUI.FilterMethod,
		   GUI.ScreenDepth,
		   GUI.RedShift,
		   GUI.GreenShift, GUI.BlueShift) || !S9xGraphicsInit ())
    {
      SwitchScreenModeFailed ();
      return FALSE;
    }

  //for clear filter log
  ResetRenderMethod ();

  if (Renderer.Windowed)
    {
      S9xSetInfoString ("");
      if (SwitchDisplayMode)
	{
	  S9xSetWindowPos ();
	  // It set HWND_TOPMOST by timer
	  GUI.SwitchToWindowed = TRUE;
	  S9xMessage2 (WindowTitleText, 1000);
	}
      if (GUI.statusbar == 1)
	uowCreateStatusBar (GUI.hWnd);
      if (GetMenu (GUI.hWnd) == NULL)
	{
	  SetMenu (GUI.hWnd, GUI.hMenu);
	  GUI.AppMenuConnect = TRUE;
	}
      RefreshRectParams (GUI.hWnd, GUI.hStatusWnd);
      SetWindowText (GUI.hWnd, WindowTitleText);
    }
  else
    RefreshRectParams (GUI.hWnd, GUI.hStatusWnd);

  //Erase mouse cursor.
  EraseMouseCursor ();

  if (!SetupVsyncTimer (Renderer.wait_for_vsync, VsyncTimerProc, NULL))
    return FALSE;

  return TRUE;
}

static void
PauseExecution (BOOL pause, BOOL lock, BOOL clear_lock)
{
  if ((!pause && !lock) || clear_lock)
    GUI.PauseLock = FALSE;

  if (pause)
    uowKillMessageTimer (GUI.hWnd);

  if ((GUI.FullScreen && Renderer.Windowed) ||
      Settings.Paused || GUI.PauseLock)
    {
      S9xSetSoundMute (TRUE);
      return;
    }

  if (pause && lock)
    GUI.PauseLock = TRUE;

  if (SPCLoadedFlag && !pause)
    {
      Sleep (500);
      SPCLoadedFlag = FALSE;
    }

  Settings.ForcedPause = pause;
  S9xSetSoundMute ((bool8) pause);

  DirectX_SetClipper (pause);

  if (!pause)
    EraseMouseCursor ();
}

bool
UIEnter ()
{
  PauseExecution (TRUE, FALSE, FALSE);
  if (GUI.FullScreen && !Renderer.Windowed)
    {
      PauseExecution (TRUE, TRUE, FALSE);
      if (SwitchScreenMode (TRUE))
	{
	  GUI.FullScreen = TRUE;
	  DirectX_SetClipper (TRUE);
	  if (Settings.StopEmulation || Settings.SPCPlaying)
	    S9xDrawScreenData ();
	  PauseExecution (TRUE, FALSE, TRUE);
	}
      else
	return FALSE;
    }
  return TRUE;
}

void
UIExit ()
{
  if ((Renderer.Windowed && !GUI.FullScreen)
      || (!Renderer.Windowed && GUI.FullScreen))
    PauseExecution (FALSE, TRUE, FALSE);
}

void
S9xwStateSave (char SaveSlotNum)
{
  if (Settings.StopEmulation || Settings.SPCPlaying
      || (Settings.Paused && GUI.FullScreen))
    return;
  char saveext[_MAX_EXT];
  char savemesj[] = "Slot #1 saved";
  char savemese[] = "Slot #1 saved";
  bool8 saveerr;

  lstrcpy (saveext, ".000");

  saveext[3] = (0x30 + SaveSlotNum - 1);
  savemesj[6] = savemese[6] = (0x30 + SaveSlotNum);
  PauseExecution (TRUE, FALSE, FALSE);
  saveerr = S9xFreezeGame (S9xGetFilename (saveext, SNAPSHOT_DIR));

  if (Settings.Paused)
    S9xSetSoundMute (TRUE);
  else
    PauseExecution (FALSE, TRUE, FALSE);

#if 0
  if (saveerr)
    S9xMessage2 (GUI.Language == 1 ? savemesj : savemese, 2000);
  else
    S9xMessage2 (GUI.Language == 1 ? "Error!" : "Error!", 2000);
#endif
}

void
S9xwStateLoad (int SaveSlotNum)
{
  if (Settings.StopEmulation || Settings.SPCPlaying
      || (Settings.Paused && GUI.FullScreen))
    return;
  char loadext[_MAX_EXT];
  char loadmesj[] = "Slot #1 loaded";
  char loadmese[] = "Slot #1 loaded";
  bool8 loaderr;

  lstrcpy (loadext, ".000");

  loadext[3] = (0x30 + SaveSlotNum - 1);
  loadmesj[6] = loadmese[6] = (0x30 + SaveSlotNum);

  PauseExecution (TRUE, FALSE, FALSE);
  loaderr = S9xUnfreezeGame (S9xGetFilename (loadext, SNAPSHOT_DIR));
  if (Settings.Paused)
    S9xSetSoundMute (TRUE);
  else
    PauseExecution (FALSE, TRUE, FALSE);
#if 0
  if (loaderr)
    S9xMessage2 (GUI.Language == 1 ? loadmesj : loadmese, 2000);
  else
    S9xMessage2 (GUI.Language == 1 ? "Error!" : "Error!", 2000);
#endif
}

void
S9xwStateSaveReplay ()
{
  if (Settings.StopEmulation || Settings.SPCPlaying
      || (Settings.Paused && GUI.FullScreen))
    return;
  bool8 saveerr;

  PauseExecution (TRUE, FALSE, FALSE);
  saveerr = S9xFreezeGame (S9xGetFilename (".rpb", SNAPSHOT_DIR));
  if (Settings.Paused)
    S9xSetSoundMute (TRUE);
  else
    PauseExecution (FALSE, TRUE, FALSE);

  if (saveerr)
    {
      S9xMessage2 (GUI.Language == 1 ? "Movie Rec Start" : "Movie Rec Start",
		   2000);
    }
  else
    {
      S9xMessage2 (GUI.Language == 1 ? "Error!" : "Error!", 2000);
      XxxMovie.Replay_play = FALSE;
      XxxMovie.Replay_rec = FALSE;
    }
}

void
S9xwStateLoadReplay ()
{
  if (Settings.StopEmulation || Settings.SPCPlaying
      || (Settings.Paused && GUI.FullScreen))
    return;

  bool8 loaderr;
  PauseExecution (TRUE, FALSE, FALSE);
  loaderr = S9xUnfreezeGame (S9xGetFilename (".rpb", SNAPSHOT_DIR));
  if (Settings.Paused)
    S9xSetSoundMute (TRUE);
  else
    PauseExecution (FALSE, TRUE, FALSE);
  if (loaderr)
    {
      S9xMessage2 (GUI.Language ==
		   1 ? "Movie Play Start" : "Movie Play Start", 2000);
    }
  else
    {
      S9xMessage2 (GUI.Language == 1 ? "Error!" : "Error!", 2000);
      XxxMovie.Replay_play = FALSE;
      XxxMovie.Replay_rec = FALSE;
    }
}

static void
MovieRecord (b8 &MovieRecording)
{
  if (Settings.StopEmulation || Settings.SPCPlaying
      || (Settings.Paused && GUI.FullScreen))
    return;

  bool8 r = TRUE;

  if (MovieRecording)
    movie_close ();
  else
    r = movie_open (S9xGetFilenameInc (".avi", SCREENSHOT_DIR));

  if(TRUE)
    MovieRecording = !MovieRecording;
}

static void CenterCursor()
{
  if(Settings.ControllerOption==SNES_MOUSE || Settings.ControllerOption==SNES_MOUSE_SWAPPED)
    {
      if(GUI.hWnd == GetActiveWindow())
	{
	  POINT cur, middle;
	  RECT size;

	  size = GUI.ClientRect;
	  middle.x = (size.right - size.left) >> 1;
	  middle.y = (size.bottom - size.top) >> 1;
	  ClientToScreen (GUI.hWnd, &middle);
	  GetCursorPos (&cur);
	  int dX = middle.x-cur.x;
	  int dY = middle.y-cur.y;
	  if(dX || dY)
	    {
	      GUI.MouseX -= dX;
	      GUI.MouseY -= dY;
	      SetCursorPos (middle.x, middle.y);
	    }
	}
    }
}

LRESULT CALLBACK
WinProc (HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  switch (uMsg)
    {
    case WM_CREATE:
      {
	InitCommonControls ();

	//for Date Time Picker Control
	INITCOMMONCONTROLSEX ic;
	ic.dwSize = sizeof (INITCOMMONCONTROLSEX);
	ic.dwICC = ICC_DATE_CLASSES;
	InitCommonControlsEx (&ic);

	GUI.hRtLib = LoadLibrary ("RICHED32.DLL");

	//j[Zbg
	SetMenu (hWnd, GUI.hMenu);
	GUI.AppMenuConnect = TRUE;

	GUI.hSysMenu = GetSystemMenu (hWnd, FALSE);

	if (GUI.hSysMenu)
	  {
	    /* svȃVXej[폜 */
	    //      for (int i = 2; i < 3; i++)
	    //              DeleteMenu(GUI.hSysMenu, i, MF_BYPOSITION);
	    InsertMenu (GUI.hSysMenu,
			0,
			MF_BYPOSITION | MF_POPUP,
			(UINT) GetSubMenu (GUI.hVolMenu, 0),
			(GUI.Language ==
			 1 ? "{[x(&V)" : "&Volume Level"));
	    InsertMenu (GUI.hSysMenu, 1, MF_BYPOSITION | MFT_SEPARATOR, 0, 0);
	  }

	if (GUI.statusbar == 1)
	  uowCreateStatusBar (hWnd);

	RefreshRectParams (hWnd, GUI.hStatusWnd);

	SetMenuStatus (GUI.hMenu, GUI.hSysMenu);

	//inactivate IME
#if 0
	ImeEnable (hWnd, FALSE);
#else
	GUI.hImc = ImmAssociateContext (hWnd, NULL);
#endif

	DragAcceptFiles (hWnd, TRUE);	//set drag & drop
	WindowActiveFlag = 1;

	GUI.FrameTimerSemaphore = CreateSemaphore (NULL, 0, 10, NULL);

	if (GUI.FrameTimerSemaphore == NULL ||
	    !uowSetupFrameTimer ((DWORD) Settings.FrameTime))
	  {
	    MessageBox (hWnd,
			Languages[GUI.Language].errFrameTimer,
			"uosnes - Frame Timer", MB_OK | MB_ICONINFORMATION);
	  }

	//check QueryPerformanceCounter
	LARGE_INTEGER liPerfCount;
	PerformanceCounterExist = QueryPerformanceCounter (&liPerfCount);
	if (PerformanceCounterExist)
	  QueryPerformanceFrequency (&PerfTicksPerSecond);

	if (!uowInit (hWnd))
	  {

	    GUI.Exit = TRUE;

	    //PauseExecution (TRUE, TRUE, FALSE);
	    SetPriorityClassAndThreadPriority (NORMAL_PRIORITY_CLASS,
					       THREAD_PRIORITY_NORMAL);
	    DragAcceptFiles (hWnd, FALSE);	//hbOhbv

	    //save window size
	    //if (Renderer.Windowed && !MinimizedFlag)
	    //  GetWindowRect (hWnd, &GUI.WindowRectSetting);
	    uowKillMessageTimer (hWnd);
	    uowClose (hWnd);
	    return -1;
	  }

	if (__argc > 1)
	  {
	    //get long filename
	    if (!GetLongFileName (rom_filename, ROMFileName, _MAX_PATH))
	      rom_filename = NULL;
	  }
	else
	  rom_filename = NULL;

	if (Options.LoadLastImageStartup && rom_filename == NULL &&
	    access ((const char *) ROMFileName, 0) == 0)
	  rom_filename = ROMFileName;

	//SetCursor(GUI.Arrow);

	//for dubug
	//MessageBox(hWnd, "uosnes", "uosnes", MB_OK | MB_ICONINFORMATION);
      }
      break;

      //get status of SNES mouse superscope
    case WM_LBUTTONDOWN:
      if ((Settings.ControllerOption == SNES_MOUSE ||
	   Settings.ControllerOption == SNES_MOUSE_SWAPPED ||
	   Settings.ControllerOption == SNES_SUPERSCOPE ||
	   Settings.ControllerOption == SNES_JUSTIFIER ||
	   Settings.ControllerOption == SNES_JUSTIFIER_2) &&
	  !Settings.StopEmulation &&
	  !Settings.ForcedPause &&
	  !Settings.Paused &&
	  !Settings.SPCPlaying)
	SetCursor (NULL);
      else
	{
	  SetCursor (GUI.Arrow);
	  EraseMouseCursor ();
	}
      GUI.MouseButtons |= 1;
      break;

    case WM_LBUTTONUP:
      GUI.MouseButtons &= ~1;
      break;

    case WM_RBUTTONDOWN:
      if ((Settings.ControllerOption == SNES_MOUSE ||
	   Settings.ControllerOption == SNES_MOUSE_SWAPPED ||
	   Settings.ControllerOption == SNES_SUPERSCOPE ||
	   Settings.ControllerOption == SNES_JUSTIFIER ||
	   Settings.ControllerOption == SNES_JUSTIFIER_2) &&
	  !Settings.StopEmulation &&
	  !Settings.ForcedPause &&
	  !Settings.Paused &&
	  !Settings.SPCPlaying)
	SetCursor (NULL);
      else
	{
	  SetCursor (GUI.Arrow);
	  EraseMouseCursor ();
	}
      GUI.MouseButtons |= 2;
      break;

    case WM_RBUTTONUP:
      GUI.MouseButtons &= ~2;
      if(Settings.ControllerOption == SNES_JUSTIFIER || Settings.ControllerOption == SNES_JUSTIFIER_2)
	{
	  POINT p;
	  p.x = GET_X_LPARAM(lParam);
	  p.y = GET_Y_LPARAM(lParam);
	  ClientToScreen (hWnd, &p);

	  RECT dstRect;
	  GetRenderedRect (&dstRect);

	  GUI.MouseButtons &= ~1;
	  GUI.MouseX = (p.x - dstRect.left) * IPPU.RenderedScreenWidth / (dstRect.right - dstRect.left);
	  GUI.MouseY = (p.y - dstRect.top) * IPPU.RenderedScreenHeight / (dstRect.bottom - dstRect.top);
	}
      break;

    case WM_MBUTTONDOWN:
      if ((Settings.ControllerOption == SNES_MOUSE ||
	   Settings.ControllerOption == SNES_MOUSE_SWAPPED ||
	   Settings.ControllerOption == SNES_SUPERSCOPE ||
	   Settings.ControllerOption == SNES_JUSTIFIER ||
	   Settings.ControllerOption == SNES_JUSTIFIER_2) &&
	  !Settings.StopEmulation &&
	  !Settings.ForcedPause &&
	  !Settings.Paused &&
	  !Settings.SPCPlaying)
	SetCursor (NULL);
      else
	{
	  SetCursor (GUI.Arrow);
	  EraseMouseCursor ();
	}
      GUI.MouseButtons |= 4;
      break;

    case WM_MBUTTONUP:
      GUI.MouseButtons &= ~4;
      break;

    case WM_MOUSEMOVE:
      if (!Settings.ForcedPause && !Settings.StopEmulation &&
	  !Settings.Paused && !Settings.SPCPlaying)
	{
	  if(Settings.ControllerOption == SNES_MOUSE || Settings.ControllerOption == SNES_MOUSE_SWAPPED)
	    CenterCursor();
	  else if(Settings.ControllerOption == SNES_SUPERSCOPE ||
		  Settings.ControllerOption == SNES_JUSTIFIER ||
		  Settings.ControllerOption == SNES_JUSTIFIER_2)

	    {
	      POINT p;
	      p.x = GET_X_LPARAM(lParam);
	      p.y = GET_Y_LPARAM(lParam);
	      ClientToScreen (hWnd, &p);

	      RECT dstRect;
	      GetRenderedRect (&dstRect);

	      GUI.MouseX = (p.x - dstRect.left) * IPPU.RenderedScreenWidth / (dstRect.right - dstRect.left);
	      GUI.MouseY = (p.y - dstRect.top) * IPPU.RenderedScreenHeight / (dstRect.bottom - dstRect.top);
	    }
	}

      if ((Settings.ControllerOption == SNES_MOUSE ||
	   Settings.ControllerOption == SNES_MOUSE_SWAPPED ||
	   Settings.ControllerOption == SNES_SUPERSCOPE ||
	   Settings.ControllerOption == SNES_JUSTIFIER ||
	   Settings.ControllerOption == SNES_JUSTIFIER_2) &&
	  !Settings.StopEmulation &&
	  !Settings.ForcedPause &&
	  !Settings.Paused &&
	  !Settings.SPCPlaying)
	SetCursor (NULL);
      else
	{
	  if ((GUI.MousePosition.x + 2) <= (LONG) LOWORD (lParam)
	      || (GUI.MousePosition.y + 2) <= (LONG) HIWORD (lParam)
	      || (GUI.MousePosition.x - 2) >= (LONG) LOWORD (lParam)
	      || (GUI.MousePosition.y - 2) >= (LONG) HIWORD (lParam))
	    {
	      SetCursor (GUI.Arrow);

	      GUI.MousePosition.x = (int16) (lParam & 0xffff);
	      GUI.MousePosition.y = (int16) ((lParam >> 16) & 0xffff);
	    }
	  else
	    return 0;

	  EraseMouseCursor ();
	}
      break;

    case WM_SETCURSOR:
      break;

    case WM_NCMOUSEMOVE:
      GUI.MouseButtons = 0;
      break;

    case WM_TIMER:
      if (!Renderer.Windowed && OnScreenMessage[0])
	{
	  lstrcpy (S9xInfoString, OnScreenMessage);
	  S9xSetInfoString (S9xInfoString);
	  OnScreenMessage[0] = 0;
	  OnScreenMessageTimeOut = 0;
	}
      else if (OnScreenMessage[0] || ExitMenuMessage[0]
	       || MouseEraseMessage[0])
	OnScreenMessageUpdate ();

      //set HWND_TOPMOST after switch screen mode
      if (GUI.SwitchToWindowed)
	{
	  GUI.SwitchToWindowed = FALSE;
	  if (GUI.WindowTopMost && GetForegroundWindow () == hWnd)
	    SetWindowPos (hWnd, HWND_TOPMOST, 0, 0, 0, 0,
			  SWP_NOMOVE | SWP_NOSIZE);
	}
      break;

    case WM_EXITMENULOOP:
      S9xMessage2 ("ExitMenu", 200);
      break;

    case WM_MOVE:
      sb_avail = FALSE;
      RefreshRectParams (hWnd, GUI.hStatusWnd);
      break;

    case WM_MOVING:
      sb_avail = FALSE;
      RefreshRectParams (hWnd, GUI.hStatusWnd);
      break;

    case WM_ACTIVATE:
      switch (LOWORD (wParam))
	{
	case WA_ACTIVE:
	case WA_CLICKACTIVE:
	  WindowActiveFlag = 1;

	  if (GUI.WindowTopMost)
	    {
	      SetWindowPos (hWnd, HWND_TOPMOST, 0, 0, 0, 0,
			    SWP_NOMOVE | SWP_NOSIZE);
	    }
	  else
	    {
	      SetWindowPos (hWnd, HWND_NOTOPMOST, 0, 0, 0, 0,
			    SWP_NOMOVE | SWP_NOSIZE);
	    }

	  if (!Settings.StopEmulation)
	    SetPriorityClassAndThreadPriority (GUI.PriorityClass,
					       GUI.ThreadPriority);
	  else
	    SetPriorityClassAndThreadPriority (NORMAL_PRIORITY_CLASS,
					       THREAD_PRIORITY_NORMAL);
	  if (!GUI.FullScreen && Renderer.Windowed && !ncbuttondown_flag
	      && !MinimizedFlag)
	    {
	      PauseExecution (FALSE, TRUE, FALSE);
	    }
	  break;

	case WA_INACTIVE:
	  {
	    HWND hActive, hTop, hParent;
	    WindowActiveFlag = 0;
	    hActive = GetForegroundWindow ();

	    if (hActive)
	      {
		for (hTop = hActive; (hParent = GetParent (hTop));
		     hTop = hParent);
	      }
	    else
	      {
		hTop = 0;
		hParent = 0;
	      }

	    if (GUI.WindowTopMost)
	      {
		if (GUI.WindowTopMostAlways == FALSE)
		  {
		    if (hActive && hTop != hWnd
			&& GetWindow (hActive, GW_HWNDNEXT))
		      SetWindowPos (hWnd, hActive, 0, 0, 0, 0,
				    SWP_NOMOVE | SWP_NOSIZE);
		    else
		      SetWindowPos (hWnd, HWND_NOTOPMOST, 0, 0, 0, 0,
				    SWP_NOMOVE | SWP_NOSIZE);
		  }
	      }
	    else
	      SetWindowPos (hWnd, HWND_NOTOPMOST, 0, 0, 0, 0,
			    SWP_NOMOVE | SWP_NOSIZE);

	    if (Settings.SPCPlaying && MinimizedFlag)
	      {
		PauseExecution (FALSE, TRUE, FALSE);
	      }
	    else
	      {
		if (hTop == hWnd || !Options.inactive_x)
		  {
		    SetPriorityClassAndThreadPriority (NORMAL_PRIORITY_CLASS,
						       THREAD_PRIORITY_NORMAL);
		    PauseExecution (TRUE, FALSE, FALSE);
		  }
		else
		  DirectX_SetClipper (TRUE);
	      }
	  }
	  break;

	default:
	  break;
	}
      break;

#if 0
    case WM_ACTIVATEAPP:
      if (wParam && !GUI.FullScreen && Renderer.Windowed && !ncbuttondown_flag
	  && !MinimizedFlag)
	{
	  WindowActiveFlag = 1;
	  PauseExecution (FALSE, TRUE, FALSE);
	}
      else if (!wParam && !Settings.SPCPlaying)
	{
	  WindowActiveFlag = 0;
	  PauseExecution (TRUE, FALSE, FALSE);
	}
      break;
#endif

    case WM_DROPFILES:
      /* drag & drop */
      if (Settings.Paused)
	break;
      {
	SetAbsoluteForegroundWindow (hWnd);
	DragQueryFile ((HDROP) wParam, 0, ROMFileName, _MAX_PATH);
	DragFinish ((HDROP) wParam);
	PauseExecution (TRUE, FALSE, FALSE);
	ROMLoadProc (ROMFileName);
	if (!Settings.StopEmulation)
	  SetPriorityClassAndThreadPriority (GUI.PriorityClass,
					     GUI.ThreadPriority);
	else
	  SetPriorityClassAndThreadPriority (NORMAL_PRIORITY_CLASS,
					     THREAD_PRIORITY_NORMAL);
	PauseExecution (FALSE, TRUE, FALSE);
	EraseMouseCursor ();
      }
      break;

    case WM_KEYDOWN:
      switch (wParam)
	{
	case VK_ESCAPE:
	  //window mode
	  if (Renderer.Windowed && !GUI.FullScreen)
	    {
	      if (GetMenu (hWnd) == NULL)
		{
		  SetMenu (hWnd, GUI.hMenu);
		  RefreshRectParams (hWnd, GUI.hStatusWnd);
		  GUI.AppMenuConnect = TRUE;
		  DrawMenuBar (hWnd);
		}
	      else
		{
		  SetMenu (hWnd, NULL);
		  RefreshRectParams (hWnd, GUI.hStatusWnd);
		  GUI.AppMenuConnect = FALSE;
		}
	      RedrawClientRectAfterSizedMovedClient (hWnd, &GUI.ClientRect);
	      SetMenuStatus (GUI.hMenu, GUI.hSysMenu);
	      if (Settings.StopEmulation || Settings.SPCPlaying)
		uowScreenRedraw (hWnd);
	    }
	  //full screen mode
	  else if (!Renderer.Windowed && GUI.FullScreen)
	    {
	      PauseExecution (TRUE, TRUE, FALSE);
	      if (SwitchScreenMode (TRUE))
		{
		  GUI.FullScreen = TRUE;
		  DirectX_SetClipper (TRUE);
		  if (Settings.StopEmulation || Settings.SPCPlaying)
		    S9xDrawScreenData ();
		  PauseExecution (TRUE, FALSE, TRUE);
		}
	    }
	  else if (Renderer.Windowed && GUI.FullScreen
		   && !Settings.StopEmulation)
	    {
	      PauseExecution (TRUE, TRUE, FALSE);
	      if (SwitchScreenMode (FALSE))
		PauseExecution (FALSE, FALSE, TRUE);
	      else
		break;
	    }
	  break;

	  //State save load
	case VK_F1:
	case VK_F2:
	case VK_F3:
	case VK_F4:
	case VK_F5:
	case VK_F6:
	case VK_F7:
	case VK_F8:
	case VK_F9:
	  if (Settings.StopEmulation || Settings.SPCPlaying)
	    break;
	  //load
	  if ((GetKeyState (VK_SHIFT) & 0x8000) == 0)
	    {
	      wsprintf (tmpcharbuf, ".%03d", wParam - VK_F1);
	      if (GetFileAttributes
		  (S9xGetFilename (tmpcharbuf, SNAPSHOT_DIR)) == 0xffffffff)
		break;
	      S9xwStateLoad (wParam - VK_F1 + 1);
	    }
	  //save
	  else
	    {
	      S9xwStateSave (wParam - VK_F1 + 1);
	    }
	  break;

	default:
	  break;
	}
      break;

    case WM_SYSKEYUP:
      switch (wParam)
	{
	case VK_RETURN:
	  if ((Renderer.Windowed && Renderer.Depth == 8)
	      || Settings.SPCPlaying)
	    break;

	  if ((GUI.FullScreen && Renderer.Windowed) ||
	      (!GUI.FullScreen && Renderer.Windowed
	       && Settings.StopEmulation))
	    {
	      GUI.FullScreen = !GUI.FullScreen;
	      PauseExecution (FALSE, TRUE, FALSE);
	    }
	  // to full screen
	  else if (!GUI.FullScreen && Renderer.Windowed
		   && !Settings.StopEmulation)
	    {
	      PauseExecution (TRUE, TRUE, FALSE);
	      if (SwitchScreenMode (FALSE))
		PauseExecution (FALSE, FALSE, TRUE);
	      else
		break;
	    }
	  // to windowed
	  else if (GUI.FullScreen && !Renderer.Windowed
		   && !Settings.StopEmulation)
	    {
	      PauseExecution (TRUE, TRUE, FALSE);
	      if (SwitchScreenMode (TRUE))
		PauseExecution (FALSE, FALSE, TRUE);
	      else
		break;
	    }
	  break;

	default:
	  break;
	}
      break;

    case WM_COMMAND:
      switch (LOWORD (wParam))
	{
	case ID_FILE_OPEN:
	  if (Settings.Paused || !UIEnter ())
	    break;
	  PauseExecution (TRUE, TRUE, FALSE);
	  if (GetFileAttributes (InitialROMFileDirectory) == 0xffffffff)
	    {
	      char drive[_MAX_DRIVE + 1];
	      char dir[_MAX_DIR + 1];
	      char fname[_MAX_FNAME + 1];
	      char ext[_MAX_EXT + 1];

	      if (strlen ((const char *) Options.HomeDirectory) <
		  _MAX_PATH - 7)
		strcpy (ROMFileName, (const char *) Options.HomeDirectory);
	      else
		strcpy (ROMFileName, "c:\\");

	      _splitpath (ROMFileName, drive, dir, fname, ext);
	      if (fname[0])
		lstrcat (ROMFileName, "\\a.smc");
	      else
		lstrcat (ROMFileName, "a.smc");
	      _splitpath (ROMFileName, drive, dir, fname, ext);
	      _makepath (InitialROMFileDirectory, drive, dir, NULL, NULL);
	    }
	  if ((GUI.FileBrowseWindow == 0
	       && OpenFile (hWnd, ROMFileName, FileTitle,
			    InitialROMFileDirectory))
	      || (GUI.FileBrowseWindow == 1
		  && OpenFileEx (hWnd, ROMFileName, FileTitle,
				 InitialROMFileDirectory)))
	    {
	      ROMLoadProc (ROMFileName);
	      if (!Settings.StopEmulation)
		SetPriorityClassAndThreadPriority (GUI.PriorityClass,
						   GUI.ThreadPriority);
	      else
		SetPriorityClassAndThreadPriority (NORMAL_PRIORITY_CLASS,
						   THREAD_PRIORITY_NORMAL);
	    }
	  PauseExecution (TRUE, FALSE, TRUE);
	  UIExit ();
	  EraseMouseCursor ();
	  break;

	case ID_FILE_RECENT1:
	case ID_FILE_RECENT2:
	case ID_FILE_RECENT3:
	case ID_FILE_RECENT4:
	case ID_FILE_RECENT5:
	case ID_FILE_RECENT6:
	case ID_FILE_RECENT7:
	case ID_FILE_RECENT8:
	case ID_FILE_RECENT9:
	case ID_FILE_RECENTA:
	  if (Settings.Paused)
	    break;
	  PauseExecution (TRUE, FALSE, FALSE);
	  ROMLoadProc (&RecentROMFileName
		       [_MAX_PATH * (LOWORD (wParam) - ID_FILE_RECENT1)]);
	  if (!Settings.StopEmulation)
	    SetPriorityClassAndThreadPriority (GUI.PriorityClass,
					       GUI.ThreadPriority);
	  else
	    SetPriorityClassAndThreadPriority (NORMAL_PRIORITY_CLASS,
					       THREAD_PRIORITY_NORMAL);
	  PauseExecution (FALSE, TRUE, FALSE);
	  break;

	case ID_FILE_RESET:
	  if (Settings.StopEmulation || Settings.SPCPlaying
	      || Settings.Paused)
	    break;
	  PauseExecution (TRUE, FALSE, FALSE);
	  S9xReset ();

	  // Original
	  if (Xxxcdda.Enable)
	    cdda_stop ();

#ifdef UNCO_FULL_TEAM
	  if (Xxxbsx.BsxRomCheck)
	    {
	      BSX_CLEAR ();
	      BSX_TIMESET ();
	    }
#endif
	  if (GUI.FullScreen && Renderer.Windowed)
	    {
	      PauseExecution (TRUE, TRUE, FALSE);
	      if (SwitchScreenMode (FALSE))
		PauseExecution (FALSE, FALSE, TRUE);
	      else
		break;
	    }
	  PauseExecution (FALSE, TRUE, FALSE);
	  break;

	case ID_FILE_SOFTRESET:
	  if (Settings.StopEmulation || Settings.SPCPlaying
	      || Settings.Paused)
	    break;
	  PauseExecution (TRUE, FALSE, FALSE);
	  S9xSoftReset ();

	  // Original
	  if (Xxxcdda.Enable)
	    cdda_stop ();

#ifdef UNCO_FULL_TEAM
	  if (Xxxbsx.BsxRomCheck)
	    {
	      BSX_CLEAR ();
	      BSX_TIMESET ();
	    }
#endif
	  if (GUI.FullScreen && Renderer.Windowed)
	    {
	      PauseExecution (TRUE, TRUE, FALSE);
	      if (SwitchScreenMode (FALSE))
		PauseExecution (FALSE, FALSE, TRUE);
	      else
		break;
	    }
	  PauseExecution (FALSE, TRUE, FALSE);
	  break;

	case ID_FILE_BACKTOIDLE:
	  if (Settings.StopEmulation)
	    break;

	  if (!Settings.StopEmulation && ExecLoop == S9xMainLoop)
	    {
	      Memory.SaveSRAM (S9xGetFilename (".srm", SRAM_DIR));
	      S9xSaveCheatFile (S9xGetFilename (".cht", CHEAT_DIR));
	      if (Xxxcdda.Enable)
		cdda_exit ();	// Original
	      XXX_REPLAY_END ();
	    }

	  S9xReset ();
	  Settings.StopEmulation = TRUE;
	  ExecLoop = NullExecLoop;
	  SPCLoadedFlag = FALSE;
	  Settings.SPCPlaying = FALSE;
	  Renderer.ForceClipper = TRUE;

	  // FullScreen Mode
	  if (!Renderer.Windowed)
	    {
	      PauseExecution (TRUE, TRUE, FALSE);
	      if (SwitchScreenMode (TRUE))
		{
		  GUI.FullScreen = TRUE;
		  DirectX_SetClipper (TRUE);
		  if (Settings.StopEmulation || Settings.SPCPlaying)
		    S9xDrawScreenData ();
		  PauseExecution (TRUE, FALSE, TRUE);
		}
	      else
		break;
	    }
	  // Windowed Mode
	  else
	    {
	      PauseExecution (TRUE, TRUE, FALSE);
	      DirectX_SetClipper (TRUE);
	      if (Settings.StopEmulation || Settings.SPCPlaying)
		S9xDrawScreenData ();
	      PauseExecution (TRUE, FALSE, TRUE);
	    }

	  SetMenuStatus (GUI.hMenu, GUI.hSysMenu);
	  uowDisplayStatusInfo (SB_NEEDREFRESH_ALL);
	  uowScreenRedraw (hWnd);
	  SetCursor (GUI.Arrow);
	  break;

	case ID_FILE_SPCDUMP:
	  if (Settings.StopEmulation || Settings.SPCPlaying
	      || (Settings.Paused && GUI.FullScreen))
	    break;
	  spc_is_dumping = 1;
	  break;

	case ID_FILE_ZSTSAVE:
	  if (Settings.StopEmulation || Settings.SPCPlaying
	      || (Settings.Paused && GUI.FullScreen))
	    break;
	  {
	    uint8 zstsaveerr;
	    PauseExecution (TRUE, FALSE, FALSE);
	    extern bool8 S9xFreezeZSNES (const char *filename);
	    zstsaveerr =
	      S9xFreezeZSNES (S9xGetFilename (".zst", SNAPSHOT_DIR));
	    if (Settings.Paused)
	      S9xSetSoundMute (TRUE);
	    else
	      PauseExecution (FALSE, TRUE, FALSE);
	    if (zstsaveerr)
	      S9xMessage2 (GUI.Language == 1 ? ".zst Z[u" : ".zst saved",
			   2000);
	    else
	      S9xMessage2 (GUI.Language == 1 ? "G[!" : "Error!", 2000);
	  }
	  break;

	case ID_FILE_SCREENSHOT:
	  if (Settings.StopEmulation || Settings.SPCPlaying
	      || (Settings.Paused && GUI.FullScreen))
	    break;
	  {
	    PauseExecution (TRUE, TRUE, FALSE);

	    const char *fext;

	    //Select image file format.
	    switch (Options.SaveImagefileFormat)
	      {
	      case 0:
		fext = ".bmp";
		break;

	      case 1:
		fext = ".pcx";
		break;

	      case 2:
		fext = ".gif";
		break;

	      case 3:
		fext = ".png";
		break;

	      default:
		fext = ".bmp";
		break;
	      }

	    bool8 ErrResult =
	      S9xTakeScreenShot (S9xGetFilenameInc (fext, SCREENSHOT_DIR),
				 Options.ReduceTheColorTo256,
				 Options.ReduceTheColorTo256IfWithin,
				 Options.ImagefileHiresStretch,
				 Options.RLEcompression256bitmap);

	    if (ErrResult)
	      {
		lstrcpy (OnScreenMessageStr, S9xGetFilenameIncNumExt ());
		lstrcat (OnScreenMessageStr,
			 GUI.Language == 1 ? " Z[u" : " saved");
	      }
	    else
	      lstrcpy (OnScreenMessageStr,
		       GUI.Language == 1 ? "G[!" : "Error!");
	    PauseExecution (FALSE, FALSE, FALSE);
	    S9xMessage2 (OnScreenMessageStr, 2000);
	  }
	  break;

	case ID_FILE_RECORD_MOVIE:
	  MovieRecord(Options.MovieRecording);
	  break;

	case ID_OPTION_TOGGLE:
	  {
	    Options.toggle ^= TRUE;
#ifndef DEBUGGER
	    if (Options.toggle)
	      S9xMessage2 (GUI.Language == 1 ? "toggle I" : "toggle on",
			   2000);
	    else
	      S9xMessage2 (GUI.Language == 1 ? "toggle It" : "toggle off",
			   2000);
#else
	    if (Settings.StopEmulation || Settings.SPCPlaying
		|| Settings.Paused)
	      break;

	    if (!trace && !(CPU.Flags & TRACE_FLAG))
	      {
		TracelogFilename = S9xGetFilenameInc (".log", BINDUMP_DIR);

		if (TracelogFilename)
		  trace = fopen (TracelogFilename, "wb");
		if (trace)
		  CPU.Flags |= TRACE_FLAG;
		if (trace && (CPU.Flags & TRACE_FLAG))
		  {
		    lstrcpy ((LPTSTR) OnScreenMessageStr,
			     (LPCTSTR) S9xBasename (TracelogFilename));
		    lstrcat (OnScreenMessageStr, " tracing");
		    S9xMessage2 (OnScreenMessageStr, 2000);
		  }
	      }
	    else if (trace && (CPU.Flags & TRACE_FLAG))
	      {
		CPU.Flags ^= TRACE_FLAG;
		fclose (trace);
		trace = NULL;
		if (!trace && !(CPU.Flags & TRACE_FLAG))
		  {
		    lstrcpy ((LPTSTR) OnScreenMessageStr,
			     (LPCTSTR) S9xBasename (TracelogFilename));
		    lstrcat (OnScreenMessageStr, " tracing off");
		    S9xMessage2 (OnScreenMessageStr, 2000);
		  }
	      }
#endif
#ifdef UOSNESW_TRACE
	    if (Settings.StopEmulation || Settings.SPCPlaying
		|| Settings.Paused)
	      break;

	    if (!tracex)
	      {
		uowTracelogFilename = S9xGetFilenameInc (".log", BINDUMP_DIR);

		if (uowTracelogFilename)
		  tracex = fopen (uowTracelogFilename, "wb");
		if (tracex)
		  {
		    lstrcpy ((LPTSTR) OnScreenMessageStr,
			     (LPCTSTR) S9xBasename (uowTracelogFilename));
		    lstrcat (OnScreenMessageStr, " tracing");
		    S9xMessage2 (OnScreenMessageStr, 2000);
		  }
	      }
	    else if (tracex)
	      {
		fclose (tracex);
		tracex = NULL;
		if (!tracex)
		  {
		    lstrcpy ((LPTSTR) OnScreenMessageStr,
			     (LPCTSTR) S9xBasename (uowTracelogFilename));
		    lstrcat (OnScreenMessageStr, " tracing off");
		    S9xMessage2 (OnScreenMessageStr, 2000);
		  }
	      }

#endif
	  }
	  break;

	case ID_FILE_SA1TRACE:
	  {
#ifdef DEBUGGER
	    if (Settings.StopEmulation || Settings.SPCPlaying
		|| Settings.Paused)
	      break;

	    if (!trace2 && !(SA1.Flags & TRACE_FLAG))
	      {
		TracelogFilename = S9xGetFilenameInc (".log", BINDUMP_DIR);

		if (TracelogFilename)
		  trace2 = fopen (TracelogFilename, "wb");
		if (trace2)
		  SA1.Flags |= TRACE_FLAG;
		if (trace2 && (SA1.Flags & TRACE_FLAG))
		  {
		    lstrcpy ((LPTSTR) OnScreenMessageStr,
			     (LPCTSTR) S9xBasename (TracelogFilename));
		    lstrcat (OnScreenMessageStr, " tracing");
		    S9xMessage2 (OnScreenMessageStr, 2000);
		  }
	      }
	    else if (trace2 && (SA1.Flags & TRACE_FLAG))
	      {
		SA1.Flags ^= TRACE_FLAG;
		fclose (trace2);
		trace2 = NULL;
		if (!trace2 && !(SA1.Flags & TRACE_FLAG))
		  {
		    lstrcpy ((LPTSTR) OnScreenMessageStr,
			     (LPCTSTR) S9xBasename (TracelogFilename));
		    lstrcat (OnScreenMessageStr, " tracing off");
		    S9xMessage2 (OnScreenMessageStr, 2000);
		  }
	      }
#endif
	  }
	  break;

	case ID_FILE_EXIT:
	  PostMessage (hWnd, WM_CLOSE, 0, 0);
	  break;

	case ID_OPTION_DOUBLE:
	  sb_avail = FALSE;
	  PauseExecution (TRUE, FALSE, FALSE);
	  GUI.DoubleRendering = !GUI.DoubleRendering;
	  if (!GUI.DoubleRendering)
	    Settings.SupportHiRes = FALSE;
	  else
	    Settings.SupportHiRes = (bool8) GUI.SupportHiRes;
	  if (Renderer.Windowed)
	    {
	      if (Settings.StopEmulation || Settings.SPCPlaying)
		S9xDrawScreenData ();
	      RedrawClientRectAfterSizedMovedClient (hWnd, &GUI.ClientRect);
	    }
	  else
	    UpdateBackBuffer ();
	  PauseExecution (FALSE, TRUE, FALSE);
	  break;

	case ID_OPTION_ADJUSTWINDOW:
	  {
	    if (!Renderer.Windowed)
	      break;

	    sb_avail = FALSE;

	    long dw, dh;

	    if (!GUI.DoubleRendering)
	      dw =
		GUI.AdjustWindow43 ? GUI.DefaultWindowSizeW43 : GUI.
		DefaultWindowSizeW;
	    else
	      dw =
		GUI.AdjustWindow43 ? GUI.DefaultWindowSizeWW43 : GUI.
		DefaultWindowSizeWW;
	    dh =
	      GUI.DoubleRendering ? GUI.DefaultWindowSizeHH : GUI.
	      DefaultWindowSizeH;

	    RECT rc, rcWindow;
	    GetWindowRect (hWnd, &rcWindow);
	    //Window size addjust
	    if ((rcWindow.right - rcWindow.left) != dw
		|| (rcWindow.bottom - rcWindow.top) != dh)
	      {
		PauseExecution (TRUE, TRUE, FALSE);
		if (Settings.StopEmulation || Settings.SPCPlaying)
		  S9xDrawScreenData ();
		rcWindow.right = dw;
		rcWindow.bottom = dh;
		MoveWindow (hWnd, rcWindow.left, rcWindow.top, rcWindow.right,
			    rcWindow.bottom, TRUE);
		PauseExecution (TRUE, FALSE, TRUE);
		PauseExecution (FALSE, TRUE, FALSE);
		break;
	      }
	    GUI.DoubleRendering = !GUI.DoubleRendering;

	    if (!GUI.DoubleRendering)
	      dw =
		GUI.AdjustWindow43 ? GUI.DefaultWindowSizeW43 : GUI.
		DefaultWindowSizeW;
	    else
	      dw =
		GUI.AdjustWindow43 ? GUI.DefaultWindowSizeWW43 : GUI.
		DefaultWindowSizeWW;
	    dh =
	      GUI.DoubleRendering ? GUI.DefaultWindowSizeHH : GUI.
	      DefaultWindowSizeH;

	    if (!GUI.DoubleRendering)
	      Settings.SupportHiRes = FALSE;
	    else
	      Settings.SupportHiRes = (bool8) GUI.SupportHiRes;

	    PauseExecution (TRUE, TRUE, FALSE);
	    if (Settings.StopEmulation || Settings.SPCPlaying)
	      S9xDrawScreenData ();
	    GetWindowRect (hWnd, &rcWindow);
	    rcWindow.right = dw;
	    rcWindow.bottom = dh;
	    MoveWindow (hWnd, rcWindow.left, rcWindow.top, rcWindow.right,
			rcWindow.bottom, TRUE);
	    PauseExecution (TRUE, FALSE, TRUE);
	    PauseExecution (FALSE, TRUE, FALSE);
	  }
	  break;

	case ID_OPTION_STRETCH:
	  sb_avail = FALSE;
	  PauseExecution (TRUE, FALSE, FALSE);
	  if (GUI.Stretch == 1)
	    GUI.Stretch = 0;
	  else
	    GUI.Stretch = 1;
	  if (Renderer.Windowed)
	    {
	      if (Settings.StopEmulation || Settings.SPCPlaying)
		S9xDrawScreenData ();
	      RedrawClientRectAfterSizedMovedClient (hWnd, &GUI.ClientRect);
	    }
	  else
	    UpdateBackBuffer ();
	  PauseExecution (FALSE, TRUE, FALSE);
	  break;

	case ID_OPTION_SCALESTRETCH:
	  sb_avail = FALSE;
	  PauseExecution (TRUE, FALSE, FALSE);
	  if (GUI.Stretch == 2)
	    GUI.Stretch = 0;
	  else
	    GUI.Stretch = 2;
	  if (Renderer.Windowed)
	    {
	      if (Settings.StopEmulation || Settings.SPCPlaying)
		S9xDrawScreenData ();
	      RedrawClientRectAfterSizedMovedClient (hWnd, &GUI.ClientRect);
	    }
	  else
	    UpdateBackBuffer ();
	  PauseExecution (FALSE, TRUE, FALSE);
	  break;

	case ID_OPTION_SCALESTRETCH43:
	  sb_avail = FALSE;
	  PauseExecution (TRUE, FALSE, FALSE);
	  if (GUI.Stretch == 3)
	    GUI.Stretch = 0;
	  else
	    GUI.Stretch = 3;
	  if (Renderer.Windowed)
	    {
	      if (Settings.StopEmulation || Settings.SPCPlaying)
		S9xDrawScreenData ();
	      RedrawClientRectAfterSizedMovedClient (hWnd, &GUI.ClientRect);
	    }
	  else
	    UpdateBackBuffer ();
	  PauseExecution (FALSE, TRUE, FALSE);
	  break;

	case ID_OPTION_CONFIG:
	  if (Settings.Paused || !UIEnter ())
	    break;
	  ConfigDlgProp (hWnd);
	  if (errConfigSwitch)
	    break;
	  if (Renderer.Windowed)
	    {
	      //SwitchScreenMode() in ConfigDlg unset clipper.
	      DirectX_SetClipper (TRUE);
	      if (Settings.StopEmulation || Settings.SPCPlaying)
		S9xDrawScreenData ();
	      RedrawClientRectAfterSizedMovedClient (hWnd, &GUI.ClientRect);
	    }
	  else
	    UpdateBackBuffer ();
	  UIExit ();
	  EraseMouseCursor ();
	  break;

	case ID_OPTION_CHEATCODE:
	  if (Settings.StopEmulation || Settings.SPCPlaying || !UIEnter ())
	    break;
	  DisplaySNESCheatCodeWindow (hWnd);
	  UIExit ();
	  EraseMouseCursor ();
	  //SetMenuStatus (GUI.hMenu, GUI.hSysMenu);
	  break;

	case ID_OPTION_FULLSCREEN:
	  if ((Renderer.Windowed && Renderer.Depth == 8)
	      || Settings.SPCPlaying)
	    break;

	  if ((GUI.FullScreen && Renderer.Windowed) ||
	      (!GUI.FullScreen && Renderer.Windowed
	       && Settings.StopEmulation))
	    {
	      GUI.FullScreen = !GUI.FullScreen;
	      PauseExecution (FALSE, TRUE, FALSE);
	    }
	  // to full screen
	  else if (!GUI.FullScreen && Renderer.Windowed
		   && !Settings.StopEmulation)
	    {
	      PauseExecution (TRUE, TRUE, FALSE);
	      if (SwitchScreenMode (FALSE))
		PauseExecution (FALSE, FALSE, TRUE);
	      else
		break;
	    }
	  // to windowed
	  else if (GUI.FullScreen && !Renderer.Windowed
		   && !Settings.StopEmulation)
	    {
	      PauseExecution (TRUE, TRUE, FALSE);
	      if (SwitchScreenMode (TRUE))
		PauseExecution (FALSE, FALSE, TRUE);
	      else
		break;
	    }
	  break;

	case ID_OPTION_FPS:
	  if (Settings.DisplayFrameRate)
	    Settings.DisplayFrameRate = 0;
	  else
	    Settings.DisplayFrameRate = 1;
	  break;

	  //{[ύX
	case ID_OPTION_VLUP:
	  if (Options.VolumeLevel < 5)
	    {
	      ++Options.VolumeLevel;
	      SetAPUDSPAmp (FIXED_POINT * Options.VolumeLevel);
	    }
	  lstrcpy (OnScreenMessageStr, "Level ");
	  wsprintf (OnScreenMessageStr + lstrlen (OnScreenMessageStr), "%d ",
		    Options.VolumeLevel);
	  lstrcat (OnScreenMessageStr,
		   GUI.Language == 1 ? "{[Up" : "Volume Up");
	  S9xMessage2 (OnScreenMessageStr, 2000);
	  break;

	case ID_OPTION_VLDOWN:
	  if (Options.VolumeLevel > 1)
	    {
	      --Options.VolumeLevel;
	      SetAPUDSPAmp (FIXED_POINT * Options.VolumeLevel);
	    }
	  lstrcpy (OnScreenMessageStr, "Level ");
	  wsprintf (OnScreenMessageStr + lstrlen (OnScreenMessageStr), "%d ",
		    Options.VolumeLevel);
	  lstrcat (OnScreenMessageStr,
		   GUI.Language == 1 ? "{[Down" : "Volume Down");
	  S9xMessage2 (OnScreenMessageStr, 2000);
	  break;

	case ID_OPTION_VL1:
	  Options.VolumeLevel = 1;
	  SetAPUDSPAmp (FIXED_POINT * Options.VolumeLevel);
	  break;

	case ID_OPTION_VL2:
	  Options.VolumeLevel = 2;
	  SetAPUDSPAmp (FIXED_POINT * Options.VolumeLevel);
	  break;

	case ID_OPTION_VL3:
	  Options.VolumeLevel = 3;
	  SetAPUDSPAmp (FIXED_POINT * Options.VolumeLevel);
	  break;

	case ID_OPTION_VL4:
	  Options.VolumeLevel = 4;
	  SetAPUDSPAmp (FIXED_POINT * Options.VolumeLevel);
	  break;

	case ID_OPTION_VL5:
	  Options.VolumeLevel = 5;
	  SetAPUDSPAmp (FIXED_POINT * Options.VolumeLevel);
	  break;

	case ID_OPTION_JP:
	  if (!Options.JPenvFlag)
	    break;
	  PauseExecution (TRUE, TRUE, FALSE);
	  if (GUI.Language == 0)
	    GUI.Language = 1;
	  else
	    GUI.Language = 0;
	  if (Renderer.Windowed && GetMenu (hWnd) != NULL)
	    {
	      SetMenu (hWnd, NULL);
	      RefreshRectParams (hWnd, GUI.hStatusWnd);
	      GUI.AppMenuConnect = FALSE;
	      if (GUI.hRecentGamesMenu)
		DestroyMenu (GUI.hRecentGamesMenu);
	      GUI.hRecentGamesMenu = 0;
	      DestroyMenu (GUI.hMenu);
	      GUI.hMenu =
		LoadMenu ((HINSTANCE) GetWindowLong (hWnd, GWL_HINSTANCE),
			  MAKEINTRESOURCE (Languages[GUI.Language].idMenu));
	      InsertMenu (GetSubMenu (GUI.hMenu, 1), 7, MF_BYPOSITION,
			  ID_OPTION_JP,
			  GUI.Language == 1 ? "{ UI(&U)\tCtrl+U" :
			  "English &UI\tCtrl+U");
	      SetMenu (hWnd, GUI.hMenu);
	      RefreshRectParams (hWnd, GUI.hStatusWnd);
	      GUI.AppMenuConnect = TRUE;
	      DrawMenuBar (hWnd);
	    }
	  else
	    {
	      if (GUI.hRecentGamesMenu)
		DestroyMenu (GUI.hRecentGamesMenu);
	      GUI.hRecentGamesMenu = 0;
	      DestroyMenu (GUI.hMenu);
	      GUI.AppMenuConnect = FALSE;
	      GUI.hMenu =
		LoadMenu ((HINSTANCE) GetWindowLong (hWnd, GWL_HINSTANCE),
			  MAKEINTRESOURCE (Languages[GUI.Language].idMenu));
	      InsertMenu (GetSubMenu (GUI.hMenu, 1), 7, MF_BYPOSITION,
			  ID_OPTION_JP,
			  GUI.Language == 1 ? "{ UI(&U)\tCtrl+U" :
			  "English &UI\tCtrl+U");
	    }
	  //add volume menu
	  DeleteMenu (GUI.hSysMenu, 0, MF_BYPOSITION);
	  DeleteMenu (GUI.hSysMenu, 0, MF_BYPOSITION);
	  GUI.hVolMenu =
	    LoadMenu ((HINSTANCE) GetWindowLong (hWnd, GWL_HINSTANCE),
		      MAKEINTRESOURCE (IDR_VOLMENU));
	  InsertMenu (GUI.hSysMenu, 0, MF_BYPOSITION | MF_POPUP,
		      (UINT) GetSubMenu (GUI.hVolMenu, 0),
		      (GUI.Language ==
		       1 ? "{[x(&V)" : "&Volume Level"));
	  InsertMenu (GUI.hSysMenu, 1, MF_BYPOSITION | MFT_SEPARATOR, 0, 0);
	  PauseExecution (FALSE, FALSE, FALSE);
	  break;

	case ID_OPTION_MUTE:
	  Settings.Mute = !Settings.Mute;
	  if (Settings.Mute)
	    S9xMessage2 (GUI.Language == 1 ? "TEhobt@vC It" :
			 "Mute Sound", 2000);
	  else
	    S9xMessage2 (GUI.Language == 1 ? "TEhobt@vC I" :
			 "Dis Mute Sound", 2000);
	  break;
	  //
	  //Snes9x ݒύXL[
	  //
	case ID_OPTION_SETTINGS_KEY_0:
	  Settings.DisableHDMA = !Settings.DisableHDMA;
	  if (Settings.DisableHDMA)
	    S9xMessage2 (GUI.Language == 1 ? "HDMA G~[V It" :
			 "HDMA emulation off", 2000);
	  else
	    S9xMessage2 (GUI.Language == 1 ? "HDMA G~[V I" :
			 "HDMA emulation on", 2000);
	  break;

	case ID_OPTION_SETTINGS_KEY_1:
	  if (Settings.StopEmulation || Settings.SPCPlaying
	      || Settings.Paused)
	    break;
	  Settings.BG_Forced ^= 1;
	  if (Settings.BG_Forced & 1)
	    S9xMessage2 (GUI.Language == 1 ? "BG#0 It" : "BG#0 off", 2000);
	  else
	    S9xMessage2 (GUI.Language == 1 ? "BG#0 I" : "BG#0 on", 2000);
	  break;

	case ID_OPTION_SETTINGS_KEY_2:
	  if (Settings.StopEmulation || Settings.SPCPlaying
	      || Settings.Paused)
	    break;
	  Settings.BG_Forced ^= 2;
	  if (Settings.BG_Forced & 2)
	    S9xMessage2 (GUI.Language == 1 ? "BG#1 It" : "BG#1 off", 2000);
	  else
	    S9xMessage2 (GUI.Language == 1 ? "BG#1 I" : "BG#1 on", 2000);
	  break;

	case ID_OPTION_SETTINGS_KEY_3:
	  if (Settings.StopEmulation || Settings.SPCPlaying
	      || Settings.Paused)
	    break;
	  Settings.BG_Forced ^= 4;
	  if (Settings.BG_Forced & 4)
	    S9xMessage2 (GUI.Language == 1 ? "BG#2 It" : "BG#2 off", 2000);
	  else
	    S9xMessage2 (GUI.Language == 1 ? "BG#2 I" : "BG#2 on", 2000);
	  break;

	case ID_OPTION_SETTINGS_KEY_4:
	  if (Settings.StopEmulation || Settings.SPCPlaying
	      || Settings.Paused)
	    break;
	  Settings.BG_Forced ^= 8;
	  if (Settings.BG_Forced & 8)
	    S9xMessage2 (GUI.Language == 1 ? "BG#3 It" : "BG#3 off", 2000);
	  else
	    S9xMessage2 (GUI.Language == 1 ? "BG#3 I" : "BG#3 on", 2000);
	  break;

	case ID_OPTION_SETTINGS_KEY_5:
	  if (Settings.StopEmulation || Settings.SPCPlaying
	      || Settings.Paused)
	    break;
	  Settings.BG_Forced ^= 16;
	  if (Settings.BG_Forced & 16)
	    S9xMessage2 (GUI.Language ==
			 1 ? "XvCg It" : "Sprites off", 2000);
	  else
	    S9xMessage2 (GUI.Language == 1 ? "XvCg I" : "Sprites on",
			 2000);
	  break;

	case ID_OPTION_SETTINGS_KEY_6:
	  S9xApplyCommand(S9xGetCommandT("SwapJoypads"),1,0);
	  if(GFX.InfoString)
	    {
	      const char *s = GFX.InfoString;
	      GFX.InfoString = NULL;
	      S9xMessage2 (s, 2000);
	    }
	  break;

	case IDM_SNES_JOYPAD:
	case IDM_MOUSE_TOGGLE:
	case IDM_SCOPE_TOGGLE:
	case IDM_ENABLE_MULTITAP:
	case IDM_JUSTIFIER:
	case IDM_MOUSE_SWAPPED:
	case IDM_MULTITAP8:
	case IDM_JUSTIFIERS:
	case ID_OPTION_SETTINGS_KEY_7:
	  if(LOWORD (wParam) == ID_OPTION_SETTINGS_KEY_7)
	    ++Settings.ControllerOption %= SNES_MAX_CONTROLLER_OPTIONS;
	  else
	    Settings.ControllerOption = (int)(LOWORD (wParam) - IDM_SNES_JOYPAD);
	  ChangeInputDevice();

	  S9xReportControllers();
	  if(GFX.InfoString)
	    {
	      const char *s = GFX.InfoString;
	      GFX.InfoString = NULL;
	      S9xMessage2 (s, 2000);
	    }
	  
	  if(!Settings.ForcedPause &&
	     !Settings.StopEmulation &&
	     !Settings.SPCPlaying &&
	     !Settings.Paused)
	    {
	      if (Settings.ControllerOption == SNES_MOUSE || Settings.ControllerOption == SNES_MOUSE_SWAPPED)
		CenterCursor();
	      EraseMouseCursor ();
	    }
	  break;

	case ID_OPTION_SETTINGS_KEY_8:
	  Settings.BGLayering = !Settings.BGLayering;
	  if (Settings.BGLayering)
	    S9xMessage2 (GUI.Language == 1 ? "Backgroung layering hack I" :
			 "Backgroung layering hack on", 2000);
	  else
	    S9xMessage2 (GUI.Language == 1 ? "Backgroung layering hack It" :
			 "Backgroung layering hack off", 2000);
	  break;

	case ID_OPTION_SETTINGS_KEY_9:
	  if (Settings.SixteenBit)
	    {
	      Settings.Transparency = !Settings.Transparency;
	      if (Settings.Transparency)
		S9xMessage2 (GUI.Language == 1 ? " I" :
			     "Transparency effects on", 2000);
	      else
		S9xMessage2 (GUI.Language == 1 ? " It" :
			     "Transparency effects off", 2000);
	    }
	  break;

	case ID_OPTION_SETTINGS_KEY_BACK:
	  Settings.DisableGraphicWindows = !Settings.DisableGraphicWindows;
	  if (Settings.DisableGraphicWindows)
	    S9xMessage2 (GUI.Language == 1 ? "Graphic clip windows It" :
			 "Graphic clip windows off", 2000);
	  else
	    S9xMessage2 (GUI.Language == 1 ? "Graphic clip windows I" :
			 "Graphic clip windows on", 2000);
	  break;

	case ID_OPTION_SETTINGS_KEY_TURBO:
	  //^[{[h
	  Settings.TurboMode = !Settings.TurboMode;
	  if (Settings.TurboMode)
	    {
	      lstrcpy (WindowTitleTextNormal, WindowTitleTextTurbo);
	      if (!Settings.Paused)
		lstrcpy (WindowTitleText, WindowTitleTextTurbo);
	      lstrcpy (OnScreenMessageStr,
		       GUI.Language == 1 ? "^[{[h I (XLbv " :
		       "Turbo Mode on (Skip ");
	      wsprintf (&OnScreenMessageStr[lstrlen (OnScreenMessageStr)],
			"%d)", Settings.TurboSkipFrames);
	      S9xMessage2 (OnScreenMessageStr, 2000);
	    }
	  else
	    {
	      lstrcpy (WindowTitleTextNormal, WindowTitleTextNormal_bak);
	      if (!Settings.Paused)
		lstrcpy (WindowTitleText, WindowTitleTextNormal_bak);
	      S9xMessage2 (GUI.Language ==
			   1 ? "^[{[h It" : "Turbo Mode off", 2000);
	    }
	  break;

	case ID_OPTION_SETTINGS_KEY_TURBOFRAMESKIPINC:
	  if (Settings.TurboSkipFrames < 15)
	    Settings.TurboSkipFrames++;
	  else
	    Settings.TurboSkipFrames = 15;
	  lstrcpy (OnScreenMessageStr,
		   GUI.Language ==
		   1 ? "^[{XLbvt[ " : "TurboSkipFrames ");
	  wsprintf (&OnScreenMessageStr[lstrlen (OnScreenMessageStr)], "%d",
		    Settings.TurboSkipFrames);
	  S9xMessage2 (OnScreenMessageStr, 2000);
	  break;

	case ID_OPTION_SETTINGS_KEY_TURBOFRAMESKIPDEC:
	  if (Settings.TurboSkipFrames > 0)
	    Settings.TurboSkipFrames--;
	  else
	    Settings.TurboSkipFrames = 0;
	  lstrcpy (OnScreenMessageStr,
		   GUI.Language ==
		   1 ? "^[{XLbvt[ " : "TurboSkipFrames ");
	  wsprintf (&OnScreenMessageStr[lstrlen (OnScreenMessageStr)], "%d",
		    Settings.TurboSkipFrames);
	  S9xMessage2 (OnScreenMessageStr, 2000);
	  break;

	case ID_OPTION_SETTINGS_KEY_PAUSE:
	  if (!Settings.Paused)
	    {
	      PauseExecution (TRUE, FALSE, FALSE);
	      Settings.Paused = TRUE;
	      lstrcpy (WindowTitleText, WindowTitleTextPaused);
	      SetMenuStatus (GUI.hMenu, GUI.hSysMenu);
	      HMENU hMenu = GetMenu (hWnd);
	      S9xMessage2 (GUI.Language == 1 ? "Pause I" : "Pause on",
			   2000);
	      SetCursor (GUI.Arrow);
	    }
	  else
	    {
	      Settings.Paused = FALSE;
	      PauseExecution (FALSE, TRUE, FALSE);
	      lstrcpy (WindowTitleText, WindowTitleTextNormal);
	      SetMenuStatus (GUI.hMenu, GUI.hSysMenu);
	      S9xMessage2 (GUI.Language == 1 ? "Pause It" : "Pause off",
			   2000);
	      if (!Settings.ForcedPause)
		EraseMouseCursor ();
	    }
	  break;

	case ID_OPTION_SETTINGS_KEY_APPLYCHEATS:
	  Settings.ApplyCheats = !Settings.ApplyCheats;
	  if (Settings.ApplyCheats)
	    S9xMessage2 (GUI.Language ==
			 1 ? "`[gR[hL" : "Cheat code on", 2000);
	  else
	    S9xMessage2 (GUI.Language ==
			 1 ? "`[gR[h" : "Cheat code off", 2000);
	  break;

	  //ԃZ[u
	case ID_FILE_SAVESLOT_1:
	case ID_FILE_SAVESLOT_2:
	case ID_FILE_SAVESLOT_3:
	case ID_FILE_SAVESLOT_4:
	case ID_FILE_SAVESLOT_5:
	case ID_FILE_SAVESLOT_6:
	case ID_FILE_SAVESLOT_7:
	case ID_FILE_SAVESLOT_8:
	case ID_FILE_SAVESLOT_9:
	  S9xwStateSave (LOWORD (wParam) - ID_FILE_SAVESLOT_1 + 1);
	  break;

	  //ԃ[h
	case ID_FILE_LOADSLOT_1:
	case ID_FILE_LOADSLOT_2:
	case ID_FILE_LOADSLOT_3:
	case ID_FILE_LOADSLOT_4:
	case ID_FILE_LOADSLOT_5:
	case ID_FILE_LOADSLOT_6:
	case ID_FILE_LOADSLOT_7:
	case ID_FILE_LOADSLOT_8:
	case ID_FILE_LOADSLOT_9:
	  S9xwStateLoad (LOWORD (wParam) - ID_FILE_LOADSLOT_1 + 1);
	  break;

	  //Toggle Sound Channel ON OFF
	case ID_OPTION_SETTINGS_KEY_SPCCHANNEL0:
	case ID_OPTION_SETTINGS_KEY_SPCCHANNEL1:
	case ID_OPTION_SETTINGS_KEY_SPCCHANNEL2:
	case ID_OPTION_SETTINGS_KEY_SPCCHANNEL3:
	case ID_OPTION_SETTINGS_KEY_SPCCHANNEL4:
	case ID_OPTION_SETTINGS_KEY_SPCCHANNEL5:
	case ID_OPTION_SETTINGS_KEY_SPCCHANNEL6:
	case ID_OPTION_SETTINGS_KEY_SPCCHANNEL7:
	  if (Settings.StopEmulation || Settings.Paused)
	    break;

	  S9xSetSoundControl (so.sound_switch ^ (int) (1 <<
						       (LOWORD (wParam) -
							ID_OPTION_SETTINGS_KEY_SPCCHANNEL0)));
	  lstrcpy (OnScreenMessageStr,
		   GUI.Language ==
		   1 ? "TEh`l " : "Sound Channel ");
	  wsprintf (OnScreenMessageStr + lstrlen (OnScreenMessageStr), "%d ",
		    (LOWORD (wParam) - ID_OPTION_SETTINGS_KEY_SPCCHANNEL0));
	  lstrcat (OnScreenMessageStr,
		   (so.sound_switch &
		    (int) (1 <<
			   (LOWORD (wParam) -
			    ID_OPTION_SETTINGS_KEY_SPCCHANNEL0))) ? "ON" :
		   "OFF");
	  S9xMessage2 (OnScreenMessageStr, 2000);
	  uowDisplayStatusInfo (SB_NEEDREFRESH_SPCCHANNEL);
	  break;

	case ID_FUNCTIONCODE:
	  switch (LOWORD (lParam))
	    {

	    case MF_SAVE1:
	    case MF_SAVE2:
	      //Slot 1-2 save
	      S9xwStateSave (LOWORD (lParam) - MF_SAVE1 + 1);
	      break;

	    case MF_LOAD1:
	    case MF_LOAD2:
	      //Slot 1-2 load
	      wsprintf (tmpcharbuf, ".%03d", LOWORD (lParam) - MF_LOAD1);
	      if (GetFileAttributes
		  (S9xGetFilename (tmpcharbuf, SNAPSHOT_DIR)) != 0xffffffff)
		S9xwStateLoad (LOWORD (lParam) - MF_LOAD1 + 1);
	      break;

	    case MF_TURBO:
	      //Toggle Turbo Mode
	      Settings.TurboMode = !Settings.TurboMode;
	      if (Settings.TurboMode)
		{
		  lstrcpy (WindowTitleTextNormal, WindowTitleTextTurbo);
		  lstrcpy (WindowTitleText, WindowTitleTextTurbo);
		  lstrcpy (OnScreenMessageStr,
			   GUI.Language ==
			   1 ? "^[{[h I (XLbv " :
			   "Turbo Mode on (Skip ");
		  wsprintf (&OnScreenMessageStr[lstrlen (OnScreenMessageStr)],
			    "%d)", Settings.TurboSkipFrames);
		  S9xMessage2 (OnScreenMessageStr, 2000);
		}
	      else
		{
		  lstrcpy (WindowTitleTextNormal, WindowTitleTextNormal_bak);
		  lstrcpy (WindowTitleText, WindowTitleTextNormal_bak);
		  S9xMessage2 (GUI.Language == 1 ? "^[{[h It" :
			       "Turbo Mode off", 2000);
		}
	      break;

	    case MF_TURBOPAUSEFWD:
	      //Press Turbo Mode
	      Settings.TurboMode = !Settings.TurboMode;
	      break;

	    case MF_RESET:
	      //Reset
	      PauseExecution (TRUE, FALSE, FALSE);
	      S9xReset ();
#ifdef UNCO_FULL_TEAM
	      BSX_TIMESET ();	// Original
#endif
	      if (GUI.FullScreen && Renderer.Windowed)
		{
		  PauseExecution (TRUE, TRUE, FALSE);
		  if (SwitchScreenMode (FALSE))
		    PauseExecution (FALSE, FALSE, TRUE);
		  else
		    break;
		}
	      PauseExecution (FALSE, TRUE, FALSE);
	      break;

	    case MF_SOFTRESET:
	      //Soft Reset
	      PauseExecution (TRUE, FALSE, FALSE);
	      S9xSoftReset ();
#ifdef UNCO_FULL_TEAM
	      BSX_TIMESET ();	// Original
#endif
	      if (GUI.FullScreen && Renderer.Windowed)
		{
		  PauseExecution (TRUE, TRUE, FALSE);
		  if (SwitchScreenMode (FALSE))
		    PauseExecution (FALSE, FALSE, TRUE);
		  else
		    break;
		}
	      PauseExecution (FALSE, TRUE, FALSE);
	      break;

	    case MF_SPCDUMP:
	      //SPC dump
	      spc_is_dumping = 1;
#if 0
	      ErrResult = S9xwSPCDump (S9xGetSPCFilename (), FALSE);
	      if (ErrResult)
		{
		  lstrcpy (OnScreenMessageStr,
			   S9xwGetSavedSPCNumberAndExtStr ());
		  lstrcat (OnScreenMessageStr,
			   GUI.Language == 1 ? " Z[u" : " saved");
		}
	      else
		lstrcpy (OnScreenMessageStr,
			 GUI.Language == 1 ? "G[!" : "Error!");
	      S9xMessage2 (OnScreenMessageStr, 2000);
#endif
	      break;

	    case MF_SCREENSHOT:
	      //Screenshot
	      {
		PauseExecution (TRUE, TRUE, FALSE);

		const char *fext;

		//Select image file format.
		switch (Options.SaveImagefileFormat)
		  {
		  case 0:
		    fext = ".bmp";
		    break;

		  case 1:
		    fext = ".pcx";
		    break;

		  case 2:
		    fext = ".gif";
		    break;

		  case 3:
		    fext = ".png";
		    break;

		  default:
		    fext = ".bmp";
		    break;
		  }

		bool8 ErrResult =
		  S9xTakeScreenShot (S9xGetFilenameInc (fext, SCREENSHOT_DIR),
				     Options.ReduceTheColorTo256,
				     Options.ReduceTheColorTo256IfWithin,
				     Options.ImagefileHiresStretch,
				     Options.RLEcompression256bitmap);

		if (ErrResult)
		  {
		    lstrcpy (OnScreenMessageStr, S9xGetFilenameIncNumExt ());
		    lstrcat (OnScreenMessageStr,
			     GUI.Language == 1 ? " Z[u" : " saved");
		  }
		else
		  lstrcpy (OnScreenMessageStr,
			   GUI.Language == 1 ? "G[!" : "Error!");

		PauseExecution (FALSE, FALSE, FALSE);
		S9xMessage2 (OnScreenMessageStr, 2000);
	      }
	      break;

	    case MF_XXX01:
#ifdef UNCO_FULL_TEAM
	      if (Xxxbsx.BsxRomCheck)
		BSX_WORK ();
#endif
	      XXX_ROMCHEAT_CODE (ROMCHEAT_SELECT);
	      break;

	    case MF_XXX02:
#ifdef UNCO_FULL_TEAM
	      if (Xxxbsx.BsxRomCheck)
		BSX_TIMESKIP ();
#endif
	      XXX_ROMCHEAT_CODE (ROMCHEAT_CODE);
	      break;

	    case MF_XXX03:
#ifdef UNCO_FULL_TEAM
	      if (Xxxbsx.BsxRomCheck)
		BSX_TIMEBACK ();
#endif
	      Xxxcode.CheatNumBackFlag = 1;
	      XXX_ROMCHEAT_CODE (ROMCHEAT_SELECT);
	      Xxxcode.CheatNumBackFlag = 0;
	      break;

	    case MF_XXX04:
#ifdef UNCO_FULL_TEAM
	      if (Xxxbsx.BsxRomCheck)
		BSX_WORKEXTRA ();
#endif
	      if (SNESGameFixes.VoicerKun)
		{
		  Xxxcdda.VoicerCDChange = TRUE;
		  lstrcpy (OnScreenMessageStr, "Disc Change");
		  S9xMessage2 (OnScreenMessageStr, 2000);
		}
	      break;

	    case MF_XXX05:
	      if (Settings.FrameTimeNTSC == 16 && Settings.FrameTimePAL == 20)
		{
		  Xxxsystem.SpeedEnable ^= 1;

		  if (!Xxxsystem.SpeedEnable)
		    {
		      if (Settings.PAL)
			Settings.FrameTime = 20;
		      else
			Settings.FrameTime = 16;
		    }
		  else if (Xxxsystem.Speedflag == 0)
		    {
		      if (Settings.PAL)
			Settings.FrameTime = 15;
		      else
			Settings.FrameTime = 12;
		    }
		  else if (Xxxsystem.Speedflag == 1)
		    {
		      if (Settings.PAL)
			Settings.FrameTime = 12;
		      else
			Settings.FrameTime = 10;
		    }
		  else if (Xxxsystem.Speedflag == 2)
		    {
		      if (Settings.PAL)
			Settings.FrameTime = 10;
		      else
			Settings.FrameTime = 8;
		    }
		  else if (Xxxsystem.Speedflag == 3)
		    {
		      if (Settings.PAL)
			Settings.FrameTime = 80;
		      else
			Settings.FrameTime = 64;
		    }
		  else if (Xxxsystem.Speedflag == 4)
		    {
		      if (Settings.PAL)
			Settings.FrameTime = 40;
		      else
			Settings.FrameTime = 32;
		    }
		  else if (Xxxsystem.Speedflag == 5)
		    {
		      if (Settings.PAL)
			Settings.FrameTime = 30;
		      else
			Settings.FrameTime = 24;
		    }

		  if (!uowSetupFrameTimer ((DWORD) Settings.FrameTime))
		    {
		      MessageBox (hWnd,
				  Languages[GUI.Language].errFrameTimer,
				  "uosnes - Frame Timer",
				  MB_OK | MB_ICONINFORMATION);
		    }

		  lstrcpy (OnScreenMessageStr, "Change Game Speed ");
		  wsprintf (OnScreenMessageStr + lstrlen (OnScreenMessageStr),
			    "%d ", Settings.FrameTime);
		  lstrcat (OnScreenMessageStr,
			   GUI.Language == 1 ? "ms" : "ms");
		  S9xMessage2 (OnScreenMessageStr, 2000);
		}
	      break;

	    case MF_XXX06:
	      if (Settings.FrameTimeNTSC == 16 && Settings.FrameTimePAL == 20)
		{
		  if (Xxxsystem.Speedflag < 5)
		    Xxxsystem.Speedflag++;
		  else
		    Xxxsystem.Speedflag = 0;

		  if (Settings.PAL)
		    {
		      if (Xxxsystem.Speedflag == 0)
			S9xMessage2 (GUI.Language == 1 ?
				     "XXX KEY 5 [Change Game Speed 15 ms]" :
				     "XXX KEY 5 [Change Game Speed 15 ms]",
				     2000);
		      else if (Xxxsystem.Speedflag == 1)
			S9xMessage2 (GUI.Language == 1 ?
				     "XXX KEY 5 [Change Game Speed 12 ms]" :
				     "XXX KEY 5 [Change Game Speed 12 ms]",
				     2000);
		      else if (Xxxsystem.Speedflag == 2)
			S9xMessage2 (GUI.Language == 1 ?
				     "XXX KEY 5 [Change Game Speed 10 ms]" :
				     "XXX KEY 5 [Change Game Speed 10 ms]",
				     2000);
		      else if (Xxxsystem.Speedflag == 3)
			S9xMessage2 (GUI.Language == 1 ?
				     "XXX KEY 5 [Change Game Speed 80 ms]" :
				     "XXX KEY 5 [Change Game Speed 80 ms]",
				     2000);
		      else if (Xxxsystem.Speedflag == 4)
			S9xMessage2 (GUI.Language == 1 ?
				     "XXX KEY 5 [Change Game Speed 40 ms]" :
				     "XXX KEY 5 [Change Game Speed 40 ms]",
				     2000);
		      else if (Xxxsystem.Speedflag == 5)
			S9xMessage2 (GUI.Language == 1 ?
				     "XXX KEY 5 [Change Game Speed 30 ms]" :
				     "XXX KEY 5 [Change Game Speed 30 ms]",
				     2000);
		    }
		  else
		    {
		      if (Xxxsystem.Speedflag == 0)
			S9xMessage2 (GUI.Language == 1 ?
				     "XXX KEY 5 [Change Game Speed 12 ms]" :
				     "XXX KEY 5 [Change Game Speed 12 ms]",
				     2000);
		      else if (Xxxsystem.Speedflag == 1)
			S9xMessage2 (GUI.Language == 1 ?
				     "XXX KEY 5 [Change Game Speed 10 ms]" :
				     "XXX KEY 5 [Change Game Speed 10 ms]",
				     2000);
		      else if (Xxxsystem.Speedflag == 2)
			S9xMessage2 (GUI.Language == 1 ?
				     "XXX KEY 5 [Change Game Speed 8 ms]" :
				     "XXX KEY 5 [Change Game Speed 8 ms]",
				     2000);
		      else if (Xxxsystem.Speedflag == 3)
			S9xMessage2 (GUI.Language == 1 ?
				     "XXX KEY 5 [Change Game Speed 64 ms]" :
				     "XXX KEY 5 [Change Game Speed 64 ms]",
				     2000);
		      else if (Xxxsystem.Speedflag == 4)
			S9xMessage2 (GUI.Language == 1 ?
				     "XXX KEY 5 [Change Game Speed 32 ms]" :
				     "XXX KEY 5 [Change Game Speed 32 ms]",
				     2000);
		      else if (Xxxsystem.Speedflag == 5)
			S9xMessage2 (GUI.Language == 1 ?
				     "XXX KEY 5 [Change Game Speed 24 ms]" :
				     "XXX KEY 5 [Change Game Speed 24 ms]",
				     2000);
		    }
		}
	      break;

	    case MF_XXX07:
	      if (XxxMovie.Replay_play == FALSE
		  && XxxMovie.Replay_rec == FALSE)
		{
		  XxxMovie.Replay_rec = TRUE;
		  XxxMovie.Replay_play = FALSE;
		  XxxMovie.Replay_count = 0;
		  S9xwStateSaveReplay ();
		  XXX_REPLAY_START ();
		}
	      else
		{
		  if (XxxMovie.Replay_rec == TRUE)
		    S9xMessage2 (GUI.Language == 1 ? "Movie Rec Stop" :
				 "Movie Rec Stop", 2000);

		  if (XxxMovie.Replay_play == TRUE)
		    S9xMessage2 (GUI.Language == 1 ? "Movie Play Stop" :
				 "Movie Play Stop", 2000);

		  XXX_REPLAY_END ();
		}
	      break;

	    case MF_XXX08:
	      if (XxxMovie.Replay_play == FALSE
		  && XxxMovie.Replay_rec == FALSE)
		{
		  XxxMovie.Replay_play = TRUE;
		  XxxMovie.Replay_rec = FALSE;
		  XxxMovie.Def_NormalSnap = TRUE;
		  S9xwStateLoadReplay ();
		  if (XxxMovie.Replay_play)
		    XXX_REPLAY_LOAD ();
		  XXX_REPLAY_START ();
		}
	      else
		{
		  if (XxxMovie.Replay_rec == TRUE)
		    S9xMessage2 (GUI.Language == 1 ? "Movie Rec Stop" :
				 "Movie Rec Stop", 2000);

		  if (XxxMovie.Replay_play == TRUE)
		    S9xMessage2 (GUI.Language == 1 ? "Movie Play Stop" :
				 "Movie Play Stop", 2000);

		  XXX_REPLAY_END ();
		}
	      break;

	    case MF_XXX09:
	      if (XxxMovie.Replay_play == TRUE || XxxMovie.Replay_rec == TRUE)
		{
		  if (XxxMovie.Replay_rec == TRUE)
		    S9xMessage2 (GUI.Language == 1 ? "Movie Rec Stop" :
				 "Movie Rec Stop", 2000);

		  if (XxxMovie.Replay_play == TRUE)
		    S9xMessage2 (GUI.Language == 1 ? "Movie Play Stop" :
				 "Movie Play Stop", 2000);

		  XXX_REPLAY_END ();
		}
	      break;

	    case MF_XXX10:
	      break;

	    case MF_SSTURBO:
	    case MF_SSPAUSE:
	    case MF_LG2_UP:
	    case MF_LG2_DOWN:
	    case MF_LG2_LEFT:
	    case MF_LG2_RIGHT:
	    case MF_LG2_SHOT:
	    case MF_LG2_PAUSE:
	    case MF_LG2_OFFSCREEN:
	      break;

	    case MF_TURBOSHOT_TOGGLE:
	      Options.TurboShotEnable = !Options.TurboShotEnable;
	      if (Options.TurboShotEnable)
		  S9xMessage2 (GUI.Language == 1 ? "Aˋ@\\ I" : "Turbo Shot ON", 2000);
	      else
		  S9xMessage2 (GUI.Language == 1 ? "Aˋ@\\ It" : "Turbo Shot OFF", 2000);
	      break;

	    case MF_TURBOSHOT_PRESS:
	      Options.TurboShotEnable = !Options.TurboShotEnable;
	      break;

	    default: 
	      break;
	    }
	  break;
	}
      //WM_COMMAND
      break;

    case WM_ENTERMENULOOP:
      if (!UIEnter ())
	break;
      SetMenuStatus (GUI.hMenu, GUI.hSysMenu);
      DrawMenuBar (hWnd);
      break;

    case WM_NCLBUTTONDOWN:
      uowKillMessageTimer (hWnd);
      if (!GUI.FullScreen && Renderer.Windowed && wParam == HTCAPTION)
	{
	  ncbuttondown_flag = 1;
	  PauseExecution (TRUE, FALSE, FALSE);
	}
      break;

    case WM_PAINT:
      if (GUI.Exit)
	PostMessage (hWnd, WM_CLOSE, 0, 0);

      if (rom_filename && !GUI.Exit)
	{
	  rom_filename = NULL;
	  PauseExecution (TRUE, FALSE, FALSE);
	  ROMLoadProc (ROMFileName);
	  if (!Settings.StopEmulation)
	    SetPriorityClassAndThreadPriority (GUI.PriorityClass,
					       GUI.ThreadPriority);
	  else
	    SetPriorityClassAndThreadPriority (NORMAL_PRIORITY_CLASS,
					       THREAD_PRIORITY_NORMAL);
	  PauseExecution (FALSE, TRUE, FALSE);
	  EraseMouseCursor ();

	  NeedScreenInit = 2;
	}

      if (NeedScreenInit > 0 && !GUI.Exit)
	{
	  if (NeedScreenInit == 1)
	    S9xDrawScreenData ();
	  DirectX_SetClipper (TRUE);
	  uowScreenRedraw (hWnd);
	  NeedScreenInit = 0;
	}

      if (!Renderer.Windowed)
	break;

      if (ScreenRedraw_OK == FALSE)
	{
	  ScreenRedraw_OK = TRUE;
	  break;
	}

      if (Settings.StopEmulation || Settings.Paused || Settings.ForcedPause
	  || Settings.SPCPlaying)
	uowScreenRedraw (hWnd);
      break;

    case WM_CAPTURECHANGED:
      if (!GUI.FullScreen && Renderer.Windowed && ncbuttondown_flag)
	{
	  ncbuttondown_flag = 0;
	  PauseExecution (FALSE, TRUE, FALSE);
	}
      break;

      // user is moving window
    case WM_ENTERSIZEMOVE:
      if (!GUI.FullScreen && Renderer.Windowed)
	PauseExecution (TRUE, FALSE, FALSE);
      break;

    case WM_EXITSIZEMOVE:
      SizingFlag = FALSE;
      if (!GUI.FullScreen && Renderer.Windowed)
	{
	  // save window size
	  GetWindowRect (hWnd, &GUI.WindowRectSetting);
	  PauseExecution (FALSE, TRUE, FALSE);
	}
      break;

    case WM_SIZE:
      RefreshRectParams (hWnd, GUI.hStatusWnd);

      if (GUI.hStatusWnd)
	{
	  RECT clrect, strect;
	  GetWindowRect (GUI.hStatusWnd, &strect);
	  GetClientRect (hWnd, &clrect);
	  MoveWindow (GUI.hStatusWnd, clrect.left,
		      clrect.bottom - (strect.bottom - strect.top),
		      LOWORD (lParam), (strect.bottom - strect.top), TRUE);
#if 0
	  GetClientRect (GUI.hStatusWnd, &strect);
	  sb_size[2] = strect.right - strect.left;
#else
	  sb_size[2] = -1;
#endif
	  SendMessage (GUI.hStatusWnd, SB_SETPARTS, (WPARAM) 3,
		       (LPARAM) (LPINT) sb_size);
	  InvalidateRgn (GUI.hStatusWnd, NULL, TRUE);
	}

      switch (wParam)
	{
	case SIZE_MAXIMIZED:
	  RedrawClientRectAfterSizedMovedClient (hWnd, &GUI.ClientRect);
	  break;

	case SIZE_MINIMIZED:
	  MinimizedFlag = 1;
	  break;

	case SIZE_RESTORED:
	  if (MinimizedFlag == 2 && Renderer.Windowed && !GUI.FullScreen
	      && !Settings.StopEmulation)
	    {
	      MinimizedFlag = 0;
	      PauseExecution (TRUE, TRUE, FALSE);
	      if (SwitchScreenMode (FALSE))
		PauseExecution (FALSE, FALSE, TRUE);
	      else
		break;
	    }
	  //EChETCYύXɃQ[oȂ悤ɂ
	  else if (!SizingFlag && !GUI.FullScreen && Renderer.Windowed
		   && !Settings.StopEmulation)
	    PauseExecution (FALSE, TRUE, FALSE);

	  if (Renderer.Windowed)
	    RedrawClientRectAfterSizedMovedClient (hWnd, &GUI.ClientRect);

	  MinimizedFlag = 0;
	  break;

	default:
	  break;
	}
      break;

    case WM_DISPLAYCHANGE:
      {
	if (DisplayModeChanged)
	  {
	    DisplayModeChanged = FALSE;
	    break;
	  }

	PauseExecution (TRUE, FALSE, FALSE);
	if (GUI.FullScreen)
	  {
	    PauseExecution (TRUE, TRUE, FALSE);
	    if (SwitchScreenMode (Renderer.Windowed))
	      {
		PauseExecution (TRUE, FALSE, TRUE);
		GUI.FullScreen = TRUE;
	      }
	  }
	else
	  {
	    PauseExecution (TRUE, TRUE, FALSE);
	    if (SwitchScreenMode (Renderer.Windowed))
	      {
		PauseExecution (TRUE, FALSE, TRUE);
		GUI.FullScreen = FALSE;
	      }
	  }
	if (Settings.StopEmulation || Settings.SPCPlaying)
	  S9xDrawScreenData ();
	if ((!MinimizedFlag || Settings.SPCPlaying) &&
	    !GUI.FullScreen &&
	    Renderer.Windowed &&
	    !Settings.Paused &&
	    (WindowActiveFlag || Options.inactive_x) && !SizingFlag
	    && !ncbuttondown_flag)
	  PauseExecution (FALSE, TRUE, FALSE);
      }
      break;

    case WM_WINDOWPOSCHANGING:
//              ((LPWINDOWPOS)lParam)->hwndInsertAfter = HWND_TOPMOST;
      break;

    case WM_SIZING:
      RefreshRectParams (hWnd, GUI.hStatusWnd);
      if (!Renderer.Windowed || MinimizedFlag)
	break;
      else if (!SizingFlag)
	{
	  PauseExecution (TRUE, FALSE, FALSE);
	  SizingFlag = TRUE;
	}
      break;

    case WM_CLOSE:
      PauseExecution (TRUE, TRUE, FALSE);
      SetPriorityClassAndThreadPriority (NORMAL_PRIORITY_CLASS,
					 THREAD_PRIORITY_NORMAL);
      DragAcceptFiles (hWnd, FALSE);	//hbOhbv
      //save window size
      if (Renderer.Windowed && !MinimizedFlag)
	GetWindowRect (hWnd, &GUI.WindowRectSetting);
      uowKillMessageTimer (hWnd);
      uowClose (hWnd);
      DestroyWindow (hWnd);
      return 0;

    case WM_DESTROY:
      PostQuitMessage (0);
      break;

    case WM_SYSCOMMAND:
      switch (LOWORD (wParam))
	{
	case ID_OPTION_VL1:
	  Options.VolumeLevel = 1;
	  SetAPUDSPAmp (FIXED_POINT * Options.VolumeLevel);
	  return DefWindowProc (hWnd, uMsg, wParam, lParam);

	case ID_OPTION_VL2:
	  Options.VolumeLevel = 2;
	  SetAPUDSPAmp (FIXED_POINT * Options.VolumeLevel);
	  return DefWindowProc (hWnd, uMsg, wParam, lParam);

	case ID_OPTION_VL3:
	  Options.VolumeLevel = 3;
	  SetAPUDSPAmp (FIXED_POINT * Options.VolumeLevel);
	  return DefWindowProc (hWnd, uMsg, wParam, lParam);

	case ID_OPTION_VL4:
	  Options.VolumeLevel = 4;
	  SetAPUDSPAmp (FIXED_POINT * Options.VolumeLevel);
	  return DefWindowProc (hWnd, uMsg, wParam, lParam);

	case ID_OPTION_VL5:
	  Options.VolumeLevel = 5;
	  SetAPUDSPAmp (FIXED_POINT * Options.VolumeLevel);
	  return DefWindowProc (hWnd, uMsg, wParam, lParam);
	}
      switch (wParam & 0xfff0)	// & to catch double-click on title bar maximize
	{
	case SC_MINIMIZE:
	  if (!GUI.FullScreen && Renderer.Windowed && !Settings.SPCPlaying)
	    PauseExecution (TRUE, FALSE, FALSE);
	  MinimizedFlag = 1;
	  break;

	case SC_MAXIMIZE:
	  if (MinimizedFlag)
	    {
	      if (!Settings.SPCPlaying)
		MinimizedFlag = 2;
	      SendMessage (hWnd, WM_SYSCOMMAND, (WPARAM) SC_RESTORE, 0);
	    }
	  else if (Renderer.Windowed &&
		   !GUI.FullScreen &&
		   !Settings.StopEmulation &&
		   !Settings.ForcedPause &&
		   !Settings.SPCPlaying &&
		   !(Renderer.Windowed && Renderer.Depth == 8))
	    {
	      PauseExecution (TRUE, TRUE, FALSE);
	      if (SwitchScreenMode (FALSE))
		PauseExecution (FALSE, FALSE, TRUE);
	      else
		break;
	    }
	  return 0;

	case SC_RESTORE:
	  if (MinimizedFlag == 1)
	    MinimizedFlag = 0;
	  break;

	case SC_MONITORPOWER:
	case SC_SCREENSAVE:
	  //return 1;
	  break;

	default:
	  break;
	}
      break;

    default:
      break;
    }
  return DefWindowProc (hWnd, uMsg, wParam, lParam);
}

void
SetInfoDlgColor (unsigned char r, unsigned char g, unsigned char b)
{
  GUI.InfoColor = RGB (r, g, b);
}

void
uowSPCDumpMessages (bool8 err)
{
  if (err)
    {
      lstrcpy (OnScreenMessageStr, S9xGetFilenameIncNumExt ());
      lstrcat (OnScreenMessageStr, GUI.Language == 1 ? " Z[u" : " saved");
    }
  else
    lstrcpy (OnScreenMessageStr, GUI.Language == 1 ? "G[!" : "Error!");
  S9xMessage2 (OnScreenMessageStr, 2000);
}

BOOL
uowCreateStatusBar (HWND hWnd)
{
  if (!hWnd || GUI.hStatusWnd || GUI.statusbar == 0)
    return FALSE;

  GUI.hStatusWnd = CreateStatusWindow (WS_CHILD | WS_VISIBLE | CCS_BOTTOM | SBARS_SIZEGRIP,	// EBhEX^C
				       NULL,	// Pɕ\镶
				       hWnd,	// eEBhEnh
				       ID_MAINSTATUSWINDOW	// Xe[^Xo[̂hc
    );

  if (GUI.hStatusWnd)
    {
      RECT strect;
//              HICON hIcon;
#if 0
      GetClientRect (GUI.hStatusWnd, &strect);
      sb_size[2] = strect.right - strect.left;
#else
      sb_size[2] = -1;
#endif
      SendMessage (GUI.hStatusWnd, SB_SETPARTS, (WPARAM) 3,
		   (LPARAM) (LPINT) sb_size);
//              hIcon = (HICON)LoadImage(GUI.hInstance, MAKEINTRESOURCE(ONPU_ICON), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
      //#define SB_SETICON 1039
//              SendMessage(GUI.hStatusWnd, 1039, (WPARAM)2, (LPARAM)hIcon);
      uowDisplayStatusInfo (SB_NEEDREFRESH_ALL);
      //ftHgݒEChETCYɃXe[^Xo[
      if (GUI.NeedWindowSizeAddition == 1)
	{
	  POINT p;
	  GUI.NeedWindowSizeAddition = 0;
	  GetWindowRect (GUI.hStatusWnd, &strect);
	  GUI.WindowSizeH += (strect.bottom - strect.top);
	  p =
	    *GetWindowPosCenter (GUI.WindowSizeW, GUI.WindowSizeH,
				 GUI.WindowTopMost);
	  GUI.WindowRectSetting.left = p.x;
	  GUI.WindowRectSetting.top = p.y;
	  GUI.WindowRectSetting.right = (p.x + GUI.WindowSizeW);
	  GUI.WindowRectSetting.bottom = (p.y + GUI.WindowSizeH);
	  MoveWindow (hWnd, GUI.WindowRectSetting.left,
		      GUI.WindowRectSetting.top, GUI.WindowSizeW,
		      GUI.WindowSizeH, TRUE);
	}
      else if (GUI.NeedWindowSizeAddition == 2)
	{
	  GUI.NeedWindowSizeAddition = 0;
	  GetWindowRect (GUI.hStatusWnd, &strect);
	  GUI.WindowSizeH += (strect.bottom - strect.top);
	  GUI.WindowRectSetting.bottom += (strect.bottom - strect.top);
	  MoveWindow (hWnd, GUI.WindowRectSetting.left,
		      GUI.WindowRectSetting.top, GUI.WindowSizeW,
		      GUI.WindowSizeH, TRUE);
	}
      else
	GetWindowRect (GUI.hStatusWnd, &strect);

      GUI.DefaultWindowSizeH += (strect.bottom - strect.top);
      GUI.DefaultWindowSizeHH += (strect.bottom - strect.top);

      RefreshRectParams (hWnd, GUI.hStatusWnd);
      UpdateWindow (GUI.hStatusWnd);
      return TRUE;
    }
  else
    {
      RefreshRectParams (hWnd, GUI.hStatusWnd);
      return FALSE;
    }
}

void
uowDestroyStatusBar ()
{
  if (!GUI.hStatusWnd)
    return;

  RECT strect;

  GetWindowRect (GUI.hStatusWnd, &strect);
  GUI.DefaultWindowSizeH -= (strect.bottom - strect.top);
  GUI.DefaultWindowSizeHH -= (strect.bottom - strect.top);

  DestroyWindow (GUI.hStatusWnd);
  GUI.hStatusWnd = NULL;
  RefreshRectParams (GUI.hWnd, GUI.hStatusWnd);
  return;
}

void
uowSetupStatusBar (int status)
{
  RECT strect, winrect;

  if (!GUI.hStatusWnd && status == 1)
    {
      PauseExecution (TRUE, TRUE, FALSE);

      uowCreateStatusBar (GUI.hWnd);

      GetWindowRect (GUI.hWnd, &winrect);
      GetWindowRect (GUI.hStatusWnd, &strect);

      MoveWindow (GUI.hWnd, winrect.left, winrect.top,
		  (winrect.right - winrect.left),
		  (winrect.bottom - winrect.top) + (strect.bottom -
						    strect.top), TRUE);
      RefreshRectParams (GUI.hWnd, GUI.hStatusWnd);

      RedrawClientRectAfterSizedMovedClient (GUI.hWnd, &GUI.ClientRect);

      //save window size
      GetWindowRect (GUI.hWnd, &GUI.WindowRectSetting);

      PauseExecution (TRUE, FALSE, TRUE);
    }
  else if (GUI.hStatusWnd && status == 0)
    {
      PauseExecution (TRUE, TRUE, FALSE);

      GetWindowRect (GUI.hWnd, &winrect);
      GetWindowRect (GUI.hStatusWnd, &strect);

      uowDestroyStatusBar ();

      MoveWindow (GUI.hWnd, winrect.left, winrect.top,
		  (winrect.right - winrect.left),
		  (winrect.bottom - winrect.top) - (strect.bottom -
						    strect.top), TRUE);
      RefreshRectParams (GUI.hWnd, GUI.hStatusWnd);

      RedrawClientRectAfterSizedMovedClient (GUI.hWnd, &GUI.ClientRect);

      //save window size
      GetWindowRect (GUI.hWnd, &GUI.WindowRectSetting);

      PauseExecution (TRUE, FALSE, TRUE);
    }
  return;
}

/*****************
 default settings
*****************/
BOOL GUI_SoundGlobalFocus_def = TRUE;
BOOL GUI_DoubleBuffered_def = FALSE;
DWORD GUI_PriorityClass_def = NORMAL_PRIORITY_CLASS;
int GUI_ThreadPriority_def = THREAD_PRIORITY_NORMAL;
BOOL GUI_SupportHiRes_def = TRUE;
int GUI_FileBrowseWindow_def = 0;
BOOL GUI_WindowTopMost_def = TRUE;
BOOL GUI_WindowTopMostAlways_def = FALSE;
BOOL GUI_AttachConsole_def = FALSE;
int GUI_statusbar_def = 1;
BOOL GUI_DoubleRendering_def = TRUE;
BOOL GUI_DIuse_def = TRUE;
BOOL GUI_DSuse_def = TRUE;
BOOL GUI_DirectSoundNotify_def = FALSE;
int GUI_FilterMethod_def = 0;
BOOL GUI_AdjustWindow43_def = FALSE;

static void
WinLoad ()
{
  char filename[_MAX_PATH + 1];
  char drive[_MAX_DRIVE + 1];
  char dir[_MAX_DIR + 1];
  char fname[_MAX_FNAME + 1];
  char ext[_MAX_EXT + 1];

  LoadDefaultSettings ();
  S9xLoadDefaultSettings ();

  //set ROM directry
  if (strlen ((const char *) Options.HomeDirectory) < _MAX_PATH - 7)
    strcpy (ROMFileName, (const char *) Options.HomeDirectory);
  else
    strcpy (ROMFileName, "c:\\");
  _splitpath (ROMFileName, drive, dir, fname, ext);
  if (fname[0])
    lstrcat (ROMFileName, "\\a.smc");
  else
    lstrcat (ROMFileName, "a.smc");
  _splitpath (ROMFileName, drive, dir, fname, ext);
  _makepath (InitialROMFileDirectory, drive, dir, NULL, NULL);


  //set snapshot ScreenShot SPC BinaryDump directry
  if (strlen ((const char *) Options.HomeDirectory) < _MAX_PATH - 10)
    strcpy (GUI.FreezeFileDir, (const char *) Options.HomeDirectory);
  else
    strcpy (GUI.FreezeFileDir, "c:\\");
  _splitpath (GUI.FreezeFileDir, drive, dir, fname, ext);
  if (fname[0])
    lstrcat (GUI.FreezeFileDir, "\\snesnaps");
  else
    lstrcat (GUI.FreezeFileDir, "snesnaps");
  lstrcpy (Memory.ScreenShotDirectory, GUI.FreezeFileDir);
  lstrcpy (Memory.SPCDumpDirectory, GUI.FreezeFileDir);
  lstrcpy (Options.BinaryDumpDirectory, GUI.FreezeFileDir);

  //Satellav.smc
  if (strlen ((const char *) Options.HomeDirectory) < _MAX_PATH - 14)
    strcpy (Memory.BSXBIOSROMFileName, (const char *) Options.HomeDirectory);
  else
    strcpy (Memory.BSXBIOSROMFileName, "c:\\");
  _splitpath (Memory.BSXBIOSROMFileName, drive, dir, fname, ext);
  if (fname[0])
    lstrcat (Memory.BSXBIOSROMFileName, "\\Satellav.smc");
  else
    lstrcat (Memory.BSXBIOSROMFileName, "Satellav.smc");

  //SFTbase.smc
  if (strlen ((const char *) Options.HomeDirectory) < _MAX_PATH - 13)
    strcpy (Memory.SFTBIOSROMFileName, (const char *) Options.HomeDirectory);
  else
    strcpy (Memory.SFTBIOSROMFileName, "c:\\");
  _splitpath (Memory.SFTBIOSROMFileName, drive, dir, fname, ext);
  if (fname[0])
    lstrcat (Memory.SFTBIOSROMFileName, "\\SFTbase.smc");
  else
    lstrcat (Memory.SFTBIOSROMFileName, "SFTbase.smc");

  GUI.dwStyleWindowed =
    WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX | WS_MAXIMIZEBOX
    | WS_VISIBLE | WS_THICKFRAME | WS_CLIPCHILDREN;

  GUI.dwStyleFullScreen = WS_POPUP | WS_VISIBLE;

  GUI.WindowRectSetting.left = -1;
  GUI.WindowRectSetting.right = -1;
  GUI.WindowRectSetting.top = -1;
  GUI.WindowRectSetting.bottom = -1;

  RECT rc;

  //calcurate x1 window size
  SetRect (&rc, 0, 0, 256, 239);
  AdjustWindowRect (&rc, GUI.dwStyleWindowed, TRUE);
  GUI.DefaultWindowSizeW = rc.right - rc.left;
  GUI.DefaultWindowSizeH = rc.bottom - rc.top;
  SetRect (&rc, 0, 0, 301, 239);
  AdjustWindowRect (&rc, GUI.dwStyleWindowed, TRUE);
  GUI.DefaultWindowSizeW43 = rc.right - rc.left;


  //calcurate x2 window size
  SetRect (&rc, 0, 0, 512, 478);
  AdjustWindowRect (&rc, GUI.dwStyleWindowed, TRUE);
  GUI.DefaultWindowSizeWW = rc.right - rc.left;
  GUI.DefaultWindowSizeHH = rc.bottom - rc.top;
  SetRect (&rc, 0, 0, 602, 478);
  AdjustWindowRect (&rc, GUI.dwStyleWindowed, TRUE);
  GUI.DefaultWindowSizeWW43 = rc.right - rc.left;

  GUI.AdjustWindow43 = GUI_AdjustWindow43_def;

  GUI.hStatusWnd = NULL;

  //default settings
  GUI.DoubleRendering = GUI_DoubleRendering_def;
  GUI.FullscreenDisplayModeIndex = 0;
  GUI.ScreenDepth = 16;
  GUI.FilterMethod = GUI_FilterMethod_def;
  GUI.DoubleBuffered = GUI_DoubleBuffered_def;
  Settings.Paused = FALSE;
  Settings.ForcedPause = FALSE;
  GUI.FullScreen = FALSE;
  GUI.Stretch = 0;
  GUI.SupportHiRes = GUI_SupportHiRes_def;


  //Sound Settings
  GUI.SoundGlobalFocus = GUI_SoundGlobalFocus_def;

  //LangID 0x0411 Japanese
  Options.JPenvFlag = (GetSystemDefaultLangID () == 0x0411 ? TRUE : FALSE);
  GUI.Language = (GetSystemDefaultLangID () == 0x0411 ? 1 : 0);

  GUI.PriorityClass = GUI_PriorityClass_def;
  GUI.ThreadPriority = GUI_ThreadPriority_def;

  GUI.FileBrowseWindow = GUI_FileBrowseWindow_def;
  GUI.WindowTopMost = GUI_WindowTopMost_def;
  GUI.WindowTopMostAlways = GUI_WindowTopMostAlways_def;

  GUI.AttachConsole = GUI_AttachConsole_def;
  GUI.statusbar = GUI_statusbar_def;

  GUI.DIuse = GUI_DIuse_def;
  GUI.DSuse = GUI_DSuse_def;

  GUI.DirectSoundNotify = GUI_DirectSoundNotify_def;

  RendererInit ();

  //ݒt@Cǂݍ
  read_config ();

  //Command Line
  rom_filename = S9xParseArgs (__argv, __argc);

  if (GUI.AttachConsole)
    {
      AllocConsole ();
      freopen ("CONOUT$", "w", stdout);
      freopen ("CONOUT$", "w", stderr);
      freopen ("CONIN$", "r", stdin);
    }

  lstrcpy (FileTitle, S9xBasename ((const char *) ROMFileName));

  //mkdir
  if (access ((const char *) GUI.FreezeFileDir, 0))
    mkdir ((const char *) GUI.FreezeFileDir);
  if (access ((const char *) Memory.ScreenShotDirectory, 0))
    mkdir ((const char *) Memory.ScreenShotDirectory);
  if (access ((const char *) Memory.SPCDumpDirectory, 0))
    mkdir ((const char *) Memory.SPCDumpDirectory);
  if (access ((const char *) Options.BinaryDumpDirectory, 0))
    mkdir ((const char *) Options.BinaryDumpDirectory);

  S9xSetHCycles (Settings.H_MaxTimingHack, Settings.HDMATimingHack,
		 Settings.OldTimingMaster);

  if (Settings.ForceTransparency == 1 && Settings.ForceNoTransparency == 0)
    {
      Settings.Transparency = TRUE;
    }
  else if (Settings.ForceTransparency == 0
	   && Settings.ForceNoTransparency == 1)
    {
      Settings.Transparency = FALSE;
    }
  else
    {
      if (Settings.ForceTransparency == 1)
	{
	  Settings.ForceNoTransparency = 0;
	  Settings.Transparency = TRUE;
	}
      else
	{
	  Settings.ForceNoTransparency = 1;
	  Settings.Transparency = FALSE;
	}
    }

  //Sound Settings
  Settings.SoundPlaybackRate = (uint32) SoundRates[Options.SoundRate];
  Settings.SixteenBitSound = Options.SoundBit == 16 ? TRUE : FALSE;
  Settings.Stereo = Options.SoundChn == 2 ? TRUE : FALSE;

  GUI.dwExStyle = GUI.WindowTopMost ? WS_EX_TOPMOST : 0;

  if (GUI.DoubleRendering)
    Settings.SupportHiRes = (bool8) GUI.SupportHiRes;

  if (!Options.JPenvFlag)
    GUI.Language = 0;

  S9xUnmapAllControls();
  S9xSetupDefaultKeymap();
  ChangeInputDevice ();

  MakeTurboStatus ();
}

/* ROMLoadProc */
static bool
ROMLoadProc (char *FileName)
{
  char drive[_MAX_DRIVE + 1];
  char dir[_MAX_DIR + 1];
  char fname[_MAX_FNAME + 1];
  char ext[_MAX_EXT + 1];
  char *eext;

  //set filename for GetOpenFileName
  lstrcpy (InitialROMFileDirectory, FileName);
  _splitpath (InitialROMFileDirectory, drive, dir, fname, ext);
  _makepath (InitialROMFileDirectory, drive, dir, NULL, NULL);
  lstrcpy (FileTitle, fname);
  lstrcat (FileTitle, ext);
  if (FileName != ROMFileName)
    lstrcpy (ROMFileName, FileName);

  if (!Settings.StopEmulation && ExecLoop == S9xMainLoop)
    {
      Memory.SaveSRAM (S9xGetFilename (".srm", SRAM_DIR));
      S9xSaveCheatFile (S9xGetFilename (".cht", CHEAT_DIR));
      if (Xxxcdda.Enable)
	cdda_exit ();		// Original
      XXX_REPLAY_END ();
    }
  eext = GetFilenameExt (FileName);
  if ((!strcasecmp (eext, ".spc") || !strcasecmp (eext, ".sp1") ||
       !strcasecmp (eext, ".sp2") || !strcasecmp (eext, ".sp3") ||
       !strcasecmp (eext, ".sp4") || !strcasecmp (eext, ".sp5") ||
       !strcasecmp (eext, ".sp6") || !strcasecmp (eext, ".sp7") ||
       !strcasecmp (eext, ".sp8") || !strcasecmp (eext, ".sp9")))
    {

      Memory.ClearForced ();

      Settings.StopEmulation = !LoadSPC (ROMFileName);
      if (!Settings.StopEmulation)
	{
	  ExecLoop = SPCPlayMainLoop;
	  SPCLoadedFlag = TRUE;
	  GUI.FullScreen = FALSE;
	  SetMenuStatus (GUI.hMenu, GUI.hSysMenu);
	  Renderer.ForceClipper = TRUE;
	  S9xDrawScreenData ();
	  uowDisplayStatusInfo (SB_NEEDREFRESH_ALL);
	  uowScreenRedraw (GUI.hWnd);
	  ClearSamples ();
	  if (!uowSetupFrameTimer ((DWORD) Settings.FrameTime))
	    {
	      MessageBox (GUI.hWnd,
			  Languages[GUI.Language].errFrameTimer,
			  "uosnes - Frame Timer", MB_OK | MB_ICONINFORMATION);
	    }
	  return TRUE;
	}
      else
	{
	  GUI.FullScreen = FALSE;
	  SetMenuStatus (GUI.hMenu, GUI.hSysMenu);
	  Renderer.ForceClipper = TRUE;
	  S9xDrawScreenData ();
	  uowDisplayStatusInfo (SB_NEEDREFRESH_ALL);
	  uowScreenRedraw (GUI.hWnd);
	  return FALSE;
	}
    }

  Settings.StopEmulation = !Memory.LoadROM (FileName);

#if 0
  if (!trace && !(CPU.Flags & TRACE_FLAG))
    {
      int logsavednum;
      TracelogFilename =
	(char *) S9xGetNumFilename (GUI.FreezeFileDir, ".log", &logsavednum);

      if (TracelogFilename)
	trace = fopen (TracelogFilename, "wb");
      if (trace)
	CPU.Flags |= TRACE_FLAG;
      if (trace && (CPU.Flags & TRACE_FLAG))
	{
	  lstrcpy ((LPTSTR) OnScreenMessageStr,
		   (LPCTSTR) S9xBasename (TracelogFilename));
	  lstrcat (OnScreenMessageStr, " tracing");
	  S9xMessage2 (OnScreenMessageStr, 2000);
	}
    }
  else if (trace && (CPU.Flags & TRACE_FLAG))
    {
      CPU.Flags ^= TRACE_FLAG;
      fclose (trace);
      trace = NULL;
      if (!trace && !(CPU.Flags & TRACE_FLAG))
	{
	  lstrcpy ((LPTSTR) OnScreenMessageStr,
		   (LPCTSTR) S9xBasename (TracelogFilename));
	  lstrcat (OnScreenMessageStr, " tracing off");
	  S9xMessage2 (OnScreenMessageStr, 2000);
	}
    }
#endif

  Memory.ClearForced ();
  ResetSNESCheatCodeWindow ();

  if (!Settings.StopEmulation)
    {
      Memory.LoadSRAM (S9xGetFilename (".srm", SRAM_DIR));

      // Original
      if (Xxxcdda.Enable)
	{
	  cdda_open ();
	  cdda_stop ();
	}

#ifdef UNCO_FULL_TEAM
      if (Xxxbsx.BsxRomCheck)
	{
	  BSX_CLEAR ();
	  BSX_SRAMFIRST ();
	}
#endif

      XXX_ROMCHEAT_CODE (ROMCHEAT_CLEAR);	// Original
      ExecLoop = S9xMainLoop;
    }
  else
    {
      SetMenuStatus (GUI.hMenu, GUI.hSysMenu);
      Renderer.ForceClipper = FALSE;
      uowDisplayStatusInfo (SB_NEEDREFRESH_ALL);
      return FALSE;
    }
  //force fullscreen if it's in 256 color.
  if (Renderer.Windowed && Renderer.Depth == 8)
    GUI.FullScreen = TRUE;

  //fullscreen mode.
  if (GUI.FullScreen && Renderer.Windowed)
    {
      PauseExecution (TRUE, TRUE, FALSE);
      if (!SwitchScreenMode (FALSE))
	{
	  Renderer.ForceClipper = FALSE;
	  uowDisplayStatusInfo (SB_NEEDREFRESH_ALL);
	  return FALSE;
	}
      else
	PauseExecution (TRUE, FALSE, TRUE);
    }

  SetMenuStatus (GUI.hMenu, GUI.hSysMenu);
  Renderer.ForceClipper = FALSE;
  uowDisplayStatusInfo (SB_NEEDREFRESH_ALL);
  ClearSamples ();
  if (!uowSetupFrameTimer ((DWORD) Settings.FrameTime))
    {
      MessageBox (GUI.hWnd,
		  Languages[GUI.Language].errFrameTimer,
		  "uosnes - Frame Timer", MB_OK | MB_ICONINFORMATION);
    }
  return TRUE;
}

void
S9xSetWindowPos ()
{
  SetWindowPos (GUI.hWnd,
		GUI.WindowTopMost ? HWND_TOPMOST : HWND_NOTOPMOST,
		GUI.WindowRectSetting.left,
		GUI.WindowRectSetting.top,
		GUI.WindowRectSetting.right - GUI.WindowRectSetting.left,
		GUI.WindowRectSetting.bottom - GUI.WindowRectSetting.top,
		SWP_DRAWFRAME | SWP_FRAMECHANGED);
  RefreshRectParams (GUI.hWnd, GUI.hStatusWnd);
}

static void
Draw1frame ()
{
  if (Settings.StopEmulation || Settings.SPCPlaying)
    return;
  uowScreenRedraw (GUI.hWnd);
}

static void
SetPriorityClassAndThreadPriority (DWORD priocl, int threadprio)
{
  SetPriorityClass (GetCurrentProcess (), priocl);
  SetThreadPriority (GetCurrentThread (), threadprio);
}

/*****************************************************************************/
/* WinInit                                                                   */
/*****************************************************************************/

static LPCTSTR uosneswlpszClassName = "uosnesw: WndClass";

static HWND
WinInit (HINSTANCE hInstance)
{
  WNDCLASSEX wndclass_main;
  POINT p;

  wndclass_main.cbSize = sizeof (WNDCLASSEX);
  wndclass_main.style = 0;
  wndclass_main.lpfnWndProc = WinProc;
  wndclass_main.cbClsExtra = 0;
  wndclass_main.cbWndExtra = 0;
  wndclass_main.hInstance = hInstance;
  //wndclass_main.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(OTOKO_ICON));
  wndclass_main.hIcon = LoadIcon (hInstance, MAKEINTRESOURCE (UOSXW_ICON32));
  wndclass_main.hCursor = NULL;
  wndclass_main.hbrBackground = (HBRUSH) GetStockObject (BLACK_BRUSH);
  wndclass_main.lpszMenuName = 0;
  wndclass_main.lpszClassName = uosneswlpszClassName;
  //wndclass_main.hIconSm = NULL;
  wndclass_main.hIconSm =
    LoadIcon (hInstance, MAKEINTRESOURCE (UOSXW_ICON16));

  if (!RegisterClassEx (&wndclass_main))
    return NULL;

  RECT rc;

  if (GUI.WindowTopMost)
    {
      rc.left = 0;
      rc.top = 0;
      rc.right = GetSystemMetrics (SM_CXSCREEN);
      rc.bottom = GetSystemMetrics (SM_CYSCREEN);
    }
  else
    {
      SystemParametersInfo (SPI_GETWORKAREA, 0, &rc, 0);
    }

  //If it not set window rect setting or invalid setting
  if ((GUI.WindowRectSetting.left == -1 &&
       GUI.WindowRectSetting.right == -1 &&
       GUI.WindowRectSetting.top == -1 &&
       GUI.WindowRectSetting.bottom == -1) ||
      (GUI.WindowRectSetting.right - GUI.WindowRectSetting.left) <
      (GUI.AdjustWindow43 ? GUI.DefaultWindowSizeW43 : GUI.DefaultWindowSizeW)
      || (GUI.WindowRectSetting.bottom - GUI.WindowRectSetting.top) <
      GUI.DefaultWindowSizeH)
    {

      GUI.WindowSizeW =
	(GUI.AdjustWindow43 ? GUI.DefaultWindowSizeW43 : GUI.
	 DefaultWindowSizeW);
      GUI.WindowSizeH = GUI.DefaultWindowSizeH;
      p =
	*GetWindowPosCenter (GUI.WindowSizeW, GUI.WindowSizeH,
			     GUI.WindowTopMost);
      GUI.WindowRectSetting.left = p.x;
      GUI.WindowRectSetting.top = p.y;
      GUI.WindowRectSetting.right = (p.x + GUI.WindowSizeW);
      GUI.WindowRectSetting.bottom = (p.y + GUI.WindowSizeH);
      //Xe[^Xo[EChETCYcɐL΂Kv
      GUI.NeedWindowSizeAddition = 1;
    }
  //ǂݍ񂾃EChEʒuݒ肪Ɨ̈̈ʒuTCYƔrĖꍇ
  else if ((rc.right - 50) < GUI.WindowRectSetting.left ||
	   (rc.bottom - 50) < GUI.WindowRectSetting.top ||
	   rc.top > GUI.WindowRectSetting.top
	   || GUI.WindowRectSetting.right < 50)
    {

      GUI.WindowSizeW =
	(GUI.WindowRectSetting.right - GUI.WindowRectSetting.left);
      GUI.WindowSizeH =
	(GUI.WindowRectSetting.bottom - GUI.WindowRectSetting.top);
      p =
	*GetWindowPosCenter (GUI.WindowSizeW, GUI.WindowSizeH,
			     GUI.WindowTopMost);
      GUI.WindowRectSetting.left = p.x;
      GUI.WindowRectSetting.top = p.y;
      GUI.WindowRectSetting.right = (p.x + GUI.WindowSizeW);
      GUI.WindowRectSetting.bottom = (p.y + GUI.WindowSizeH);
    }
  //ǂݍ񂾃EChETCYʒuݒŃEChE
  else
    {
      GUI.WindowSizeW =
	(GUI.WindowRectSetting.right - GUI.WindowRectSetting.left);
      GUI.WindowSizeH =
	(GUI.WindowRectSetting.bottom - GUI.WindowRectSetting.top);
      p.x = GUI.WindowRectSetting.left;
      p.y = GUI.WindowRectSetting.top;
    }

  if ((GUI.hWnd = CreateWindowEx (GUI.dwExStyle,
				  uosneswlpszClassName,
				  WindowTitleText,
				  GUI.dwStyleWindowed,
				  p.x,
				  p.y,
				  GUI.WindowSizeW, GUI.WindowSizeH,
				  NULL, NULL, hInstance, NULL)) == NULL)
    {
      UnregisterClass (wndclass_main.lpszClassName, hInstance);
      return NULL;
    }

  return GUI.hWnd;
}

/*****************************************************************************/
/*                                                                           */
/*****************************************************************************/

#if 1				// G[\
static LPTOP_LEVEL_EXCEPTION_FILTER pass_thru_filter;
static LONG CALLBACK exception_filter (struct _EXCEPTION_POINTERS *info);

static LONG CALLBACK
exception_filter (struct _EXCEPTION_POINTERS *info)
{
  // exit
  return 1;
}
#endif

/*****************************************************************************/
/* WinMain                                                                   */
/*****************************************************************************/

int WINAPI
WinMain (HINSTANCE hInstance,
	 HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
#if 1				// G[\
  pass_thru_filter = SetUnhandledExceptionFilter (exception_filter);
#endif
  FillMemory ((PVOID) & GUI, sizeof (GUI), 0);
  GUI.hInstance = hInstance;

  ExecLoop = NullExecLoop;

  //SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_HIGHEST);

  //set default and load settings
  WinLoad ();

  //load resources
  GUI.hMenu =
    LoadMenu (hInstance, MAKEINTRESOURCE (Languages[GUI.Language].idMenu));
  GUI.hVolMenu = LoadMenu (hInstance, MAKEINTRESOURCE (IDR_VOLMENU));
  GUI.Blank = LoadCursor (hInstance, MAKEINTRESOURCE (IDC_CURSOR_BLANK));
  GUI.GunSight =
    LoadCursor (hInstance, MAKEINTRESOURCE (IDC_CURSOR_GUNSIGHT));
  GUI.Arrow = LoadCursor (NULL, IDC_ARROW);
  HACCEL Accelerators =
    LoadAccelerators (hInstance, MAKEINTRESOURCE (AACCEL));

  if (!GUI.hMenu || !GUI.hVolMenu ||
      !GUI.Blank || !GUI.GunSight || !GUI.Arrow || !Accelerators)
    {
      // error
      MessageBox (NULL,
		  "failed to initialize!",
		  "uosnesw - Init", MB_OK | MB_ICONSTOP);

      if (GUI.hMenu)
	DestroyMenu (GUI.hMenu);

      if (GUI.hVolMenu)
	DestroyMenu (GUI.hVolMenu);

      if (GUI.AttachConsole)
	FreeConsole ();

      return FALSE;
    }

  if (Options.JPenvFlag)
    InsertMenu (GetSubMenu (GUI.hMenu, 1),
		7,
		MF_BYPOSITION,
		ID_OPTION_JP,
		GUI.Language ==
		1 ? "{ UI(&U)\tCtrl+U" : "English &UI\tCtrl+U");


  Settings.StopEmulation = TRUE;
  HWND hWnd = WinInit (hInstance);

  if (hWnd == NULL)
    {
      // error
      MessageBox (NULL,
		  "window failed to initialize!",
		  "uosnesw - Init", MB_OK | MB_ICONSTOP);

      if (GUI.hMenu)
	DestroyMenu (GUI.hMenu);

      if (GUI.hVolMenu)
	DestroyMenu (GUI.hVolMenu);

      if (GUI.AttachConsole)
	FreeConsole ();

      return FALSE;
    }

  MSG msg;

  for (;;)
    {
      if (Settings.StopEmulation || Settings.Paused || Settings.ForcedPause ||
	  PeekMessage (&msg, NULL, 0, 0, PM_NOREMOVE))
	{
	  if (!GetMessage (&msg, NULL, 0, 0))
	    goto loop_exit;
	  if (!TranslateAccelerator (hWnd, Accelerators, &msg))
	    {
	      TranslateMessage (&msg);
	      DispatchMessage (&msg);
	    }
	}
      else
	{
	  if(!Settings.SPCPlaying)
	    ProcessInput();
	  ExecLoop ();
	}
    }
loop_exit:
  return msg.wParam;
}

static void
uowClose (HWND hWnd)
{
  uowSetupFrameTimer (0);

  if (GUI.hRtLib)
    FreeLibrary (GUI.hRtLib);

  if (GUI.FrameTimerSemaphore)
    {
      CloseHandle (GUI.FrameTimerSemaphore);
      GUI.FrameTimerSemaphore = NULL;
    }

  if (!Settings.StopEmulation && ExecLoop == S9xMainLoop)
    {
      Memory.SaveSRAM (S9xGetFilename (".srm", SRAM_DIR));
      S9xSaveCheatFile (S9xGetFilename (".cht", CHEAT_DIR));
      if (Xxxcdda.Enable)
	cdda_exit ();		// Original
      XXX_REPLAY_END ();
    }

  /* End */
  uowDeinit ();

  // delete menu
  if (!GUI.AppMenuConnect)
    DestroyMenu (GUI.hMenu);
  if (GUI.hRecentGamesMenu)
    DestroyMenu (GUI.hRecentGamesMenu);
  if (GUI.hVolMenu)
    DestroyMenu (GUI.hVolMenu);

  exit_configfile ();

  if (GUI.AttachConsole)
    FreeConsole ();
}

/*****************************************************************************/
