#ifndef _UOSNESW_H_
#define _UOSNESW_H_

#include <stdlib.h>
#ifndef STRICT
#define STRICT
#endif
#include <windows.h>
#include <commctrl.h>
#include <mmsystem.h>
#include <imm.h>
#include "resource.h"

struct sGUI
{
  HWND hWnd;
  HWND hStatusWnd;
  HMENU hMenu;
  HMENU hVolMenu;
  HMENU hSysMenu;
  HMENU hRecentGamesMenu;
  HINSTANCE hInstance;
  HINSTANCE hRtLib;//for Rich edit control
  HIMC hImc;

  HCURSOR Blank;
  HCURSOR GunSight;
  HCURSOR Arrow;
  DWORD dwStyleWindowed;
  DWORD dwStyleFullScreen;
  DWORD dwExStyle;

  BOOL AppMenuConnect;

  long DefaultWindowSizeW;
  long DefaultWindowSizeH;
  long DefaultWindowSizeWW;
  long DefaultWindowSizeHH;
  long DefaultWindowSizeW43;
  long DefaultWindowSizeWW43;
  long WindowSizeW;
  long WindowSizeH;
  RECT WindowRectSetting;
  BOOL AdjustWindow43;

  //Status bar size
  int NeedWindowSizeAddition;

  //Client Rect, .left == 0 .top == 0
  RECT ClientRect;
  //Screen xy Client Rect
  RECT sClientRect;

  HANDLE FrameTimerSemaphore;

  BOOL SoundGlobalFocus;
  BOOL PauseLock;

  int FilterMethod;

  BOOL SupportHiRes;
  BOOL DoubleRendering;
  int Stretch;
  BOOL FullScreen;
  BOOL DoubleBuffered;

  BOOL NeedDepthConvert;
  int ScreenDepth;

  int FullscreenDisplayModeIndex;
  char DisplayModeString[1024 + 1];

  int RedShift;
  int GreenShift;
  int BlueShift;

  char FreezeFileDir[_MAX_PATH];
  COLORREF InfoColor;
  POINT MousePosition;
  int MouseX;
  int MouseY;
  DWORD MouseButtons;

  DWORD PriorityClass;
  int ThreadPriority;

  BOOL DIuse;
  BOOL DSuse;
  BOOL DirectSoundNotify;

  int FileBrowseWindow;
  BOOL WindowTopMost;
  BOOL WindowTopMostAlways;

  BOOL AttachConsole;
  int statusbar;

  BOOL SwitchToWindowed;
  BOOL Exit;

  int Language;
};

struct sLanguages
{
  int idMenu;
  const char *errInitDD;
  const char *errModeDD;
  const char *errInitSound;
  const char *ApplyNeedRestart;
  const char *errFrameTimer;
  const char *S9xExitMessage;
  const char *errMemoryInit;
  const char *errSwitchGFX;
  const char *errInitDI;
};

/*****************************************************************************/
/* uosnesw defines                                                           */
/*****************************************************************************/
#define ID_MAINSTATUSWINDOW 101

#define SB_NEEDREFRESH_NONE       0
#define SB_NEEDREFRESH_FPS        1
#define SB_NEEDREFRESH_SPCCHANNEL 2
#define SB_NEEDREFRESH_BGMODE     4
#define SB_NEEDREFRESH_ALL        7

/*****************************************************************************/
/* Snes9x proc extern                                                        */
/*****************************************************************************/

void SetInfoDlgColor (unsigned char r, unsigned char g, unsigned char b);

/*****************************************************************************/
/* uosnesw variables extern                                                  */
/*****************************************************************************/
extern sGUI GUI;
extern sGUI DefaultGUI;
extern struct sLanguages Languages[];
extern BOOL errConfigSwitch;
extern struct SDisplayMode DisplayMode[];

/*****************************************************************************/
/* uosnesw proc extern                                                       */
/*****************************************************************************/
BOOL OpenFile (HWND hWnd, char *FileName, char *FileTitle,
	       char *InitialROMFileDirectory);
BOOL OpenFileEx (HWND hWnd, char *FileName, char *FileTitle,
		 char *InitialROMFileDirectory);
void ConfigDlgProp (HWND hWnd);
BOOL uowInit (HWND hWnd);
void uowDeinit ();
void S9xSetWindowPos ();
void RefreshRectParams (HWND hWnd, HWND hStatusWnd);
void uowDisplayStatusInfo (DWORD sb_needrefresh);
void uowSetupStatusBar (int status);

BOOL SwitchScreenMode (BOOL Windowed);
void SetMenuStatus (HMENU hAppMenu, HMENU hSysMenu);
void SetRecentFileMenu ();
BOOL uowSetupFrameTimer (DWORD ms);

#endif /* _UOSNESW_H_ */
